# IO.Swagger.Api.ModelClassesApi

All URIs are relative to *https://platform.its4land.com*

Method | HTTP request | Description
------------- | ------------- | -------------
[**GetModelClasses**](ModelClassesApi.md#getmodelclasses) | **GET** /modelclasses | Returns ModelClasses
[**GetModelClassesByUID**](ModelClassesApi.md#getmodelclassesbyuid) | **GET** /modelclasses/{modelclasses_uid} | Returns a single model class
[**UpdateModelClasses**](ModelClassesApi.md#updatemodelclasses) | **PATCH** /modelclasses/{modelclasses_uid} | Updates some attributes of a ModelClass


<a name="getmodelclasses"></a>
# **GetModelClasses**
> List<ModelClassesEndpointType> GetModelClasses (string envelope = null, List<string> UID = null, List<string> nameinmodel = null, List<string> conceptname = null, int? page = null, string sort = null, List<string> fields = null)

Returns ModelClasses

Returns ModelClasses

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class GetModelClassesExample
    {
        public void main()
        {
            var apiInstance = new ModelClassesApi();
            var envelope = envelope_example;  // string | The endpoint can package everything (header, status code) neatly into the response body. Include envelope=true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional) 
            var UID = new List<string>(); // List<string> | Comma separated list of ModelClasses UID (optional) 
            var nameinmodel = new List<string>(); // List<string> | Comma separated list of ModelClasses names (optional) 
            var conceptname = new List<string>(); // List<string> | Comma separated list of ModelClasses concept names (optional) 
            var page = 56;  // int? | Requests for collections can return between 0 and N results, controlled using the per_page and page query parameters. All endpoints are limited to 10 results by default. (optional) 
            var sort = sort_example;  // string | The sorting is initiated by the sort query parameter and a list of comma separated list of fields to sort by. (optional) 
            var fields = new List<string>(); // List<string> | Comma separated list of field names (optional) 

            try
            {
                // Returns ModelClasses
                List&lt;ModelClassesEndpointType&gt; result = apiInstance.GetModelClasses(envelope, UID, nameinmodel, conceptname, page, sort, fields);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling ModelClassesApi.GetModelClasses: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **envelope** | **string**| The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. | [optional] 
 **UID** | [**List&lt;string&gt;**](string.md)| Comma separated list of ModelClasses UID | [optional] 
 **nameinmodel** | [**List&lt;string&gt;**](string.md)| Comma separated list of ModelClasses names | [optional] 
 **conceptname** | [**List&lt;string&gt;**](string.md)| Comma separated list of ModelClasses concept names | [optional] 
 **page** | **int?**| Requests for collections can return between 0 and N results, controlled using the per_page and page query parameters. All endpoints are limited to 10 results by default. | [optional] 
 **sort** | **string**| The sorting is initiated by the sort query parameter and a list of comma separated list of fields to sort by. | [optional] 
 **fields** | [**List&lt;string&gt;**](string.md)| Comma separated list of field names | [optional] 

### Return type

[**List<ModelClassesEndpointType>**](ModelClassesEndpointType.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="getmodelclassesbyuid"></a>
# **GetModelClassesByUID**
> ModelClassesEndpointType GetModelClassesByUID (string modelclassesUid, string envelope = null)

Returns a single model class

Returns a single model class

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class GetModelClassesByUIDExample
    {
        public void main()
        {
            var apiInstance = new ModelClassesApi();
            var modelclassesUid = modelclassesUid_example;  // string | ModelClass UID
            var envelope = envelope_example;  // string | The endpoint can package everything (header, status code) neatly into the response body. Include envelope=true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional) 

            try
            {
                // Returns a single model class
                ModelClassesEndpointType result = apiInstance.GetModelClassesByUID(modelclassesUid, envelope);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling ModelClassesApi.GetModelClassesByUID: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **modelclassesUid** | **string**| ModelClass UID | 
 **envelope** | **string**| The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. | [optional] 

### Return type

[**ModelClassesEndpointType**](ModelClassesEndpointType.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="updatemodelclasses"></a>
# **UpdateModelClasses**
> ModelClassesEndpointType UpdateModelClasses (string modelclassesUid, RFC6902PatchRequest patchmodelclasses, string envelope = null, string i4lProcessUid = null)

Updates some attributes of a ModelClass

Updates some attributes of a ModelClass

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class UpdateModelClassesExample
    {
        public void main()
        {
            var apiInstance = new ModelClassesApi();
            var modelclassesUid = modelclassesUid_example;  // string | ModelClass UID
            var patchmodelclasses = new RFC6902PatchRequest(); // RFC6902PatchRequest | Update data
            var envelope = envelope_example;  // string | The endpoint can package everything (header, status code) neatly into the response body. Include envelope=true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional) 
            var i4lProcessUid = i4lProcessUid_example;  // string | Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional) 

            try
            {
                // Updates some attributes of a ModelClass
                ModelClassesEndpointType result = apiInstance.UpdateModelClasses(modelclassesUid, patchmodelclasses, envelope, i4lProcessUid);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling ModelClassesApi.UpdateModelClasses: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **modelclassesUid** | **string**| ModelClass UID | 
 **patchmodelclasses** | [**RFC6902PatchRequest**](RFC6902PatchRequest.md)| Update data | 
 **envelope** | **string**| The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. | [optional] 
 **i4lProcessUid** | **string**| Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. | [optional] 

### Return type

[**ModelClassesEndpointType**](ModelClassesEndpointType.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

