# IO.Swagger.Api.SpatialSourcesApi

All URIs are relative to *https://platform.its4land.com*

Method | HTTP request | Description
------------- | ------------- | -------------
[**DetachSpatialSourceAddDoc**](SpatialSourcesApi.md#detachspatialsourceadddoc) | **DELETE** /spatialsource/{spatialsource_uid}/AdditionalDocument/{adddoc_uid} | Removes an additional document for a spatial source.
[**GetSpatialSourceAddDocs**](SpatialSourcesApi.md#getspatialsourceadddocs) | **GET** /spatialsource/{spatialsource_uid}/AdditionalDocument | Returns the additional documents of a spatial source
[**GetSpatialSourceByUID**](SpatialSourcesApi.md#getspatialsourcebyuid) | **GET** /spatialsource/{spatialsource_uid} | Returns a single SpatialSource
[**GetSpatialSourceSingleAddDoc**](SpatialSourcesApi.md#getspatialsourcesingleadddoc) | **GET** /spatialsource/{spatialsource_uid}/AdditionalDocument/{adddoc_uid} | Returns the additional documents of a spatial source
[**GetSpatialSources**](SpatialSourcesApi.md#getspatialsources) | **GET** /spatialsources | Returns a list of SpatialSources
[**NewSpatialSource**](SpatialSourcesApi.md#newspatialsource) | **POST** /spatialsources | Create a new SpatialSource
[**NewSpatialSourceAddAddDoc**](SpatialSourcesApi.md#newspatialsourceaddadddoc) | **POST** /spatialsource/{spatialsource_uid}/AdditionalDocument | Add a new additional document to a spatial source
[**PutSpatialSourceByUID**](SpatialSourcesApi.md#putspatialsourcebyuid) | **PUT** /spatialsource/{spatialsource_uid} | Replace an existing SpatialSource by a newer version


<a name="detachspatialsourceadddoc"></a>
# **DetachSpatialSourceAddDoc**
> List<SpatialSourcesEndpointType> DetachSpatialSourceAddDoc (string spatialsourceUid, string adddocUid, string envelope = null, string forceDelete = null)

Removes an additional document for a spatial source.

Removes an additional document for a spatial source. By default only the link between additional document and spatial source is removed.

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class DetachSpatialSourceAddDocExample
    {
        public void main()
        {
            var apiInstance = new SpatialSourcesApi();
            var spatialsourceUid = spatialsourceUid_example;  // string | SpatialSource UID
            var adddocUid = adddocUid_example;  // string | SpatialSource UID
            var envelope = envelope_example;  // string | The endpoint can package everything (header, status code) neatly into the response body. Include envelope=true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional) 
            var forceDelete = forceDelete_example;  // string | Deletes the additional document resource. (optional) 

            try
            {
                // Removes an additional document for a spatial source.
                List&lt;SpatialSourcesEndpointType&gt; result = apiInstance.DetachSpatialSourceAddDoc(spatialsourceUid, adddocUid, envelope, forceDelete);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling SpatialSourcesApi.DetachSpatialSourceAddDoc: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **spatialsourceUid** | **string**| SpatialSource UID | 
 **adddocUid** | **string**| SpatialSource UID | 
 **envelope** | **string**| The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. | [optional] 
 **forceDelete** | **string**| Deletes the additional document resource. | [optional] 

### Return type

[**List<SpatialSourcesEndpointType>**](SpatialSourcesEndpointType.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="getspatialsourceadddocs"></a>
# **GetSpatialSourceAddDocs**
> List<AdditionalDocumentsEndpointType> GetSpatialSourceAddDocs (string spatialsourceUid, string envelope = null, int? page = null, string sort = null, List<string> fields = null)

Returns the additional documents of a spatial source

Returns the additional documents of a spatial source

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class GetSpatialSourceAddDocsExample
    {
        public void main()
        {
            var apiInstance = new SpatialSourcesApi();
            var spatialsourceUid = spatialsourceUid_example;  // string | SpatialSource UID
            var envelope = envelope_example;  // string | The endpoint can package everything (header, status code) neatly into the response body. Include envelope=true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional) 
            var page = 56;  // int? | Requests for collections can return between 0 and N results, controlled using the per_page and page query parameters. All endpoints are limited to 10 results by default. (optional) 
            var sort = sort_example;  // string | The sorting is initiated by the sort query parameter and a list of comma separated list of fields to sort by. (optional) 
            var fields = new List<string>(); // List<string> | Comma separated list of field names (optional) 

            try
            {
                // Returns the additional documents of a spatial source
                List&lt;AdditionalDocumentsEndpointType&gt; result = apiInstance.GetSpatialSourceAddDocs(spatialsourceUid, envelope, page, sort, fields);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling SpatialSourcesApi.GetSpatialSourceAddDocs: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **spatialsourceUid** | **string**| SpatialSource UID | 
 **envelope** | **string**| The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. | [optional] 
 **page** | **int?**| Requests for collections can return between 0 and N results, controlled using the per_page and page query parameters. All endpoints are limited to 10 results by default. | [optional] 
 **sort** | **string**| The sorting is initiated by the sort query parameter and a list of comma separated list of fields to sort by. | [optional] 
 **fields** | [**List&lt;string&gt;**](string.md)| Comma separated list of field names | [optional] 

### Return type

[**List<AdditionalDocumentsEndpointType>**](AdditionalDocumentsEndpointType.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="getspatialsourcebyuid"></a>
# **GetSpatialSourceByUID**
> SpatialSourcesEndpointType GetSpatialSourceByUID (string spatialsourceUid, string envelope = null, List<string> embed = null)

Returns a single SpatialSource

Returns a single SpatialSource

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class GetSpatialSourceByUIDExample
    {
        public void main()
        {
            var apiInstance = new SpatialSourcesApi();
            var spatialsourceUid = spatialsourceUid_example;  // string | SpatialSource UID
            var envelope = envelope_example;  // string | The endpoint can package everything (header, status code) neatly into the response body. Include envelope=true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional) 
            var embed = new List<string>(); // List<string> | Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional) 

            try
            {
                // Returns a single SpatialSource
                SpatialSourcesEndpointType result = apiInstance.GetSpatialSourceByUID(spatialsourceUid, envelope, embed);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling SpatialSourcesApi.GetSpatialSourceByUID: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **spatialsourceUid** | **string**| SpatialSource UID | 
 **envelope** | **string**| The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. | [optional] 
 **embed** | [**List&lt;string&gt;**](string.md)| Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) | [optional] 

### Return type

[**SpatialSourcesEndpointType**](SpatialSourcesEndpointType.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="getspatialsourcesingleadddoc"></a>
# **GetSpatialSourceSingleAddDoc**
> List<AdditionalDocumentsEndpointType> GetSpatialSourceSingleAddDoc (string spatialsourceUid, string adddocUid, string envelope = null, List<string> fields = null)

Returns the additional documents of a spatial source

Returns the additional documents of a spatial source

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class GetSpatialSourceSingleAddDocExample
    {
        public void main()
        {
            var apiInstance = new SpatialSourcesApi();
            var spatialsourceUid = spatialsourceUid_example;  // string | SpatialSource UID
            var adddocUid = adddocUid_example;  // string | SpatialSource UID
            var envelope = envelope_example;  // string | The endpoint can package everything (header, status code) neatly into the response body. Include envelope=true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional) 
            var fields = new List<string>(); // List<string> | Comma separated list of field names (optional) 

            try
            {
                // Returns the additional documents of a spatial source
                List&lt;AdditionalDocumentsEndpointType&gt; result = apiInstance.GetSpatialSourceSingleAddDoc(spatialsourceUid, adddocUid, envelope, fields);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling SpatialSourcesApi.GetSpatialSourceSingleAddDoc: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **spatialsourceUid** | **string**| SpatialSource UID | 
 **adddocUid** | **string**| SpatialSource UID | 
 **envelope** | **string**| The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. | [optional] 
 **fields** | [**List&lt;string&gt;**](string.md)| Comma separated list of field names | [optional] 

### Return type

[**List<AdditionalDocumentsEndpointType>**](AdditionalDocumentsEndpointType.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="getspatialsources"></a>
# **GetSpatialSources**
> List<SpatialSourcesEndpointType> GetSpatialSources (string envelope = null, List<string> uid = null, List<string> name = null, List<string> type = null, List<string> projects = null, List<string> tags = null, int? page = null, string sort = null, List<string> fields = null, List<string> embed = null)

Returns a list of SpatialSources

Returns a list of SpatialSources

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class GetSpatialSourcesExample
    {
        public void main()
        {
            var apiInstance = new SpatialSourcesApi();
            var envelope = envelope_example;  // string | The endpoint can package everything (header, status code) neatly into the response body. Include envelope=true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional) 
            var uid = new List<string>(); // List<string> | Comma separated list of SpatialSources UID (optional) 
            var name = new List<string>(); // List<string> | Comma separated list of SpatialSources names (optional) 
            var type = new List<string>(); // List<string> | Comma separated list of SpatialSources types (optional) 
            var projects = new List<string>(); // List<string> | Comma separated list of project UID (optional) 
            var tags = new List<string>(); // List<string> | Comma separated list of tags (optional) 
            var page = 56;  // int? | Requests for collections can return between 0 and N results, controlled using the per_page and page query parameters. All endpoints are limited to 10 results by default. (optional) 
            var sort = sort_example;  // string | The sorting is initiated by the sort query parameter and a list of comma separated list of fields to sort by. (optional) 
            var fields = new List<string>(); // List<string> | Comma separated list of tags (optional) 
            var embed = new List<string>(); // List<string> | Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional) 

            try
            {
                // Returns a list of SpatialSources
                List&lt;SpatialSourcesEndpointType&gt; result = apiInstance.GetSpatialSources(envelope, uid, name, type, projects, tags, page, sort, fields, embed);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling SpatialSourcesApi.GetSpatialSources: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **envelope** | **string**| The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. | [optional] 
 **uid** | [**List&lt;string&gt;**](string.md)| Comma separated list of SpatialSources UID | [optional] 
 **name** | [**List&lt;string&gt;**](string.md)| Comma separated list of SpatialSources names | [optional] 
 **type** | [**List&lt;string&gt;**](string.md)| Comma separated list of SpatialSources types | [optional] 
 **projects** | [**List&lt;string&gt;**](string.md)| Comma separated list of project UID | [optional] 
 **tags** | [**List&lt;string&gt;**](string.md)| Comma separated list of tags | [optional] 
 **page** | **int?**| Requests for collections can return between 0 and N results, controlled using the per_page and page query parameters. All endpoints are limited to 10 results by default. | [optional] 
 **sort** | **string**| The sorting is initiated by the sort query parameter and a list of comma separated list of fields to sort by. | [optional] 
 **fields** | [**List&lt;string&gt;**](string.md)| Comma separated list of tags | [optional] 
 **embed** | [**List&lt;string&gt;**](string.md)| Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) | [optional] 

### Return type

[**List<SpatialSourcesEndpointType>**](SpatialSourcesEndpointType.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="newspatialsource"></a>
# **NewSpatialSource**
> SpatialSourcesEndpointType NewSpatialSource (SpatialSourcesPostRequest newspatialsource, string envelope = null, List<string> embed = null, string processUid = null, string i4lProcessUid = null)

Create a new SpatialSource

Create a new SpatialSource. To add a new SpatialSources , the content of SpatialSources  must be stored in advanced via the ContentItem endpoint.

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class NewSpatialSourceExample
    {
        public void main()
        {
            var apiInstance = new SpatialSourcesApi();
            var newspatialsource = new SpatialSourcesPostRequest(); // SpatialSourcesPostRequest | New SpatialSource data
            var envelope = envelope_example;  // string | The endpoint can package everything (header, status code) neatly into the response body. Include envelope=true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional) 
            var embed = new List<string>(); // List<string> | Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional) 
            var processUid = processUid_example;  // string | deprecated (optional) 
            var i4lProcessUid = i4lProcessUid_example;  // string | Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional) 

            try
            {
                // Create a new SpatialSource
                SpatialSourcesEndpointType result = apiInstance.NewSpatialSource(newspatialsource, envelope, embed, processUid, i4lProcessUid);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling SpatialSourcesApi.NewSpatialSource: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **newspatialsource** | [**SpatialSourcesPostRequest**](SpatialSourcesPostRequest.md)| New SpatialSource data | 
 **envelope** | **string**| The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. | [optional] 
 **embed** | [**List&lt;string&gt;**](string.md)| Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) | [optional] 
 **processUid** | **string**| deprecated | [optional] 
 **i4lProcessUid** | **string**| Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. | [optional] 

### Return type

[**SpatialSourcesEndpointType**](SpatialSourcesEndpointType.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="newspatialsourceaddadddoc"></a>
# **NewSpatialSourceAddAddDoc**
> AdditionalDocumentsEndpointType NewSpatialSourceAddAddDoc (string spatialsourceUid, AdditionalDocumentsPost newadddocdata, string envelope = null, string i4lProcessUid = null)

Add a new additional document to a spatial source

Add a new additional document to a spatial source

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class NewSpatialSourceAddAddDocExample
    {
        public void main()
        {
            var apiInstance = new SpatialSourcesApi();
            var spatialsourceUid = spatialsourceUid_example;  // string | SpatialSource UID
            var newadddocdata = new AdditionalDocumentsPost(); // AdditionalDocumentsPost | New additional document data
            var envelope = envelope_example;  // string | The endpoint can package everything (header, status code) neatly into the response body. Include envelope=true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional) 
            var i4lProcessUid = i4lProcessUid_example;  // string | Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional) 

            try
            {
                // Add a new additional document to a spatial source
                AdditionalDocumentsEndpointType result = apiInstance.NewSpatialSourceAddAddDoc(spatialsourceUid, newadddocdata, envelope, i4lProcessUid);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling SpatialSourcesApi.NewSpatialSourceAddAddDoc: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **spatialsourceUid** | **string**| SpatialSource UID | 
 **newadddocdata** | [**AdditionalDocumentsPost**](AdditionalDocumentsPost.md)| New additional document data | 
 **envelope** | **string**| The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. | [optional] 
 **i4lProcessUid** | **string**| Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. | [optional] 

### Return type

[**AdditionalDocumentsEndpointType**](AdditionalDocumentsEndpointType.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="putspatialsourcebyuid"></a>
# **PutSpatialSourceByUID**
> SpatialSourcesEndpointType PutSpatialSourceByUID (string spatialsourceUid, SpatialSourcesPostRequest updatedspatialsource, string envelope = null, List<string> embed = null, string i4lProcessUid = null)

Replace an existing SpatialSource by a newer version

An existing SpatialSource will be replaced by a newer version. The UID of SpatialSource remains

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class PutSpatialSourceByUIDExample
    {
        public void main()
        {
            var apiInstance = new SpatialSourcesApi();
            var spatialsourceUid = spatialsourceUid_example;  // string | SpatialSource UID
            var updatedspatialsource = new SpatialSourcesPostRequest(); // SpatialSourcesPostRequest | Updated spatial source
            var envelope = envelope_example;  // string | The endpoint can package everything (header, status code) neatly into the response body. Include envelope=true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional) 
            var embed = new List<string>(); // List<string> | Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional) 
            var i4lProcessUid = i4lProcessUid_example;  // string | Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional) 

            try
            {
                // Replace an existing SpatialSource by a newer version
                SpatialSourcesEndpointType result = apiInstance.PutSpatialSourceByUID(spatialsourceUid, updatedspatialsource, envelope, embed, i4lProcessUid);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling SpatialSourcesApi.PutSpatialSourceByUID: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **spatialsourceUid** | **string**| SpatialSource UID | 
 **updatedspatialsource** | [**SpatialSourcesPostRequest**](SpatialSourcesPostRequest.md)| Updated spatial source | 
 **envelope** | **string**| The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. | [optional] 
 **embed** | [**List&lt;string&gt;**](string.md)| Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) | [optional] 
 **i4lProcessUid** | **string**| Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. | [optional] 

### Return type

[**SpatialSourcesEndpointType**](SpatialSourcesEndpointType.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

