# IO.Swagger.Api.TagsApi

All URIs are relative to *https://platform.its4land.com*

Method | HTTP request | Description
------------- | ------------- | -------------
[**GetTagByName**](TagsApi.md#gettagbyname) | **GET** /tags/{tag_name} | Returns a single tag
[**GetTags**](TagsApi.md#gettags) | **GET** /tags | Get a list of tags
[**MergeTagByUID**](TagsApi.md#mergetagbyuid) | **PATCH** /tags/{tag_uid}/merge | Merge tags
[**UpdateTagByName**](TagsApi.md#updatetagbyname) | **PATCH** /tags/{tag_name} | Updates a tag


<a name="gettagbyname"></a>
# **GetTagByName**
> TagsEndpointType GetTagByName (string tagName, string envelope = null, List<string> embed = null)

Returns a single tag

Returns a tag

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class GetTagByNameExample
    {
        public void main()
        {
            var apiInstance = new TagsApi();
            var tagName = tagName_example;  // string | Tag Name
            var envelope = envelope_example;  // string | The endpoint can package everything (header, status code) neatly into the response body. Include envelope=true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional) 
            var embed = new List<string>(); // List<string> | Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional) 

            try
            {
                // Returns a single tag
                TagsEndpointType result = apiInstance.GetTagByName(tagName, envelope, embed);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling TagsApi.GetTagByName: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **tagName** | **string**| Tag Name | 
 **envelope** | **string**| The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. | [optional] 
 **embed** | [**List&lt;string&gt;**](string.md)| Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) | [optional] 

### Return type

[**TagsEndpointType**](TagsEndpointType.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="gettags"></a>
# **GetTags**
> List<TagsEndpointType> GetTags (string envelope = null, List<string> uid = null, List<string> displayvalue = null, List<string> objecttypes = null, List<string> objectuuid = null, int? page = null, string sort = null, List<string> fields = null, List<string> embed = null)

Get a list of tags

Get a list of tags

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class GetTagsExample
    {
        public void main()
        {
            var apiInstance = new TagsApi();
            var envelope = envelope_example;  // string | The endpoint can package everything (header, status code) neatly into the response body. Include envelope=true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional) 
            var uid = new List<string>(); // List<string> | Comma separated list of Tag UID (optional) 
            var displayvalue = new List<string>(); // List<string> | Comma separated list of Tag display value (optional) 
            var objecttypes = new List<string>(); // List<string> | Comma separated list of objects types (optional) 
            var objectuuid = new List<string>(); // List<string> | Comma separated list of object UID (optional) 
            var page = 56;  // int? | Requests for collections can return between 0 and N results, controlled using the per_page and page query parameters. All endpoints are limited to 10 results by default. (optional) 
            var sort = sort_example;  // string | The sorting is initiated by the sort query parameter and a list of comma separated list of fields to sort by. (optional) 
            var fields = new List<string>(); // List<string> | Comma separated list of tags (optional) 
            var embed = new List<string>(); // List<string> | Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional) 

            try
            {
                // Get a list of tags
                List&lt;TagsEndpointType&gt; result = apiInstance.GetTags(envelope, uid, displayvalue, objecttypes, objectuuid, page, sort, fields, embed);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling TagsApi.GetTags: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **envelope** | **string**| The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. | [optional] 
 **uid** | [**List&lt;string&gt;**](string.md)| Comma separated list of Tag UID | [optional] 
 **displayvalue** | [**List&lt;string&gt;**](string.md)| Comma separated list of Tag display value | [optional] 
 **objecttypes** | [**List&lt;string&gt;**](string.md)| Comma separated list of objects types | [optional] 
 **objectuuid** | [**List&lt;string&gt;**](string.md)| Comma separated list of object UID | [optional] 
 **page** | **int?**| Requests for collections can return between 0 and N results, controlled using the per_page and page query parameters. All endpoints are limited to 10 results by default. | [optional] 
 **sort** | **string**| The sorting is initiated by the sort query parameter and a list of comma separated list of fields to sort by. | [optional] 
 **fields** | [**List&lt;string&gt;**](string.md)| Comma separated list of tags | [optional] 
 **embed** | [**List&lt;string&gt;**](string.md)| Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) | [optional] 

### Return type

[**List<TagsEndpointType>**](TagsEndpointType.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="mergetagbyuid"></a>
# **MergeTagByUID**
> TagsEndpointType MergeTagByUID (string tagUid, RFC6902PatchRequest mergetag, string envelope = null, string i4lProcessUid = null)

Merge tags

merge tags

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class MergeTagByUIDExample
    {
        public void main()
        {
            var apiInstance = new TagsApi();
            var tagUid = tagUid_example;  // string | Tag UID
            var mergetag = new RFC6902PatchRequest(); // RFC6902PatchRequest | Update data
            var envelope = envelope_example;  // string | The endpoint can package everything (header, status code) neatly into the response body. Include envelope=true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional) 
            var i4lProcessUid = i4lProcessUid_example;  // string | Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional) 

            try
            {
                // Merge tags
                TagsEndpointType result = apiInstance.MergeTagByUID(tagUid, mergetag, envelope, i4lProcessUid);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling TagsApi.MergeTagByUID: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **tagUid** | **string**| Tag UID | 
 **mergetag** | [**RFC6902PatchRequest**](RFC6902PatchRequest.md)| Update data | 
 **envelope** | **string**| The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. | [optional] 
 **i4lProcessUid** | **string**| Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. | [optional] 

### Return type

[**TagsEndpointType**](TagsEndpointType.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="updatetagbyname"></a>
# **UpdateTagByName**
> TagsEndpointType UpdateTagByName (string tagName, RFC6902PatchRequest patchtag, string envelope = null, List<string> embed = null, string i4lProcessUid = null)

Updates a tag

Updates a tag

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class UpdateTagByNameExample
    {
        public void main()
        {
            var apiInstance = new TagsApi();
            var tagName = tagName_example;  // string | Tag UID
            var patchtag = new RFC6902PatchRequest(); // RFC6902PatchRequest | Update data
            var envelope = envelope_example;  // string | The endpoint can package everything (header, status code) neatly into the response body. Include envelope=true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional) 
            var embed = new List<string>(); // List<string> | Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional) 
            var i4lProcessUid = i4lProcessUid_example;  // string | Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional) 

            try
            {
                // Updates a tag
                TagsEndpointType result = apiInstance.UpdateTagByName(tagName, patchtag, envelope, embed, i4lProcessUid);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling TagsApi.UpdateTagByName: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **tagName** | **string**| Tag UID | 
 **patchtag** | [**RFC6902PatchRequest**](RFC6902PatchRequest.md)| Update data | 
 **envelope** | **string**| The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. | [optional] 
 **embed** | [**List&lt;string&gt;**](string.md)| Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) | [optional] 
 **i4lProcessUid** | **string**| Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. | [optional] 

### Return type

[**TagsEndpointType**](TagsEndpointType.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

