# IO.Swagger.Api.TrainingSetsApi

All URIs are relative to *https://platform.its4land.com*

Method | HTTP request | Description
------------- | ------------- | -------------
[**GetTrainingSetByUID**](TrainingSetsApi.md#gettrainingsetbyuid) | **GET** /trainingsets/{trainingsets_uid} | Returns a single TrainingSet
[**GetTrainingSets**](TrainingSetsApi.md#gettrainingsets) | **GET** /trainingsets | Returns a list of TrainingSets
[**NewTrainingSet**](TrainingSetsApi.md#newtrainingset) | **POST** /trainingsets | Create a new TrainingSet


<a name="gettrainingsetbyuid"></a>
# **GetTrainingSetByUID**
> TrainingsSetEndpointType GetTrainingSetByUID (string trainingsetsUid, string envelope = null, List<string> embed = null)

Returns a single TrainingSet

Returns a single TrainingSet

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class GetTrainingSetByUIDExample
    {
        public void main()
        {
            var apiInstance = new TrainingSetsApi();
            var trainingsetsUid = trainingsetsUid_example;  // string | TrainingSet UID
            var envelope = envelope_example;  // string | The endpoint can package everything (header, status code) neatly into the response body. Include envelope=true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional) 
            var embed = new List<string>(); // List<string> | Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional) 

            try
            {
                // Returns a single TrainingSet
                TrainingsSetEndpointType result = apiInstance.GetTrainingSetByUID(trainingsetsUid, envelope, embed);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling TrainingSetsApi.GetTrainingSetByUID: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **trainingsetsUid** | **string**| TrainingSet UID | 
 **envelope** | **string**| The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. | [optional] 
 **embed** | [**List&lt;string&gt;**](string.md)| Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) | [optional] 

### Return type

[**TrainingsSetEndpointType**](TrainingsSetEndpointType.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="gettrainingsets"></a>
# **GetTrainingSets**
> List<TrainingsSetEndpointType> GetTrainingSets (string envelope = null, List<string> uid = null, List<string> name = null, List<string> models = null, List<string> tags = null, int? page = null, string sort = null, List<string> fields = null, List<string> embed = null)

Returns a list of TrainingSets

Returns a list of TrainingSets

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class GetTrainingSetsExample
    {
        public void main()
        {
            var apiInstance = new TrainingSetsApi();
            var envelope = envelope_example;  // string | The endpoint can package everything (header, status code) neatly into the response body. Include envelope=true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional) 
            var uid = new List<string>(); // List<string> | Comma separated list of TrainingSet UID (optional) 
            var name = new List<string>(); // List<string> | Comma separated list of TrainingSet Names (optional) 
            var models = new List<string>(); // List<string> | Comma separated list of model UID (optional) 
            var tags = new List<string>(); // List<string> | Comma separated list of tags (optional) 
            var page = 56;  // int? | Requests for collections can return between 0 and N results, controlled using the per_page and page query parameters. All endpoints are limited to 10 results by default. (optional) 
            var sort = sort_example;  // string | The sorting is initiated by the sort query parameter and a list of comma separated list of fields to sort by. (optional) 
            var fields = new List<string>(); // List<string> | Comma separated list of field names (optional) 
            var embed = new List<string>(); // List<string> | Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional) 

            try
            {
                // Returns a list of TrainingSets
                List&lt;TrainingsSetEndpointType&gt; result = apiInstance.GetTrainingSets(envelope, uid, name, models, tags, page, sort, fields, embed);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling TrainingSetsApi.GetTrainingSets: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **envelope** | **string**| The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. | [optional] 
 **uid** | [**List&lt;string&gt;**](string.md)| Comma separated list of TrainingSet UID | [optional] 
 **name** | [**List&lt;string&gt;**](string.md)| Comma separated list of TrainingSet Names | [optional] 
 **models** | [**List&lt;string&gt;**](string.md)| Comma separated list of model UID | [optional] 
 **tags** | [**List&lt;string&gt;**](string.md)| Comma separated list of tags | [optional] 
 **page** | **int?**| Requests for collections can return between 0 and N results, controlled using the per_page and page query parameters. All endpoints are limited to 10 results by default. | [optional] 
 **sort** | **string**| The sorting is initiated by the sort query parameter and a list of comma separated list of fields to sort by. | [optional] 
 **fields** | [**List&lt;string&gt;**](string.md)| Comma separated list of field names | [optional] 
 **embed** | [**List&lt;string&gt;**](string.md)| Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) | [optional] 

### Return type

[**List<TrainingsSetEndpointType>**](TrainingsSetEndpointType.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

<a name="newtrainingset"></a>
# **NewTrainingSet**
> TrainingsSetEndpointType NewTrainingSet (TrainingSetsPostRequest newtrainingset, string envelope = null, List<string> embed = null, string i4lProcessUid = null)

Create a new TrainingSet

Create a new TrainingSet. To add a new TrainingSet , the content of TrainingSet  must be stored in advanced via the ContentItem endpoint

### Example
```csharp
using System;
using System.Diagnostics;
using IO.Swagger.Api;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace Example
{
    public class NewTrainingSetExample
    {
        public void main()
        {
            var apiInstance = new TrainingSetsApi();
            var newtrainingset = new TrainingSetsPostRequest(); // TrainingSetsPostRequest | New TrainingSet data
            var envelope = envelope_example;  // string | The endpoint can package everything (header, status code) neatly into the response body. Include envelope=true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional) 
            var embed = new List<string>(); // List<string> | Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional) 
            var i4lProcessUid = i4lProcessUid_example;  // string | Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional) 

            try
            {
                // Create a new TrainingSet
                TrainingsSetEndpointType result = apiInstance.NewTrainingSet(newtrainingset, envelope, embed, i4lProcessUid);
                Debug.WriteLine(result);
            }
            catch (Exception e)
            {
                Debug.Print("Exception when calling TrainingSetsApi.NewTrainingSet: " + e.Message );
            }
        }
    }
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **newtrainingset** | [**TrainingSetsPostRequest**](TrainingSetsPostRequest.md)| New TrainingSet data | 
 **envelope** | **string**| The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. | [optional] 
 **embed** | [**List&lt;string&gt;**](string.md)| Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) | [optional] 
 **i4lProcessUid** | **string**| Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. | [optional] 

### Return type

[**TrainingsSetEndpointType**](TrainingsSetEndpointType.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

