/* 
 * its4land Public API
 *
 * The its4land Public API provides access to the services of the its4land Publish and Share platform.
 *
 * OpenAPI spec version: 0.0.2
 * Contact: contact@its4land.com
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */

using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using RestSharp;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace IO.Swagger.Api
{
    /// <summary>
    /// Represents a collection of functions to interact with the API endpoints
    /// </summary>
    public interface IAdminSourcesApi : IApiAccessor
    {
        #region Synchronous Operations
        /// <summary>
        /// Returns a single Admin Source
        /// </summary>
        /// <remarks>
        /// Returns a single Admin Source
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="adminsourceUid">AdminSource UID</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <returns>AdminSourcesEndpointType</returns>
        AdminSourcesEndpointType GetAdminSourceByUID (string adminsourceUid, string envelope = null, List<string> embed = null);

        /// <summary>
        /// Returns a single Admin Source
        /// </summary>
        /// <remarks>
        /// Returns a single Admin Source
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="adminsourceUid">AdminSource UID</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <returns>ApiResponse of AdminSourcesEndpointType</returns>
        ApiResponse<AdminSourcesEndpointType> GetAdminSourceByUIDWithHttpInfo (string adminsourceUid, string envelope = null, List<string> embed = null);
        /// <summary>
        /// Returns a list of AdminSource document indizes
        /// </summary>
        /// <remarks>
        /// Returns a list of AdminSource document indizes
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="uid">Comma separated list of AdminSources UID (optional)</param>
        /// <param name="name">Comma separated list of AdminSources names (optional)</param>
        /// <param name="type">Comma separated list of AdminSources types (optional)</param>
        /// <param name="projects">Comma separated list of project UID (optional)</param>
        /// <param name="spatialunits">Comma separated list of SpatialUnit UID (optional)</param>
        /// <param name="tags">Comma separated list of tags (optional)</param>
        /// <param name="page">Requests for collections can return between 0 and N results, controlled using the per_page and page query parameters. All endpoints are limited to 10 results by default. (optional)</param>
        /// <param name="sort">The sorting is initiated by the sort query parameter and a list of comma separated list of fields to sort by. (optional)</param>
        /// <param name="fields">Comma separated list of tags (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <returns>List&lt;AdminSourcesEndpointType&gt;</returns>
        List<AdminSourcesEndpointType> GetAdminSources (string envelope = null, List<string> uid = null, List<string> name = null, List<string> type = null, List<string> projects = null, List<string> spatialunits = null, List<string> tags = null, int? page = null, string sort = null, List<string> fields = null, List<string> embed = null);

        /// <summary>
        /// Returns a list of AdminSource document indizes
        /// </summary>
        /// <remarks>
        /// Returns a list of AdminSource document indizes
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="uid">Comma separated list of AdminSources UID (optional)</param>
        /// <param name="name">Comma separated list of AdminSources names (optional)</param>
        /// <param name="type">Comma separated list of AdminSources types (optional)</param>
        /// <param name="projects">Comma separated list of project UID (optional)</param>
        /// <param name="spatialunits">Comma separated list of SpatialUnit UID (optional)</param>
        /// <param name="tags">Comma separated list of tags (optional)</param>
        /// <param name="page">Requests for collections can return between 0 and N results, controlled using the per_page and page query parameters. All endpoints are limited to 10 results by default. (optional)</param>
        /// <param name="sort">The sorting is initiated by the sort query parameter and a list of comma separated list of fields to sort by. (optional)</param>
        /// <param name="fields">Comma separated list of tags (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <returns>ApiResponse of List&lt;AdminSourcesEndpointType&gt;</returns>
        ApiResponse<List<AdminSourcesEndpointType>> GetAdminSourcesWithHttpInfo (string envelope = null, List<string> uid = null, List<string> name = null, List<string> type = null, List<string> projects = null, List<string> spatialunits = null, List<string> tags = null, int? page = null, string sort = null, List<string> fields = null, List<string> embed = null);
        /// <summary>
        /// Creates a new AdminSource
        /// </summary>
        /// <remarks>
        /// Creates a new AdminSource
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="newadminsource">New AdminSource data</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <param name="i4lProcessUid">Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional)</param>
        /// <returns>AdminSourcesEndpointType</returns>
        AdminSourcesEndpointType NewAdminSource (AdminSourcesPostRequest newadminsource, string envelope = null, List<string> embed = null, string i4lProcessUid = null);

        /// <summary>
        /// Creates a new AdminSource
        /// </summary>
        /// <remarks>
        /// Creates a new AdminSource
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="newadminsource">New AdminSource data</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <param name="i4lProcessUid">Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional)</param>
        /// <returns>ApiResponse of AdminSourcesEndpointType</returns>
        ApiResponse<AdminSourcesEndpointType> NewAdminSourceWithHttpInfo (AdminSourcesPostRequest newadminsource, string envelope = null, List<string> embed = null, string i4lProcessUid = null);
        /// <summary>
        /// Update an Admin Source
        /// </summary>
        /// <remarks>
        /// Update an Admin Source
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="adminsourceUid">AdminSource UID</param>
        /// <param name="patchadminsource">Update data</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="i4lProcessUid">Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional)</param>
        /// <returns>AdminSourcesEndpointType</returns>
        AdminSourcesEndpointType UpdateAdminSource (string adminsourceUid, RFC6902PatchRequest patchadminsource, string envelope = null, string i4lProcessUid = null);

        /// <summary>
        /// Update an Admin Source
        /// </summary>
        /// <remarks>
        /// Update an Admin Source
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="adminsourceUid">AdminSource UID</param>
        /// <param name="patchadminsource">Update data</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="i4lProcessUid">Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional)</param>
        /// <returns>ApiResponse of AdminSourcesEndpointType</returns>
        ApiResponse<AdminSourcesEndpointType> UpdateAdminSourceWithHttpInfo (string adminsourceUid, RFC6902PatchRequest patchadminsource, string envelope = null, string i4lProcessUid = null);
        #endregion Synchronous Operations
        #region Asynchronous Operations
        /// <summary>
        /// Returns a single Admin Source
        /// </summary>
        /// <remarks>
        /// Returns a single Admin Source
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="adminsourceUid">AdminSource UID</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <returns>Task of AdminSourcesEndpointType</returns>
        System.Threading.Tasks.Task<AdminSourcesEndpointType> GetAdminSourceByUIDAsync (string adminsourceUid, string envelope = null, List<string> embed = null);

        /// <summary>
        /// Returns a single Admin Source
        /// </summary>
        /// <remarks>
        /// Returns a single Admin Source
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="adminsourceUid">AdminSource UID</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <returns>Task of ApiResponse (AdminSourcesEndpointType)</returns>
        System.Threading.Tasks.Task<ApiResponse<AdminSourcesEndpointType>> GetAdminSourceByUIDAsyncWithHttpInfo (string adminsourceUid, string envelope = null, List<string> embed = null);
        /// <summary>
        /// Returns a list of AdminSource document indizes
        /// </summary>
        /// <remarks>
        /// Returns a list of AdminSource document indizes
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="uid">Comma separated list of AdminSources UID (optional)</param>
        /// <param name="name">Comma separated list of AdminSources names (optional)</param>
        /// <param name="type">Comma separated list of AdminSources types (optional)</param>
        /// <param name="projects">Comma separated list of project UID (optional)</param>
        /// <param name="spatialunits">Comma separated list of SpatialUnit UID (optional)</param>
        /// <param name="tags">Comma separated list of tags (optional)</param>
        /// <param name="page">Requests for collections can return between 0 and N results, controlled using the per_page and page query parameters. All endpoints are limited to 10 results by default. (optional)</param>
        /// <param name="sort">The sorting is initiated by the sort query parameter and a list of comma separated list of fields to sort by. (optional)</param>
        /// <param name="fields">Comma separated list of tags (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <returns>Task of List&lt;AdminSourcesEndpointType&gt;</returns>
        System.Threading.Tasks.Task<List<AdminSourcesEndpointType>> GetAdminSourcesAsync (string envelope = null, List<string> uid = null, List<string> name = null, List<string> type = null, List<string> projects = null, List<string> spatialunits = null, List<string> tags = null, int? page = null, string sort = null, List<string> fields = null, List<string> embed = null);

        /// <summary>
        /// Returns a list of AdminSource document indizes
        /// </summary>
        /// <remarks>
        /// Returns a list of AdminSource document indizes
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="uid">Comma separated list of AdminSources UID (optional)</param>
        /// <param name="name">Comma separated list of AdminSources names (optional)</param>
        /// <param name="type">Comma separated list of AdminSources types (optional)</param>
        /// <param name="projects">Comma separated list of project UID (optional)</param>
        /// <param name="spatialunits">Comma separated list of SpatialUnit UID (optional)</param>
        /// <param name="tags">Comma separated list of tags (optional)</param>
        /// <param name="page">Requests for collections can return between 0 and N results, controlled using the per_page and page query parameters. All endpoints are limited to 10 results by default. (optional)</param>
        /// <param name="sort">The sorting is initiated by the sort query parameter and a list of comma separated list of fields to sort by. (optional)</param>
        /// <param name="fields">Comma separated list of tags (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <returns>Task of ApiResponse (List&lt;AdminSourcesEndpointType&gt;)</returns>
        System.Threading.Tasks.Task<ApiResponse<List<AdminSourcesEndpointType>>> GetAdminSourcesAsyncWithHttpInfo (string envelope = null, List<string> uid = null, List<string> name = null, List<string> type = null, List<string> projects = null, List<string> spatialunits = null, List<string> tags = null, int? page = null, string sort = null, List<string> fields = null, List<string> embed = null);
        /// <summary>
        /// Creates a new AdminSource
        /// </summary>
        /// <remarks>
        /// Creates a new AdminSource
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="newadminsource">New AdminSource data</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <param name="i4lProcessUid">Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional)</param>
        /// <returns>Task of AdminSourcesEndpointType</returns>
        System.Threading.Tasks.Task<AdminSourcesEndpointType> NewAdminSourceAsync (AdminSourcesPostRequest newadminsource, string envelope = null, List<string> embed = null, string i4lProcessUid = null);

        /// <summary>
        /// Creates a new AdminSource
        /// </summary>
        /// <remarks>
        /// Creates a new AdminSource
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="newadminsource">New AdminSource data</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <param name="i4lProcessUid">Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional)</param>
        /// <returns>Task of ApiResponse (AdminSourcesEndpointType)</returns>
        System.Threading.Tasks.Task<ApiResponse<AdminSourcesEndpointType>> NewAdminSourceAsyncWithHttpInfo (AdminSourcesPostRequest newadminsource, string envelope = null, List<string> embed = null, string i4lProcessUid = null);
        /// <summary>
        /// Update an Admin Source
        /// </summary>
        /// <remarks>
        /// Update an Admin Source
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="adminsourceUid">AdminSource UID</param>
        /// <param name="patchadminsource">Update data</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="i4lProcessUid">Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional)</param>
        /// <returns>Task of AdminSourcesEndpointType</returns>
        System.Threading.Tasks.Task<AdminSourcesEndpointType> UpdateAdminSourceAsync (string adminsourceUid, RFC6902PatchRequest patchadminsource, string envelope = null, string i4lProcessUid = null);

        /// <summary>
        /// Update an Admin Source
        /// </summary>
        /// <remarks>
        /// Update an Admin Source
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="adminsourceUid">AdminSource UID</param>
        /// <param name="patchadminsource">Update data</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="i4lProcessUid">Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional)</param>
        /// <returns>Task of ApiResponse (AdminSourcesEndpointType)</returns>
        System.Threading.Tasks.Task<ApiResponse<AdminSourcesEndpointType>> UpdateAdminSourceAsyncWithHttpInfo (string adminsourceUid, RFC6902PatchRequest patchadminsource, string envelope = null, string i4lProcessUid = null);
        #endregion Asynchronous Operations
    }

    /// <summary>
    /// Represents a collection of functions to interact with the API endpoints
    /// </summary>
    public partial class AdminSourcesApi : IAdminSourcesApi
    {
        private IO.Swagger.Client.ExceptionFactory _exceptionFactory = (name, response) => null;

        /// <summary>
        /// Initializes a new instance of the <see cref="AdminSourcesApi"/> class.
        /// </summary>
        /// <returns></returns>
        public AdminSourcesApi(String basePath)
        {
            this.Configuration = new Configuration { BasePath = basePath };

            ExceptionFactory = IO.Swagger.Client.Configuration.DefaultExceptionFactory;
        }

        /// <summary>
        /// Initializes a new instance of the <see cref="AdminSourcesApi"/> class
        /// using Configuration object
        /// </summary>
        /// <param name="configuration">An instance of Configuration</param>
        /// <returns></returns>
        public AdminSourcesApi(Configuration configuration = null)
        {
            if (configuration == null) // use the default one in Configuration
                this.Configuration = Configuration.Default;
            else
                this.Configuration = configuration;

            ExceptionFactory = IO.Swagger.Client.Configuration.DefaultExceptionFactory;
        }

        /// <summary>
        /// Gets the base path of the API client.
        /// </summary>
        /// <value>The base path</value>
        public String GetBasePath()
        {
            return this.Configuration.ApiClient.RestClient.BaseUrl.ToString();
        }

        /// <summary>
        /// Sets the base path of the API client.
        /// </summary>
        /// <value>The base path</value>
        [Obsolete("SetBasePath is deprecated, please do 'Configuration.ApiClient = new ApiClient(\"http://new-path\")' instead.")]
        public void SetBasePath(String basePath)
        {
            // do nothing
        }

        /// <summary>
        /// Gets or sets the configuration object
        /// </summary>
        /// <value>An instance of the Configuration</value>
        public Configuration Configuration {get; set;}

        /// <summary>
        /// Provides a factory method hook for the creation of exceptions.
        /// </summary>
        public IO.Swagger.Client.ExceptionFactory ExceptionFactory
        {
            get
            {
                if (_exceptionFactory != null && _exceptionFactory.GetInvocationList().Length > 1)
                {
                    throw new InvalidOperationException("Multicast delegate for ExceptionFactory is unsupported.");
                }
                return _exceptionFactory;
            }
            set { _exceptionFactory = value; }
        }

        /// <summary>
        /// Gets the default header.
        /// </summary>
        /// <returns>Dictionary of HTTP header</returns>
        [Obsolete("DefaultHeader is deprecated, please use Configuration.DefaultHeader instead.")]
        public IDictionary<String, String> DefaultHeader()
        {
            return new ReadOnlyDictionary<string, string>(this.Configuration.DefaultHeader);
        }

        /// <summary>
        /// Add default header.
        /// </summary>
        /// <param name="key">Header field name.</param>
        /// <param name="value">Header field value.</param>
        /// <returns></returns>
        [Obsolete("AddDefaultHeader is deprecated, please use Configuration.AddDefaultHeader instead.")]
        public void AddDefaultHeader(string key, string value)
        {
            this.Configuration.AddDefaultHeader(key, value);
        }

        /// <summary>
        /// Returns a single Admin Source Returns a single Admin Source
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="adminsourceUid">AdminSource UID</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <returns>AdminSourcesEndpointType</returns>
        public AdminSourcesEndpointType GetAdminSourceByUID (string adminsourceUid, string envelope = null, List<string> embed = null)
        {
             ApiResponse<AdminSourcesEndpointType> localVarResponse = GetAdminSourceByUIDWithHttpInfo(adminsourceUid, envelope, embed);
             return localVarResponse.Data;
        }

        /// <summary>
        /// Returns a single Admin Source Returns a single Admin Source
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="adminsourceUid">AdminSource UID</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <returns>ApiResponse of AdminSourcesEndpointType</returns>
        public ApiResponse< AdminSourcesEndpointType > GetAdminSourceByUIDWithHttpInfo (string adminsourceUid, string envelope = null, List<string> embed = null)
        {
            // verify the required parameter 'adminsourceUid' is set
            if (adminsourceUid == null)
                throw new ApiException(400, "Missing required parameter 'adminsourceUid' when calling AdminSourcesApi->GetAdminSourceByUID");

            var localVarPath = "/adminsources/{adminsource_uid}";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (adminsourceUid != null) localVarPathParams.Add("adminsource_uid", Configuration.ApiClient.ParameterToString(adminsourceUid)); // path parameter
            if (envelope != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("", "envelope", envelope)); // query parameter
            if (embed != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("csv", "embed", embed)); // query parameter


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) Configuration.ApiClient.CallApi(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("GetAdminSourceByUID", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<AdminSourcesEndpointType>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (AdminSourcesEndpointType) Configuration.ApiClient.Deserialize(localVarResponse, typeof(AdminSourcesEndpointType)));
        }

        /// <summary>
        /// Returns a single Admin Source Returns a single Admin Source
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="adminsourceUid">AdminSource UID</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <returns>Task of AdminSourcesEndpointType</returns>
        public async System.Threading.Tasks.Task<AdminSourcesEndpointType> GetAdminSourceByUIDAsync (string adminsourceUid, string envelope = null, List<string> embed = null)
        {
             ApiResponse<AdminSourcesEndpointType> localVarResponse = await GetAdminSourceByUIDAsyncWithHttpInfo(adminsourceUid, envelope, embed);
             return localVarResponse.Data;

        }

        /// <summary>
        /// Returns a single Admin Source Returns a single Admin Source
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="adminsourceUid">AdminSource UID</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <returns>Task of ApiResponse (AdminSourcesEndpointType)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<AdminSourcesEndpointType>> GetAdminSourceByUIDAsyncWithHttpInfo (string adminsourceUid, string envelope = null, List<string> embed = null)
        {
            // verify the required parameter 'adminsourceUid' is set
            if (adminsourceUid == null)
                throw new ApiException(400, "Missing required parameter 'adminsourceUid' when calling AdminSourcesApi->GetAdminSourceByUID");

            var localVarPath = "/adminsources/{adminsource_uid}";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (adminsourceUid != null) localVarPathParams.Add("adminsource_uid", Configuration.ApiClient.ParameterToString(adminsourceUid)); // path parameter
            if (envelope != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("", "envelope", envelope)); // query parameter
            if (embed != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("csv", "embed", embed)); // query parameter


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("GetAdminSourceByUID", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<AdminSourcesEndpointType>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (AdminSourcesEndpointType) Configuration.ApiClient.Deserialize(localVarResponse, typeof(AdminSourcesEndpointType)));
        }

        /// <summary>
        /// Returns a list of AdminSource document indizes Returns a list of AdminSource document indizes
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="uid">Comma separated list of AdminSources UID (optional)</param>
        /// <param name="name">Comma separated list of AdminSources names (optional)</param>
        /// <param name="type">Comma separated list of AdminSources types (optional)</param>
        /// <param name="projects">Comma separated list of project UID (optional)</param>
        /// <param name="spatialunits">Comma separated list of SpatialUnit UID (optional)</param>
        /// <param name="tags">Comma separated list of tags (optional)</param>
        /// <param name="page">Requests for collections can return between 0 and N results, controlled using the per_page and page query parameters. All endpoints are limited to 10 results by default. (optional)</param>
        /// <param name="sort">The sorting is initiated by the sort query parameter and a list of comma separated list of fields to sort by. (optional)</param>
        /// <param name="fields">Comma separated list of tags (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <returns>List&lt;AdminSourcesEndpointType&gt;</returns>
        public List<AdminSourcesEndpointType> GetAdminSources (string envelope = null, List<string> uid = null, List<string> name = null, List<string> type = null, List<string> projects = null, List<string> spatialunits = null, List<string> tags = null, int? page = null, string sort = null, List<string> fields = null, List<string> embed = null)
        {
             ApiResponse<List<AdminSourcesEndpointType>> localVarResponse = GetAdminSourcesWithHttpInfo(envelope, uid, name, type, projects, spatialunits, tags, page, sort, fields, embed);
             return localVarResponse.Data;
        }

        /// <summary>
        /// Returns a list of AdminSource document indizes Returns a list of AdminSource document indizes
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="uid">Comma separated list of AdminSources UID (optional)</param>
        /// <param name="name">Comma separated list of AdminSources names (optional)</param>
        /// <param name="type">Comma separated list of AdminSources types (optional)</param>
        /// <param name="projects">Comma separated list of project UID (optional)</param>
        /// <param name="spatialunits">Comma separated list of SpatialUnit UID (optional)</param>
        /// <param name="tags">Comma separated list of tags (optional)</param>
        /// <param name="page">Requests for collections can return between 0 and N results, controlled using the per_page and page query parameters. All endpoints are limited to 10 results by default. (optional)</param>
        /// <param name="sort">The sorting is initiated by the sort query parameter and a list of comma separated list of fields to sort by. (optional)</param>
        /// <param name="fields">Comma separated list of tags (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <returns>ApiResponse of List&lt;AdminSourcesEndpointType&gt;</returns>
        public ApiResponse< List<AdminSourcesEndpointType> > GetAdminSourcesWithHttpInfo (string envelope = null, List<string> uid = null, List<string> name = null, List<string> type = null, List<string> projects = null, List<string> spatialunits = null, List<string> tags = null, int? page = null, string sort = null, List<string> fields = null, List<string> embed = null)
        {

            var localVarPath = "/adminsources";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (envelope != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("", "envelope", envelope)); // query parameter
            if (uid != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("csv", "uid", uid)); // query parameter
            if (name != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("csv", "name", name)); // query parameter
            if (type != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("csv", "type", type)); // query parameter
            if (projects != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("csv", "projects", projects)); // query parameter
            if (spatialunits != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("csv", "spatialunits", spatialunits)); // query parameter
            if (tags != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("csv", "tags", tags)); // query parameter
            if (page != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("", "page", page)); // query parameter
            if (sort != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("", "sort", sort)); // query parameter
            if (fields != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("csv", "fields", fields)); // query parameter
            if (embed != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("csv", "embed", embed)); // query parameter


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) Configuration.ApiClient.CallApi(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("GetAdminSources", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<List<AdminSourcesEndpointType>>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (List<AdminSourcesEndpointType>) Configuration.ApiClient.Deserialize(localVarResponse, typeof(List<AdminSourcesEndpointType>)));
        }

        /// <summary>
        /// Returns a list of AdminSource document indizes Returns a list of AdminSource document indizes
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="uid">Comma separated list of AdminSources UID (optional)</param>
        /// <param name="name">Comma separated list of AdminSources names (optional)</param>
        /// <param name="type">Comma separated list of AdminSources types (optional)</param>
        /// <param name="projects">Comma separated list of project UID (optional)</param>
        /// <param name="spatialunits">Comma separated list of SpatialUnit UID (optional)</param>
        /// <param name="tags">Comma separated list of tags (optional)</param>
        /// <param name="page">Requests for collections can return between 0 and N results, controlled using the per_page and page query parameters. All endpoints are limited to 10 results by default. (optional)</param>
        /// <param name="sort">The sorting is initiated by the sort query parameter and a list of comma separated list of fields to sort by. (optional)</param>
        /// <param name="fields">Comma separated list of tags (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <returns>Task of List&lt;AdminSourcesEndpointType&gt;</returns>
        public async System.Threading.Tasks.Task<List<AdminSourcesEndpointType>> GetAdminSourcesAsync (string envelope = null, List<string> uid = null, List<string> name = null, List<string> type = null, List<string> projects = null, List<string> spatialunits = null, List<string> tags = null, int? page = null, string sort = null, List<string> fields = null, List<string> embed = null)
        {
             ApiResponse<List<AdminSourcesEndpointType>> localVarResponse = await GetAdminSourcesAsyncWithHttpInfo(envelope, uid, name, type, projects, spatialunits, tags, page, sort, fields, embed);
             return localVarResponse.Data;

        }

        /// <summary>
        /// Returns a list of AdminSource document indizes Returns a list of AdminSource document indizes
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="uid">Comma separated list of AdminSources UID (optional)</param>
        /// <param name="name">Comma separated list of AdminSources names (optional)</param>
        /// <param name="type">Comma separated list of AdminSources types (optional)</param>
        /// <param name="projects">Comma separated list of project UID (optional)</param>
        /// <param name="spatialunits">Comma separated list of SpatialUnit UID (optional)</param>
        /// <param name="tags">Comma separated list of tags (optional)</param>
        /// <param name="page">Requests for collections can return between 0 and N results, controlled using the per_page and page query parameters. All endpoints are limited to 10 results by default. (optional)</param>
        /// <param name="sort">The sorting is initiated by the sort query parameter and a list of comma separated list of fields to sort by. (optional)</param>
        /// <param name="fields">Comma separated list of tags (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <returns>Task of ApiResponse (List&lt;AdminSourcesEndpointType&gt;)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<List<AdminSourcesEndpointType>>> GetAdminSourcesAsyncWithHttpInfo (string envelope = null, List<string> uid = null, List<string> name = null, List<string> type = null, List<string> projects = null, List<string> spatialunits = null, List<string> tags = null, int? page = null, string sort = null, List<string> fields = null, List<string> embed = null)
        {

            var localVarPath = "/adminsources";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (envelope != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("", "envelope", envelope)); // query parameter
            if (uid != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("csv", "uid", uid)); // query parameter
            if (name != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("csv", "name", name)); // query parameter
            if (type != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("csv", "type", type)); // query parameter
            if (projects != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("csv", "projects", projects)); // query parameter
            if (spatialunits != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("csv", "spatialunits", spatialunits)); // query parameter
            if (tags != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("csv", "tags", tags)); // query parameter
            if (page != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("", "page", page)); // query parameter
            if (sort != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("", "sort", sort)); // query parameter
            if (fields != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("csv", "fields", fields)); // query parameter
            if (embed != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("csv", "embed", embed)); // query parameter


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("GetAdminSources", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<List<AdminSourcesEndpointType>>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (List<AdminSourcesEndpointType>) Configuration.ApiClient.Deserialize(localVarResponse, typeof(List<AdminSourcesEndpointType>)));
        }

        /// <summary>
        /// Creates a new AdminSource Creates a new AdminSource
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="newadminsource">New AdminSource data</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <param name="i4lProcessUid">Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional)</param>
        /// <returns>AdminSourcesEndpointType</returns>
        public AdminSourcesEndpointType NewAdminSource (AdminSourcesPostRequest newadminsource, string envelope = null, List<string> embed = null, string i4lProcessUid = null)
        {
             ApiResponse<AdminSourcesEndpointType> localVarResponse = NewAdminSourceWithHttpInfo(newadminsource, envelope, embed, i4lProcessUid);
             return localVarResponse.Data;
        }

        /// <summary>
        /// Creates a new AdminSource Creates a new AdminSource
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="newadminsource">New AdminSource data</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <param name="i4lProcessUid">Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional)</param>
        /// <returns>ApiResponse of AdminSourcesEndpointType</returns>
        public ApiResponse< AdminSourcesEndpointType > NewAdminSourceWithHttpInfo (AdminSourcesPostRequest newadminsource, string envelope = null, List<string> embed = null, string i4lProcessUid = null)
        {
            // verify the required parameter 'newadminsource' is set
            if (newadminsource == null)
                throw new ApiException(400, "Missing required parameter 'newadminsource' when calling AdminSourcesApi->NewAdminSource");

            var localVarPath = "/adminsources";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/json"
            };
            String localVarHttpContentType = Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (envelope != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("", "envelope", envelope)); // query parameter
            if (embed != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("csv", "embed", embed)); // query parameter
            if (i4lProcessUid != null) localVarHeaderParams.Add("i4l-process-uid", Configuration.ApiClient.ParameterToString(i4lProcessUid)); // header parameter
            if (newadminsource != null && newadminsource.GetType() != typeof(byte[]))
            {
                localVarPostBody = Configuration.ApiClient.Serialize(newadminsource); // http body (model) parameter
            }
            else
            {
                localVarPostBody = newadminsource; // byte array
            }


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) Configuration.ApiClient.CallApi(localVarPath,
                Method.POST, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("NewAdminSource", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<AdminSourcesEndpointType>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (AdminSourcesEndpointType) Configuration.ApiClient.Deserialize(localVarResponse, typeof(AdminSourcesEndpointType)));
        }

        /// <summary>
        /// Creates a new AdminSource Creates a new AdminSource
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="newadminsource">New AdminSource data</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <param name="i4lProcessUid">Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional)</param>
        /// <returns>Task of AdminSourcesEndpointType</returns>
        public async System.Threading.Tasks.Task<AdminSourcesEndpointType> NewAdminSourceAsync (AdminSourcesPostRequest newadminsource, string envelope = null, List<string> embed = null, string i4lProcessUid = null)
        {
             ApiResponse<AdminSourcesEndpointType> localVarResponse = await NewAdminSourceAsyncWithHttpInfo(newadminsource, envelope, embed, i4lProcessUid);
             return localVarResponse.Data;

        }

        /// <summary>
        /// Creates a new AdminSource Creates a new AdminSource
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="newadminsource">New AdminSource data</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <param name="i4lProcessUid">Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional)</param>
        /// <returns>Task of ApiResponse (AdminSourcesEndpointType)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<AdminSourcesEndpointType>> NewAdminSourceAsyncWithHttpInfo (AdminSourcesPostRequest newadminsource, string envelope = null, List<string> embed = null, string i4lProcessUid = null)
        {
            // verify the required parameter 'newadminsource' is set
            if (newadminsource == null)
                throw new ApiException(400, "Missing required parameter 'newadminsource' when calling AdminSourcesApi->NewAdminSource");

            var localVarPath = "/adminsources";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/json"
            };
            String localVarHttpContentType = Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (envelope != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("", "envelope", envelope)); // query parameter
            if (embed != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("csv", "embed", embed)); // query parameter
            if (i4lProcessUid != null) localVarHeaderParams.Add("i4l-process-uid", Configuration.ApiClient.ParameterToString(i4lProcessUid)); // header parameter
            if (newadminsource != null && newadminsource.GetType() != typeof(byte[]))
            {
                localVarPostBody = Configuration.ApiClient.Serialize(newadminsource); // http body (model) parameter
            }
            else
            {
                localVarPostBody = newadminsource; // byte array
            }


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.POST, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("NewAdminSource", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<AdminSourcesEndpointType>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (AdminSourcesEndpointType) Configuration.ApiClient.Deserialize(localVarResponse, typeof(AdminSourcesEndpointType)));
        }

        /// <summary>
        /// Update an Admin Source Update an Admin Source
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="adminsourceUid">AdminSource UID</param>
        /// <param name="patchadminsource">Update data</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="i4lProcessUid">Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional)</param>
        /// <returns>AdminSourcesEndpointType</returns>
        public AdminSourcesEndpointType UpdateAdminSource (string adminsourceUid, RFC6902PatchRequest patchadminsource, string envelope = null, string i4lProcessUid = null)
        {
             ApiResponse<AdminSourcesEndpointType> localVarResponse = UpdateAdminSourceWithHttpInfo(adminsourceUid, patchadminsource, envelope, i4lProcessUid);
             return localVarResponse.Data;
        }

        /// <summary>
        /// Update an Admin Source Update an Admin Source
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="adminsourceUid">AdminSource UID</param>
        /// <param name="patchadminsource">Update data</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="i4lProcessUid">Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional)</param>
        /// <returns>ApiResponse of AdminSourcesEndpointType</returns>
        public ApiResponse< AdminSourcesEndpointType > UpdateAdminSourceWithHttpInfo (string adminsourceUid, RFC6902PatchRequest patchadminsource, string envelope = null, string i4lProcessUid = null)
        {
            // verify the required parameter 'adminsourceUid' is set
            if (adminsourceUid == null)
                throw new ApiException(400, "Missing required parameter 'adminsourceUid' when calling AdminSourcesApi->UpdateAdminSource");
            // verify the required parameter 'patchadminsource' is set
            if (patchadminsource == null)
                throw new ApiException(400, "Missing required parameter 'patchadminsource' when calling AdminSourcesApi->UpdateAdminSource");

            var localVarPath = "/adminsources/{adminsource_uid}";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/json"
            };
            String localVarHttpContentType = Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (adminsourceUid != null) localVarPathParams.Add("adminsource_uid", Configuration.ApiClient.ParameterToString(adminsourceUid)); // path parameter
            if (envelope != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("", "envelope", envelope)); // query parameter
            if (i4lProcessUid != null) localVarHeaderParams.Add("i4l-process-uid", Configuration.ApiClient.ParameterToString(i4lProcessUid)); // header parameter
            if (patchadminsource != null && patchadminsource.GetType() != typeof(byte[]))
            {
                localVarPostBody = Configuration.ApiClient.Serialize(patchadminsource); // http body (model) parameter
            }
            else
            {
                localVarPostBody = patchadminsource; // byte array
            }


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) Configuration.ApiClient.CallApi(localVarPath,
                Method.PATCH, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("UpdateAdminSource", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<AdminSourcesEndpointType>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (AdminSourcesEndpointType) Configuration.ApiClient.Deserialize(localVarResponse, typeof(AdminSourcesEndpointType)));
        }

        /// <summary>
        /// Update an Admin Source Update an Admin Source
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="adminsourceUid">AdminSource UID</param>
        /// <param name="patchadminsource">Update data</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="i4lProcessUid">Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional)</param>
        /// <returns>Task of AdminSourcesEndpointType</returns>
        public async System.Threading.Tasks.Task<AdminSourcesEndpointType> UpdateAdminSourceAsync (string adminsourceUid, RFC6902PatchRequest patchadminsource, string envelope = null, string i4lProcessUid = null)
        {
             ApiResponse<AdminSourcesEndpointType> localVarResponse = await UpdateAdminSourceAsyncWithHttpInfo(adminsourceUid, patchadminsource, envelope, i4lProcessUid);
             return localVarResponse.Data;

        }

        /// <summary>
        /// Update an Admin Source Update an Admin Source
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="adminsourceUid">AdminSource UID</param>
        /// <param name="patchadminsource">Update data</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="i4lProcessUid">Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional)</param>
        /// <returns>Task of ApiResponse (AdminSourcesEndpointType)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<AdminSourcesEndpointType>> UpdateAdminSourceAsyncWithHttpInfo (string adminsourceUid, RFC6902PatchRequest patchadminsource, string envelope = null, string i4lProcessUid = null)
        {
            // verify the required parameter 'adminsourceUid' is set
            if (adminsourceUid == null)
                throw new ApiException(400, "Missing required parameter 'adminsourceUid' when calling AdminSourcesApi->UpdateAdminSource");
            // verify the required parameter 'patchadminsource' is set
            if (patchadminsource == null)
                throw new ApiException(400, "Missing required parameter 'patchadminsource' when calling AdminSourcesApi->UpdateAdminSource");

            var localVarPath = "/adminsources/{adminsource_uid}";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/json"
            };
            String localVarHttpContentType = Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (adminsourceUid != null) localVarPathParams.Add("adminsource_uid", Configuration.ApiClient.ParameterToString(adminsourceUid)); // path parameter
            if (envelope != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("", "envelope", envelope)); // query parameter
            if (i4lProcessUid != null) localVarHeaderParams.Add("i4l-process-uid", Configuration.ApiClient.ParameterToString(i4lProcessUid)); // header parameter
            if (patchadminsource != null && patchadminsource.GetType() != typeof(byte[]))
            {
                localVarPostBody = Configuration.ApiClient.Serialize(patchadminsource); // http body (model) parameter
            }
            else
            {
                localVarPostBody = patchadminsource; // byte array
            }


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.PATCH, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("UpdateAdminSource", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<AdminSourcesEndpointType>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (AdminSourcesEndpointType) Configuration.ApiClient.Deserialize(localVarResponse, typeof(AdminSourcesEndpointType)));
        }

    }
}
