/* 
 * its4land Public API
 *
 * The its4land Public API provides access to the services of the its4land Publish and Share platform.
 *
 * OpenAPI spec version: 0.0.2
 * Contact: contact@its4land.com
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */

using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using RestSharp;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace IO.Swagger.Api
{
    /// <summary>
    /// Represents a collection of functions to interact with the API endpoints
    /// </summary>
    public interface IContentItemsApi : IApiAccessor
    {
        #region Synchronous Operations
        /// <summary>
        /// Returns a single content from the object storage.
        /// </summary>
        /// <remarks>
        /// Returns a single content from the object storage.
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="contentitemId">UID of the ContentItem</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <returns>System.IO.Stream</returns>
        System.IO.Stream GetContentItem (string contentitemId, string envelope = null);

        /// <summary>
        /// Returns a single content from the object storage.
        /// </summary>
        /// <remarks>
        /// Returns a single content from the object storage.
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="contentitemId">UID of the ContentItem</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <returns>ApiResponse of System.IO.Stream</returns>
        ApiResponse<System.IO.Stream> GetContentItemWithHttpInfo (string contentitemId, string envelope = null);
        /// <summary>
        /// Returns a list of contentitems
        /// </summary>
        /// <remarks>
        /// Returns a list of contentitem metadata based on the filter criteria
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="uid">UID of a ContentItem (optional)</param>
        /// <param name="contentname">Name of File (optional)</param>
        /// <param name="contenttype">mime/type of the content (optional)</param>
        /// <param name="contentdescription">Free text for description. Only plain text. (optional)</param>
        /// <param name="page">Requests for collections can return between 0 and N results, controlled using the per_page and page query parameters. All endpoints are limited to 10 results by default. (optional)</param>
        /// <param name="sort">The sorting is initiated by the sort query parameter and a list of comma separated list of fields to sort by. (optional)</param>
        /// <param name="fields">Comma separated list of field names (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <returns>List&lt;ContentItemEndpointType&gt;</returns>
        List<ContentItemEndpointType> GetContentItems (string envelope = null, List<string> uid = null, List<string> contentname = null, List<string> contenttype = null, string contentdescription = null, int? page = null, string sort = null, List<string> fields = null, List<string> embed = null);

        /// <summary>
        /// Returns a list of contentitems
        /// </summary>
        /// <remarks>
        /// Returns a list of contentitem metadata based on the filter criteria
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="uid">UID of a ContentItem (optional)</param>
        /// <param name="contentname">Name of File (optional)</param>
        /// <param name="contenttype">mime/type of the content (optional)</param>
        /// <param name="contentdescription">Free text for description. Only plain text. (optional)</param>
        /// <param name="page">Requests for collections can return between 0 and N results, controlled using the per_page and page query parameters. All endpoints are limited to 10 results by default. (optional)</param>
        /// <param name="sort">The sorting is initiated by the sort query parameter and a list of comma separated list of fields to sort by. (optional)</param>
        /// <param name="fields">Comma separated list of field names (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <returns>ApiResponse of List&lt;ContentItemEndpointType&gt;</returns>
        ApiResponse<List<ContentItemEndpointType>> GetContentItemsWithHttpInfo (string envelope = null, List<string> uid = null, List<string> contentname = null, List<string> contenttype = null, string contentdescription = null, int? page = null, string sort = null, List<string> fields = null, List<string> embed = null);
        /// <summary>
        /// Create a new content in the object storage
        /// </summary>
        /// <remarks>
        /// Create a new content in the object storage
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="newcontent">Content as multipart from-data</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="description">Description of content (optional) (optional)</param>
        /// <param name="i4lProcessUid">Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional)</param>
        /// <returns>ContentItemEndpointType</returns>
        ContentItemEndpointType NewContentItem (System.IO.Stream newcontent, string envelope = null, string description = null, string i4lProcessUid = null);

        /// <summary>
        /// Create a new content in the object storage
        /// </summary>
        /// <remarks>
        /// Create a new content in the object storage
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="newcontent">Content as multipart from-data</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="description">Description of content (optional) (optional)</param>
        /// <param name="i4lProcessUid">Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional)</param>
        /// <returns>ApiResponse of ContentItemEndpointType</returns>
        ApiResponse<ContentItemEndpointType> NewContentItemWithHttpInfo (System.IO.Stream newcontent, string envelope = null, string description = null, string i4lProcessUid = null);
        #endregion Synchronous Operations
        #region Asynchronous Operations
        /// <summary>
        /// Returns a single content from the object storage.
        /// </summary>
        /// <remarks>
        /// Returns a single content from the object storage.
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="contentitemId">UID of the ContentItem</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <returns>Task of System.IO.Stream</returns>
        System.Threading.Tasks.Task<System.IO.Stream> GetContentItemAsync (string contentitemId, string envelope = null);

        /// <summary>
        /// Returns a single content from the object storage.
        /// </summary>
        /// <remarks>
        /// Returns a single content from the object storage.
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="contentitemId">UID of the ContentItem</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <returns>Task of ApiResponse (System.IO.Stream)</returns>
        System.Threading.Tasks.Task<ApiResponse<System.IO.Stream>> GetContentItemAsyncWithHttpInfo (string contentitemId, string envelope = null);
        /// <summary>
        /// Returns a list of contentitems
        /// </summary>
        /// <remarks>
        /// Returns a list of contentitem metadata based on the filter criteria
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="uid">UID of a ContentItem (optional)</param>
        /// <param name="contentname">Name of File (optional)</param>
        /// <param name="contenttype">mime/type of the content (optional)</param>
        /// <param name="contentdescription">Free text for description. Only plain text. (optional)</param>
        /// <param name="page">Requests for collections can return between 0 and N results, controlled using the per_page and page query parameters. All endpoints are limited to 10 results by default. (optional)</param>
        /// <param name="sort">The sorting is initiated by the sort query parameter and a list of comma separated list of fields to sort by. (optional)</param>
        /// <param name="fields">Comma separated list of field names (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <returns>Task of List&lt;ContentItemEndpointType&gt;</returns>
        System.Threading.Tasks.Task<List<ContentItemEndpointType>> GetContentItemsAsync (string envelope = null, List<string> uid = null, List<string> contentname = null, List<string> contenttype = null, string contentdescription = null, int? page = null, string sort = null, List<string> fields = null, List<string> embed = null);

        /// <summary>
        /// Returns a list of contentitems
        /// </summary>
        /// <remarks>
        /// Returns a list of contentitem metadata based on the filter criteria
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="uid">UID of a ContentItem (optional)</param>
        /// <param name="contentname">Name of File (optional)</param>
        /// <param name="contenttype">mime/type of the content (optional)</param>
        /// <param name="contentdescription">Free text for description. Only plain text. (optional)</param>
        /// <param name="page">Requests for collections can return between 0 and N results, controlled using the per_page and page query parameters. All endpoints are limited to 10 results by default. (optional)</param>
        /// <param name="sort">The sorting is initiated by the sort query parameter and a list of comma separated list of fields to sort by. (optional)</param>
        /// <param name="fields">Comma separated list of field names (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <returns>Task of ApiResponse (List&lt;ContentItemEndpointType&gt;)</returns>
        System.Threading.Tasks.Task<ApiResponse<List<ContentItemEndpointType>>> GetContentItemsAsyncWithHttpInfo (string envelope = null, List<string> uid = null, List<string> contentname = null, List<string> contenttype = null, string contentdescription = null, int? page = null, string sort = null, List<string> fields = null, List<string> embed = null);
        /// <summary>
        /// Create a new content in the object storage
        /// </summary>
        /// <remarks>
        /// Create a new content in the object storage
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="newcontent">Content as multipart from-data</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="description">Description of content (optional) (optional)</param>
        /// <param name="i4lProcessUid">Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional)</param>
        /// <returns>Task of ContentItemEndpointType</returns>
        System.Threading.Tasks.Task<ContentItemEndpointType> NewContentItemAsync (System.IO.Stream newcontent, string envelope = null, string description = null, string i4lProcessUid = null);

        /// <summary>
        /// Create a new content in the object storage
        /// </summary>
        /// <remarks>
        /// Create a new content in the object storage
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="newcontent">Content as multipart from-data</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="description">Description of content (optional) (optional)</param>
        /// <param name="i4lProcessUid">Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional)</param>
        /// <returns>Task of ApiResponse (ContentItemEndpointType)</returns>
        System.Threading.Tasks.Task<ApiResponse<ContentItemEndpointType>> NewContentItemAsyncWithHttpInfo (System.IO.Stream newcontent, string envelope = null, string description = null, string i4lProcessUid = null);
        #endregion Asynchronous Operations
    }

    /// <summary>
    /// Represents a collection of functions to interact with the API endpoints
    /// </summary>
    public partial class ContentItemsApi : IContentItemsApi
    {
        private IO.Swagger.Client.ExceptionFactory _exceptionFactory = (name, response) => null;

        /// <summary>
        /// Initializes a new instance of the <see cref="ContentItemsApi"/> class.
        /// </summary>
        /// <returns></returns>
        public ContentItemsApi(String basePath)
        {
            this.Configuration = new Configuration { BasePath = basePath };

            ExceptionFactory = IO.Swagger.Client.Configuration.DefaultExceptionFactory;
        }

        /// <summary>
        /// Initializes a new instance of the <see cref="ContentItemsApi"/> class
        /// using Configuration object
        /// </summary>
        /// <param name="configuration">An instance of Configuration</param>
        /// <returns></returns>
        public ContentItemsApi(Configuration configuration = null)
        {
            if (configuration == null) // use the default one in Configuration
                this.Configuration = Configuration.Default;
            else
                this.Configuration = configuration;

            ExceptionFactory = IO.Swagger.Client.Configuration.DefaultExceptionFactory;
        }

        /// <summary>
        /// Gets the base path of the API client.
        /// </summary>
        /// <value>The base path</value>
        public String GetBasePath()
        {
            return this.Configuration.ApiClient.RestClient.BaseUrl.ToString();
        }

        /// <summary>
        /// Sets the base path of the API client.
        /// </summary>
        /// <value>The base path</value>
        [Obsolete("SetBasePath is deprecated, please do 'Configuration.ApiClient = new ApiClient(\"http://new-path\")' instead.")]
        public void SetBasePath(String basePath)
        {
            // do nothing
        }

        /// <summary>
        /// Gets or sets the configuration object
        /// </summary>
        /// <value>An instance of the Configuration</value>
        public Configuration Configuration {get; set;}

        /// <summary>
        /// Provides a factory method hook for the creation of exceptions.
        /// </summary>
        public IO.Swagger.Client.ExceptionFactory ExceptionFactory
        {
            get
            {
                if (_exceptionFactory != null && _exceptionFactory.GetInvocationList().Length > 1)
                {
                    throw new InvalidOperationException("Multicast delegate for ExceptionFactory is unsupported.");
                }
                return _exceptionFactory;
            }
            set { _exceptionFactory = value; }
        }

        /// <summary>
        /// Gets the default header.
        /// </summary>
        /// <returns>Dictionary of HTTP header</returns>
        [Obsolete("DefaultHeader is deprecated, please use Configuration.DefaultHeader instead.")]
        public IDictionary<String, String> DefaultHeader()
        {
            return new ReadOnlyDictionary<string, string>(this.Configuration.DefaultHeader);
        }

        /// <summary>
        /// Add default header.
        /// </summary>
        /// <param name="key">Header field name.</param>
        /// <param name="value">Header field value.</param>
        /// <returns></returns>
        [Obsolete("AddDefaultHeader is deprecated, please use Configuration.AddDefaultHeader instead.")]
        public void AddDefaultHeader(string key, string value)
        {
            this.Configuration.AddDefaultHeader(key, value);
        }

        /// <summary>
        /// Returns a single content from the object storage. Returns a single content from the object storage.
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="contentitemId">UID of the ContentItem</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <returns>System.IO.Stream</returns>
        public System.IO.Stream GetContentItem (string contentitemId, string envelope = null)
        {
             ApiResponse<System.IO.Stream> localVarResponse = GetContentItemWithHttpInfo(contentitemId, envelope);
             return localVarResponse.Data;
        }

        /// <summary>
        /// Returns a single content from the object storage. Returns a single content from the object storage.
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="contentitemId">UID of the ContentItem</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <returns>ApiResponse of System.IO.Stream</returns>
        public ApiResponse< System.IO.Stream > GetContentItemWithHttpInfo (string contentitemId, string envelope = null)
        {
            // verify the required parameter 'contentitemId' is set
            if (contentitemId == null)
                throw new ApiException(400, "Missing required parameter 'contentitemId' when calling ContentItemsApi->GetContentItem");

            var localVarPath = "/contentitems/{contentitem_id}";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "multipart/form-data"
            };
            String localVarHttpHeaderAccept = Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (contentitemId != null) localVarPathParams.Add("contentitem_id", Configuration.ApiClient.ParameterToString(contentitemId)); // path parameter
            if (envelope != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("", "envelope", envelope)); // query parameter


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) Configuration.ApiClient.CallApi(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("GetContentItem", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<System.IO.Stream>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (System.IO.Stream) Configuration.ApiClient.Deserialize(localVarResponse, typeof(System.IO.Stream)));
        }

        /// <summary>
        /// Returns a single content from the object storage. Returns a single content from the object storage.
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="contentitemId">UID of the ContentItem</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <returns>Task of System.IO.Stream</returns>
        public async System.Threading.Tasks.Task<System.IO.Stream> GetContentItemAsync (string contentitemId, string envelope = null)
        {
             ApiResponse<System.IO.Stream> localVarResponse = await GetContentItemAsyncWithHttpInfo(contentitemId, envelope);
             return localVarResponse.Data;

        }

        /// <summary>
        /// Returns a single content from the object storage. Returns a single content from the object storage.
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="contentitemId">UID of the ContentItem</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <returns>Task of ApiResponse (System.IO.Stream)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<System.IO.Stream>> GetContentItemAsyncWithHttpInfo (string contentitemId, string envelope = null)
        {
            // verify the required parameter 'contentitemId' is set
            if (contentitemId == null)
                throw new ApiException(400, "Missing required parameter 'contentitemId' when calling ContentItemsApi->GetContentItem");

            var localVarPath = "/contentitems/{contentitem_id}";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "multipart/form-data"
            };
            String localVarHttpHeaderAccept = Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (contentitemId != null) localVarPathParams.Add("contentitem_id", Configuration.ApiClient.ParameterToString(contentitemId)); // path parameter
            if (envelope != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("", "envelope", envelope)); // query parameter


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("GetContentItem", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<System.IO.Stream>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (System.IO.Stream) Configuration.ApiClient.Deserialize(localVarResponse, typeof(System.IO.Stream)));
        }

        /// <summary>
        /// Returns a list of contentitems Returns a list of contentitem metadata based on the filter criteria
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="uid">UID of a ContentItem (optional)</param>
        /// <param name="contentname">Name of File (optional)</param>
        /// <param name="contenttype">mime/type of the content (optional)</param>
        /// <param name="contentdescription">Free text for description. Only plain text. (optional)</param>
        /// <param name="page">Requests for collections can return between 0 and N results, controlled using the per_page and page query parameters. All endpoints are limited to 10 results by default. (optional)</param>
        /// <param name="sort">The sorting is initiated by the sort query parameter and a list of comma separated list of fields to sort by. (optional)</param>
        /// <param name="fields">Comma separated list of field names (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <returns>List&lt;ContentItemEndpointType&gt;</returns>
        public List<ContentItemEndpointType> GetContentItems (string envelope = null, List<string> uid = null, List<string> contentname = null, List<string> contenttype = null, string contentdescription = null, int? page = null, string sort = null, List<string> fields = null, List<string> embed = null)
        {
             ApiResponse<List<ContentItemEndpointType>> localVarResponse = GetContentItemsWithHttpInfo(envelope, uid, contentname, contenttype, contentdescription, page, sort, fields, embed);
             return localVarResponse.Data;
        }

        /// <summary>
        /// Returns a list of contentitems Returns a list of contentitem metadata based on the filter criteria
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="uid">UID of a ContentItem (optional)</param>
        /// <param name="contentname">Name of File (optional)</param>
        /// <param name="contenttype">mime/type of the content (optional)</param>
        /// <param name="contentdescription">Free text for description. Only plain text. (optional)</param>
        /// <param name="page">Requests for collections can return between 0 and N results, controlled using the per_page and page query parameters. All endpoints are limited to 10 results by default. (optional)</param>
        /// <param name="sort">The sorting is initiated by the sort query parameter and a list of comma separated list of fields to sort by. (optional)</param>
        /// <param name="fields">Comma separated list of field names (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <returns>ApiResponse of List&lt;ContentItemEndpointType&gt;</returns>
        public ApiResponse< List<ContentItemEndpointType> > GetContentItemsWithHttpInfo (string envelope = null, List<string> uid = null, List<string> contentname = null, List<string> contenttype = null, string contentdescription = null, int? page = null, string sort = null, List<string> fields = null, List<string> embed = null)
        {

            var localVarPath = "/contentitems";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (envelope != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("", "envelope", envelope)); // query parameter
            if (uid != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("csv", "uid", uid)); // query parameter
            if (contentname != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("csv", "contentname", contentname)); // query parameter
            if (contenttype != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("csv", "contenttype", contenttype)); // query parameter
            if (contentdescription != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("", "contentdescription", contentdescription)); // query parameter
            if (page != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("", "page", page)); // query parameter
            if (sort != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("", "sort", sort)); // query parameter
            if (fields != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("csv", "fields", fields)); // query parameter
            if (embed != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("csv", "embed", embed)); // query parameter


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) Configuration.ApiClient.CallApi(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("GetContentItems", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<List<ContentItemEndpointType>>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (List<ContentItemEndpointType>) Configuration.ApiClient.Deserialize(localVarResponse, typeof(List<ContentItemEndpointType>)));
        }

        /// <summary>
        /// Returns a list of contentitems Returns a list of contentitem metadata based on the filter criteria
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="uid">UID of a ContentItem (optional)</param>
        /// <param name="contentname">Name of File (optional)</param>
        /// <param name="contenttype">mime/type of the content (optional)</param>
        /// <param name="contentdescription">Free text for description. Only plain text. (optional)</param>
        /// <param name="page">Requests for collections can return between 0 and N results, controlled using the per_page and page query parameters. All endpoints are limited to 10 results by default. (optional)</param>
        /// <param name="sort">The sorting is initiated by the sort query parameter and a list of comma separated list of fields to sort by. (optional)</param>
        /// <param name="fields">Comma separated list of field names (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <returns>Task of List&lt;ContentItemEndpointType&gt;</returns>
        public async System.Threading.Tasks.Task<List<ContentItemEndpointType>> GetContentItemsAsync (string envelope = null, List<string> uid = null, List<string> contentname = null, List<string> contenttype = null, string contentdescription = null, int? page = null, string sort = null, List<string> fields = null, List<string> embed = null)
        {
             ApiResponse<List<ContentItemEndpointType>> localVarResponse = await GetContentItemsAsyncWithHttpInfo(envelope, uid, contentname, contenttype, contentdescription, page, sort, fields, embed);
             return localVarResponse.Data;

        }

        /// <summary>
        /// Returns a list of contentitems Returns a list of contentitem metadata based on the filter criteria
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="uid">UID of a ContentItem (optional)</param>
        /// <param name="contentname">Name of File (optional)</param>
        /// <param name="contenttype">mime/type of the content (optional)</param>
        /// <param name="contentdescription">Free text for description. Only plain text. (optional)</param>
        /// <param name="page">Requests for collections can return between 0 and N results, controlled using the per_page and page query parameters. All endpoints are limited to 10 results by default. (optional)</param>
        /// <param name="sort">The sorting is initiated by the sort query parameter and a list of comma separated list of fields to sort by. (optional)</param>
        /// <param name="fields">Comma separated list of field names (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <returns>Task of ApiResponse (List&lt;ContentItemEndpointType&gt;)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<List<ContentItemEndpointType>>> GetContentItemsAsyncWithHttpInfo (string envelope = null, List<string> uid = null, List<string> contentname = null, List<string> contenttype = null, string contentdescription = null, int? page = null, string sort = null, List<string> fields = null, List<string> embed = null)
        {

            var localVarPath = "/contentitems";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (envelope != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("", "envelope", envelope)); // query parameter
            if (uid != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("csv", "uid", uid)); // query parameter
            if (contentname != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("csv", "contentname", contentname)); // query parameter
            if (contenttype != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("csv", "contenttype", contenttype)); // query parameter
            if (contentdescription != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("", "contentdescription", contentdescription)); // query parameter
            if (page != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("", "page", page)); // query parameter
            if (sort != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("", "sort", sort)); // query parameter
            if (fields != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("csv", "fields", fields)); // query parameter
            if (embed != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("csv", "embed", embed)); // query parameter


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("GetContentItems", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<List<ContentItemEndpointType>>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (List<ContentItemEndpointType>) Configuration.ApiClient.Deserialize(localVarResponse, typeof(List<ContentItemEndpointType>)));
        }

        /// <summary>
        /// Create a new content in the object storage Create a new content in the object storage
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="newcontent">Content as multipart from-data</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="description">Description of content (optional) (optional)</param>
        /// <param name="i4lProcessUid">Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional)</param>
        /// <returns>ContentItemEndpointType</returns>
        public ContentItemEndpointType NewContentItem (System.IO.Stream newcontent, string envelope = null, string description = null, string i4lProcessUid = null)
        {
             ApiResponse<ContentItemEndpointType> localVarResponse = NewContentItemWithHttpInfo(newcontent, envelope, description, i4lProcessUid);
             return localVarResponse.Data;
        }

        /// <summary>
        /// Create a new content in the object storage Create a new content in the object storage
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="newcontent">Content as multipart from-data</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="description">Description of content (optional) (optional)</param>
        /// <param name="i4lProcessUid">Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional)</param>
        /// <returns>ApiResponse of ContentItemEndpointType</returns>
        public ApiResponse< ContentItemEndpointType > NewContentItemWithHttpInfo (System.IO.Stream newcontent, string envelope = null, string description = null, string i4lProcessUid = null)
        {
            // verify the required parameter 'newcontent' is set
            if (newcontent == null)
                throw new ApiException(400, "Missing required parameter 'newcontent' when calling ContentItemsApi->NewContentItem");

            var localVarPath = "/contentitems";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "multipart/form-data"
            };
            String localVarHttpContentType = Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (envelope != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("", "envelope", envelope)); // query parameter
            if (i4lProcessUid != null) localVarHeaderParams.Add("i4l-process-uid", Configuration.ApiClient.ParameterToString(i4lProcessUid)); // header parameter
            if (newcontent != null) localVarFileParams.Add("newcontent", Configuration.ApiClient.ParameterToFile("newcontent", newcontent));
            if (description != null) localVarFormParams.Add("description", Configuration.ApiClient.ParameterToString(description)); // form parameter


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) Configuration.ApiClient.CallApi(localVarPath,
                Method.POST, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("NewContentItem", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<ContentItemEndpointType>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (ContentItemEndpointType) Configuration.ApiClient.Deserialize(localVarResponse, typeof(ContentItemEndpointType)));
        }

        /// <summary>
        /// Create a new content in the object storage Create a new content in the object storage
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="newcontent">Content as multipart from-data</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="description">Description of content (optional) (optional)</param>
        /// <param name="i4lProcessUid">Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional)</param>
        /// <returns>Task of ContentItemEndpointType</returns>
        public async System.Threading.Tasks.Task<ContentItemEndpointType> NewContentItemAsync (System.IO.Stream newcontent, string envelope = null, string description = null, string i4lProcessUid = null)
        {
             ApiResponse<ContentItemEndpointType> localVarResponse = await NewContentItemAsyncWithHttpInfo(newcontent, envelope, description, i4lProcessUid);
             return localVarResponse.Data;

        }

        /// <summary>
        /// Create a new content in the object storage Create a new content in the object storage
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="newcontent">Content as multipart from-data</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="description">Description of content (optional) (optional)</param>
        /// <param name="i4lProcessUid">Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional)</param>
        /// <returns>Task of ApiResponse (ContentItemEndpointType)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<ContentItemEndpointType>> NewContentItemAsyncWithHttpInfo (System.IO.Stream newcontent, string envelope = null, string description = null, string i4lProcessUid = null)
        {
            // verify the required parameter 'newcontent' is set
            if (newcontent == null)
                throw new ApiException(400, "Missing required parameter 'newcontent' when calling ContentItemsApi->NewContentItem");

            var localVarPath = "/contentitems";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "multipart/form-data"
            };
            String localVarHttpContentType = Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (envelope != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("", "envelope", envelope)); // query parameter
            if (i4lProcessUid != null) localVarHeaderParams.Add("i4l-process-uid", Configuration.ApiClient.ParameterToString(i4lProcessUid)); // header parameter
            if (newcontent != null) localVarFileParams.Add("newcontent", Configuration.ApiClient.ParameterToFile("newcontent", newcontent));
            if (description != null) localVarFormParams.Add("description", Configuration.ApiClient.ParameterToString(description)); // form parameter


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.POST, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("NewContentItem", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<ContentItemEndpointType>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (ContentItemEndpointType) Configuration.ApiClient.Deserialize(localVarResponse, typeof(ContentItemEndpointType)));
        }

    }
}
