/* 
 * its4land Public API
 *
 * The its4land Public API provides access to the services of the its4land Publish and Share platform.
 *
 * OpenAPI spec version: 0.0.2
 * Contact: contact@its4land.com
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */

using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using RestSharp;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace IO.Swagger.Api
{
    /// <summary>
    /// Represents a collection of functions to interact with the API endpoints
    /// </summary>
    public interface IModelClassesApi : IApiAccessor
    {
        #region Synchronous Operations
        /// <summary>
        /// Returns ModelClasses
        /// </summary>
        /// <remarks>
        /// Returns ModelClasses
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="UID">Comma separated list of ModelClasses UID (optional)</param>
        /// <param name="nameinmodel">Comma separated list of ModelClasses names (optional)</param>
        /// <param name="conceptname">Comma separated list of ModelClasses concept names (optional)</param>
        /// <param name="page">Requests for collections can return between 0 and N results, controlled using the per_page and page query parameters. All endpoints are limited to 10 results by default. (optional)</param>
        /// <param name="sort">The sorting is initiated by the sort query parameter and a list of comma separated list of fields to sort by. (optional)</param>
        /// <param name="fields">Comma separated list of field names (optional)</param>
        /// <returns>List&lt;ModelClassesEndpointType&gt;</returns>
        List<ModelClassesEndpointType> GetModelClasses (string envelope = null, List<string> UID = null, List<string> nameinmodel = null, List<string> conceptname = null, int? page = null, string sort = null, List<string> fields = null);

        /// <summary>
        /// Returns ModelClasses
        /// </summary>
        /// <remarks>
        /// Returns ModelClasses
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="UID">Comma separated list of ModelClasses UID (optional)</param>
        /// <param name="nameinmodel">Comma separated list of ModelClasses names (optional)</param>
        /// <param name="conceptname">Comma separated list of ModelClasses concept names (optional)</param>
        /// <param name="page">Requests for collections can return between 0 and N results, controlled using the per_page and page query parameters. All endpoints are limited to 10 results by default. (optional)</param>
        /// <param name="sort">The sorting is initiated by the sort query parameter and a list of comma separated list of fields to sort by. (optional)</param>
        /// <param name="fields">Comma separated list of field names (optional)</param>
        /// <returns>ApiResponse of List&lt;ModelClassesEndpointType&gt;</returns>
        ApiResponse<List<ModelClassesEndpointType>> GetModelClassesWithHttpInfo (string envelope = null, List<string> UID = null, List<string> nameinmodel = null, List<string> conceptname = null, int? page = null, string sort = null, List<string> fields = null);
        /// <summary>
        /// Returns a single model class
        /// </summary>
        /// <remarks>
        /// Returns a single model class
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="modelclassesUid">ModelClass UID</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <returns>ModelClassesEndpointType</returns>
        ModelClassesEndpointType GetModelClassesByUID (string modelclassesUid, string envelope = null);

        /// <summary>
        /// Returns a single model class
        /// </summary>
        /// <remarks>
        /// Returns a single model class
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="modelclassesUid">ModelClass UID</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <returns>ApiResponse of ModelClassesEndpointType</returns>
        ApiResponse<ModelClassesEndpointType> GetModelClassesByUIDWithHttpInfo (string modelclassesUid, string envelope = null);
        /// <summary>
        /// Updates some attributes of a ModelClass
        /// </summary>
        /// <remarks>
        /// Updates some attributes of a ModelClass
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="modelclassesUid">ModelClass UID</param>
        /// <param name="patchmodelclasses">Update data</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="i4lProcessUid">Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional)</param>
        /// <returns>ModelClassesEndpointType</returns>
        ModelClassesEndpointType UpdateModelClasses (string modelclassesUid, RFC6902PatchRequest patchmodelclasses, string envelope = null, string i4lProcessUid = null);

        /// <summary>
        /// Updates some attributes of a ModelClass
        /// </summary>
        /// <remarks>
        /// Updates some attributes of a ModelClass
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="modelclassesUid">ModelClass UID</param>
        /// <param name="patchmodelclasses">Update data</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="i4lProcessUid">Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional)</param>
        /// <returns>ApiResponse of ModelClassesEndpointType</returns>
        ApiResponse<ModelClassesEndpointType> UpdateModelClassesWithHttpInfo (string modelclassesUid, RFC6902PatchRequest patchmodelclasses, string envelope = null, string i4lProcessUid = null);
        #endregion Synchronous Operations
        #region Asynchronous Operations
        /// <summary>
        /// Returns ModelClasses
        /// </summary>
        /// <remarks>
        /// Returns ModelClasses
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="UID">Comma separated list of ModelClasses UID (optional)</param>
        /// <param name="nameinmodel">Comma separated list of ModelClasses names (optional)</param>
        /// <param name="conceptname">Comma separated list of ModelClasses concept names (optional)</param>
        /// <param name="page">Requests for collections can return between 0 and N results, controlled using the per_page and page query parameters. All endpoints are limited to 10 results by default. (optional)</param>
        /// <param name="sort">The sorting is initiated by the sort query parameter and a list of comma separated list of fields to sort by. (optional)</param>
        /// <param name="fields">Comma separated list of field names (optional)</param>
        /// <returns>Task of List&lt;ModelClassesEndpointType&gt;</returns>
        System.Threading.Tasks.Task<List<ModelClassesEndpointType>> GetModelClassesAsync (string envelope = null, List<string> UID = null, List<string> nameinmodel = null, List<string> conceptname = null, int? page = null, string sort = null, List<string> fields = null);

        /// <summary>
        /// Returns ModelClasses
        /// </summary>
        /// <remarks>
        /// Returns ModelClasses
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="UID">Comma separated list of ModelClasses UID (optional)</param>
        /// <param name="nameinmodel">Comma separated list of ModelClasses names (optional)</param>
        /// <param name="conceptname">Comma separated list of ModelClasses concept names (optional)</param>
        /// <param name="page">Requests for collections can return between 0 and N results, controlled using the per_page and page query parameters. All endpoints are limited to 10 results by default. (optional)</param>
        /// <param name="sort">The sorting is initiated by the sort query parameter and a list of comma separated list of fields to sort by. (optional)</param>
        /// <param name="fields">Comma separated list of field names (optional)</param>
        /// <returns>Task of ApiResponse (List&lt;ModelClassesEndpointType&gt;)</returns>
        System.Threading.Tasks.Task<ApiResponse<List<ModelClassesEndpointType>>> GetModelClassesAsyncWithHttpInfo (string envelope = null, List<string> UID = null, List<string> nameinmodel = null, List<string> conceptname = null, int? page = null, string sort = null, List<string> fields = null);
        /// <summary>
        /// Returns a single model class
        /// </summary>
        /// <remarks>
        /// Returns a single model class
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="modelclassesUid">ModelClass UID</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <returns>Task of ModelClassesEndpointType</returns>
        System.Threading.Tasks.Task<ModelClassesEndpointType> GetModelClassesByUIDAsync (string modelclassesUid, string envelope = null);

        /// <summary>
        /// Returns a single model class
        /// </summary>
        /// <remarks>
        /// Returns a single model class
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="modelclassesUid">ModelClass UID</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <returns>Task of ApiResponse (ModelClassesEndpointType)</returns>
        System.Threading.Tasks.Task<ApiResponse<ModelClassesEndpointType>> GetModelClassesByUIDAsyncWithHttpInfo (string modelclassesUid, string envelope = null);
        /// <summary>
        /// Updates some attributes of a ModelClass
        /// </summary>
        /// <remarks>
        /// Updates some attributes of a ModelClass
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="modelclassesUid">ModelClass UID</param>
        /// <param name="patchmodelclasses">Update data</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="i4lProcessUid">Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional)</param>
        /// <returns>Task of ModelClassesEndpointType</returns>
        System.Threading.Tasks.Task<ModelClassesEndpointType> UpdateModelClassesAsync (string modelclassesUid, RFC6902PatchRequest patchmodelclasses, string envelope = null, string i4lProcessUid = null);

        /// <summary>
        /// Updates some attributes of a ModelClass
        /// </summary>
        /// <remarks>
        /// Updates some attributes of a ModelClass
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="modelclassesUid">ModelClass UID</param>
        /// <param name="patchmodelclasses">Update data</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="i4lProcessUid">Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional)</param>
        /// <returns>Task of ApiResponse (ModelClassesEndpointType)</returns>
        System.Threading.Tasks.Task<ApiResponse<ModelClassesEndpointType>> UpdateModelClassesAsyncWithHttpInfo (string modelclassesUid, RFC6902PatchRequest patchmodelclasses, string envelope = null, string i4lProcessUid = null);
        #endregion Asynchronous Operations
    }

    /// <summary>
    /// Represents a collection of functions to interact with the API endpoints
    /// </summary>
    public partial class ModelClassesApi : IModelClassesApi
    {
        private IO.Swagger.Client.ExceptionFactory _exceptionFactory = (name, response) => null;

        /// <summary>
        /// Initializes a new instance of the <see cref="ModelClassesApi"/> class.
        /// </summary>
        /// <returns></returns>
        public ModelClassesApi(String basePath)
        {
            this.Configuration = new Configuration { BasePath = basePath };

            ExceptionFactory = IO.Swagger.Client.Configuration.DefaultExceptionFactory;
        }

        /// <summary>
        /// Initializes a new instance of the <see cref="ModelClassesApi"/> class
        /// using Configuration object
        /// </summary>
        /// <param name="configuration">An instance of Configuration</param>
        /// <returns></returns>
        public ModelClassesApi(Configuration configuration = null)
        {
            if (configuration == null) // use the default one in Configuration
                this.Configuration = Configuration.Default;
            else
                this.Configuration = configuration;

            ExceptionFactory = IO.Swagger.Client.Configuration.DefaultExceptionFactory;
        }

        /// <summary>
        /// Gets the base path of the API client.
        /// </summary>
        /// <value>The base path</value>
        public String GetBasePath()
        {
            return this.Configuration.ApiClient.RestClient.BaseUrl.ToString();
        }

        /// <summary>
        /// Sets the base path of the API client.
        /// </summary>
        /// <value>The base path</value>
        [Obsolete("SetBasePath is deprecated, please do 'Configuration.ApiClient = new ApiClient(\"http://new-path\")' instead.")]
        public void SetBasePath(String basePath)
        {
            // do nothing
        }

        /// <summary>
        /// Gets or sets the configuration object
        /// </summary>
        /// <value>An instance of the Configuration</value>
        public Configuration Configuration {get; set;}

        /// <summary>
        /// Provides a factory method hook for the creation of exceptions.
        /// </summary>
        public IO.Swagger.Client.ExceptionFactory ExceptionFactory
        {
            get
            {
                if (_exceptionFactory != null && _exceptionFactory.GetInvocationList().Length > 1)
                {
                    throw new InvalidOperationException("Multicast delegate for ExceptionFactory is unsupported.");
                }
                return _exceptionFactory;
            }
            set { _exceptionFactory = value; }
        }

        /// <summary>
        /// Gets the default header.
        /// </summary>
        /// <returns>Dictionary of HTTP header</returns>
        [Obsolete("DefaultHeader is deprecated, please use Configuration.DefaultHeader instead.")]
        public IDictionary<String, String> DefaultHeader()
        {
            return new ReadOnlyDictionary<string, string>(this.Configuration.DefaultHeader);
        }

        /// <summary>
        /// Add default header.
        /// </summary>
        /// <param name="key">Header field name.</param>
        /// <param name="value">Header field value.</param>
        /// <returns></returns>
        [Obsolete("AddDefaultHeader is deprecated, please use Configuration.AddDefaultHeader instead.")]
        public void AddDefaultHeader(string key, string value)
        {
            this.Configuration.AddDefaultHeader(key, value);
        }

        /// <summary>
        /// Returns ModelClasses Returns ModelClasses
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="UID">Comma separated list of ModelClasses UID (optional)</param>
        /// <param name="nameinmodel">Comma separated list of ModelClasses names (optional)</param>
        /// <param name="conceptname">Comma separated list of ModelClasses concept names (optional)</param>
        /// <param name="page">Requests for collections can return between 0 and N results, controlled using the per_page and page query parameters. All endpoints are limited to 10 results by default. (optional)</param>
        /// <param name="sort">The sorting is initiated by the sort query parameter and a list of comma separated list of fields to sort by. (optional)</param>
        /// <param name="fields">Comma separated list of field names (optional)</param>
        /// <returns>List&lt;ModelClassesEndpointType&gt;</returns>
        public List<ModelClassesEndpointType> GetModelClasses (string envelope = null, List<string> UID = null, List<string> nameinmodel = null, List<string> conceptname = null, int? page = null, string sort = null, List<string> fields = null)
        {
             ApiResponse<List<ModelClassesEndpointType>> localVarResponse = GetModelClassesWithHttpInfo(envelope, UID, nameinmodel, conceptname, page, sort, fields);
             return localVarResponse.Data;
        }

        /// <summary>
        /// Returns ModelClasses Returns ModelClasses
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="UID">Comma separated list of ModelClasses UID (optional)</param>
        /// <param name="nameinmodel">Comma separated list of ModelClasses names (optional)</param>
        /// <param name="conceptname">Comma separated list of ModelClasses concept names (optional)</param>
        /// <param name="page">Requests for collections can return between 0 and N results, controlled using the per_page and page query parameters. All endpoints are limited to 10 results by default. (optional)</param>
        /// <param name="sort">The sorting is initiated by the sort query parameter and a list of comma separated list of fields to sort by. (optional)</param>
        /// <param name="fields">Comma separated list of field names (optional)</param>
        /// <returns>ApiResponse of List&lt;ModelClassesEndpointType&gt;</returns>
        public ApiResponse< List<ModelClassesEndpointType> > GetModelClassesWithHttpInfo (string envelope = null, List<string> UID = null, List<string> nameinmodel = null, List<string> conceptname = null, int? page = null, string sort = null, List<string> fields = null)
        {

            var localVarPath = "/modelclasses";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (envelope != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("", "envelope", envelope)); // query parameter
            if (UID != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("csv", "UID", UID)); // query parameter
            if (nameinmodel != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("csv", "nameinmodel", nameinmodel)); // query parameter
            if (conceptname != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("csv", "conceptname", conceptname)); // query parameter
            if (page != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("", "page", page)); // query parameter
            if (sort != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("", "sort", sort)); // query parameter
            if (fields != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("csv", "fields", fields)); // query parameter


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) Configuration.ApiClient.CallApi(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("GetModelClasses", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<List<ModelClassesEndpointType>>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (List<ModelClassesEndpointType>) Configuration.ApiClient.Deserialize(localVarResponse, typeof(List<ModelClassesEndpointType>)));
        }

        /// <summary>
        /// Returns ModelClasses Returns ModelClasses
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="UID">Comma separated list of ModelClasses UID (optional)</param>
        /// <param name="nameinmodel">Comma separated list of ModelClasses names (optional)</param>
        /// <param name="conceptname">Comma separated list of ModelClasses concept names (optional)</param>
        /// <param name="page">Requests for collections can return between 0 and N results, controlled using the per_page and page query parameters. All endpoints are limited to 10 results by default. (optional)</param>
        /// <param name="sort">The sorting is initiated by the sort query parameter and a list of comma separated list of fields to sort by. (optional)</param>
        /// <param name="fields">Comma separated list of field names (optional)</param>
        /// <returns>Task of List&lt;ModelClassesEndpointType&gt;</returns>
        public async System.Threading.Tasks.Task<List<ModelClassesEndpointType>> GetModelClassesAsync (string envelope = null, List<string> UID = null, List<string> nameinmodel = null, List<string> conceptname = null, int? page = null, string sort = null, List<string> fields = null)
        {
             ApiResponse<List<ModelClassesEndpointType>> localVarResponse = await GetModelClassesAsyncWithHttpInfo(envelope, UID, nameinmodel, conceptname, page, sort, fields);
             return localVarResponse.Data;

        }

        /// <summary>
        /// Returns ModelClasses Returns ModelClasses
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="UID">Comma separated list of ModelClasses UID (optional)</param>
        /// <param name="nameinmodel">Comma separated list of ModelClasses names (optional)</param>
        /// <param name="conceptname">Comma separated list of ModelClasses concept names (optional)</param>
        /// <param name="page">Requests for collections can return between 0 and N results, controlled using the per_page and page query parameters. All endpoints are limited to 10 results by default. (optional)</param>
        /// <param name="sort">The sorting is initiated by the sort query parameter and a list of comma separated list of fields to sort by. (optional)</param>
        /// <param name="fields">Comma separated list of field names (optional)</param>
        /// <returns>Task of ApiResponse (List&lt;ModelClassesEndpointType&gt;)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<List<ModelClassesEndpointType>>> GetModelClassesAsyncWithHttpInfo (string envelope = null, List<string> UID = null, List<string> nameinmodel = null, List<string> conceptname = null, int? page = null, string sort = null, List<string> fields = null)
        {

            var localVarPath = "/modelclasses";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (envelope != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("", "envelope", envelope)); // query parameter
            if (UID != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("csv", "UID", UID)); // query parameter
            if (nameinmodel != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("csv", "nameinmodel", nameinmodel)); // query parameter
            if (conceptname != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("csv", "conceptname", conceptname)); // query parameter
            if (page != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("", "page", page)); // query parameter
            if (sort != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("", "sort", sort)); // query parameter
            if (fields != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("csv", "fields", fields)); // query parameter


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("GetModelClasses", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<List<ModelClassesEndpointType>>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (List<ModelClassesEndpointType>) Configuration.ApiClient.Deserialize(localVarResponse, typeof(List<ModelClassesEndpointType>)));
        }

        /// <summary>
        /// Returns a single model class Returns a single model class
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="modelclassesUid">ModelClass UID</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <returns>ModelClassesEndpointType</returns>
        public ModelClassesEndpointType GetModelClassesByUID (string modelclassesUid, string envelope = null)
        {
             ApiResponse<ModelClassesEndpointType> localVarResponse = GetModelClassesByUIDWithHttpInfo(modelclassesUid, envelope);
             return localVarResponse.Data;
        }

        /// <summary>
        /// Returns a single model class Returns a single model class
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="modelclassesUid">ModelClass UID</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <returns>ApiResponse of ModelClassesEndpointType</returns>
        public ApiResponse< ModelClassesEndpointType > GetModelClassesByUIDWithHttpInfo (string modelclassesUid, string envelope = null)
        {
            // verify the required parameter 'modelclassesUid' is set
            if (modelclassesUid == null)
                throw new ApiException(400, "Missing required parameter 'modelclassesUid' when calling ModelClassesApi->GetModelClassesByUID");

            var localVarPath = "/modelclasses/{modelclasses_uid}";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (modelclassesUid != null) localVarPathParams.Add("modelclasses_uid", Configuration.ApiClient.ParameterToString(modelclassesUid)); // path parameter
            if (envelope != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("", "envelope", envelope)); // query parameter


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) Configuration.ApiClient.CallApi(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("GetModelClassesByUID", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<ModelClassesEndpointType>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (ModelClassesEndpointType) Configuration.ApiClient.Deserialize(localVarResponse, typeof(ModelClassesEndpointType)));
        }

        /// <summary>
        /// Returns a single model class Returns a single model class
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="modelclassesUid">ModelClass UID</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <returns>Task of ModelClassesEndpointType</returns>
        public async System.Threading.Tasks.Task<ModelClassesEndpointType> GetModelClassesByUIDAsync (string modelclassesUid, string envelope = null)
        {
             ApiResponse<ModelClassesEndpointType> localVarResponse = await GetModelClassesByUIDAsyncWithHttpInfo(modelclassesUid, envelope);
             return localVarResponse.Data;

        }

        /// <summary>
        /// Returns a single model class Returns a single model class
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="modelclassesUid">ModelClass UID</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <returns>Task of ApiResponse (ModelClassesEndpointType)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<ModelClassesEndpointType>> GetModelClassesByUIDAsyncWithHttpInfo (string modelclassesUid, string envelope = null)
        {
            // verify the required parameter 'modelclassesUid' is set
            if (modelclassesUid == null)
                throw new ApiException(400, "Missing required parameter 'modelclassesUid' when calling ModelClassesApi->GetModelClassesByUID");

            var localVarPath = "/modelclasses/{modelclasses_uid}";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (modelclassesUid != null) localVarPathParams.Add("modelclasses_uid", Configuration.ApiClient.ParameterToString(modelclassesUid)); // path parameter
            if (envelope != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("", "envelope", envelope)); // query parameter


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("GetModelClassesByUID", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<ModelClassesEndpointType>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (ModelClassesEndpointType) Configuration.ApiClient.Deserialize(localVarResponse, typeof(ModelClassesEndpointType)));
        }

        /// <summary>
        /// Updates some attributes of a ModelClass Updates some attributes of a ModelClass
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="modelclassesUid">ModelClass UID</param>
        /// <param name="patchmodelclasses">Update data</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="i4lProcessUid">Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional)</param>
        /// <returns>ModelClassesEndpointType</returns>
        public ModelClassesEndpointType UpdateModelClasses (string modelclassesUid, RFC6902PatchRequest patchmodelclasses, string envelope = null, string i4lProcessUid = null)
        {
             ApiResponse<ModelClassesEndpointType> localVarResponse = UpdateModelClassesWithHttpInfo(modelclassesUid, patchmodelclasses, envelope, i4lProcessUid);
             return localVarResponse.Data;
        }

        /// <summary>
        /// Updates some attributes of a ModelClass Updates some attributes of a ModelClass
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="modelclassesUid">ModelClass UID</param>
        /// <param name="patchmodelclasses">Update data</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="i4lProcessUid">Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional)</param>
        /// <returns>ApiResponse of ModelClassesEndpointType</returns>
        public ApiResponse< ModelClassesEndpointType > UpdateModelClassesWithHttpInfo (string modelclassesUid, RFC6902PatchRequest patchmodelclasses, string envelope = null, string i4lProcessUid = null)
        {
            // verify the required parameter 'modelclassesUid' is set
            if (modelclassesUid == null)
                throw new ApiException(400, "Missing required parameter 'modelclassesUid' when calling ModelClassesApi->UpdateModelClasses");
            // verify the required parameter 'patchmodelclasses' is set
            if (patchmodelclasses == null)
                throw new ApiException(400, "Missing required parameter 'patchmodelclasses' when calling ModelClassesApi->UpdateModelClasses");

            var localVarPath = "/modelclasses/{modelclasses_uid}";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/json"
            };
            String localVarHttpContentType = Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (modelclassesUid != null) localVarPathParams.Add("modelclasses_uid", Configuration.ApiClient.ParameterToString(modelclassesUid)); // path parameter
            if (envelope != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("", "envelope", envelope)); // query parameter
            if (i4lProcessUid != null) localVarHeaderParams.Add("i4l-process-uid", Configuration.ApiClient.ParameterToString(i4lProcessUid)); // header parameter
            if (patchmodelclasses != null && patchmodelclasses.GetType() != typeof(byte[]))
            {
                localVarPostBody = Configuration.ApiClient.Serialize(patchmodelclasses); // http body (model) parameter
            }
            else
            {
                localVarPostBody = patchmodelclasses; // byte array
            }


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) Configuration.ApiClient.CallApi(localVarPath,
                Method.PATCH, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("UpdateModelClasses", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<ModelClassesEndpointType>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (ModelClassesEndpointType) Configuration.ApiClient.Deserialize(localVarResponse, typeof(ModelClassesEndpointType)));
        }

        /// <summary>
        /// Updates some attributes of a ModelClass Updates some attributes of a ModelClass
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="modelclassesUid">ModelClass UID</param>
        /// <param name="patchmodelclasses">Update data</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="i4lProcessUid">Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional)</param>
        /// <returns>Task of ModelClassesEndpointType</returns>
        public async System.Threading.Tasks.Task<ModelClassesEndpointType> UpdateModelClassesAsync (string modelclassesUid, RFC6902PatchRequest patchmodelclasses, string envelope = null, string i4lProcessUid = null)
        {
             ApiResponse<ModelClassesEndpointType> localVarResponse = await UpdateModelClassesAsyncWithHttpInfo(modelclassesUid, patchmodelclasses, envelope, i4lProcessUid);
             return localVarResponse.Data;

        }

        /// <summary>
        /// Updates some attributes of a ModelClass Updates some attributes of a ModelClass
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="modelclassesUid">ModelClass UID</param>
        /// <param name="patchmodelclasses">Update data</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="i4lProcessUid">Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional)</param>
        /// <returns>Task of ApiResponse (ModelClassesEndpointType)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<ModelClassesEndpointType>> UpdateModelClassesAsyncWithHttpInfo (string modelclassesUid, RFC6902PatchRequest patchmodelclasses, string envelope = null, string i4lProcessUid = null)
        {
            // verify the required parameter 'modelclassesUid' is set
            if (modelclassesUid == null)
                throw new ApiException(400, "Missing required parameter 'modelclassesUid' when calling ModelClassesApi->UpdateModelClasses");
            // verify the required parameter 'patchmodelclasses' is set
            if (patchmodelclasses == null)
                throw new ApiException(400, "Missing required parameter 'patchmodelclasses' when calling ModelClassesApi->UpdateModelClasses");

            var localVarPath = "/modelclasses/{modelclasses_uid}";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/json"
            };
            String localVarHttpContentType = Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (modelclassesUid != null) localVarPathParams.Add("modelclasses_uid", Configuration.ApiClient.ParameterToString(modelclassesUid)); // path parameter
            if (envelope != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("", "envelope", envelope)); // query parameter
            if (i4lProcessUid != null) localVarHeaderParams.Add("i4l-process-uid", Configuration.ApiClient.ParameterToString(i4lProcessUid)); // header parameter
            if (patchmodelclasses != null && patchmodelclasses.GetType() != typeof(byte[]))
            {
                localVarPostBody = Configuration.ApiClient.Serialize(patchmodelclasses); // http body (model) parameter
            }
            else
            {
                localVarPostBody = patchmodelclasses; // byte array
            }


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.PATCH, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("UpdateModelClasses", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<ModelClassesEndpointType>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (ModelClassesEndpointType) Configuration.ApiClient.Deserialize(localVarResponse, typeof(ModelClassesEndpointType)));
        }

    }
}
