/* 
 * its4land Public API
 *
 * The its4land Public API provides access to the services of the its4land Publish and Share platform.
 *
 * OpenAPI spec version: 0.0.2
 * Contact: contact@its4land.com
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */

using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System.ComponentModel.DataAnnotations;
using SwaggerDateConverter = IO.Swagger.Client.SwaggerDateConverter;

namespace IO.Swagger.Model
{
    /// <summary>
    /// AdditionalDocumentsPost
    /// </summary>
    [DataContract]
    public partial class AdditionalDocumentsPost :  IEquatable<AdditionalDocumentsPost>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="AdditionalDocumentsPost" /> class.
        /// </summary>
        /// <param name="Type">Type of the additional document..</param>
        /// <param name="Description">Free text for description. Only plain text..</param>
        /// <param name="ContentItem">UID of the ContentItem.</param>
        public AdditionalDocumentsPost(string Type = default(string), string Description = default(string), string ContentItem = default(string))
        {
            this.Type = Type;
            this.Description = Description;
            this.ContentItem = ContentItem;
        }
        
        /// <summary>
        /// Type of the additional document.
        /// </summary>
        /// <value>Type of the additional document.</value>
        [DataMember(Name="Type", EmitDefaultValue=false)]
        public string Type { get; set; }

        /// <summary>
        /// Free text for description. Only plain text.
        /// </summary>
        /// <value>Free text for description. Only plain text.</value>
        [DataMember(Name="Description", EmitDefaultValue=false)]
        public string Description { get; set; }

        /// <summary>
        /// UID of the ContentItem
        /// </summary>
        /// <value>UID of the ContentItem</value>
        [DataMember(Name="ContentItem", EmitDefaultValue=false)]
        public string ContentItem { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class AdditionalDocumentsPost {\n");
            sb.Append("  Type: ").Append(Type).Append("\n");
            sb.Append("  Description: ").Append(Description).Append("\n");
            sb.Append("  ContentItem: ").Append(ContentItem).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as AdditionalDocumentsPost);
        }

        /// <summary>
        /// Returns true if AdditionalDocumentsPost instances are equal
        /// </summary>
        /// <param name="input">Instance of AdditionalDocumentsPost to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(AdditionalDocumentsPost input)
        {
            if (input == null)
                return false;

            return 
                (
                    this.Type == input.Type ||
                    (this.Type != null &&
                    this.Type.Equals(input.Type))
                ) && 
                (
                    this.Description == input.Description ||
                    (this.Description != null &&
                    this.Description.Equals(input.Description))
                ) && 
                (
                    this.ContentItem == input.ContentItem ||
                    (this.ContentItem != null &&
                    this.ContentItem.Equals(input.ContentItem))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.Type != null)
                    hashCode = hashCode * 59 + this.Type.GetHashCode();
                if (this.Description != null)
                    hashCode = hashCode * 59 + this.Description.GetHashCode();
                if (this.ContentItem != null)
                    hashCode = hashCode * 59 + this.ContentItem.GetHashCode();
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }

}
