/* 
 * its4land Public API
 *
 * The its4land Public API provides access to the services of the its4land Publish and Share platform.
 *
 * OpenAPI spec version: 0.0.2
 * Contact: contact@its4land.com
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */

using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System.ComponentModel.DataAnnotations;
using SwaggerDateConverter = IO.Swagger.Client.SwaggerDateConverter;

namespace IO.Swagger.Model
{
    /// <summary>
    /// MetricMapFeaturesEndpointTypeProperties
    /// </summary>
    [DataContract]
    public partial class MetricMapFeaturesEndpointTypeProperties :  IEquatable<MetricMapFeaturesEndpointTypeProperties>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="MetricMapFeaturesEndpointTypeProperties" /> class.
        /// </summary>
        /// <param name="UID">UUID.</param>
        /// <param name="Fgroup">Name of the feature group.</param>
        /// <param name="Ftype">Name of the feature type.</param>
        /// <param name="Fsubtype">Name of the feature subtype.</param>
        /// <param name="Fname">Freely chosen name.</param>
        /// <param name="FURI">URI to the feature definition.</param>
        public MetricMapFeaturesEndpointTypeProperties(string UID = default(string), string Fgroup = default(string), string Ftype = default(string), string Fsubtype = default(string), string Fname = default(string), string FURI = default(string))
        {
            this.UID = UID;
            this.Fgroup = Fgroup;
            this.Ftype = Ftype;
            this.Fsubtype = Fsubtype;
            this.Fname = Fname;
            this.FURI = FURI;
        }
        
        /// <summary>
        /// UUID
        /// </summary>
        /// <value>UUID</value>
        [DataMember(Name="UID", EmitDefaultValue=false)]
        public string UID { get; set; }

        /// <summary>
        /// Name of the feature group
        /// </summary>
        /// <value>Name of the feature group</value>
        [DataMember(Name="fgroup", EmitDefaultValue=false)]
        public string Fgroup { get; set; }

        /// <summary>
        /// Name of the feature type
        /// </summary>
        /// <value>Name of the feature type</value>
        [DataMember(Name="ftype", EmitDefaultValue=false)]
        public string Ftype { get; set; }

        /// <summary>
        /// Name of the feature subtype
        /// </summary>
        /// <value>Name of the feature subtype</value>
        [DataMember(Name="fsubtype", EmitDefaultValue=false)]
        public string Fsubtype { get; set; }

        /// <summary>
        /// Freely chosen name
        /// </summary>
        /// <value>Freely chosen name</value>
        [DataMember(Name="fname", EmitDefaultValue=false)]
        public string Fname { get; set; }

        /// <summary>
        /// URI to the feature definition
        /// </summary>
        /// <value>URI to the feature definition</value>
        [DataMember(Name="fURI", EmitDefaultValue=false)]
        public string FURI { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class MetricMapFeaturesEndpointTypeProperties {\n");
            sb.Append("  UID: ").Append(UID).Append("\n");
            sb.Append("  Fgroup: ").Append(Fgroup).Append("\n");
            sb.Append("  Ftype: ").Append(Ftype).Append("\n");
            sb.Append("  Fsubtype: ").Append(Fsubtype).Append("\n");
            sb.Append("  Fname: ").Append(Fname).Append("\n");
            sb.Append("  FURI: ").Append(FURI).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as MetricMapFeaturesEndpointTypeProperties);
        }

        /// <summary>
        /// Returns true if MetricMapFeaturesEndpointTypeProperties instances are equal
        /// </summary>
        /// <param name="input">Instance of MetricMapFeaturesEndpointTypeProperties to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(MetricMapFeaturesEndpointTypeProperties input)
        {
            if (input == null)
                return false;

            return 
                (
                    this.UID == input.UID ||
                    (this.UID != null &&
                    this.UID.Equals(input.UID))
                ) && 
                (
                    this.Fgroup == input.Fgroup ||
                    (this.Fgroup != null &&
                    this.Fgroup.Equals(input.Fgroup))
                ) && 
                (
                    this.Ftype == input.Ftype ||
                    (this.Ftype != null &&
                    this.Ftype.Equals(input.Ftype))
                ) && 
                (
                    this.Fsubtype == input.Fsubtype ||
                    (this.Fsubtype != null &&
                    this.Fsubtype.Equals(input.Fsubtype))
                ) && 
                (
                    this.Fname == input.Fname ||
                    (this.Fname != null &&
                    this.Fname.Equals(input.Fname))
                ) && 
                (
                    this.FURI == input.FURI ||
                    (this.FURI != null &&
                    this.FURI.Equals(input.FURI))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.UID != null)
                    hashCode = hashCode * 59 + this.UID.GetHashCode();
                if (this.Fgroup != null)
                    hashCode = hashCode * 59 + this.Fgroup.GetHashCode();
                if (this.Ftype != null)
                    hashCode = hashCode * 59 + this.Ftype.GetHashCode();
                if (this.Fsubtype != null)
                    hashCode = hashCode * 59 + this.Fsubtype.GetHashCode();
                if (this.Fname != null)
                    hashCode = hashCode * 59 + this.Fname.GetHashCode();
                if (this.FURI != null)
                    hashCode = hashCode * 59 + this.FURI.GetHashCode();
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }

}
