/* 
 * its4land Public API
 *
 * The its4land Public API provides access to the services of the its4land Publish and Share platform.
 *
 * OpenAPI spec version: 0.0.2
 * Contact: contact@its4land.com
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */

using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System.ComponentModel.DataAnnotations;
using SwaggerDateConverter = IO.Swagger.Client.SwaggerDateConverter;

namespace IO.Swagger.Model
{
    /// <summary>
    /// ModelClassesEndpointType
    /// </summary>
    [DataContract]
    public partial class ModelClassesEndpointType :  IEquatable<ModelClassesEndpointType>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="ModelClassesEndpointType" /> class.
        /// </summary>
        /// <param name="UID">UUID.</param>
        /// <param name="ConceptName">Freely chosen name of the concept represented by the class.</param>
        /// <param name="NameInModel">Freely chosen name of the concept represented by the class.</param>
        /// <param name="ConceptImage">UID of an image that illustrates the concept. The image must be stored in advanced via the ContentItem endpoint..</param>
        /// <param name="Model">Model.</param>
        public ModelClassesEndpointType(string UID = default(string), string ConceptName = default(string), string NameInModel = default(string), string ConceptImage = default(string), ModelClassesEndpointTypeModel Model = default(ModelClassesEndpointTypeModel))
        {
            this.UID = UID;
            this.ConceptName = ConceptName;
            this.NameInModel = NameInModel;
            this.ConceptImage = ConceptImage;
            this.Model = Model;
        }
        
        /// <summary>
        /// UUID
        /// </summary>
        /// <value>UUID</value>
        [DataMember(Name="UID", EmitDefaultValue=false)]
        public string UID { get; set; }

        /// <summary>
        /// Freely chosen name of the concept represented by the class
        /// </summary>
        /// <value>Freely chosen name of the concept represented by the class</value>
        [DataMember(Name="ConceptName", EmitDefaultValue=false)]
        public string ConceptName { get; set; }

        /// <summary>
        /// Freely chosen name of the concept represented by the class
        /// </summary>
        /// <value>Freely chosen name of the concept represented by the class</value>
        [DataMember(Name="NameInModel", EmitDefaultValue=false)]
        public string NameInModel { get; set; }

        /// <summary>
        /// UID of an image that illustrates the concept. The image must be stored in advanced via the ContentItem endpoint.
        /// </summary>
        /// <value>UID of an image that illustrates the concept. The image must be stored in advanced via the ContentItem endpoint.</value>
        [DataMember(Name="ConceptImage", EmitDefaultValue=false)]
        public string ConceptImage { get; set; }

        /// <summary>
        /// Gets or Sets Model
        /// </summary>
        [DataMember(Name="Model", EmitDefaultValue=false)]
        public ModelClassesEndpointTypeModel Model { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class ModelClassesEndpointType {\n");
            sb.Append("  UID: ").Append(UID).Append("\n");
            sb.Append("  ConceptName: ").Append(ConceptName).Append("\n");
            sb.Append("  NameInModel: ").Append(NameInModel).Append("\n");
            sb.Append("  ConceptImage: ").Append(ConceptImage).Append("\n");
            sb.Append("  Model: ").Append(Model).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as ModelClassesEndpointType);
        }

        /// <summary>
        /// Returns true if ModelClassesEndpointType instances are equal
        /// </summary>
        /// <param name="input">Instance of ModelClassesEndpointType to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(ModelClassesEndpointType input)
        {
            if (input == null)
                return false;

            return 
                (
                    this.UID == input.UID ||
                    (this.UID != null &&
                    this.UID.Equals(input.UID))
                ) && 
                (
                    this.ConceptName == input.ConceptName ||
                    (this.ConceptName != null &&
                    this.ConceptName.Equals(input.ConceptName))
                ) && 
                (
                    this.NameInModel == input.NameInModel ||
                    (this.NameInModel != null &&
                    this.NameInModel.Equals(input.NameInModel))
                ) && 
                (
                    this.ConceptImage == input.ConceptImage ||
                    (this.ConceptImage != null &&
                    this.ConceptImage.Equals(input.ConceptImage))
                ) && 
                (
                    this.Model == input.Model ||
                    (this.Model != null &&
                    this.Model.Equals(input.Model))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.UID != null)
                    hashCode = hashCode * 59 + this.UID.GetHashCode();
                if (this.ConceptName != null)
                    hashCode = hashCode * 59 + this.ConceptName.GetHashCode();
                if (this.NameInModel != null)
                    hashCode = hashCode * 59 + this.NameInModel.GetHashCode();
                if (this.ConceptImage != null)
                    hashCode = hashCode * 59 + this.ConceptImage.GetHashCode();
                if (this.Model != null)
                    hashCode = hashCode * 59 + this.Model.GetHashCode();
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }

}
