/* 
 * its4land Public API
 *
 * The its4land Public API provides access to the services of the its4land Publish and Share platform.
 *
 * OpenAPI spec version: 0.0.2
 * Contact: contact@its4land.com
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */

using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System.ComponentModel.DataAnnotations;
using SwaggerDateConverter = IO.Swagger.Client.SwaggerDateConverter;

namespace IO.Swagger.Model
{
    /// <summary>
    /// ModelsEndpointType
    /// </summary>
    [DataContract]
    public partial class ModelsEndpointType :  IEquatable<ModelsEndpointType>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="ModelsEndpointType" /> class.
        /// </summary>
        /// <param name="UID">UUID.</param>
        /// <param name="Name">Freely chosen name.</param>
        /// <param name="Description">Free text for description. Only plain text..</param>
        /// <param name="TrainingSet">UID of the TrainingSet..</param>
        /// <param name="Classifier">UID of the assigned classifier.</param>
        /// <param name="Tools">Comma separated list tool names which can make use of the model..</param>
        /// <param name="ModelClasses">Array of ModelClasses (UID)..</param>
        /// <param name="NumModelClasses">Number of ModelClasses in the Model.</param>
        /// <param name="Tags">Array of tags (strings)..</param>
        /// <param name="Projects">Array of Projects (UID)..</param>
        public ModelsEndpointType(string UID = default(string), string Name = default(string), string Description = default(string), string TrainingSet = default(string), string Classifier = default(string), List<string> Tools = default(List<string>), List<ModelsEndpointTypeModelClasses> ModelClasses = default(List<ModelsEndpointTypeModelClasses>), int? NumModelClasses = default(int?), List<string> Tags = default(List<string>), List<ModelsEndpointTypeProjects> Projects = default(List<ModelsEndpointTypeProjects>))
        {
            this.UID = UID;
            this.Name = Name;
            this.Description = Description;
            this.TrainingSet = TrainingSet;
            this.Classifier = Classifier;
            this.Tools = Tools;
            this.ModelClasses = ModelClasses;
            this.NumModelClasses = NumModelClasses;
            this.Tags = Tags;
            this.Projects = Projects;
        }
        
        /// <summary>
        /// UUID
        /// </summary>
        /// <value>UUID</value>
        [DataMember(Name="UID", EmitDefaultValue=false)]
        public string UID { get; set; }

        /// <summary>
        /// Freely chosen name
        /// </summary>
        /// <value>Freely chosen name</value>
        [DataMember(Name="Name", EmitDefaultValue=false)]
        public string Name { get; set; }

        /// <summary>
        /// Free text for description. Only plain text.
        /// </summary>
        /// <value>Free text for description. Only plain text.</value>
        [DataMember(Name="Description", EmitDefaultValue=false)]
        public string Description { get; set; }

        /// <summary>
        /// UID of the TrainingSet.
        /// </summary>
        /// <value>UID of the TrainingSet.</value>
        [DataMember(Name="TrainingSet", EmitDefaultValue=false)]
        public string TrainingSet { get; set; }

        /// <summary>
        /// UID of the assigned classifier
        /// </summary>
        /// <value>UID of the assigned classifier</value>
        [DataMember(Name="Classifier", EmitDefaultValue=false)]
        public string Classifier { get; set; }

        /// <summary>
        /// Comma separated list tool names which can make use of the model.
        /// </summary>
        /// <value>Comma separated list tool names which can make use of the model.</value>
        [DataMember(Name="Tools", EmitDefaultValue=false)]
        public List<string> Tools { get; set; }

        /// <summary>
        /// Array of ModelClasses (UID).
        /// </summary>
        /// <value>Array of ModelClasses (UID).</value>
        [DataMember(Name="ModelClasses", EmitDefaultValue=false)]
        public List<ModelsEndpointTypeModelClasses> ModelClasses { get; set; }

        /// <summary>
        /// Number of ModelClasses in the Model
        /// </summary>
        /// <value>Number of ModelClasses in the Model</value>
        [DataMember(Name="NumModelClasses", EmitDefaultValue=false)]
        public int? NumModelClasses { get; set; }

        /// <summary>
        /// Array of tags (strings).
        /// </summary>
        /// <value>Array of tags (strings).</value>
        [DataMember(Name="Tags", EmitDefaultValue=false)]
        public List<string> Tags { get; set; }

        /// <summary>
        /// Array of Projects (UID).
        /// </summary>
        /// <value>Array of Projects (UID).</value>
        [DataMember(Name="Projects", EmitDefaultValue=false)]
        public List<ModelsEndpointTypeProjects> Projects { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class ModelsEndpointType {\n");
            sb.Append("  UID: ").Append(UID).Append("\n");
            sb.Append("  Name: ").Append(Name).Append("\n");
            sb.Append("  Description: ").Append(Description).Append("\n");
            sb.Append("  TrainingSet: ").Append(TrainingSet).Append("\n");
            sb.Append("  Classifier: ").Append(Classifier).Append("\n");
            sb.Append("  Tools: ").Append(Tools).Append("\n");
            sb.Append("  ModelClasses: ").Append(ModelClasses).Append("\n");
            sb.Append("  NumModelClasses: ").Append(NumModelClasses).Append("\n");
            sb.Append("  Tags: ").Append(Tags).Append("\n");
            sb.Append("  Projects: ").Append(Projects).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as ModelsEndpointType);
        }

        /// <summary>
        /// Returns true if ModelsEndpointType instances are equal
        /// </summary>
        /// <param name="input">Instance of ModelsEndpointType to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(ModelsEndpointType input)
        {
            if (input == null)
                return false;

            return 
                (
                    this.UID == input.UID ||
                    (this.UID != null &&
                    this.UID.Equals(input.UID))
                ) && 
                (
                    this.Name == input.Name ||
                    (this.Name != null &&
                    this.Name.Equals(input.Name))
                ) && 
                (
                    this.Description == input.Description ||
                    (this.Description != null &&
                    this.Description.Equals(input.Description))
                ) && 
                (
                    this.TrainingSet == input.TrainingSet ||
                    (this.TrainingSet != null &&
                    this.TrainingSet.Equals(input.TrainingSet))
                ) && 
                (
                    this.Classifier == input.Classifier ||
                    (this.Classifier != null &&
                    this.Classifier.Equals(input.Classifier))
                ) && 
                (
                    this.Tools == input.Tools ||
                    this.Tools != null &&
                    this.Tools.SequenceEqual(input.Tools)
                ) && 
                (
                    this.ModelClasses == input.ModelClasses ||
                    this.ModelClasses != null &&
                    this.ModelClasses.SequenceEqual(input.ModelClasses)
                ) && 
                (
                    this.NumModelClasses == input.NumModelClasses ||
                    (this.NumModelClasses != null &&
                    this.NumModelClasses.Equals(input.NumModelClasses))
                ) && 
                (
                    this.Tags == input.Tags ||
                    this.Tags != null &&
                    this.Tags.SequenceEqual(input.Tags)
                ) && 
                (
                    this.Projects == input.Projects ||
                    this.Projects != null &&
                    this.Projects.SequenceEqual(input.Projects)
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.UID != null)
                    hashCode = hashCode * 59 + this.UID.GetHashCode();
                if (this.Name != null)
                    hashCode = hashCode * 59 + this.Name.GetHashCode();
                if (this.Description != null)
                    hashCode = hashCode * 59 + this.Description.GetHashCode();
                if (this.TrainingSet != null)
                    hashCode = hashCode * 59 + this.TrainingSet.GetHashCode();
                if (this.Classifier != null)
                    hashCode = hashCode * 59 + this.Classifier.GetHashCode();
                if (this.Tools != null)
                    hashCode = hashCode * 59 + this.Tools.GetHashCode();
                if (this.ModelClasses != null)
                    hashCode = hashCode * 59 + this.ModelClasses.GetHashCode();
                if (this.NumModelClasses != null)
                    hashCode = hashCode * 59 + this.NumModelClasses.GetHashCode();
                if (this.Tags != null)
                    hashCode = hashCode * 59 + this.Tags.GetHashCode();
                if (this.Projects != null)
                    hashCode = hashCode * 59 + this.Projects.GetHashCode();
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }

}
