/* 
 * its4land Public API
 *
 * The its4land Public API provides access to the services of the its4land Publish and Share platform.
 *
 * OpenAPI spec version: 0.0.2
 * Contact: contact@its4land.com
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */

using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System.ComponentModel.DataAnnotations;
using SwaggerDateConverter = IO.Swagger.Client.SwaggerDateConverter;

namespace IO.Swagger.Model
{
    /// <summary>
    /// ProcessPostRequest
    /// </summary>
    [DataContract]
    public partial class ProcessPostRequest :  IEquatable<ProcessPostRequest>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="ProcessPostRequest" /> class.
        /// </summary>
        [JsonConstructorAttribute]
        protected ProcessPostRequest() { }
        /// <summary>
        /// Initializes a new instance of the <see cref="ProcessPostRequest" /> class.
        /// </summary>
        /// <param name="Project">Project (required).</param>
        /// <param name="Tool">Tool (required).</param>
        public ProcessPostRequest(ProcessPostRequestProject Project = default(ProcessPostRequestProject), ProcessPostRequestTool Tool = default(ProcessPostRequestTool))
        {
            // to ensure "Project" is required (not null)
            if (Project == null)
            {
                throw new InvalidDataException("Project is a required property for ProcessPostRequest and cannot be null");
            }
            else
            {
                this.Project = Project;
            }
            // to ensure "Tool" is required (not null)
            if (Tool == null)
            {
                throw new InvalidDataException("Tool is a required property for ProcessPostRequest and cannot be null");
            }
            else
            {
                this.Tool = Tool;
            }
        }
        
        /// <summary>
        /// Gets or Sets Project
        /// </summary>
        [DataMember(Name="Project", EmitDefaultValue=false)]
        public ProcessPostRequestProject Project { get; set; }

        /// <summary>
        /// Gets or Sets Tool
        /// </summary>
        [DataMember(Name="Tool", EmitDefaultValue=false)]
        public ProcessPostRequestTool Tool { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class ProcessPostRequest {\n");
            sb.Append("  Project: ").Append(Project).Append("\n");
            sb.Append("  Tool: ").Append(Tool).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as ProcessPostRequest);
        }

        /// <summary>
        /// Returns true if ProcessPostRequest instances are equal
        /// </summary>
        /// <param name="input">Instance of ProcessPostRequest to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(ProcessPostRequest input)
        {
            if (input == null)
                return false;

            return 
                (
                    this.Project == input.Project ||
                    (this.Project != null &&
                    this.Project.Equals(input.Project))
                ) && 
                (
                    this.Tool == input.Tool ||
                    (this.Tool != null &&
                    this.Tool.Equals(input.Tool))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.Project != null)
                    hashCode = hashCode * 59 + this.Project.GetHashCode();
                if (this.Tool != null)
                    hashCode = hashCode * 59 + this.Tool.GetHashCode();
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }

}
