/* 
 * its4land Public API
 *
 * The its4land Public API provides access to the services of the its4land Publish and Share platform.
 *
 * OpenAPI spec version: 0.0.2
 * Contact: contact@its4land.com
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */

using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System.ComponentModel.DataAnnotations;
using SwaggerDateConverter = IO.Swagger.Client.SwaggerDateConverter;

namespace IO.Swagger.Model
{
    /// <summary>
    /// A process always belongs to a project
    /// </summary>
    [DataContract]
    public partial class ProcessPostRequestProject :  IEquatable<ProcessPostRequestProject>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="ProcessPostRequestProject" /> class.
        /// </summary>
        [JsonConstructorAttribute]
        protected ProcessPostRequestProject() { }
        /// <summary>
        /// Initializes a new instance of the <see cref="ProcessPostRequestProject" /> class.
        /// </summary>
        /// <param name="UID">UID of the project (required).</param>
        public ProcessPostRequestProject(string UID = default(string))
        {
            // to ensure "UID" is required (not null)
            if (UID == null)
            {
                throw new InvalidDataException("UID is a required property for ProcessPostRequestProject and cannot be null");
            }
            else
            {
                this.UID = UID;
            }
        }
        
        /// <summary>
        /// UID of the project
        /// </summary>
        /// <value>UID of the project</value>
        [DataMember(Name="UID", EmitDefaultValue=false)]
        public string UID { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class ProcessPostRequestProject {\n");
            sb.Append("  UID: ").Append(UID).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as ProcessPostRequestProject);
        }

        /// <summary>
        /// Returns true if ProcessPostRequestProject instances are equal
        /// </summary>
        /// <param name="input">Instance of ProcessPostRequestProject to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(ProcessPostRequestProject input)
        {
            if (input == null)
                return false;

            return 
                (
                    this.UID == input.UID ||
                    (this.UID != null &&
                    this.UID.Equals(input.UID))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.UID != null)
                    hashCode = hashCode * 59 + this.UID.GetHashCode();
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }

}
