/* 
 * its4land Public API
 *
 * The its4land Public API provides access to the services of the its4land Publish and Share platform.
 *
 * OpenAPI spec version: 0.0.2
 * Contact: contact@its4land.com
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */

using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System.ComponentModel.DataAnnotations;
using SwaggerDateConverter = IO.Swagger.Client.SwaggerDateConverter;

namespace IO.Swagger.Model
{
    /// <summary>
    /// ProjectsEndpointType2Properties
    /// </summary>
    [DataContract]
    public partial class ProjectsEndpointType2Properties :  IEquatable<ProjectsEndpointType2Properties>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="ProjectsEndpointType2Properties" /> class.
        /// </summary>
        /// <param name="UID">UUID.</param>
        /// <param name="Name">Freely chosen name.</param>
        /// <param name="Description">Free text for description. Only plain text..</param>
        /// <param name="LongDescription">Text for description. Can contain html. Max 4000 char..</param>
        /// <param name="ExtDescriptionURL">URL to an external description of the document..</param>
        /// <param name="ConnectedObjects">ConnectedObjects.</param>
        /// <param name="Tags">Array of tags (strings)..</param>
        public ProjectsEndpointType2Properties(string UID = default(string), string Name = default(string), string Description = default(string), string LongDescription = default(string), string ExtDescriptionURL = default(string), ConnectedObjectsEndpointType ConnectedObjects = default(ConnectedObjectsEndpointType), List<string> Tags = default(List<string>))
        {
            this.UID = UID;
            this.Name = Name;
            this.Description = Description;
            this.LongDescription = LongDescription;
            this.ExtDescriptionURL = ExtDescriptionURL;
            this.ConnectedObjects = ConnectedObjects;
            this.Tags = Tags;
        }
        
        /// <summary>
        /// UUID
        /// </summary>
        /// <value>UUID</value>
        [DataMember(Name="UID", EmitDefaultValue=false)]
        public string UID { get; set; }

        /// <summary>
        /// Freely chosen name
        /// </summary>
        /// <value>Freely chosen name</value>
        [DataMember(Name="Name", EmitDefaultValue=false)]
        public string Name { get; set; }

        /// <summary>
        /// Free text for description. Only plain text.
        /// </summary>
        /// <value>Free text for description. Only plain text.</value>
        [DataMember(Name="Description", EmitDefaultValue=false)]
        public string Description { get; set; }

        /// <summary>
        /// Text for description. Can contain html. Max 4000 char.
        /// </summary>
        /// <value>Text for description. Can contain html. Max 4000 char.</value>
        [DataMember(Name="LongDescription", EmitDefaultValue=false)]
        public string LongDescription { get; set; }

        /// <summary>
        /// URL to an external description of the document.
        /// </summary>
        /// <value>URL to an external description of the document.</value>
        [DataMember(Name="ExtDescriptionURL", EmitDefaultValue=false)]
        public string ExtDescriptionURL { get; set; }

        /// <summary>
        /// Gets or Sets ConnectedObjects
        /// </summary>
        [DataMember(Name="ConnectedObjects", EmitDefaultValue=false)]
        public ConnectedObjectsEndpointType ConnectedObjects { get; set; }

        /// <summary>
        /// Array of tags (strings).
        /// </summary>
        /// <value>Array of tags (strings).</value>
        [DataMember(Name="Tags", EmitDefaultValue=false)]
        public List<string> Tags { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class ProjectsEndpointType2Properties {\n");
            sb.Append("  UID: ").Append(UID).Append("\n");
            sb.Append("  Name: ").Append(Name).Append("\n");
            sb.Append("  Description: ").Append(Description).Append("\n");
            sb.Append("  LongDescription: ").Append(LongDescription).Append("\n");
            sb.Append("  ExtDescriptionURL: ").Append(ExtDescriptionURL).Append("\n");
            sb.Append("  ConnectedObjects: ").Append(ConnectedObjects).Append("\n");
            sb.Append("  Tags: ").Append(Tags).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as ProjectsEndpointType2Properties);
        }

        /// <summary>
        /// Returns true if ProjectsEndpointType2Properties instances are equal
        /// </summary>
        /// <param name="input">Instance of ProjectsEndpointType2Properties to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(ProjectsEndpointType2Properties input)
        {
            if (input == null)
                return false;

            return 
                (
                    this.UID == input.UID ||
                    (this.UID != null &&
                    this.UID.Equals(input.UID))
                ) && 
                (
                    this.Name == input.Name ||
                    (this.Name != null &&
                    this.Name.Equals(input.Name))
                ) && 
                (
                    this.Description == input.Description ||
                    (this.Description != null &&
                    this.Description.Equals(input.Description))
                ) && 
                (
                    this.LongDescription == input.LongDescription ||
                    (this.LongDescription != null &&
                    this.LongDescription.Equals(input.LongDescription))
                ) && 
                (
                    this.ExtDescriptionURL == input.ExtDescriptionURL ||
                    (this.ExtDescriptionURL != null &&
                    this.ExtDescriptionURL.Equals(input.ExtDescriptionURL))
                ) && 
                (
                    this.ConnectedObjects == input.ConnectedObjects ||
                    (this.ConnectedObjects != null &&
                    this.ConnectedObjects.Equals(input.ConnectedObjects))
                ) && 
                (
                    this.Tags == input.Tags ||
                    this.Tags != null &&
                    this.Tags.SequenceEqual(input.Tags)
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.UID != null)
                    hashCode = hashCode * 59 + this.UID.GetHashCode();
                if (this.Name != null)
                    hashCode = hashCode * 59 + this.Name.GetHashCode();
                if (this.Description != null)
                    hashCode = hashCode * 59 + this.Description.GetHashCode();
                if (this.LongDescription != null)
                    hashCode = hashCode * 59 + this.LongDescription.GetHashCode();
                if (this.ExtDescriptionURL != null)
                    hashCode = hashCode * 59 + this.ExtDescriptionURL.GetHashCode();
                if (this.ConnectedObjects != null)
                    hashCode = hashCode * 59 + this.ConnectedObjects.GetHashCode();
                if (this.Tags != null)
                    hashCode = hashCode * 59 + this.Tags.GetHashCode();
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }

}
