/* 
 * its4land Public API
 *
 * The its4land Public API provides access to the services of the its4land Publish and Share platform.
 *
 * OpenAPI spec version: 0.0.2
 * Contact: contact@its4land.com
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */

using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System.ComponentModel.DataAnnotations;
using SwaggerDateConverter = IO.Swagger.Client.SwaggerDateConverter;

namespace IO.Swagger.Model
{
    /// <summary>
    /// ProjectsEndpointTypeCrsProperties
    /// </summary>
    [DataContract]
    public partial class ProjectsEndpointTypeCrsProperties :  IEquatable<ProjectsEndpointTypeCrsProperties>, IValidatableObject
    {
        /// <summary>
        /// Defines Name
        /// </summary>
        [JsonConverter(typeof(StringEnumConverter))]
        public enum NameEnum
        {
            
            /// <summary>
            /// Enum _13CRS84 for value: urn:ogc:def:crs:OGC:1.3:CRS84
            /// </summary>
            [EnumMember(Value = "urn:ogc:def:crs:OGC:1.3:CRS84")]
            _13CRS84 = 1,
            
            /// <summary>
            /// Enum CRS84 for value: urn:ogc:def:crs:OGC::CRS84
            /// </summary>
            [EnumMember(Value = "urn:ogc:def:crs:OGC::CRS84")]
            CRS84 = 2
        }

        /// <summary>
        /// Gets or Sets Name
        /// </summary>
        [DataMember(Name="name", EmitDefaultValue=false)]
        public NameEnum? Name { get; set; }
        /// <summary>
        /// Initializes a new instance of the <see cref="ProjectsEndpointTypeCrsProperties" /> class.
        /// </summary>
        /// <param name="Name">Name.</param>
        public ProjectsEndpointTypeCrsProperties(NameEnum? Name = default(NameEnum?))
        {
            this.Name = Name;
        }
        

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class ProjectsEndpointTypeCrsProperties {\n");
            sb.Append("  Name: ").Append(Name).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as ProjectsEndpointTypeCrsProperties);
        }

        /// <summary>
        /// Returns true if ProjectsEndpointTypeCrsProperties instances are equal
        /// </summary>
        /// <param name="input">Instance of ProjectsEndpointTypeCrsProperties to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(ProjectsEndpointTypeCrsProperties input)
        {
            if (input == null)
                return false;

            return 
                (
                    this.Name == input.Name ||
                    (this.Name != null &&
                    this.Name.Equals(input.Name))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.Name != null)
                    hashCode = hashCode * 59 + this.Name.GetHashCode();
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }

}
