/* 
 * its4land Public API
 *
 * The its4land Public API provides access to the services of the its4land Publish and Share platform.
 *
 * OpenAPI spec version: 0.0.2
 * Contact: contact@its4land.com
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */

using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System.ComponentModel.DataAnnotations;
using SwaggerDateConverter = IO.Swagger.Client.SwaggerDateConverter;

namespace IO.Swagger.Model
{
    /// <summary>
    /// ProjectsPatchRequest
    /// </summary>
    [DataContract]
    public partial class ProjectsPatchRequest :  IEquatable<ProjectsPatchRequest>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="ProjectsPatchRequest" /> class.
        /// </summary>
        /// <param name="Name">Freely chosen name.</param>
        /// <param name="Description">Free text for description. Only plain text..</param>
        /// <param name="ProjectDir">URI to a directory resource. Not clear if needed..</param>
        /// <param name="Models">Array of models (UID)..</param>
        /// <param name="SpatialSources">Array of SpatialSources (UID)..</param>
        /// <param name="AOI">Polygon. The polygon is encoded a comma separated list of coordinates. X1, Y1, X2, Y2, ..., Xn, Yn, X1, Y1. Patch requires a complete polygon..</param>
        /// <param name="Tags">Array of tags (strings) of the associated models. Patch requires an updated array..</param>
        public ProjectsPatchRequest(string Name = default(string), string Description = default(string), string ProjectDir = default(string), List<ProjectsEndpointTypePropertiesModels> Models = default(List<ProjectsEndpointTypePropertiesModels>), List<ProjectsPostRequestPropertiesSpatialSources> SpatialSources = default(List<ProjectsPostRequestPropertiesSpatialSources>), List<string> AOI = default(List<string>), List<string> Tags = default(List<string>))
        {
            this.Name = Name;
            this.Description = Description;
            this.ProjectDir = ProjectDir;
            this.Models = Models;
            this.SpatialSources = SpatialSources;
            this.AOI = AOI;
            this.Tags = Tags;
        }
        
        /// <summary>
        /// Freely chosen name
        /// </summary>
        /// <value>Freely chosen name</value>
        [DataMember(Name="Name", EmitDefaultValue=false)]
        public string Name { get; set; }

        /// <summary>
        /// Free text for description. Only plain text.
        /// </summary>
        /// <value>Free text for description. Only plain text.</value>
        [DataMember(Name="Description", EmitDefaultValue=false)]
        public string Description { get; set; }

        /// <summary>
        /// URI to a directory resource. Not clear if needed.
        /// </summary>
        /// <value>URI to a directory resource. Not clear if needed.</value>
        [DataMember(Name="ProjectDir", EmitDefaultValue=false)]
        public string ProjectDir { get; set; }

        /// <summary>
        /// Array of models (UID).
        /// </summary>
        /// <value>Array of models (UID).</value>
        [DataMember(Name="Models", EmitDefaultValue=false)]
        public List<ProjectsEndpointTypePropertiesModels> Models { get; set; }

        /// <summary>
        /// Array of SpatialSources (UID).
        /// </summary>
        /// <value>Array of SpatialSources (UID).</value>
        [DataMember(Name="SpatialSources", EmitDefaultValue=false)]
        public List<ProjectsPostRequestPropertiesSpatialSources> SpatialSources { get; set; }

        /// <summary>
        /// Polygon. The polygon is encoded a comma separated list of coordinates. X1, Y1, X2, Y2, ..., Xn, Yn, X1, Y1. Patch requires a complete polygon.
        /// </summary>
        /// <value>Polygon. The polygon is encoded a comma separated list of coordinates. X1, Y1, X2, Y2, ..., Xn, Yn, X1, Y1. Patch requires a complete polygon.</value>
        [DataMember(Name="AOI", EmitDefaultValue=false)]
        public List<string> AOI { get; set; }

        /// <summary>
        /// Array of tags (strings) of the associated models. Patch requires an updated array.
        /// </summary>
        /// <value>Array of tags (strings) of the associated models. Patch requires an updated array.</value>
        [DataMember(Name="Tags", EmitDefaultValue=false)]
        public List<string> Tags { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class ProjectsPatchRequest {\n");
            sb.Append("  Name: ").Append(Name).Append("\n");
            sb.Append("  Description: ").Append(Description).Append("\n");
            sb.Append("  ProjectDir: ").Append(ProjectDir).Append("\n");
            sb.Append("  Models: ").Append(Models).Append("\n");
            sb.Append("  SpatialSources: ").Append(SpatialSources).Append("\n");
            sb.Append("  AOI: ").Append(AOI).Append("\n");
            sb.Append("  Tags: ").Append(Tags).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as ProjectsPatchRequest);
        }

        /// <summary>
        /// Returns true if ProjectsPatchRequest instances are equal
        /// </summary>
        /// <param name="input">Instance of ProjectsPatchRequest to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(ProjectsPatchRequest input)
        {
            if (input == null)
                return false;

            return 
                (
                    this.Name == input.Name ||
                    (this.Name != null &&
                    this.Name.Equals(input.Name))
                ) && 
                (
                    this.Description == input.Description ||
                    (this.Description != null &&
                    this.Description.Equals(input.Description))
                ) && 
                (
                    this.ProjectDir == input.ProjectDir ||
                    (this.ProjectDir != null &&
                    this.ProjectDir.Equals(input.ProjectDir))
                ) && 
                (
                    this.Models == input.Models ||
                    this.Models != null &&
                    this.Models.SequenceEqual(input.Models)
                ) && 
                (
                    this.SpatialSources == input.SpatialSources ||
                    this.SpatialSources != null &&
                    this.SpatialSources.SequenceEqual(input.SpatialSources)
                ) && 
                (
                    this.AOI == input.AOI ||
                    this.AOI != null &&
                    this.AOI.SequenceEqual(input.AOI)
                ) && 
                (
                    this.Tags == input.Tags ||
                    this.Tags != null &&
                    this.Tags.SequenceEqual(input.Tags)
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.Name != null)
                    hashCode = hashCode * 59 + this.Name.GetHashCode();
                if (this.Description != null)
                    hashCode = hashCode * 59 + this.Description.GetHashCode();
                if (this.ProjectDir != null)
                    hashCode = hashCode * 59 + this.ProjectDir.GetHashCode();
                if (this.Models != null)
                    hashCode = hashCode * 59 + this.Models.GetHashCode();
                if (this.SpatialSources != null)
                    hashCode = hashCode * 59 + this.SpatialSources.GetHashCode();
                if (this.AOI != null)
                    hashCode = hashCode * 59 + this.AOI.GetHashCode();
                if (this.Tags != null)
                    hashCode = hashCode * 59 + this.Tags.GetHashCode();
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }

}
