/* 
 * its4land Public API
 *
 * The its4land Public API provides access to the services of the its4land Publish and Share platform.
 *
 * OpenAPI spec version: 0.0.2
 * Contact: contact@its4land.com
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */

using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System.ComponentModel.DataAnnotations;
using SwaggerDateConverter = IO.Swagger.Client.SwaggerDateConverter;

namespace IO.Swagger.Model
{
    /// <summary>
    /// Data model of the /spatialsources endpoint
    /// </summary>
    [DataContract]
    public partial class SpatialSourcesEndpointType :  IEquatable<SpatialSourcesEndpointType>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="SpatialSourcesEndpointType" /> class.
        /// </summary>
        /// <param name="UID">UUID.</param>
        /// <param name="Name">Freely chosen name.</param>
        /// <param name="Description">Free text for description. Only plain text..</param>
        /// <param name="Type">Spatial Source type..</param>
        /// <param name="ContentItem">UID of the ContentItem.</param>
        /// <param name="AdditionalDocuments">Array of additional SpatialSource Documents. Mainly uses in WP3 tp store the different representation of a SketchMap..</param>
        /// <param name="Tags">Array of tags (strings)..</param>
        /// <param name="Projects">Array of Projects (UID)..</param>
        public SpatialSourcesEndpointType(string UID = default(string), string Name = default(string), string Description = default(string), string Type = default(string), string ContentItem = default(string), List<SpatialSourcesEndpointTypeAdditionalDocuments> AdditionalDocuments = default(List<SpatialSourcesEndpointTypeAdditionalDocuments>), List<string> Tags = default(List<string>), List<ModelsEndpointTypeProjects> Projects = default(List<ModelsEndpointTypeProjects>))
        {
            this.UID = UID;
            this.Name = Name;
            this.Description = Description;
            this.Type = Type;
            this.ContentItem = ContentItem;
            this.AdditionalDocuments = AdditionalDocuments;
            this.Tags = Tags;
            this.Projects = Projects;
        }
        
        /// <summary>
        /// UUID
        /// </summary>
        /// <value>UUID</value>
        [DataMember(Name="UID", EmitDefaultValue=false)]
        public string UID { get; set; }

        /// <summary>
        /// Freely chosen name
        /// </summary>
        /// <value>Freely chosen name</value>
        [DataMember(Name="Name", EmitDefaultValue=false)]
        public string Name { get; set; }

        /// <summary>
        /// Free text for description. Only plain text.
        /// </summary>
        /// <value>Free text for description. Only plain text.</value>
        [DataMember(Name="Description", EmitDefaultValue=false)]
        public string Description { get; set; }

        /// <summary>
        /// Spatial Source type.
        /// </summary>
        /// <value>Spatial Source type.</value>
        [DataMember(Name="Type", EmitDefaultValue=false)]
        public string Type { get; set; }

        /// <summary>
        /// UID of the ContentItem
        /// </summary>
        /// <value>UID of the ContentItem</value>
        [DataMember(Name="ContentItem", EmitDefaultValue=false)]
        public string ContentItem { get; set; }

        /// <summary>
        /// Array of additional SpatialSource Documents. Mainly uses in WP3 tp store the different representation of a SketchMap.
        /// </summary>
        /// <value>Array of additional SpatialSource Documents. Mainly uses in WP3 tp store the different representation of a SketchMap.</value>
        [DataMember(Name="AdditionalDocuments", EmitDefaultValue=false)]
        public List<SpatialSourcesEndpointTypeAdditionalDocuments> AdditionalDocuments { get; set; }

        /// <summary>
        /// Array of tags (strings).
        /// </summary>
        /// <value>Array of tags (strings).</value>
        [DataMember(Name="Tags", EmitDefaultValue=false)]
        public List<string> Tags { get; set; }

        /// <summary>
        /// Array of Projects (UID).
        /// </summary>
        /// <value>Array of Projects (UID).</value>
        [DataMember(Name="Projects", EmitDefaultValue=false)]
        public List<ModelsEndpointTypeProjects> Projects { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class SpatialSourcesEndpointType {\n");
            sb.Append("  UID: ").Append(UID).Append("\n");
            sb.Append("  Name: ").Append(Name).Append("\n");
            sb.Append("  Description: ").Append(Description).Append("\n");
            sb.Append("  Type: ").Append(Type).Append("\n");
            sb.Append("  ContentItem: ").Append(ContentItem).Append("\n");
            sb.Append("  AdditionalDocuments: ").Append(AdditionalDocuments).Append("\n");
            sb.Append("  Tags: ").Append(Tags).Append("\n");
            sb.Append("  Projects: ").Append(Projects).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as SpatialSourcesEndpointType);
        }

        /// <summary>
        /// Returns true if SpatialSourcesEndpointType instances are equal
        /// </summary>
        /// <param name="input">Instance of SpatialSourcesEndpointType to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(SpatialSourcesEndpointType input)
        {
            if (input == null)
                return false;

            return 
                (
                    this.UID == input.UID ||
                    (this.UID != null &&
                    this.UID.Equals(input.UID))
                ) && 
                (
                    this.Name == input.Name ||
                    (this.Name != null &&
                    this.Name.Equals(input.Name))
                ) && 
                (
                    this.Description == input.Description ||
                    (this.Description != null &&
                    this.Description.Equals(input.Description))
                ) && 
                (
                    this.Type == input.Type ||
                    (this.Type != null &&
                    this.Type.Equals(input.Type))
                ) && 
                (
                    this.ContentItem == input.ContentItem ||
                    (this.ContentItem != null &&
                    this.ContentItem.Equals(input.ContentItem))
                ) && 
                (
                    this.AdditionalDocuments == input.AdditionalDocuments ||
                    this.AdditionalDocuments != null &&
                    this.AdditionalDocuments.SequenceEqual(input.AdditionalDocuments)
                ) && 
                (
                    this.Tags == input.Tags ||
                    this.Tags != null &&
                    this.Tags.SequenceEqual(input.Tags)
                ) && 
                (
                    this.Projects == input.Projects ||
                    this.Projects != null &&
                    this.Projects.SequenceEqual(input.Projects)
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.UID != null)
                    hashCode = hashCode * 59 + this.UID.GetHashCode();
                if (this.Name != null)
                    hashCode = hashCode * 59 + this.Name.GetHashCode();
                if (this.Description != null)
                    hashCode = hashCode * 59 + this.Description.GetHashCode();
                if (this.Type != null)
                    hashCode = hashCode * 59 + this.Type.GetHashCode();
                if (this.ContentItem != null)
                    hashCode = hashCode * 59 + this.ContentItem.GetHashCode();
                if (this.AdditionalDocuments != null)
                    hashCode = hashCode * 59 + this.AdditionalDocuments.GetHashCode();
                if (this.Tags != null)
                    hashCode = hashCode * 59 + this.Tags.GetHashCode();
                if (this.Projects != null)
                    hashCode = hashCode * 59 + this.Projects.GetHashCode();
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }

}
