/* 
 * its4land Public API
 *
 * The its4land Public API provides access to the services of the its4land Publish and Share platform.
 *
 * OpenAPI spec version: 0.0.2
 * Contact: contact@its4land.com
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */

using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System.ComponentModel.DataAnnotations;
using SwaggerDateConverter = IO.Swagger.Client.SwaggerDateConverter;

namespace IO.Swagger.Model
{
    /// <summary>
    /// SpatialSourcesPostRequest
    /// </summary>
    [DataContract]
    public partial class SpatialSourcesPostRequest :  IEquatable<SpatialSourcesPostRequest>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="SpatialSourcesPostRequest" /> class.
        /// </summary>
        /// <param name="Name">Freely chosen name.</param>
        /// <param name="Description">Free text for description. Only plain text..</param>
        /// <param name="Type">Spatial Source type..</param>
        /// <param name="ContentItem">UID of the ContentItem.</param>
        /// <param name="Tags">Array of tags (strings)..</param>
        public SpatialSourcesPostRequest(string Name = default(string), string Description = default(string), string Type = default(string), string ContentItem = default(string), List<string> Tags = default(List<string>))
        {
            this.Name = Name;
            this.Description = Description;
            this.Type = Type;
            this.ContentItem = ContentItem;
            this.Tags = Tags;
        }
        
        /// <summary>
        /// Freely chosen name
        /// </summary>
        /// <value>Freely chosen name</value>
        [DataMember(Name="Name", EmitDefaultValue=false)]
        public string Name { get; set; }

        /// <summary>
        /// Free text for description. Only plain text.
        /// </summary>
        /// <value>Free text for description. Only plain text.</value>
        [DataMember(Name="Description", EmitDefaultValue=false)]
        public string Description { get; set; }

        /// <summary>
        /// Spatial Source type.
        /// </summary>
        /// <value>Spatial Source type.</value>
        [DataMember(Name="Type", EmitDefaultValue=false)]
        public string Type { get; set; }

        /// <summary>
        /// UID of the ContentItem
        /// </summary>
        /// <value>UID of the ContentItem</value>
        [DataMember(Name="ContentItem", EmitDefaultValue=false)]
        public string ContentItem { get; set; }

        /// <summary>
        /// Array of tags (strings).
        /// </summary>
        /// <value>Array of tags (strings).</value>
        [DataMember(Name="Tags", EmitDefaultValue=false)]
        public List<string> Tags { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class SpatialSourcesPostRequest {\n");
            sb.Append("  Name: ").Append(Name).Append("\n");
            sb.Append("  Description: ").Append(Description).Append("\n");
            sb.Append("  Type: ").Append(Type).Append("\n");
            sb.Append("  ContentItem: ").Append(ContentItem).Append("\n");
            sb.Append("  Tags: ").Append(Tags).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as SpatialSourcesPostRequest);
        }

        /// <summary>
        /// Returns true if SpatialSourcesPostRequest instances are equal
        /// </summary>
        /// <param name="input">Instance of SpatialSourcesPostRequest to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(SpatialSourcesPostRequest input)
        {
            if (input == null)
                return false;

            return 
                (
                    this.Name == input.Name ||
                    (this.Name != null &&
                    this.Name.Equals(input.Name))
                ) && 
                (
                    this.Description == input.Description ||
                    (this.Description != null &&
                    this.Description.Equals(input.Description))
                ) && 
                (
                    this.Type == input.Type ||
                    (this.Type != null &&
                    this.Type.Equals(input.Type))
                ) && 
                (
                    this.ContentItem == input.ContentItem ||
                    (this.ContentItem != null &&
                    this.ContentItem.Equals(input.ContentItem))
                ) && 
                (
                    this.Tags == input.Tags ||
                    this.Tags != null &&
                    this.Tags.SequenceEqual(input.Tags)
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.Name != null)
                    hashCode = hashCode * 59 + this.Name.GetHashCode();
                if (this.Description != null)
                    hashCode = hashCode * 59 + this.Description.GetHashCode();
                if (this.Type != null)
                    hashCode = hashCode * 59 + this.Type.GetHashCode();
                if (this.ContentItem != null)
                    hashCode = hashCode * 59 + this.ContentItem.GetHashCode();
                if (this.Tags != null)
                    hashCode = hashCode * 59 + this.Tags.GetHashCode();
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }

}
