/* 
 * its4land Public API
 *
 * The its4land Public API provides access to the services of the its4land Publish and Share platform.
 *
 * OpenAPI spec version: 0.0.2
 * Contact: contact@its4land.com
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */

using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System.ComponentModel.DataAnnotations;
using SwaggerDateConverter = IO.Swagger.Client.SwaggerDateConverter;

namespace IO.Swagger.Model
{
    /// <summary>
    /// TrainingsSetEndpointType
    /// </summary>
    [DataContract]
    public partial class TrainingsSetEndpointType :  IEquatable<TrainingsSetEndpointType>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="TrainingsSetEndpointType" /> class.
        /// </summary>
        /// <param name="UID">UUID.</param>
        /// <param name="Name">Freely chosen name.</param>
        /// <param name="Description">Free text for description. Only plain text..</param>
        /// <param name="TrainingSetType">TrainingSet type..</param>
        /// <param name="TrainingSetStatus">0 &#x3D; untrained 1 &#x3D; trained.</param>
        /// <param name="Tools">Comma separated list tool names which can make use of the training set..</param>
        /// <param name="ContentItem">UID of the ContentItem.</param>
        /// <param name="Tags">Array of tags (strings)..</param>
        /// <param name="Models">Array of Projects (UID)..</param>
        public TrainingsSetEndpointType(string UID = default(string), string Name = default(string), string Description = default(string), string TrainingSetType = default(string), int? TrainingSetStatus = default(int?), List<string> Tools = default(List<string>), string ContentItem = default(string), List<string> Tags = default(List<string>), List<TrainingsSetEndpointTypeModels> Models = default(List<TrainingsSetEndpointTypeModels>))
        {
            this.UID = UID;
            this.Name = Name;
            this.Description = Description;
            this.TrainingSetType = TrainingSetType;
            this.TrainingSetStatus = TrainingSetStatus;
            this.Tools = Tools;
            this.ContentItem = ContentItem;
            this.Tags = Tags;
            this.Models = Models;
        }
        
        /// <summary>
        /// UUID
        /// </summary>
        /// <value>UUID</value>
        [DataMember(Name="UID", EmitDefaultValue=false)]
        public string UID { get; set; }

        /// <summary>
        /// Freely chosen name
        /// </summary>
        /// <value>Freely chosen name</value>
        [DataMember(Name="Name", EmitDefaultValue=false)]
        public string Name { get; set; }

        /// <summary>
        /// Free text for description. Only plain text.
        /// </summary>
        /// <value>Free text for description. Only plain text.</value>
        [DataMember(Name="Description", EmitDefaultValue=false)]
        public string Description { get; set; }

        /// <summary>
        /// TrainingSet type.
        /// </summary>
        /// <value>TrainingSet type.</value>
        [DataMember(Name="TrainingSetType", EmitDefaultValue=false)]
        public string TrainingSetType { get; set; }

        /// <summary>
        /// 0 &#x3D; untrained 1 &#x3D; trained
        /// </summary>
        /// <value>0 &#x3D; untrained 1 &#x3D; trained</value>
        [DataMember(Name="TrainingSetStatus", EmitDefaultValue=false)]
        public int? TrainingSetStatus { get; set; }

        /// <summary>
        /// Comma separated list tool names which can make use of the training set.
        /// </summary>
        /// <value>Comma separated list tool names which can make use of the training set.</value>
        [DataMember(Name="Tools", EmitDefaultValue=false)]
        public List<string> Tools { get; set; }

        /// <summary>
        /// UID of the ContentItem
        /// </summary>
        /// <value>UID of the ContentItem</value>
        [DataMember(Name="ContentItem", EmitDefaultValue=false)]
        public string ContentItem { get; set; }

        /// <summary>
        /// Array of tags (strings).
        /// </summary>
        /// <value>Array of tags (strings).</value>
        [DataMember(Name="Tags", EmitDefaultValue=false)]
        public List<string> Tags { get; set; }

        /// <summary>
        /// Array of Projects (UID).
        /// </summary>
        /// <value>Array of Projects (UID).</value>
        [DataMember(Name="Models", EmitDefaultValue=false)]
        public List<TrainingsSetEndpointTypeModels> Models { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class TrainingsSetEndpointType {\n");
            sb.Append("  UID: ").Append(UID).Append("\n");
            sb.Append("  Name: ").Append(Name).Append("\n");
            sb.Append("  Description: ").Append(Description).Append("\n");
            sb.Append("  TrainingSetType: ").Append(TrainingSetType).Append("\n");
            sb.Append("  TrainingSetStatus: ").Append(TrainingSetStatus).Append("\n");
            sb.Append("  Tools: ").Append(Tools).Append("\n");
            sb.Append("  ContentItem: ").Append(ContentItem).Append("\n");
            sb.Append("  Tags: ").Append(Tags).Append("\n");
            sb.Append("  Models: ").Append(Models).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as TrainingsSetEndpointType);
        }

        /// <summary>
        /// Returns true if TrainingsSetEndpointType instances are equal
        /// </summary>
        /// <param name="input">Instance of TrainingsSetEndpointType to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(TrainingsSetEndpointType input)
        {
            if (input == null)
                return false;

            return 
                (
                    this.UID == input.UID ||
                    (this.UID != null &&
                    this.UID.Equals(input.UID))
                ) && 
                (
                    this.Name == input.Name ||
                    (this.Name != null &&
                    this.Name.Equals(input.Name))
                ) && 
                (
                    this.Description == input.Description ||
                    (this.Description != null &&
                    this.Description.Equals(input.Description))
                ) && 
                (
                    this.TrainingSetType == input.TrainingSetType ||
                    (this.TrainingSetType != null &&
                    this.TrainingSetType.Equals(input.TrainingSetType))
                ) && 
                (
                    this.TrainingSetStatus == input.TrainingSetStatus ||
                    (this.TrainingSetStatus != null &&
                    this.TrainingSetStatus.Equals(input.TrainingSetStatus))
                ) && 
                (
                    this.Tools == input.Tools ||
                    this.Tools != null &&
                    this.Tools.SequenceEqual(input.Tools)
                ) && 
                (
                    this.ContentItem == input.ContentItem ||
                    (this.ContentItem != null &&
                    this.ContentItem.Equals(input.ContentItem))
                ) && 
                (
                    this.Tags == input.Tags ||
                    this.Tags != null &&
                    this.Tags.SequenceEqual(input.Tags)
                ) && 
                (
                    this.Models == input.Models ||
                    this.Models != null &&
                    this.Models.SequenceEqual(input.Models)
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.UID != null)
                    hashCode = hashCode * 59 + this.UID.GetHashCode();
                if (this.Name != null)
                    hashCode = hashCode * 59 + this.Name.GetHashCode();
                if (this.Description != null)
                    hashCode = hashCode * 59 + this.Description.GetHashCode();
                if (this.TrainingSetType != null)
                    hashCode = hashCode * 59 + this.TrainingSetType.GetHashCode();
                if (this.TrainingSetStatus != null)
                    hashCode = hashCode * 59 + this.TrainingSetStatus.GetHashCode();
                if (this.Tools != null)
                    hashCode = hashCode * 59 + this.Tools.GetHashCode();
                if (this.ContentItem != null)
                    hashCode = hashCode * 59 + this.ContentItem.GetHashCode();
                if (this.Tags != null)
                    hashCode = hashCode * 59 + this.Tags.GetHashCode();
                if (this.Models != null)
                    hashCode = hashCode * 59 + this.Models.GetHashCode();
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }

}
