/* 
 * its4land Public API
 *
 * The its4land Public API provides access to the services of the its4land Publish and Share platform.
 *
 * OpenAPI spec version: 0.0.2
 * Contact: contact@its4land.com
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */

using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using RestSharp;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace IO.Swagger.Api
{
    /// <summary>
    /// Represents a collection of functions to interact with the API endpoints
    /// </summary>
    public interface IProjectsApi : IApiAccessor
    {
        #region Synchronous Operations
        /// <summary>
        /// Adds a tag to the project
        /// </summary>
        /// <remarks>
        /// Creates a new tag and attach it to the project. If the tag already exist, the existing tag will be attached to the project.
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="projectUid">Project UID</param>
        /// <param name="newtag">New Tag data</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <param name="i4lProcessUid">Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional)</param>
        /// <returns>ProjectsEndpointType</returns>
        ProjectsEndpointType AddTagToProject (string projectUid, TagsPostRequest newtag, string envelope = null, List<string> embed = null, string i4lProcessUid = null);

        /// <summary>
        /// Adds a tag to the project
        /// </summary>
        /// <remarks>
        /// Creates a new tag and attach it to the project. If the tag already exist, the existing tag will be attached to the project.
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="projectUid">Project UID</param>
        /// <param name="newtag">New Tag data</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <param name="i4lProcessUid">Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional)</param>
        /// <returns>ApiResponse of ProjectsEndpointType</returns>
        ApiResponse<ProjectsEndpointType> AddTagToProjectWithHttpInfo (string projectUid, TagsPostRequest newtag, string envelope = null, List<string> embed = null, string i4lProcessUid = null);
        /// <summary>
        /// Deletes a single e project by its UID
        /// </summary>
        /// <remarks>
        /// A single project is deleted. This endpoint deletes the project itself and the connected to subordered data like SpatialSources, etc. The subordered data itself are not deleted
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="projectUid">UID of the project</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <param name="i4lProcessUid">Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional)</param>
        /// <returns>ProjectsEndpointType</returns>
        ProjectsEndpointType DelProjectByUID (string projectUid, string envelope = null, List<string> embed = null, string i4lProcessUid = null);

        /// <summary>
        /// Deletes a single e project by its UID
        /// </summary>
        /// <remarks>
        /// A single project is deleted. This endpoint deletes the project itself and the connected to subordered data like SpatialSources, etc. The subordered data itself are not deleted
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="projectUid">UID of the project</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <param name="i4lProcessUid">Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional)</param>
        /// <returns>ApiResponse of ProjectsEndpointType</returns>
        ApiResponse<ProjectsEndpointType> DelProjectByUIDWithHttpInfo (string projectUid, string envelope = null, List<string> embed = null, string i4lProcessUid = null);
        /// <summary>
        /// Removes a model from a project.
        /// </summary>
        /// <remarks>
        /// Removes a model from a project. By default only the link between model and project is removed.
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="projectUid">Project UID</param>
        /// <param name="modelUid">Model UID</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="forceDelete">Deletes the model resource. ********* What&#39;s about subordinate resources? ********* (optional)</param>
        /// <returns>ProjectsEndpointType</returns>
        ProjectsEndpointType DetachProjectModel (string projectUid, string modelUid, string envelope = null, string forceDelete = null);

        /// <summary>
        /// Removes a model from a project.
        /// </summary>
        /// <remarks>
        /// Removes a model from a project. By default only the link between model and project is removed.
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="projectUid">Project UID</param>
        /// <param name="modelUid">Model UID</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="forceDelete">Deletes the model resource. ********* What&#39;s about subordinate resources? ********* (optional)</param>
        /// <returns>ApiResponse of ProjectsEndpointType</returns>
        ApiResponse<ProjectsEndpointType> DetachProjectModelWithHttpInfo (string projectUid, string modelUid, string envelope = null, string forceDelete = null);
        /// <summary>
        /// Removes a spatialsource from a project.
        /// </summary>
        /// <remarks>
        /// Removes a spatial from a project. By default only the link between spatialsource and project is removed.
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="projectUid">Project UID</param>
        /// <param name="spatialsourceUid">SpatialSource UID</param>
        /// <param name="forceDelete">Deletes the spatialsource resource. ********* What&#39;s about subordinate resources? ********* (optional)</param>
        /// <returns>ProjectsEndpointType</returns>
        ProjectsEndpointType DetachProjectSpatialSource (string projectUid, string spatialsourceUid, string forceDelete = null);

        /// <summary>
        /// Removes a spatialsource from a project.
        /// </summary>
        /// <remarks>
        /// Removes a spatial from a project. By default only the link between spatialsource and project is removed.
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="projectUid">Project UID</param>
        /// <param name="spatialsourceUid">SpatialSource UID</param>
        /// <param name="forceDelete">Deletes the spatialsource resource. ********* What&#39;s about subordinate resources? ********* (optional)</param>
        /// <returns>ApiResponse of ProjectsEndpointType</returns>
        ApiResponse<ProjectsEndpointType> DetachProjectSpatialSourceWithHttpInfo (string projectUid, string spatialsourceUid, string forceDelete = null);
        /// <summary>
        /// Removes a tag from a project.
        /// </summary>
        /// <remarks>
        /// Removes a tag from a project. By default only the link between tag and project is removed.
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="projectUid">Project UID</param>
        /// <param name="tag">tag value</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="forceDelete">Deletes the tag resource. ********* Only possible, when tag is not attached to any other resource. ********* (optional)</param>
        /// <returns>ProjectsEndpointType</returns>
        ProjectsEndpointType DetachProjectTag (string projectUid, string tag, string envelope = null, string forceDelete = null);

        /// <summary>
        /// Removes a tag from a project.
        /// </summary>
        /// <remarks>
        /// Removes a tag from a project. By default only the link between tag and project is removed.
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="projectUid">Project UID</param>
        /// <param name="tag">tag value</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="forceDelete">Deletes the tag resource. ********* Only possible, when tag is not attached to any other resource. ********* (optional)</param>
        /// <returns>ApiResponse of ProjectsEndpointType</returns>
        ApiResponse<ProjectsEndpointType> DetachProjectTagWithHttpInfo (string projectUid, string tag, string envelope = null, string forceDelete = null);
        /// <summary>
        /// Returns an array of connect objects
        /// </summary>
        /// <remarks>
        /// Returns an array of connect objects of a project. For each connected object the endpoint returns the type, name and uuid
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="projectUid">Project UID</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="page">Requests for collections can return between 0 and N results, controlled using the per_page and page query parameters. All endpoints are limited to 10 results by default. (optional)</param>
        /// <param name="sort">The sorting is initiated by the sort query parameter and a list of comma separated list of fields to sort by. (optional)</param>
        /// <param name="fields">Comma separated list of field names (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <returns>ConnectedObjectsEndpointType</returns>
        ConnectedObjectsEndpointType GetConnectedObjectsByProjectUID (string projectUid, string envelope = null, int? page = null, string sort = null, List<string> fields = null, List<string> embed = null);

        /// <summary>
        /// Returns an array of connect objects
        /// </summary>
        /// <remarks>
        /// Returns an array of connect objects of a project. For each connected object the endpoint returns the type, name and uuid
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="projectUid">Project UID</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="page">Requests for collections can return between 0 and N results, controlled using the per_page and page query parameters. All endpoints are limited to 10 results by default. (optional)</param>
        /// <param name="sort">The sorting is initiated by the sort query parameter and a list of comma separated list of fields to sort by. (optional)</param>
        /// <param name="fields">Comma separated list of field names (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <returns>ApiResponse of ConnectedObjectsEndpointType</returns>
        ApiResponse<ConnectedObjectsEndpointType> GetConnectedObjectsByProjectUIDWithHttpInfo (string projectUid, string envelope = null, int? page = null, string sort = null, List<string> fields = null, List<string> embed = null);
        /// <summary>
        /// Returns the models of a project
        /// </summary>
        /// <remarks>
        /// Returns the models of a project
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="projectUid">Project UID</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="page">Requests for collections can return between 0 and N results, controlled using the per_page and page query parameters. All endpoints are limited to 10 results by default. (optional)</param>
        /// <param name="sort">The sorting is initiated by the sort query parameter and a list of comma separated list of fields to sort by. (optional)</param>
        /// <param name="fields">Comma separated list of field names (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <returns>List&lt;ModelsEndpointType&gt;</returns>
        List<ModelsEndpointType> GetModelsByProjectUID (string projectUid, string envelope = null, int? page = null, string sort = null, List<string> fields = null, List<string> embed = null);

        /// <summary>
        /// Returns the models of a project
        /// </summary>
        /// <remarks>
        /// Returns the models of a project
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="projectUid">Project UID</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="page">Requests for collections can return between 0 and N results, controlled using the per_page and page query parameters. All endpoints are limited to 10 results by default. (optional)</param>
        /// <param name="sort">The sorting is initiated by the sort query parameter and a list of comma separated list of fields to sort by. (optional)</param>
        /// <param name="fields">Comma separated list of field names (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <returns>ApiResponse of List&lt;ModelsEndpointType&gt;</returns>
        ApiResponse<List<ModelsEndpointType>> GetModelsByProjectUIDWithHttpInfo (string projectUid, string envelope = null, int? page = null, string sort = null, List<string> fields = null, List<string> embed = null);
        /// <summary>
        /// Returns the tags of a project.
        /// </summary>
        /// <remarks>
        /// Is this method really necessary? Returns the tags of a project.
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="projectUid">Project UID</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <returns>TagsListResponse</returns>
        TagsListResponse GetProjectTagsByProjectUID (string projectUid, string envelope = null);

        /// <summary>
        /// Returns the tags of a project.
        /// </summary>
        /// <remarks>
        /// Is this method really necessary? Returns the tags of a project.
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="projectUid">Project UID</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <returns>ApiResponse of TagsListResponse</returns>
        ApiResponse<TagsListResponse> GetProjectTagsByProjectUIDWithHttpInfo (string projectUid, string envelope = null);
        /// <summary>
        /// Get a GeoJSON structure containing a list of Projects.
        /// </summary>
        /// <remarks>
        /// Get a GeoJSON structure containing a list of Projects. A single project is modeled as a GeoJSON feature.
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="uid">Comma separated list of UID (optional)</param>
        /// <param name="name">Comma separated list of names (optional)</param>
        /// <param name="aoi">Polygon. The polygon is encoded a comma separated list of coordinates. X1, Y1, X2, Y2, ..., Xn, Yn, X1, Y1 (optional)</param>
        /// <param name="tags">Comma separated list of tags (optional)</param>
        /// <param name="page">Requests for collections can return between 0 and N results, controlled using the per_page and page query parameters. All endpoints are limited to 10 results by default. (optional)</param>
        /// <param name="sort">The sorting is initiated by the sort query parameter and a list of comma separated list of fields to sort by. (optional)</param>
        /// <param name="fields">Comma separated list of field names (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <returns>ProjectsEndpointType</returns>
        ProjectsEndpointType GetProjects (string envelope = null, List<string> uid = null, List<string> name = null, string aoi = null, List<string> tags = null, int? page = null, string sort = null, List<string> fields = null, List<string> embed = null);

        /// <summary>
        /// Get a GeoJSON structure containing a list of Projects.
        /// </summary>
        /// <remarks>
        /// Get a GeoJSON structure containing a list of Projects. A single project is modeled as a GeoJSON feature.
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="uid">Comma separated list of UID (optional)</param>
        /// <param name="name">Comma separated list of names (optional)</param>
        /// <param name="aoi">Polygon. The polygon is encoded a comma separated list of coordinates. X1, Y1, X2, Y2, ..., Xn, Yn, X1, Y1 (optional)</param>
        /// <param name="tags">Comma separated list of tags (optional)</param>
        /// <param name="page">Requests for collections can return between 0 and N results, controlled using the per_page and page query parameters. All endpoints are limited to 10 results by default. (optional)</param>
        /// <param name="sort">The sorting is initiated by the sort query parameter and a list of comma separated list of fields to sort by. (optional)</param>
        /// <param name="fields">Comma separated list of field names (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <returns>ApiResponse of ProjectsEndpointType</returns>
        ApiResponse<ProjectsEndpointType> GetProjectsWithHttpInfo (string envelope = null, List<string> uid = null, List<string> name = null, string aoi = null, List<string> tags = null, int? page = null, string sort = null, List<string> fields = null, List<string> embed = null);
        /// <summary>
        /// Getting single Projects by its UID
        /// </summary>
        /// <remarks>
        /// Getting single Projects by its UID. The project is modeled as a feature in a GeoJSON structure.
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="projectUid">UID of the project</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <returns>ProjectsEndpointType</returns>
        ProjectsEndpointType GetProjectsByUID (string projectUid, string envelope = null, List<string> embed = null);

        /// <summary>
        /// Getting single Projects by its UID
        /// </summary>
        /// <remarks>
        /// Getting single Projects by its UID. The project is modeled as a feature in a GeoJSON structure.
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="projectUid">UID of the project</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <returns>ApiResponse of ProjectsEndpointType</returns>
        ApiResponse<ProjectsEndpointType> GetProjectsByUIDWithHttpInfo (string projectUid, string envelope = null, List<string> embed = null);
        /// <summary>
        /// Returns the SpatialSources of a Project.
        /// </summary>
        /// <remarks>
        /// Returns the SpatialSources of a Project.
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="projectUid">Project UID</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="page">Requests for collections can return between 0 and N results, controlled using the per_page and page query parameters. All endpoints are limited to 10 results by default. (optional)</param>
        /// <param name="sort">The sorting is initiated by the sort query parameter and a list of comma separated list of fields to sort by. (optional)</param>
        /// <param name="fields">Comma separated list of field names (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <returns>List&lt;SpatialSourcesEndpointType&gt;</returns>
        List<SpatialSourcesEndpointType> GetSpatialSourceByProjectUID (string projectUid, string envelope = null, int? page = null, string sort = null, List<string> fields = null, List<string> embed = null);

        /// <summary>
        /// Returns the SpatialSources of a Project.
        /// </summary>
        /// <remarks>
        /// Returns the SpatialSources of a Project.
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="projectUid">Project UID</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="page">Requests for collections can return between 0 and N results, controlled using the per_page and page query parameters. All endpoints are limited to 10 results by default. (optional)</param>
        /// <param name="sort">The sorting is initiated by the sort query parameter and a list of comma separated list of fields to sort by. (optional)</param>
        /// <param name="fields">Comma separated list of field names (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <returns>ApiResponse of List&lt;SpatialSourcesEndpointType&gt;</returns>
        ApiResponse<List<SpatialSourcesEndpointType>> GetSpatialSourceByProjectUIDWithHttpInfo (string projectUid, string envelope = null, int? page = null, string sort = null, List<string> fields = null, List<string> embed = null);
        /// <summary>
        /// Create a new model
        /// </summary>
        /// <remarks>
        /// Create a new model.  To add a new Model , the content of Models  must be stored in advanced via the ContentItem endpoint
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="projectUid">Project UID</param>
        /// <param name="newmodel">New model data</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <param name="i4lProcessUid">Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional)</param>
        /// <returns>ProjectsEndpointType</returns>
        ProjectsEndpointType NewModelUnderProject (string projectUid, ModelsPostRequest newmodel, string envelope = null, List<string> embed = null, string i4lProcessUid = null);

        /// <summary>
        /// Create a new model
        /// </summary>
        /// <remarks>
        /// Create a new model.  To add a new Model , the content of Models  must be stored in advanced via the ContentItem endpoint
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="projectUid">Project UID</param>
        /// <param name="newmodel">New model data</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <param name="i4lProcessUid">Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional)</param>
        /// <returns>ApiResponse of ProjectsEndpointType</returns>
        ApiResponse<ProjectsEndpointType> NewModelUnderProjectWithHttpInfo (string projectUid, ModelsPostRequest newmodel, string envelope = null, List<string> embed = null, string i4lProcessUid = null);
        /// <summary>
        /// Create a new project
        /// </summary>
        /// <remarks>
        /// Create a new project. The new project is modeled as a feature in a GeoJSON structure. Currently only one project feature is allowed.
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="newproject">New project data</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <param name="i4lProcessUid">Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional)</param>
        /// <returns>ProjectsEndpointType</returns>
        ProjectsEndpointType NewProject (ProjectsPostRequest newproject, string envelope = null, List<string> embed = null, string i4lProcessUid = null);

        /// <summary>
        /// Create a new project
        /// </summary>
        /// <remarks>
        /// Create a new project. The new project is modeled as a feature in a GeoJSON structure. Currently only one project feature is allowed.
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="newproject">New project data</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <param name="i4lProcessUid">Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional)</param>
        /// <returns>ApiResponse of ProjectsEndpointType</returns>
        ApiResponse<ProjectsEndpointType> NewProjectWithHttpInfo (ProjectsPostRequest newproject, string envelope = null, List<string> embed = null, string i4lProcessUid = null);
        /// <summary>
        /// Create a new SpatialSource
        /// </summary>
        /// <remarks>
        /// Create a new SpatialSource. To add a new SpatialSource , the content of SpatialSource  must be stored in advanced via the ContentItem endpoint
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="projectUid">Project UID</param>
        /// <param name="newspatialsource">New SpatialSource data</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <param name="i4lProcessUid">Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional)</param>
        /// <returns>ProjectsEndpointType</returns>
        ProjectsEndpointType NewSpatialSourceUnderProject (string projectUid, SpatialSourcesPostRequest newspatialsource, string envelope = null, List<string> embed = null, string i4lProcessUid = null);

        /// <summary>
        /// Create a new SpatialSource
        /// </summary>
        /// <remarks>
        /// Create a new SpatialSource. To add a new SpatialSource , the content of SpatialSource  must be stored in advanced via the ContentItem endpoint
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="projectUid">Project UID</param>
        /// <param name="newspatialsource">New SpatialSource data</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <param name="i4lProcessUid">Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional)</param>
        /// <returns>ApiResponse of ProjectsEndpointType</returns>
        ApiResponse<ProjectsEndpointType> NewSpatialSourceUnderProjectWithHttpInfo (string projectUid, SpatialSourcesPostRequest newspatialsource, string envelope = null, List<string> embed = null, string i4lProcessUid = null);
        /// <summary>
        /// Update a project
        /// </summary>
        /// <remarks>
        /// Updates some attributes of a project.
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="projectUid">Project UID to be patched</param>
        /// <param name="patchproject">Update data</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <param name="i4lProcessUid">Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional)</param>
        /// <returns>ProjectsEndpointType</returns>
        ProjectsEndpointType UpdateProjects (string projectUid, RFC6902PatchRequest patchproject, string envelope = null, List<string> embed = null, string i4lProcessUid = null);

        /// <summary>
        /// Update a project
        /// </summary>
        /// <remarks>
        /// Updates some attributes of a project.
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="projectUid">Project UID to be patched</param>
        /// <param name="patchproject">Update data</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <param name="i4lProcessUid">Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional)</param>
        /// <returns>ApiResponse of ProjectsEndpointType</returns>
        ApiResponse<ProjectsEndpointType> UpdateProjectsWithHttpInfo (string projectUid, RFC6902PatchRequest patchproject, string envelope = null, List<string> embed = null, string i4lProcessUid = null);
        #endregion Synchronous Operations
        #region Asynchronous Operations
        /// <summary>
        /// Adds a tag to the project
        /// </summary>
        /// <remarks>
        /// Creates a new tag and attach it to the project. If the tag already exist, the existing tag will be attached to the project.
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="projectUid">Project UID</param>
        /// <param name="newtag">New Tag data</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <param name="i4lProcessUid">Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional)</param>
        /// <returns>Task of ProjectsEndpointType</returns>
        System.Threading.Tasks.Task<ProjectsEndpointType> AddTagToProjectAsync (string projectUid, TagsPostRequest newtag, string envelope = null, List<string> embed = null, string i4lProcessUid = null);

        /// <summary>
        /// Adds a tag to the project
        /// </summary>
        /// <remarks>
        /// Creates a new tag and attach it to the project. If the tag already exist, the existing tag will be attached to the project.
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="projectUid">Project UID</param>
        /// <param name="newtag">New Tag data</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <param name="i4lProcessUid">Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional)</param>
        /// <returns>Task of ApiResponse (ProjectsEndpointType)</returns>
        System.Threading.Tasks.Task<ApiResponse<ProjectsEndpointType>> AddTagToProjectAsyncWithHttpInfo (string projectUid, TagsPostRequest newtag, string envelope = null, List<string> embed = null, string i4lProcessUid = null);
        /// <summary>
        /// Deletes a single e project by its UID
        /// </summary>
        /// <remarks>
        /// A single project is deleted. This endpoint deletes the project itself and the connected to subordered data like SpatialSources, etc. The subordered data itself are not deleted
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="projectUid">UID of the project</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <param name="i4lProcessUid">Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional)</param>
        /// <returns>Task of ProjectsEndpointType</returns>
        System.Threading.Tasks.Task<ProjectsEndpointType> DelProjectByUIDAsync (string projectUid, string envelope = null, List<string> embed = null, string i4lProcessUid = null);

        /// <summary>
        /// Deletes a single e project by its UID
        /// </summary>
        /// <remarks>
        /// A single project is deleted. This endpoint deletes the project itself and the connected to subordered data like SpatialSources, etc. The subordered data itself are not deleted
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="projectUid">UID of the project</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <param name="i4lProcessUid">Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional)</param>
        /// <returns>Task of ApiResponse (ProjectsEndpointType)</returns>
        System.Threading.Tasks.Task<ApiResponse<ProjectsEndpointType>> DelProjectByUIDAsyncWithHttpInfo (string projectUid, string envelope = null, List<string> embed = null, string i4lProcessUid = null);
        /// <summary>
        /// Removes a model from a project.
        /// </summary>
        /// <remarks>
        /// Removes a model from a project. By default only the link between model and project is removed.
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="projectUid">Project UID</param>
        /// <param name="modelUid">Model UID</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="forceDelete">Deletes the model resource. ********* What&#39;s about subordinate resources? ********* (optional)</param>
        /// <returns>Task of ProjectsEndpointType</returns>
        System.Threading.Tasks.Task<ProjectsEndpointType> DetachProjectModelAsync (string projectUid, string modelUid, string envelope = null, string forceDelete = null);

        /// <summary>
        /// Removes a model from a project.
        /// </summary>
        /// <remarks>
        /// Removes a model from a project. By default only the link between model and project is removed.
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="projectUid">Project UID</param>
        /// <param name="modelUid">Model UID</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="forceDelete">Deletes the model resource. ********* What&#39;s about subordinate resources? ********* (optional)</param>
        /// <returns>Task of ApiResponse (ProjectsEndpointType)</returns>
        System.Threading.Tasks.Task<ApiResponse<ProjectsEndpointType>> DetachProjectModelAsyncWithHttpInfo (string projectUid, string modelUid, string envelope = null, string forceDelete = null);
        /// <summary>
        /// Removes a spatialsource from a project.
        /// </summary>
        /// <remarks>
        /// Removes a spatial from a project. By default only the link between spatialsource and project is removed.
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="projectUid">Project UID</param>
        /// <param name="spatialsourceUid">SpatialSource UID</param>
        /// <param name="forceDelete">Deletes the spatialsource resource. ********* What&#39;s about subordinate resources? ********* (optional)</param>
        /// <returns>Task of ProjectsEndpointType</returns>
        System.Threading.Tasks.Task<ProjectsEndpointType> DetachProjectSpatialSourceAsync (string projectUid, string spatialsourceUid, string forceDelete = null);

        /// <summary>
        /// Removes a spatialsource from a project.
        /// </summary>
        /// <remarks>
        /// Removes a spatial from a project. By default only the link between spatialsource and project is removed.
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="projectUid">Project UID</param>
        /// <param name="spatialsourceUid">SpatialSource UID</param>
        /// <param name="forceDelete">Deletes the spatialsource resource. ********* What&#39;s about subordinate resources? ********* (optional)</param>
        /// <returns>Task of ApiResponse (ProjectsEndpointType)</returns>
        System.Threading.Tasks.Task<ApiResponse<ProjectsEndpointType>> DetachProjectSpatialSourceAsyncWithHttpInfo (string projectUid, string spatialsourceUid, string forceDelete = null);
        /// <summary>
        /// Removes a tag from a project.
        /// </summary>
        /// <remarks>
        /// Removes a tag from a project. By default only the link between tag and project is removed.
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="projectUid">Project UID</param>
        /// <param name="tag">tag value</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="forceDelete">Deletes the tag resource. ********* Only possible, when tag is not attached to any other resource. ********* (optional)</param>
        /// <returns>Task of ProjectsEndpointType</returns>
        System.Threading.Tasks.Task<ProjectsEndpointType> DetachProjectTagAsync (string projectUid, string tag, string envelope = null, string forceDelete = null);

        /// <summary>
        /// Removes a tag from a project.
        /// </summary>
        /// <remarks>
        /// Removes a tag from a project. By default only the link between tag and project is removed.
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="projectUid">Project UID</param>
        /// <param name="tag">tag value</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="forceDelete">Deletes the tag resource. ********* Only possible, when tag is not attached to any other resource. ********* (optional)</param>
        /// <returns>Task of ApiResponse (ProjectsEndpointType)</returns>
        System.Threading.Tasks.Task<ApiResponse<ProjectsEndpointType>> DetachProjectTagAsyncWithHttpInfo (string projectUid, string tag, string envelope = null, string forceDelete = null);
        /// <summary>
        /// Returns an array of connect objects
        /// </summary>
        /// <remarks>
        /// Returns an array of connect objects of a project. For each connected object the endpoint returns the type, name and uuid
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="projectUid">Project UID</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="page">Requests for collections can return between 0 and N results, controlled using the per_page and page query parameters. All endpoints are limited to 10 results by default. (optional)</param>
        /// <param name="sort">The sorting is initiated by the sort query parameter and a list of comma separated list of fields to sort by. (optional)</param>
        /// <param name="fields">Comma separated list of field names (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <returns>Task of ConnectedObjectsEndpointType</returns>
        System.Threading.Tasks.Task<ConnectedObjectsEndpointType> GetConnectedObjectsByProjectUIDAsync (string projectUid, string envelope = null, int? page = null, string sort = null, List<string> fields = null, List<string> embed = null);

        /// <summary>
        /// Returns an array of connect objects
        /// </summary>
        /// <remarks>
        /// Returns an array of connect objects of a project. For each connected object the endpoint returns the type, name and uuid
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="projectUid">Project UID</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="page">Requests for collections can return between 0 and N results, controlled using the per_page and page query parameters. All endpoints are limited to 10 results by default. (optional)</param>
        /// <param name="sort">The sorting is initiated by the sort query parameter and a list of comma separated list of fields to sort by. (optional)</param>
        /// <param name="fields">Comma separated list of field names (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <returns>Task of ApiResponse (ConnectedObjectsEndpointType)</returns>
        System.Threading.Tasks.Task<ApiResponse<ConnectedObjectsEndpointType>> GetConnectedObjectsByProjectUIDAsyncWithHttpInfo (string projectUid, string envelope = null, int? page = null, string sort = null, List<string> fields = null, List<string> embed = null);
        /// <summary>
        /// Returns the models of a project
        /// </summary>
        /// <remarks>
        /// Returns the models of a project
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="projectUid">Project UID</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="page">Requests for collections can return between 0 and N results, controlled using the per_page and page query parameters. All endpoints are limited to 10 results by default. (optional)</param>
        /// <param name="sort">The sorting is initiated by the sort query parameter and a list of comma separated list of fields to sort by. (optional)</param>
        /// <param name="fields">Comma separated list of field names (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <returns>Task of List&lt;ModelsEndpointType&gt;</returns>
        System.Threading.Tasks.Task<List<ModelsEndpointType>> GetModelsByProjectUIDAsync (string projectUid, string envelope = null, int? page = null, string sort = null, List<string> fields = null, List<string> embed = null);

        /// <summary>
        /// Returns the models of a project
        /// </summary>
        /// <remarks>
        /// Returns the models of a project
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="projectUid">Project UID</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="page">Requests for collections can return between 0 and N results, controlled using the per_page and page query parameters. All endpoints are limited to 10 results by default. (optional)</param>
        /// <param name="sort">The sorting is initiated by the sort query parameter and a list of comma separated list of fields to sort by. (optional)</param>
        /// <param name="fields">Comma separated list of field names (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <returns>Task of ApiResponse (List&lt;ModelsEndpointType&gt;)</returns>
        System.Threading.Tasks.Task<ApiResponse<List<ModelsEndpointType>>> GetModelsByProjectUIDAsyncWithHttpInfo (string projectUid, string envelope = null, int? page = null, string sort = null, List<string> fields = null, List<string> embed = null);
        /// <summary>
        /// Returns the tags of a project.
        /// </summary>
        /// <remarks>
        /// Is this method really necessary? Returns the tags of a project.
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="projectUid">Project UID</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <returns>Task of TagsListResponse</returns>
        System.Threading.Tasks.Task<TagsListResponse> GetProjectTagsByProjectUIDAsync (string projectUid, string envelope = null);

        /// <summary>
        /// Returns the tags of a project.
        /// </summary>
        /// <remarks>
        /// Is this method really necessary? Returns the tags of a project.
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="projectUid">Project UID</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <returns>Task of ApiResponse (TagsListResponse)</returns>
        System.Threading.Tasks.Task<ApiResponse<TagsListResponse>> GetProjectTagsByProjectUIDAsyncWithHttpInfo (string projectUid, string envelope = null);
        /// <summary>
        /// Get a GeoJSON structure containing a list of Projects.
        /// </summary>
        /// <remarks>
        /// Get a GeoJSON structure containing a list of Projects. A single project is modeled as a GeoJSON feature.
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="uid">Comma separated list of UID (optional)</param>
        /// <param name="name">Comma separated list of names (optional)</param>
        /// <param name="aoi">Polygon. The polygon is encoded a comma separated list of coordinates. X1, Y1, X2, Y2, ..., Xn, Yn, X1, Y1 (optional)</param>
        /// <param name="tags">Comma separated list of tags (optional)</param>
        /// <param name="page">Requests for collections can return between 0 and N results, controlled using the per_page and page query parameters. All endpoints are limited to 10 results by default. (optional)</param>
        /// <param name="sort">The sorting is initiated by the sort query parameter and a list of comma separated list of fields to sort by. (optional)</param>
        /// <param name="fields">Comma separated list of field names (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <returns>Task of ProjectsEndpointType</returns>
        System.Threading.Tasks.Task<ProjectsEndpointType> GetProjectsAsync (string envelope = null, List<string> uid = null, List<string> name = null, string aoi = null, List<string> tags = null, int? page = null, string sort = null, List<string> fields = null, List<string> embed = null);

        /// <summary>
        /// Get a GeoJSON structure containing a list of Projects.
        /// </summary>
        /// <remarks>
        /// Get a GeoJSON structure containing a list of Projects. A single project is modeled as a GeoJSON feature.
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="uid">Comma separated list of UID (optional)</param>
        /// <param name="name">Comma separated list of names (optional)</param>
        /// <param name="aoi">Polygon. The polygon is encoded a comma separated list of coordinates. X1, Y1, X2, Y2, ..., Xn, Yn, X1, Y1 (optional)</param>
        /// <param name="tags">Comma separated list of tags (optional)</param>
        /// <param name="page">Requests for collections can return between 0 and N results, controlled using the per_page and page query parameters. All endpoints are limited to 10 results by default. (optional)</param>
        /// <param name="sort">The sorting is initiated by the sort query parameter and a list of comma separated list of fields to sort by. (optional)</param>
        /// <param name="fields">Comma separated list of field names (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <returns>Task of ApiResponse (ProjectsEndpointType)</returns>
        System.Threading.Tasks.Task<ApiResponse<ProjectsEndpointType>> GetProjectsAsyncWithHttpInfo (string envelope = null, List<string> uid = null, List<string> name = null, string aoi = null, List<string> tags = null, int? page = null, string sort = null, List<string> fields = null, List<string> embed = null);
        /// <summary>
        /// Getting single Projects by its UID
        /// </summary>
        /// <remarks>
        /// Getting single Projects by its UID. The project is modeled as a feature in a GeoJSON structure.
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="projectUid">UID of the project</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <returns>Task of ProjectsEndpointType</returns>
        System.Threading.Tasks.Task<ProjectsEndpointType> GetProjectsByUIDAsync (string projectUid, string envelope = null, List<string> embed = null);

        /// <summary>
        /// Getting single Projects by its UID
        /// </summary>
        /// <remarks>
        /// Getting single Projects by its UID. The project is modeled as a feature in a GeoJSON structure.
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="projectUid">UID of the project</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <returns>Task of ApiResponse (ProjectsEndpointType)</returns>
        System.Threading.Tasks.Task<ApiResponse<ProjectsEndpointType>> GetProjectsByUIDAsyncWithHttpInfo (string projectUid, string envelope = null, List<string> embed = null);
        /// <summary>
        /// Returns the SpatialSources of a Project.
        /// </summary>
        /// <remarks>
        /// Returns the SpatialSources of a Project.
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="projectUid">Project UID</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="page">Requests for collections can return between 0 and N results, controlled using the per_page and page query parameters. All endpoints are limited to 10 results by default. (optional)</param>
        /// <param name="sort">The sorting is initiated by the sort query parameter and a list of comma separated list of fields to sort by. (optional)</param>
        /// <param name="fields">Comma separated list of field names (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <returns>Task of List&lt;SpatialSourcesEndpointType&gt;</returns>
        System.Threading.Tasks.Task<List<SpatialSourcesEndpointType>> GetSpatialSourceByProjectUIDAsync (string projectUid, string envelope = null, int? page = null, string sort = null, List<string> fields = null, List<string> embed = null);

        /// <summary>
        /// Returns the SpatialSources of a Project.
        /// </summary>
        /// <remarks>
        /// Returns the SpatialSources of a Project.
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="projectUid">Project UID</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="page">Requests for collections can return between 0 and N results, controlled using the per_page and page query parameters. All endpoints are limited to 10 results by default. (optional)</param>
        /// <param name="sort">The sorting is initiated by the sort query parameter and a list of comma separated list of fields to sort by. (optional)</param>
        /// <param name="fields">Comma separated list of field names (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <returns>Task of ApiResponse (List&lt;SpatialSourcesEndpointType&gt;)</returns>
        System.Threading.Tasks.Task<ApiResponse<List<SpatialSourcesEndpointType>>> GetSpatialSourceByProjectUIDAsyncWithHttpInfo (string projectUid, string envelope = null, int? page = null, string sort = null, List<string> fields = null, List<string> embed = null);
        /// <summary>
        /// Create a new model
        /// </summary>
        /// <remarks>
        /// Create a new model.  To add a new Model , the content of Models  must be stored in advanced via the ContentItem endpoint
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="projectUid">Project UID</param>
        /// <param name="newmodel">New model data</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <param name="i4lProcessUid">Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional)</param>
        /// <returns>Task of ProjectsEndpointType</returns>
        System.Threading.Tasks.Task<ProjectsEndpointType> NewModelUnderProjectAsync (string projectUid, ModelsPostRequest newmodel, string envelope = null, List<string> embed = null, string i4lProcessUid = null);

        /// <summary>
        /// Create a new model
        /// </summary>
        /// <remarks>
        /// Create a new model.  To add a new Model , the content of Models  must be stored in advanced via the ContentItem endpoint
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="projectUid">Project UID</param>
        /// <param name="newmodel">New model data</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <param name="i4lProcessUid">Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional)</param>
        /// <returns>Task of ApiResponse (ProjectsEndpointType)</returns>
        System.Threading.Tasks.Task<ApiResponse<ProjectsEndpointType>> NewModelUnderProjectAsyncWithHttpInfo (string projectUid, ModelsPostRequest newmodel, string envelope = null, List<string> embed = null, string i4lProcessUid = null);
        /// <summary>
        /// Create a new project
        /// </summary>
        /// <remarks>
        /// Create a new project. The new project is modeled as a feature in a GeoJSON structure. Currently only one project feature is allowed.
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="newproject">New project data</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <param name="i4lProcessUid">Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional)</param>
        /// <returns>Task of ProjectsEndpointType</returns>
        System.Threading.Tasks.Task<ProjectsEndpointType> NewProjectAsync (ProjectsPostRequest newproject, string envelope = null, List<string> embed = null, string i4lProcessUid = null);

        /// <summary>
        /// Create a new project
        /// </summary>
        /// <remarks>
        /// Create a new project. The new project is modeled as a feature in a GeoJSON structure. Currently only one project feature is allowed.
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="newproject">New project data</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <param name="i4lProcessUid">Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional)</param>
        /// <returns>Task of ApiResponse (ProjectsEndpointType)</returns>
        System.Threading.Tasks.Task<ApiResponse<ProjectsEndpointType>> NewProjectAsyncWithHttpInfo (ProjectsPostRequest newproject, string envelope = null, List<string> embed = null, string i4lProcessUid = null);
        /// <summary>
        /// Create a new SpatialSource
        /// </summary>
        /// <remarks>
        /// Create a new SpatialSource. To add a new SpatialSource , the content of SpatialSource  must be stored in advanced via the ContentItem endpoint
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="projectUid">Project UID</param>
        /// <param name="newspatialsource">New SpatialSource data</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <param name="i4lProcessUid">Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional)</param>
        /// <returns>Task of ProjectsEndpointType</returns>
        System.Threading.Tasks.Task<ProjectsEndpointType> NewSpatialSourceUnderProjectAsync (string projectUid, SpatialSourcesPostRequest newspatialsource, string envelope = null, List<string> embed = null, string i4lProcessUid = null);

        /// <summary>
        /// Create a new SpatialSource
        /// </summary>
        /// <remarks>
        /// Create a new SpatialSource. To add a new SpatialSource , the content of SpatialSource  must be stored in advanced via the ContentItem endpoint
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="projectUid">Project UID</param>
        /// <param name="newspatialsource">New SpatialSource data</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <param name="i4lProcessUid">Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional)</param>
        /// <returns>Task of ApiResponse (ProjectsEndpointType)</returns>
        System.Threading.Tasks.Task<ApiResponse<ProjectsEndpointType>> NewSpatialSourceUnderProjectAsyncWithHttpInfo (string projectUid, SpatialSourcesPostRequest newspatialsource, string envelope = null, List<string> embed = null, string i4lProcessUid = null);
        /// <summary>
        /// Update a project
        /// </summary>
        /// <remarks>
        /// Updates some attributes of a project.
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="projectUid">Project UID to be patched</param>
        /// <param name="patchproject">Update data</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <param name="i4lProcessUid">Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional)</param>
        /// <returns>Task of ProjectsEndpointType</returns>
        System.Threading.Tasks.Task<ProjectsEndpointType> UpdateProjectsAsync (string projectUid, RFC6902PatchRequest patchproject, string envelope = null, List<string> embed = null, string i4lProcessUid = null);

        /// <summary>
        /// Update a project
        /// </summary>
        /// <remarks>
        /// Updates some attributes of a project.
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="projectUid">Project UID to be patched</param>
        /// <param name="patchproject">Update data</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <param name="i4lProcessUid">Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional)</param>
        /// <returns>Task of ApiResponse (ProjectsEndpointType)</returns>
        System.Threading.Tasks.Task<ApiResponse<ProjectsEndpointType>> UpdateProjectsAsyncWithHttpInfo (string projectUid, RFC6902PatchRequest patchproject, string envelope = null, List<string> embed = null, string i4lProcessUid = null);
        #endregion Asynchronous Operations
    }

    /// <summary>
    /// Represents a collection of functions to interact with the API endpoints
    /// </summary>
    public partial class ProjectsApi : IProjectsApi
    {
        private IO.Swagger.Client.ExceptionFactory _exceptionFactory = (name, response) => null;

        /// <summary>
        /// Initializes a new instance of the <see cref="ProjectsApi"/> class.
        /// </summary>
        /// <returns></returns>
        public ProjectsApi(String basePath)
        {
            this.Configuration = new Configuration { BasePath = basePath };

            ExceptionFactory = IO.Swagger.Client.Configuration.DefaultExceptionFactory;
        }

        /// <summary>
        /// Initializes a new instance of the <see cref="ProjectsApi"/> class
        /// using Configuration object
        /// </summary>
        /// <param name="configuration">An instance of Configuration</param>
        /// <returns></returns>
        public ProjectsApi(Configuration configuration = null)
        {
            if (configuration == null) // use the default one in Configuration
                this.Configuration = Configuration.Default;
            else
                this.Configuration = configuration;

            ExceptionFactory = IO.Swagger.Client.Configuration.DefaultExceptionFactory;
        }

        /// <summary>
        /// Gets the base path of the API client.
        /// </summary>
        /// <value>The base path</value>
        public String GetBasePath()
        {
            return this.Configuration.ApiClient.RestClient.BaseUrl.ToString();
        }

        /// <summary>
        /// Sets the base path of the API client.
        /// </summary>
        /// <value>The base path</value>
        [Obsolete("SetBasePath is deprecated, please do 'Configuration.ApiClient = new ApiClient(\"http://new-path\")' instead.")]
        public void SetBasePath(String basePath)
        {
            // do nothing
        }

        /// <summary>
        /// Gets or sets the configuration object
        /// </summary>
        /// <value>An instance of the Configuration</value>
        public Configuration Configuration {get; set;}

        /// <summary>
        /// Provides a factory method hook for the creation of exceptions.
        /// </summary>
        public IO.Swagger.Client.ExceptionFactory ExceptionFactory
        {
            get
            {
                if (_exceptionFactory != null && _exceptionFactory.GetInvocationList().Length > 1)
                {
                    throw new InvalidOperationException("Multicast delegate for ExceptionFactory is unsupported.");
                }
                return _exceptionFactory;
            }
            set { _exceptionFactory = value; }
        }

        /// <summary>
        /// Gets the default header.
        /// </summary>
        /// <returns>Dictionary of HTTP header</returns>
        [Obsolete("DefaultHeader is deprecated, please use Configuration.DefaultHeader instead.")]
        public IDictionary<String, String> DefaultHeader()
        {
            return new ReadOnlyDictionary<string, string>(this.Configuration.DefaultHeader);
        }

        /// <summary>
        /// Add default header.
        /// </summary>
        /// <param name="key">Header field name.</param>
        /// <param name="value">Header field value.</param>
        /// <returns></returns>
        [Obsolete("AddDefaultHeader is deprecated, please use Configuration.AddDefaultHeader instead.")]
        public void AddDefaultHeader(string key, string value)
        {
            this.Configuration.AddDefaultHeader(key, value);
        }

        /// <summary>
        /// Adds a tag to the project Creates a new tag and attach it to the project. If the tag already exist, the existing tag will be attached to the project.
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="projectUid">Project UID</param>
        /// <param name="newtag">New Tag data</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <param name="i4lProcessUid">Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional)</param>
        /// <returns>ProjectsEndpointType</returns>
        public ProjectsEndpointType AddTagToProject (string projectUid, TagsPostRequest newtag, string envelope = null, List<string> embed = null, string i4lProcessUid = null)
        {
             ApiResponse<ProjectsEndpointType> localVarResponse = AddTagToProjectWithHttpInfo(projectUid, newtag, envelope, embed, i4lProcessUid);
             return localVarResponse.Data;
        }

        /// <summary>
        /// Adds a tag to the project Creates a new tag and attach it to the project. If the tag already exist, the existing tag will be attached to the project.
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="projectUid">Project UID</param>
        /// <param name="newtag">New Tag data</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <param name="i4lProcessUid">Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional)</param>
        /// <returns>ApiResponse of ProjectsEndpointType</returns>
        public ApiResponse< ProjectsEndpointType > AddTagToProjectWithHttpInfo (string projectUid, TagsPostRequest newtag, string envelope = null, List<string> embed = null, string i4lProcessUid = null)
        {
            // verify the required parameter 'projectUid' is set
            if (projectUid == null)
                throw new ApiException(400, "Missing required parameter 'projectUid' when calling ProjectsApi->AddTagToProject");
            // verify the required parameter 'newtag' is set
            if (newtag == null)
                throw new ApiException(400, "Missing required parameter 'newtag' when calling ProjectsApi->AddTagToProject");

            var localVarPath = "/projects/{project_uid}/Tags";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/json"
            };
            String localVarHttpContentType = Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (projectUid != null) localVarPathParams.Add("project_uid", Configuration.ApiClient.ParameterToString(projectUid)); // path parameter
            if (envelope != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("", "envelope", envelope)); // query parameter
            if (embed != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("csv", "embed", embed)); // query parameter
            if (i4lProcessUid != null) localVarHeaderParams.Add("i4l-process-uid", Configuration.ApiClient.ParameterToString(i4lProcessUid)); // header parameter
            if (newtag != null && newtag.GetType() != typeof(byte[]))
            {
                localVarPostBody = Configuration.ApiClient.Serialize(newtag); // http body (model) parameter
            }
            else
            {
                localVarPostBody = newtag; // byte array
            }


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) Configuration.ApiClient.CallApi(localVarPath,
                Method.POST, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("AddTagToProject", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<ProjectsEndpointType>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (ProjectsEndpointType) Configuration.ApiClient.Deserialize(localVarResponse, typeof(ProjectsEndpointType)));
        }

        /// <summary>
        /// Adds a tag to the project Creates a new tag and attach it to the project. If the tag already exist, the existing tag will be attached to the project.
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="projectUid">Project UID</param>
        /// <param name="newtag">New Tag data</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <param name="i4lProcessUid">Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional)</param>
        /// <returns>Task of ProjectsEndpointType</returns>
        public async System.Threading.Tasks.Task<ProjectsEndpointType> AddTagToProjectAsync (string projectUid, TagsPostRequest newtag, string envelope = null, List<string> embed = null, string i4lProcessUid = null)
        {
             ApiResponse<ProjectsEndpointType> localVarResponse = await AddTagToProjectAsyncWithHttpInfo(projectUid, newtag, envelope, embed, i4lProcessUid);
             return localVarResponse.Data;

        }

        /// <summary>
        /// Adds a tag to the project Creates a new tag and attach it to the project. If the tag already exist, the existing tag will be attached to the project.
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="projectUid">Project UID</param>
        /// <param name="newtag">New Tag data</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <param name="i4lProcessUid">Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional)</param>
        /// <returns>Task of ApiResponse (ProjectsEndpointType)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<ProjectsEndpointType>> AddTagToProjectAsyncWithHttpInfo (string projectUid, TagsPostRequest newtag, string envelope = null, List<string> embed = null, string i4lProcessUid = null)
        {
            // verify the required parameter 'projectUid' is set
            if (projectUid == null)
                throw new ApiException(400, "Missing required parameter 'projectUid' when calling ProjectsApi->AddTagToProject");
            // verify the required parameter 'newtag' is set
            if (newtag == null)
                throw new ApiException(400, "Missing required parameter 'newtag' when calling ProjectsApi->AddTagToProject");

            var localVarPath = "/projects/{project_uid}/Tags";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/json"
            };
            String localVarHttpContentType = Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (projectUid != null) localVarPathParams.Add("project_uid", Configuration.ApiClient.ParameterToString(projectUid)); // path parameter
            if (envelope != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("", "envelope", envelope)); // query parameter
            if (embed != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("csv", "embed", embed)); // query parameter
            if (i4lProcessUid != null) localVarHeaderParams.Add("i4l-process-uid", Configuration.ApiClient.ParameterToString(i4lProcessUid)); // header parameter
            if (newtag != null && newtag.GetType() != typeof(byte[]))
            {
                localVarPostBody = Configuration.ApiClient.Serialize(newtag); // http body (model) parameter
            }
            else
            {
                localVarPostBody = newtag; // byte array
            }


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.POST, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("AddTagToProject", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<ProjectsEndpointType>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (ProjectsEndpointType) Configuration.ApiClient.Deserialize(localVarResponse, typeof(ProjectsEndpointType)));
        }

        /// <summary>
        /// Deletes a single e project by its UID A single project is deleted. This endpoint deletes the project itself and the connected to subordered data like SpatialSources, etc. The subordered data itself are not deleted
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="projectUid">UID of the project</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <param name="i4lProcessUid">Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional)</param>
        /// <returns>ProjectsEndpointType</returns>
        public ProjectsEndpointType DelProjectByUID (string projectUid, string envelope = null, List<string> embed = null, string i4lProcessUid = null)
        {
             ApiResponse<ProjectsEndpointType> localVarResponse = DelProjectByUIDWithHttpInfo(projectUid, envelope, embed, i4lProcessUid);
             return localVarResponse.Data;
        }

        /// <summary>
        /// Deletes a single e project by its UID A single project is deleted. This endpoint deletes the project itself and the connected to subordered data like SpatialSources, etc. The subordered data itself are not deleted
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="projectUid">UID of the project</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <param name="i4lProcessUid">Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional)</param>
        /// <returns>ApiResponse of ProjectsEndpointType</returns>
        public ApiResponse< ProjectsEndpointType > DelProjectByUIDWithHttpInfo (string projectUid, string envelope = null, List<string> embed = null, string i4lProcessUid = null)
        {
            // verify the required parameter 'projectUid' is set
            if (projectUid == null)
                throw new ApiException(400, "Missing required parameter 'projectUid' when calling ProjectsApi->DelProjectByUID");

            var localVarPath = "/projects/{project_uid}";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (projectUid != null) localVarPathParams.Add("project_uid", Configuration.ApiClient.ParameterToString(projectUid)); // path parameter
            if (envelope != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("", "envelope", envelope)); // query parameter
            if (embed != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("csv", "embed", embed)); // query parameter
            if (i4lProcessUid != null) localVarHeaderParams.Add("i4l-process-uid", Configuration.ApiClient.ParameterToString(i4lProcessUid)); // header parameter


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) Configuration.ApiClient.CallApi(localVarPath,
                Method.DELETE, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("DelProjectByUID", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<ProjectsEndpointType>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (ProjectsEndpointType) Configuration.ApiClient.Deserialize(localVarResponse, typeof(ProjectsEndpointType)));
        }

        /// <summary>
        /// Deletes a single e project by its UID A single project is deleted. This endpoint deletes the project itself and the connected to subordered data like SpatialSources, etc. The subordered data itself are not deleted
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="projectUid">UID of the project</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <param name="i4lProcessUid">Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional)</param>
        /// <returns>Task of ProjectsEndpointType</returns>
        public async System.Threading.Tasks.Task<ProjectsEndpointType> DelProjectByUIDAsync (string projectUid, string envelope = null, List<string> embed = null, string i4lProcessUid = null)
        {
             ApiResponse<ProjectsEndpointType> localVarResponse = await DelProjectByUIDAsyncWithHttpInfo(projectUid, envelope, embed, i4lProcessUid);
             return localVarResponse.Data;

        }

        /// <summary>
        /// Deletes a single e project by its UID A single project is deleted. This endpoint deletes the project itself and the connected to subordered data like SpatialSources, etc. The subordered data itself are not deleted
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="projectUid">UID of the project</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <param name="i4lProcessUid">Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional)</param>
        /// <returns>Task of ApiResponse (ProjectsEndpointType)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<ProjectsEndpointType>> DelProjectByUIDAsyncWithHttpInfo (string projectUid, string envelope = null, List<string> embed = null, string i4lProcessUid = null)
        {
            // verify the required parameter 'projectUid' is set
            if (projectUid == null)
                throw new ApiException(400, "Missing required parameter 'projectUid' when calling ProjectsApi->DelProjectByUID");

            var localVarPath = "/projects/{project_uid}";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (projectUid != null) localVarPathParams.Add("project_uid", Configuration.ApiClient.ParameterToString(projectUid)); // path parameter
            if (envelope != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("", "envelope", envelope)); // query parameter
            if (embed != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("csv", "embed", embed)); // query parameter
            if (i4lProcessUid != null) localVarHeaderParams.Add("i4l-process-uid", Configuration.ApiClient.ParameterToString(i4lProcessUid)); // header parameter


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.DELETE, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("DelProjectByUID", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<ProjectsEndpointType>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (ProjectsEndpointType) Configuration.ApiClient.Deserialize(localVarResponse, typeof(ProjectsEndpointType)));
        }

        /// <summary>
        /// Removes a model from a project. Removes a model from a project. By default only the link between model and project is removed.
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="projectUid">Project UID</param>
        /// <param name="modelUid">Model UID</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="forceDelete">Deletes the model resource. ********* What&#39;s about subordinate resources? ********* (optional)</param>
        /// <returns>ProjectsEndpointType</returns>
        public ProjectsEndpointType DetachProjectModel (string projectUid, string modelUid, string envelope = null, string forceDelete = null)
        {
             ApiResponse<ProjectsEndpointType> localVarResponse = DetachProjectModelWithHttpInfo(projectUid, modelUid, envelope, forceDelete);
             return localVarResponse.Data;
        }

        /// <summary>
        /// Removes a model from a project. Removes a model from a project. By default only the link between model and project is removed.
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="projectUid">Project UID</param>
        /// <param name="modelUid">Model UID</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="forceDelete">Deletes the model resource. ********* What&#39;s about subordinate resources? ********* (optional)</param>
        /// <returns>ApiResponse of ProjectsEndpointType</returns>
        public ApiResponse< ProjectsEndpointType > DetachProjectModelWithHttpInfo (string projectUid, string modelUid, string envelope = null, string forceDelete = null)
        {
            // verify the required parameter 'projectUid' is set
            if (projectUid == null)
                throw new ApiException(400, "Missing required parameter 'projectUid' when calling ProjectsApi->DetachProjectModel");
            // verify the required parameter 'modelUid' is set
            if (modelUid == null)
                throw new ApiException(400, "Missing required parameter 'modelUid' when calling ProjectsApi->DetachProjectModel");

            var localVarPath = "/projects/{project_uid}/Models/{model_uid}";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (projectUid != null) localVarPathParams.Add("project_uid", Configuration.ApiClient.ParameterToString(projectUid)); // path parameter
            if (modelUid != null) localVarPathParams.Add("model_uid", Configuration.ApiClient.ParameterToString(modelUid)); // path parameter
            if (envelope != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("", "envelope", envelope)); // query parameter
            if (forceDelete != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("", "force_delete", forceDelete)); // query parameter


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) Configuration.ApiClient.CallApi(localVarPath,
                Method.DELETE, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("DetachProjectModel", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<ProjectsEndpointType>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (ProjectsEndpointType) Configuration.ApiClient.Deserialize(localVarResponse, typeof(ProjectsEndpointType)));
        }

        /// <summary>
        /// Removes a model from a project. Removes a model from a project. By default only the link between model and project is removed.
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="projectUid">Project UID</param>
        /// <param name="modelUid">Model UID</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="forceDelete">Deletes the model resource. ********* What&#39;s about subordinate resources? ********* (optional)</param>
        /// <returns>Task of ProjectsEndpointType</returns>
        public async System.Threading.Tasks.Task<ProjectsEndpointType> DetachProjectModelAsync (string projectUid, string modelUid, string envelope = null, string forceDelete = null)
        {
             ApiResponse<ProjectsEndpointType> localVarResponse = await DetachProjectModelAsyncWithHttpInfo(projectUid, modelUid, envelope, forceDelete);
             return localVarResponse.Data;

        }

        /// <summary>
        /// Removes a model from a project. Removes a model from a project. By default only the link between model and project is removed.
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="projectUid">Project UID</param>
        /// <param name="modelUid">Model UID</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="forceDelete">Deletes the model resource. ********* What&#39;s about subordinate resources? ********* (optional)</param>
        /// <returns>Task of ApiResponse (ProjectsEndpointType)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<ProjectsEndpointType>> DetachProjectModelAsyncWithHttpInfo (string projectUid, string modelUid, string envelope = null, string forceDelete = null)
        {
            // verify the required parameter 'projectUid' is set
            if (projectUid == null)
                throw new ApiException(400, "Missing required parameter 'projectUid' when calling ProjectsApi->DetachProjectModel");
            // verify the required parameter 'modelUid' is set
            if (modelUid == null)
                throw new ApiException(400, "Missing required parameter 'modelUid' when calling ProjectsApi->DetachProjectModel");

            var localVarPath = "/projects/{project_uid}/Models/{model_uid}";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (projectUid != null) localVarPathParams.Add("project_uid", Configuration.ApiClient.ParameterToString(projectUid)); // path parameter
            if (modelUid != null) localVarPathParams.Add("model_uid", Configuration.ApiClient.ParameterToString(modelUid)); // path parameter
            if (envelope != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("", "envelope", envelope)); // query parameter
            if (forceDelete != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("", "force_delete", forceDelete)); // query parameter


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.DELETE, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("DetachProjectModel", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<ProjectsEndpointType>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (ProjectsEndpointType) Configuration.ApiClient.Deserialize(localVarResponse, typeof(ProjectsEndpointType)));
        }

        /// <summary>
        /// Removes a spatialsource from a project. Removes a spatial from a project. By default only the link between spatialsource and project is removed.
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="projectUid">Project UID</param>
        /// <param name="spatialsourceUid">SpatialSource UID</param>
        /// <param name="forceDelete">Deletes the spatialsource resource. ********* What&#39;s about subordinate resources? ********* (optional)</param>
        /// <returns>ProjectsEndpointType</returns>
        public ProjectsEndpointType DetachProjectSpatialSource (string projectUid, string spatialsourceUid, string forceDelete = null)
        {
             ApiResponse<ProjectsEndpointType> localVarResponse = DetachProjectSpatialSourceWithHttpInfo(projectUid, spatialsourceUid, forceDelete);
             return localVarResponse.Data;
        }

        /// <summary>
        /// Removes a spatialsource from a project. Removes a spatial from a project. By default only the link between spatialsource and project is removed.
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="projectUid">Project UID</param>
        /// <param name="spatialsourceUid">SpatialSource UID</param>
        /// <param name="forceDelete">Deletes the spatialsource resource. ********* What&#39;s about subordinate resources? ********* (optional)</param>
        /// <returns>ApiResponse of ProjectsEndpointType</returns>
        public ApiResponse< ProjectsEndpointType > DetachProjectSpatialSourceWithHttpInfo (string projectUid, string spatialsourceUid, string forceDelete = null)
        {
            // verify the required parameter 'projectUid' is set
            if (projectUid == null)
                throw new ApiException(400, "Missing required parameter 'projectUid' when calling ProjectsApi->DetachProjectSpatialSource");
            // verify the required parameter 'spatialsourceUid' is set
            if (spatialsourceUid == null)
                throw new ApiException(400, "Missing required parameter 'spatialsourceUid' when calling ProjectsApi->DetachProjectSpatialSource");

            var localVarPath = "/projects/{project_uid}/SpatialSources/{spatialsource_uid}";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (projectUid != null) localVarPathParams.Add("project_uid", Configuration.ApiClient.ParameterToString(projectUid)); // path parameter
            if (spatialsourceUid != null) localVarPathParams.Add("spatialsource_uid", Configuration.ApiClient.ParameterToString(spatialsourceUid)); // path parameter
            if (forceDelete != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("", "force_delete", forceDelete)); // query parameter


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) Configuration.ApiClient.CallApi(localVarPath,
                Method.DELETE, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("DetachProjectSpatialSource", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<ProjectsEndpointType>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (ProjectsEndpointType) Configuration.ApiClient.Deserialize(localVarResponse, typeof(ProjectsEndpointType)));
        }

        /// <summary>
        /// Removes a spatialsource from a project. Removes a spatial from a project. By default only the link between spatialsource and project is removed.
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="projectUid">Project UID</param>
        /// <param name="spatialsourceUid">SpatialSource UID</param>
        /// <param name="forceDelete">Deletes the spatialsource resource. ********* What&#39;s about subordinate resources? ********* (optional)</param>
        /// <returns>Task of ProjectsEndpointType</returns>
        public async System.Threading.Tasks.Task<ProjectsEndpointType> DetachProjectSpatialSourceAsync (string projectUid, string spatialsourceUid, string forceDelete = null)
        {
             ApiResponse<ProjectsEndpointType> localVarResponse = await DetachProjectSpatialSourceAsyncWithHttpInfo(projectUid, spatialsourceUid, forceDelete);
             return localVarResponse.Data;

        }

        /// <summary>
        /// Removes a spatialsource from a project. Removes a spatial from a project. By default only the link between spatialsource and project is removed.
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="projectUid">Project UID</param>
        /// <param name="spatialsourceUid">SpatialSource UID</param>
        /// <param name="forceDelete">Deletes the spatialsource resource. ********* What&#39;s about subordinate resources? ********* (optional)</param>
        /// <returns>Task of ApiResponse (ProjectsEndpointType)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<ProjectsEndpointType>> DetachProjectSpatialSourceAsyncWithHttpInfo (string projectUid, string spatialsourceUid, string forceDelete = null)
        {
            // verify the required parameter 'projectUid' is set
            if (projectUid == null)
                throw new ApiException(400, "Missing required parameter 'projectUid' when calling ProjectsApi->DetachProjectSpatialSource");
            // verify the required parameter 'spatialsourceUid' is set
            if (spatialsourceUid == null)
                throw new ApiException(400, "Missing required parameter 'spatialsourceUid' when calling ProjectsApi->DetachProjectSpatialSource");

            var localVarPath = "/projects/{project_uid}/SpatialSources/{spatialsource_uid}";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (projectUid != null) localVarPathParams.Add("project_uid", Configuration.ApiClient.ParameterToString(projectUid)); // path parameter
            if (spatialsourceUid != null) localVarPathParams.Add("spatialsource_uid", Configuration.ApiClient.ParameterToString(spatialsourceUid)); // path parameter
            if (forceDelete != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("", "force_delete", forceDelete)); // query parameter


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.DELETE, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("DetachProjectSpatialSource", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<ProjectsEndpointType>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (ProjectsEndpointType) Configuration.ApiClient.Deserialize(localVarResponse, typeof(ProjectsEndpointType)));
        }

        /// <summary>
        /// Removes a tag from a project. Removes a tag from a project. By default only the link between tag and project is removed.
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="projectUid">Project UID</param>
        /// <param name="tag">tag value</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="forceDelete">Deletes the tag resource. ********* Only possible, when tag is not attached to any other resource. ********* (optional)</param>
        /// <returns>ProjectsEndpointType</returns>
        public ProjectsEndpointType DetachProjectTag (string projectUid, string tag, string envelope = null, string forceDelete = null)
        {
             ApiResponse<ProjectsEndpointType> localVarResponse = DetachProjectTagWithHttpInfo(projectUid, tag, envelope, forceDelete);
             return localVarResponse.Data;
        }

        /// <summary>
        /// Removes a tag from a project. Removes a tag from a project. By default only the link between tag and project is removed.
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="projectUid">Project UID</param>
        /// <param name="tag">tag value</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="forceDelete">Deletes the tag resource. ********* Only possible, when tag is not attached to any other resource. ********* (optional)</param>
        /// <returns>ApiResponse of ProjectsEndpointType</returns>
        public ApiResponse< ProjectsEndpointType > DetachProjectTagWithHttpInfo (string projectUid, string tag, string envelope = null, string forceDelete = null)
        {
            // verify the required parameter 'projectUid' is set
            if (projectUid == null)
                throw new ApiException(400, "Missing required parameter 'projectUid' when calling ProjectsApi->DetachProjectTag");
            // verify the required parameter 'tag' is set
            if (tag == null)
                throw new ApiException(400, "Missing required parameter 'tag' when calling ProjectsApi->DetachProjectTag");

            var localVarPath = "/projects/{project_uid}/Tags/{tag}";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (projectUid != null) localVarPathParams.Add("project_uid", Configuration.ApiClient.ParameterToString(projectUid)); // path parameter
            if (tag != null) localVarPathParams.Add("tag", Configuration.ApiClient.ParameterToString(tag)); // path parameter
            if (envelope != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("", "envelope", envelope)); // query parameter
            if (forceDelete != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("", "force_delete", forceDelete)); // query parameter


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) Configuration.ApiClient.CallApi(localVarPath,
                Method.DELETE, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("DetachProjectTag", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<ProjectsEndpointType>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (ProjectsEndpointType) Configuration.ApiClient.Deserialize(localVarResponse, typeof(ProjectsEndpointType)));
        }

        /// <summary>
        /// Removes a tag from a project. Removes a tag from a project. By default only the link between tag and project is removed.
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="projectUid">Project UID</param>
        /// <param name="tag">tag value</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="forceDelete">Deletes the tag resource. ********* Only possible, when tag is not attached to any other resource. ********* (optional)</param>
        /// <returns>Task of ProjectsEndpointType</returns>
        public async System.Threading.Tasks.Task<ProjectsEndpointType> DetachProjectTagAsync (string projectUid, string tag, string envelope = null, string forceDelete = null)
        {
             ApiResponse<ProjectsEndpointType> localVarResponse = await DetachProjectTagAsyncWithHttpInfo(projectUid, tag, envelope, forceDelete);
             return localVarResponse.Data;

        }

        /// <summary>
        /// Removes a tag from a project. Removes a tag from a project. By default only the link between tag and project is removed.
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="projectUid">Project UID</param>
        /// <param name="tag">tag value</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="forceDelete">Deletes the tag resource. ********* Only possible, when tag is not attached to any other resource. ********* (optional)</param>
        /// <returns>Task of ApiResponse (ProjectsEndpointType)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<ProjectsEndpointType>> DetachProjectTagAsyncWithHttpInfo (string projectUid, string tag, string envelope = null, string forceDelete = null)
        {
            // verify the required parameter 'projectUid' is set
            if (projectUid == null)
                throw new ApiException(400, "Missing required parameter 'projectUid' when calling ProjectsApi->DetachProjectTag");
            // verify the required parameter 'tag' is set
            if (tag == null)
                throw new ApiException(400, "Missing required parameter 'tag' when calling ProjectsApi->DetachProjectTag");

            var localVarPath = "/projects/{project_uid}/Tags/{tag}";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (projectUid != null) localVarPathParams.Add("project_uid", Configuration.ApiClient.ParameterToString(projectUid)); // path parameter
            if (tag != null) localVarPathParams.Add("tag", Configuration.ApiClient.ParameterToString(tag)); // path parameter
            if (envelope != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("", "envelope", envelope)); // query parameter
            if (forceDelete != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("", "force_delete", forceDelete)); // query parameter


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.DELETE, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("DetachProjectTag", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<ProjectsEndpointType>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (ProjectsEndpointType) Configuration.ApiClient.Deserialize(localVarResponse, typeof(ProjectsEndpointType)));
        }

        /// <summary>
        /// Returns an array of connect objects Returns an array of connect objects of a project. For each connected object the endpoint returns the type, name and uuid
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="projectUid">Project UID</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="page">Requests for collections can return between 0 and N results, controlled using the per_page and page query parameters. All endpoints are limited to 10 results by default. (optional)</param>
        /// <param name="sort">The sorting is initiated by the sort query parameter and a list of comma separated list of fields to sort by. (optional)</param>
        /// <param name="fields">Comma separated list of field names (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <returns>ConnectedObjectsEndpointType</returns>
        public ConnectedObjectsEndpointType GetConnectedObjectsByProjectUID (string projectUid, string envelope = null, int? page = null, string sort = null, List<string> fields = null, List<string> embed = null)
        {
             ApiResponse<ConnectedObjectsEndpointType> localVarResponse = GetConnectedObjectsByProjectUIDWithHttpInfo(projectUid, envelope, page, sort, fields, embed);
             return localVarResponse.Data;
        }

        /// <summary>
        /// Returns an array of connect objects Returns an array of connect objects of a project. For each connected object the endpoint returns the type, name and uuid
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="projectUid">Project UID</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="page">Requests for collections can return between 0 and N results, controlled using the per_page and page query parameters. All endpoints are limited to 10 results by default. (optional)</param>
        /// <param name="sort">The sorting is initiated by the sort query parameter and a list of comma separated list of fields to sort by. (optional)</param>
        /// <param name="fields">Comma separated list of field names (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <returns>ApiResponse of ConnectedObjectsEndpointType</returns>
        public ApiResponse< ConnectedObjectsEndpointType > GetConnectedObjectsByProjectUIDWithHttpInfo (string projectUid, string envelope = null, int? page = null, string sort = null, List<string> fields = null, List<string> embed = null)
        {
            // verify the required parameter 'projectUid' is set
            if (projectUid == null)
                throw new ApiException(400, "Missing required parameter 'projectUid' when calling ProjectsApi->GetConnectedObjectsByProjectUID");

            var localVarPath = "/projects/{project_uid}/connectedObjects";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (projectUid != null) localVarPathParams.Add("project_uid", Configuration.ApiClient.ParameterToString(projectUid)); // path parameter
            if (envelope != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("", "envelope", envelope)); // query parameter
            if (page != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("", "page", page)); // query parameter
            if (sort != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("", "sort", sort)); // query parameter
            if (fields != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("csv", "fields", fields)); // query parameter
            if (embed != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("csv", "embed", embed)); // query parameter


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) Configuration.ApiClient.CallApi(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("GetConnectedObjectsByProjectUID", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<ConnectedObjectsEndpointType>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (ConnectedObjectsEndpointType) Configuration.ApiClient.Deserialize(localVarResponse, typeof(ConnectedObjectsEndpointType)));
        }

        /// <summary>
        /// Returns an array of connect objects Returns an array of connect objects of a project. For each connected object the endpoint returns the type, name and uuid
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="projectUid">Project UID</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="page">Requests for collections can return between 0 and N results, controlled using the per_page and page query parameters. All endpoints are limited to 10 results by default. (optional)</param>
        /// <param name="sort">The sorting is initiated by the sort query parameter and a list of comma separated list of fields to sort by. (optional)</param>
        /// <param name="fields">Comma separated list of field names (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <returns>Task of ConnectedObjectsEndpointType</returns>
        public async System.Threading.Tasks.Task<ConnectedObjectsEndpointType> GetConnectedObjectsByProjectUIDAsync (string projectUid, string envelope = null, int? page = null, string sort = null, List<string> fields = null, List<string> embed = null)
        {
             ApiResponse<ConnectedObjectsEndpointType> localVarResponse = await GetConnectedObjectsByProjectUIDAsyncWithHttpInfo(projectUid, envelope, page, sort, fields, embed);
             return localVarResponse.Data;

        }

        /// <summary>
        /// Returns an array of connect objects Returns an array of connect objects of a project. For each connected object the endpoint returns the type, name and uuid
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="projectUid">Project UID</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="page">Requests for collections can return between 0 and N results, controlled using the per_page and page query parameters. All endpoints are limited to 10 results by default. (optional)</param>
        /// <param name="sort">The sorting is initiated by the sort query parameter and a list of comma separated list of fields to sort by. (optional)</param>
        /// <param name="fields">Comma separated list of field names (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <returns>Task of ApiResponse (ConnectedObjectsEndpointType)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<ConnectedObjectsEndpointType>> GetConnectedObjectsByProjectUIDAsyncWithHttpInfo (string projectUid, string envelope = null, int? page = null, string sort = null, List<string> fields = null, List<string> embed = null)
        {
            // verify the required parameter 'projectUid' is set
            if (projectUid == null)
                throw new ApiException(400, "Missing required parameter 'projectUid' when calling ProjectsApi->GetConnectedObjectsByProjectUID");

            var localVarPath = "/projects/{project_uid}/connectedObjects";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (projectUid != null) localVarPathParams.Add("project_uid", Configuration.ApiClient.ParameterToString(projectUid)); // path parameter
            if (envelope != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("", "envelope", envelope)); // query parameter
            if (page != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("", "page", page)); // query parameter
            if (sort != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("", "sort", sort)); // query parameter
            if (fields != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("csv", "fields", fields)); // query parameter
            if (embed != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("csv", "embed", embed)); // query parameter


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("GetConnectedObjectsByProjectUID", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<ConnectedObjectsEndpointType>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (ConnectedObjectsEndpointType) Configuration.ApiClient.Deserialize(localVarResponse, typeof(ConnectedObjectsEndpointType)));
        }

        /// <summary>
        /// Returns the models of a project Returns the models of a project
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="projectUid">Project UID</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="page">Requests for collections can return between 0 and N results, controlled using the per_page and page query parameters. All endpoints are limited to 10 results by default. (optional)</param>
        /// <param name="sort">The sorting is initiated by the sort query parameter and a list of comma separated list of fields to sort by. (optional)</param>
        /// <param name="fields">Comma separated list of field names (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <returns>List&lt;ModelsEndpointType&gt;</returns>
        public List<ModelsEndpointType> GetModelsByProjectUID (string projectUid, string envelope = null, int? page = null, string sort = null, List<string> fields = null, List<string> embed = null)
        {
             ApiResponse<List<ModelsEndpointType>> localVarResponse = GetModelsByProjectUIDWithHttpInfo(projectUid, envelope, page, sort, fields, embed);
             return localVarResponse.Data;
        }

        /// <summary>
        /// Returns the models of a project Returns the models of a project
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="projectUid">Project UID</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="page">Requests for collections can return between 0 and N results, controlled using the per_page and page query parameters. All endpoints are limited to 10 results by default. (optional)</param>
        /// <param name="sort">The sorting is initiated by the sort query parameter and a list of comma separated list of fields to sort by. (optional)</param>
        /// <param name="fields">Comma separated list of field names (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <returns>ApiResponse of List&lt;ModelsEndpointType&gt;</returns>
        public ApiResponse< List<ModelsEndpointType> > GetModelsByProjectUIDWithHttpInfo (string projectUid, string envelope = null, int? page = null, string sort = null, List<string> fields = null, List<string> embed = null)
        {
            // verify the required parameter 'projectUid' is set
            if (projectUid == null)
                throw new ApiException(400, "Missing required parameter 'projectUid' when calling ProjectsApi->GetModelsByProjectUID");

            var localVarPath = "/projects/{project_uid}/Models";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (projectUid != null) localVarPathParams.Add("project_uid", Configuration.ApiClient.ParameterToString(projectUid)); // path parameter
            if (envelope != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("", "envelope", envelope)); // query parameter
            if (page != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("", "page", page)); // query parameter
            if (sort != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("", "sort", sort)); // query parameter
            if (fields != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("csv", "fields", fields)); // query parameter
            if (embed != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("csv", "embed", embed)); // query parameter


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) Configuration.ApiClient.CallApi(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("GetModelsByProjectUID", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<List<ModelsEndpointType>>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (List<ModelsEndpointType>) Configuration.ApiClient.Deserialize(localVarResponse, typeof(List<ModelsEndpointType>)));
        }

        /// <summary>
        /// Returns the models of a project Returns the models of a project
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="projectUid">Project UID</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="page">Requests for collections can return between 0 and N results, controlled using the per_page and page query parameters. All endpoints are limited to 10 results by default. (optional)</param>
        /// <param name="sort">The sorting is initiated by the sort query parameter and a list of comma separated list of fields to sort by. (optional)</param>
        /// <param name="fields">Comma separated list of field names (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <returns>Task of List&lt;ModelsEndpointType&gt;</returns>
        public async System.Threading.Tasks.Task<List<ModelsEndpointType>> GetModelsByProjectUIDAsync (string projectUid, string envelope = null, int? page = null, string sort = null, List<string> fields = null, List<string> embed = null)
        {
             ApiResponse<List<ModelsEndpointType>> localVarResponse = await GetModelsByProjectUIDAsyncWithHttpInfo(projectUid, envelope, page, sort, fields, embed);
             return localVarResponse.Data;

        }

        /// <summary>
        /// Returns the models of a project Returns the models of a project
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="projectUid">Project UID</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="page">Requests for collections can return between 0 and N results, controlled using the per_page and page query parameters. All endpoints are limited to 10 results by default. (optional)</param>
        /// <param name="sort">The sorting is initiated by the sort query parameter and a list of comma separated list of fields to sort by. (optional)</param>
        /// <param name="fields">Comma separated list of field names (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <returns>Task of ApiResponse (List&lt;ModelsEndpointType&gt;)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<List<ModelsEndpointType>>> GetModelsByProjectUIDAsyncWithHttpInfo (string projectUid, string envelope = null, int? page = null, string sort = null, List<string> fields = null, List<string> embed = null)
        {
            // verify the required parameter 'projectUid' is set
            if (projectUid == null)
                throw new ApiException(400, "Missing required parameter 'projectUid' when calling ProjectsApi->GetModelsByProjectUID");

            var localVarPath = "/projects/{project_uid}/Models";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (projectUid != null) localVarPathParams.Add("project_uid", Configuration.ApiClient.ParameterToString(projectUid)); // path parameter
            if (envelope != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("", "envelope", envelope)); // query parameter
            if (page != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("", "page", page)); // query parameter
            if (sort != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("", "sort", sort)); // query parameter
            if (fields != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("csv", "fields", fields)); // query parameter
            if (embed != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("csv", "embed", embed)); // query parameter


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("GetModelsByProjectUID", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<List<ModelsEndpointType>>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (List<ModelsEndpointType>) Configuration.ApiClient.Deserialize(localVarResponse, typeof(List<ModelsEndpointType>)));
        }

        /// <summary>
        /// Returns the tags of a project. Is this method really necessary? Returns the tags of a project.
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="projectUid">Project UID</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <returns>TagsListResponse</returns>
        public TagsListResponse GetProjectTagsByProjectUID (string projectUid, string envelope = null)
        {
             ApiResponse<TagsListResponse> localVarResponse = GetProjectTagsByProjectUIDWithHttpInfo(projectUid, envelope);
             return localVarResponse.Data;
        }

        /// <summary>
        /// Returns the tags of a project. Is this method really necessary? Returns the tags of a project.
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="projectUid">Project UID</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <returns>ApiResponse of TagsListResponse</returns>
        public ApiResponse< TagsListResponse > GetProjectTagsByProjectUIDWithHttpInfo (string projectUid, string envelope = null)
        {
            // verify the required parameter 'projectUid' is set
            if (projectUid == null)
                throw new ApiException(400, "Missing required parameter 'projectUid' when calling ProjectsApi->GetProjectTagsByProjectUID");

            var localVarPath = "/projects/{project_uid}/Tags";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (projectUid != null) localVarPathParams.Add("project_uid", Configuration.ApiClient.ParameterToString(projectUid)); // path parameter
            if (envelope != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("", "envelope", envelope)); // query parameter


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) Configuration.ApiClient.CallApi(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("GetProjectTagsByProjectUID", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<TagsListResponse>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (TagsListResponse) Configuration.ApiClient.Deserialize(localVarResponse, typeof(TagsListResponse)));
        }

        /// <summary>
        /// Returns the tags of a project. Is this method really necessary? Returns the tags of a project.
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="projectUid">Project UID</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <returns>Task of TagsListResponse</returns>
        public async System.Threading.Tasks.Task<TagsListResponse> GetProjectTagsByProjectUIDAsync (string projectUid, string envelope = null)
        {
             ApiResponse<TagsListResponse> localVarResponse = await GetProjectTagsByProjectUIDAsyncWithHttpInfo(projectUid, envelope);
             return localVarResponse.Data;

        }

        /// <summary>
        /// Returns the tags of a project. Is this method really necessary? Returns the tags of a project.
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="projectUid">Project UID</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <returns>Task of ApiResponse (TagsListResponse)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<TagsListResponse>> GetProjectTagsByProjectUIDAsyncWithHttpInfo (string projectUid, string envelope = null)
        {
            // verify the required parameter 'projectUid' is set
            if (projectUid == null)
                throw new ApiException(400, "Missing required parameter 'projectUid' when calling ProjectsApi->GetProjectTagsByProjectUID");

            var localVarPath = "/projects/{project_uid}/Tags";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (projectUid != null) localVarPathParams.Add("project_uid", Configuration.ApiClient.ParameterToString(projectUid)); // path parameter
            if (envelope != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("", "envelope", envelope)); // query parameter


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("GetProjectTagsByProjectUID", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<TagsListResponse>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (TagsListResponse) Configuration.ApiClient.Deserialize(localVarResponse, typeof(TagsListResponse)));
        }

        /// <summary>
        /// Get a GeoJSON structure containing a list of Projects. Get a GeoJSON structure containing a list of Projects. A single project is modeled as a GeoJSON feature.
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="uid">Comma separated list of UID (optional)</param>
        /// <param name="name">Comma separated list of names (optional)</param>
        /// <param name="aoi">Polygon. The polygon is encoded a comma separated list of coordinates. X1, Y1, X2, Y2, ..., Xn, Yn, X1, Y1 (optional)</param>
        /// <param name="tags">Comma separated list of tags (optional)</param>
        /// <param name="page">Requests for collections can return between 0 and N results, controlled using the per_page and page query parameters. All endpoints are limited to 10 results by default. (optional)</param>
        /// <param name="sort">The sorting is initiated by the sort query parameter and a list of comma separated list of fields to sort by. (optional)</param>
        /// <param name="fields">Comma separated list of field names (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <returns>ProjectsEndpointType</returns>
        public ProjectsEndpointType GetProjects (string envelope = null, List<string> uid = null, List<string> name = null, string aoi = null, List<string> tags = null, int? page = null, string sort = null, List<string> fields = null, List<string> embed = null)
        {
             ApiResponse<ProjectsEndpointType> localVarResponse = GetProjectsWithHttpInfo(envelope, uid, name, aoi, tags, page, sort, fields, embed);
             return localVarResponse.Data;
        }

        /// <summary>
        /// Get a GeoJSON structure containing a list of Projects. Get a GeoJSON structure containing a list of Projects. A single project is modeled as a GeoJSON feature.
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="uid">Comma separated list of UID (optional)</param>
        /// <param name="name">Comma separated list of names (optional)</param>
        /// <param name="aoi">Polygon. The polygon is encoded a comma separated list of coordinates. X1, Y1, X2, Y2, ..., Xn, Yn, X1, Y1 (optional)</param>
        /// <param name="tags">Comma separated list of tags (optional)</param>
        /// <param name="page">Requests for collections can return between 0 and N results, controlled using the per_page and page query parameters. All endpoints are limited to 10 results by default. (optional)</param>
        /// <param name="sort">The sorting is initiated by the sort query parameter and a list of comma separated list of fields to sort by. (optional)</param>
        /// <param name="fields">Comma separated list of field names (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <returns>ApiResponse of ProjectsEndpointType</returns>
        public ApiResponse< ProjectsEndpointType > GetProjectsWithHttpInfo (string envelope = null, List<string> uid = null, List<string> name = null, string aoi = null, List<string> tags = null, int? page = null, string sort = null, List<string> fields = null, List<string> embed = null)
        {

            var localVarPath = "/projects";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (envelope != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("", "envelope", envelope)); // query parameter
            if (uid != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("csv", "uid", uid)); // query parameter
            if (name != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("csv", "name", name)); // query parameter
            if (aoi != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("", "aoi", aoi)); // query parameter
            if (tags != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("csv", "tags", tags)); // query parameter
            if (page != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("", "page", page)); // query parameter
            if (sort != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("", "sort", sort)); // query parameter
            if (fields != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("csv", "fields", fields)); // query parameter
            if (embed != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("csv", "embed", embed)); // query parameter


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) Configuration.ApiClient.CallApi(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("GetProjects", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<ProjectsEndpointType>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (ProjectsEndpointType) Configuration.ApiClient.Deserialize(localVarResponse, typeof(ProjectsEndpointType)));
        }

        /// <summary>
        /// Get a GeoJSON structure containing a list of Projects. Get a GeoJSON structure containing a list of Projects. A single project is modeled as a GeoJSON feature.
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="uid">Comma separated list of UID (optional)</param>
        /// <param name="name">Comma separated list of names (optional)</param>
        /// <param name="aoi">Polygon. The polygon is encoded a comma separated list of coordinates. X1, Y1, X2, Y2, ..., Xn, Yn, X1, Y1 (optional)</param>
        /// <param name="tags">Comma separated list of tags (optional)</param>
        /// <param name="page">Requests for collections can return between 0 and N results, controlled using the per_page and page query parameters. All endpoints are limited to 10 results by default. (optional)</param>
        /// <param name="sort">The sorting is initiated by the sort query parameter and a list of comma separated list of fields to sort by. (optional)</param>
        /// <param name="fields">Comma separated list of field names (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <returns>Task of ProjectsEndpointType</returns>
        public async System.Threading.Tasks.Task<ProjectsEndpointType> GetProjectsAsync (string envelope = null, List<string> uid = null, List<string> name = null, string aoi = null, List<string> tags = null, int? page = null, string sort = null, List<string> fields = null, List<string> embed = null)
        {
             ApiResponse<ProjectsEndpointType> localVarResponse = await GetProjectsAsyncWithHttpInfo(envelope, uid, name, aoi, tags, page, sort, fields, embed);
             return localVarResponse.Data;

        }

        /// <summary>
        /// Get a GeoJSON structure containing a list of Projects. Get a GeoJSON structure containing a list of Projects. A single project is modeled as a GeoJSON feature.
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="uid">Comma separated list of UID (optional)</param>
        /// <param name="name">Comma separated list of names (optional)</param>
        /// <param name="aoi">Polygon. The polygon is encoded a comma separated list of coordinates. X1, Y1, X2, Y2, ..., Xn, Yn, X1, Y1 (optional)</param>
        /// <param name="tags">Comma separated list of tags (optional)</param>
        /// <param name="page">Requests for collections can return between 0 and N results, controlled using the per_page and page query parameters. All endpoints are limited to 10 results by default. (optional)</param>
        /// <param name="sort">The sorting is initiated by the sort query parameter and a list of comma separated list of fields to sort by. (optional)</param>
        /// <param name="fields">Comma separated list of field names (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <returns>Task of ApiResponse (ProjectsEndpointType)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<ProjectsEndpointType>> GetProjectsAsyncWithHttpInfo (string envelope = null, List<string> uid = null, List<string> name = null, string aoi = null, List<string> tags = null, int? page = null, string sort = null, List<string> fields = null, List<string> embed = null)
        {

            var localVarPath = "/projects";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (envelope != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("", "envelope", envelope)); // query parameter
            if (uid != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("csv", "uid", uid)); // query parameter
            if (name != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("csv", "name", name)); // query parameter
            if (aoi != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("", "aoi", aoi)); // query parameter
            if (tags != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("csv", "tags", tags)); // query parameter
            if (page != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("", "page", page)); // query parameter
            if (sort != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("", "sort", sort)); // query parameter
            if (fields != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("csv", "fields", fields)); // query parameter
            if (embed != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("csv", "embed", embed)); // query parameter


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("GetProjects", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<ProjectsEndpointType>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (ProjectsEndpointType) Configuration.ApiClient.Deserialize(localVarResponse, typeof(ProjectsEndpointType)));
        }

        /// <summary>
        /// Getting single Projects by its UID Getting single Projects by its UID. The project is modeled as a feature in a GeoJSON structure.
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="projectUid">UID of the project</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <returns>ProjectsEndpointType</returns>
        public ProjectsEndpointType GetProjectsByUID (string projectUid, string envelope = null, List<string> embed = null)
        {
             ApiResponse<ProjectsEndpointType> localVarResponse = GetProjectsByUIDWithHttpInfo(projectUid, envelope, embed);
             return localVarResponse.Data;
        }

        /// <summary>
        /// Getting single Projects by its UID Getting single Projects by its UID. The project is modeled as a feature in a GeoJSON structure.
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="projectUid">UID of the project</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <returns>ApiResponse of ProjectsEndpointType</returns>
        public ApiResponse< ProjectsEndpointType > GetProjectsByUIDWithHttpInfo (string projectUid, string envelope = null, List<string> embed = null)
        {
            // verify the required parameter 'projectUid' is set
            if (projectUid == null)
                throw new ApiException(400, "Missing required parameter 'projectUid' when calling ProjectsApi->GetProjectsByUID");

            var localVarPath = "/projects/{project_uid}";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (projectUid != null) localVarPathParams.Add("project_uid", Configuration.ApiClient.ParameterToString(projectUid)); // path parameter
            if (envelope != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("", "envelope", envelope)); // query parameter
            if (embed != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("csv", "embed", embed)); // query parameter


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) Configuration.ApiClient.CallApi(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("GetProjectsByUID", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<ProjectsEndpointType>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (ProjectsEndpointType) Configuration.ApiClient.Deserialize(localVarResponse, typeof(ProjectsEndpointType)));
        }

        /// <summary>
        /// Getting single Projects by its UID Getting single Projects by its UID. The project is modeled as a feature in a GeoJSON structure.
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="projectUid">UID of the project</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <returns>Task of ProjectsEndpointType</returns>
        public async System.Threading.Tasks.Task<ProjectsEndpointType> GetProjectsByUIDAsync (string projectUid, string envelope = null, List<string> embed = null)
        {
             ApiResponse<ProjectsEndpointType> localVarResponse = await GetProjectsByUIDAsyncWithHttpInfo(projectUid, envelope, embed);
             return localVarResponse.Data;

        }

        /// <summary>
        /// Getting single Projects by its UID Getting single Projects by its UID. The project is modeled as a feature in a GeoJSON structure.
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="projectUid">UID of the project</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <returns>Task of ApiResponse (ProjectsEndpointType)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<ProjectsEndpointType>> GetProjectsByUIDAsyncWithHttpInfo (string projectUid, string envelope = null, List<string> embed = null)
        {
            // verify the required parameter 'projectUid' is set
            if (projectUid == null)
                throw new ApiException(400, "Missing required parameter 'projectUid' when calling ProjectsApi->GetProjectsByUID");

            var localVarPath = "/projects/{project_uid}";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (projectUid != null) localVarPathParams.Add("project_uid", Configuration.ApiClient.ParameterToString(projectUid)); // path parameter
            if (envelope != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("", "envelope", envelope)); // query parameter
            if (embed != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("csv", "embed", embed)); // query parameter


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("GetProjectsByUID", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<ProjectsEndpointType>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (ProjectsEndpointType) Configuration.ApiClient.Deserialize(localVarResponse, typeof(ProjectsEndpointType)));
        }

        /// <summary>
        /// Returns the SpatialSources of a Project. Returns the SpatialSources of a Project.
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="projectUid">Project UID</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="page">Requests for collections can return between 0 and N results, controlled using the per_page and page query parameters. All endpoints are limited to 10 results by default. (optional)</param>
        /// <param name="sort">The sorting is initiated by the sort query parameter and a list of comma separated list of fields to sort by. (optional)</param>
        /// <param name="fields">Comma separated list of field names (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <returns>List&lt;SpatialSourcesEndpointType&gt;</returns>
        public List<SpatialSourcesEndpointType> GetSpatialSourceByProjectUID (string projectUid, string envelope = null, int? page = null, string sort = null, List<string> fields = null, List<string> embed = null)
        {
             ApiResponse<List<SpatialSourcesEndpointType>> localVarResponse = GetSpatialSourceByProjectUIDWithHttpInfo(projectUid, envelope, page, sort, fields, embed);
             return localVarResponse.Data;
        }

        /// <summary>
        /// Returns the SpatialSources of a Project. Returns the SpatialSources of a Project.
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="projectUid">Project UID</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="page">Requests for collections can return between 0 and N results, controlled using the per_page and page query parameters. All endpoints are limited to 10 results by default. (optional)</param>
        /// <param name="sort">The sorting is initiated by the sort query parameter and a list of comma separated list of fields to sort by. (optional)</param>
        /// <param name="fields">Comma separated list of field names (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <returns>ApiResponse of List&lt;SpatialSourcesEndpointType&gt;</returns>
        public ApiResponse< List<SpatialSourcesEndpointType> > GetSpatialSourceByProjectUIDWithHttpInfo (string projectUid, string envelope = null, int? page = null, string sort = null, List<string> fields = null, List<string> embed = null)
        {
            // verify the required parameter 'projectUid' is set
            if (projectUid == null)
                throw new ApiException(400, "Missing required parameter 'projectUid' when calling ProjectsApi->GetSpatialSourceByProjectUID");

            var localVarPath = "/projects/{project_uid}/SpatialSources";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (projectUid != null) localVarPathParams.Add("project_uid", Configuration.ApiClient.ParameterToString(projectUid)); // path parameter
            if (envelope != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("", "envelope", envelope)); // query parameter
            if (page != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("", "page", page)); // query parameter
            if (sort != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("", "sort", sort)); // query parameter
            if (fields != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("csv", "fields", fields)); // query parameter
            if (embed != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("csv", "embed", embed)); // query parameter


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) Configuration.ApiClient.CallApi(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("GetSpatialSourceByProjectUID", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<List<SpatialSourcesEndpointType>>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (List<SpatialSourcesEndpointType>) Configuration.ApiClient.Deserialize(localVarResponse, typeof(List<SpatialSourcesEndpointType>)));
        }

        /// <summary>
        /// Returns the SpatialSources of a Project. Returns the SpatialSources of a Project.
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="projectUid">Project UID</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="page">Requests for collections can return between 0 and N results, controlled using the per_page and page query parameters. All endpoints are limited to 10 results by default. (optional)</param>
        /// <param name="sort">The sorting is initiated by the sort query parameter and a list of comma separated list of fields to sort by. (optional)</param>
        /// <param name="fields">Comma separated list of field names (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <returns>Task of List&lt;SpatialSourcesEndpointType&gt;</returns>
        public async System.Threading.Tasks.Task<List<SpatialSourcesEndpointType>> GetSpatialSourceByProjectUIDAsync (string projectUid, string envelope = null, int? page = null, string sort = null, List<string> fields = null, List<string> embed = null)
        {
             ApiResponse<List<SpatialSourcesEndpointType>> localVarResponse = await GetSpatialSourceByProjectUIDAsyncWithHttpInfo(projectUid, envelope, page, sort, fields, embed);
             return localVarResponse.Data;

        }

        /// <summary>
        /// Returns the SpatialSources of a Project. Returns the SpatialSources of a Project.
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="projectUid">Project UID</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="page">Requests for collections can return between 0 and N results, controlled using the per_page and page query parameters. All endpoints are limited to 10 results by default. (optional)</param>
        /// <param name="sort">The sorting is initiated by the sort query parameter and a list of comma separated list of fields to sort by. (optional)</param>
        /// <param name="fields">Comma separated list of field names (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <returns>Task of ApiResponse (List&lt;SpatialSourcesEndpointType&gt;)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<List<SpatialSourcesEndpointType>>> GetSpatialSourceByProjectUIDAsyncWithHttpInfo (string projectUid, string envelope = null, int? page = null, string sort = null, List<string> fields = null, List<string> embed = null)
        {
            // verify the required parameter 'projectUid' is set
            if (projectUid == null)
                throw new ApiException(400, "Missing required parameter 'projectUid' when calling ProjectsApi->GetSpatialSourceByProjectUID");

            var localVarPath = "/projects/{project_uid}/SpatialSources";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (projectUid != null) localVarPathParams.Add("project_uid", Configuration.ApiClient.ParameterToString(projectUid)); // path parameter
            if (envelope != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("", "envelope", envelope)); // query parameter
            if (page != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("", "page", page)); // query parameter
            if (sort != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("", "sort", sort)); // query parameter
            if (fields != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("csv", "fields", fields)); // query parameter
            if (embed != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("csv", "embed", embed)); // query parameter


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("GetSpatialSourceByProjectUID", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<List<SpatialSourcesEndpointType>>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (List<SpatialSourcesEndpointType>) Configuration.ApiClient.Deserialize(localVarResponse, typeof(List<SpatialSourcesEndpointType>)));
        }

        /// <summary>
        /// Create a new model Create a new model.  To add a new Model , the content of Models  must be stored in advanced via the ContentItem endpoint
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="projectUid">Project UID</param>
        /// <param name="newmodel">New model data</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <param name="i4lProcessUid">Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional)</param>
        /// <returns>ProjectsEndpointType</returns>
        public ProjectsEndpointType NewModelUnderProject (string projectUid, ModelsPostRequest newmodel, string envelope = null, List<string> embed = null, string i4lProcessUid = null)
        {
             ApiResponse<ProjectsEndpointType> localVarResponse = NewModelUnderProjectWithHttpInfo(projectUid, newmodel, envelope, embed, i4lProcessUid);
             return localVarResponse.Data;
        }

        /// <summary>
        /// Create a new model Create a new model.  To add a new Model , the content of Models  must be stored in advanced via the ContentItem endpoint
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="projectUid">Project UID</param>
        /// <param name="newmodel">New model data</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <param name="i4lProcessUid">Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional)</param>
        /// <returns>ApiResponse of ProjectsEndpointType</returns>
        public ApiResponse< ProjectsEndpointType > NewModelUnderProjectWithHttpInfo (string projectUid, ModelsPostRequest newmodel, string envelope = null, List<string> embed = null, string i4lProcessUid = null)
        {
            // verify the required parameter 'projectUid' is set
            if (projectUid == null)
                throw new ApiException(400, "Missing required parameter 'projectUid' when calling ProjectsApi->NewModelUnderProject");
            // verify the required parameter 'newmodel' is set
            if (newmodel == null)
                throw new ApiException(400, "Missing required parameter 'newmodel' when calling ProjectsApi->NewModelUnderProject");

            var localVarPath = "/projects/{project_uid}/Models";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/json"
            };
            String localVarHttpContentType = Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (projectUid != null) localVarPathParams.Add("project_uid", Configuration.ApiClient.ParameterToString(projectUid)); // path parameter
            if (envelope != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("", "envelope", envelope)); // query parameter
            if (embed != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("csv", "embed", embed)); // query parameter
            if (i4lProcessUid != null) localVarHeaderParams.Add("i4l-process-uid", Configuration.ApiClient.ParameterToString(i4lProcessUid)); // header parameter
            if (newmodel != null && newmodel.GetType() != typeof(byte[]))
            {
                localVarPostBody = Configuration.ApiClient.Serialize(newmodel); // http body (model) parameter
            }
            else
            {
                localVarPostBody = newmodel; // byte array
            }


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) Configuration.ApiClient.CallApi(localVarPath,
                Method.POST, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("NewModelUnderProject", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<ProjectsEndpointType>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (ProjectsEndpointType) Configuration.ApiClient.Deserialize(localVarResponse, typeof(ProjectsEndpointType)));
        }

        /// <summary>
        /// Create a new model Create a new model.  To add a new Model , the content of Models  must be stored in advanced via the ContentItem endpoint
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="projectUid">Project UID</param>
        /// <param name="newmodel">New model data</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <param name="i4lProcessUid">Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional)</param>
        /// <returns>Task of ProjectsEndpointType</returns>
        public async System.Threading.Tasks.Task<ProjectsEndpointType> NewModelUnderProjectAsync (string projectUid, ModelsPostRequest newmodel, string envelope = null, List<string> embed = null, string i4lProcessUid = null)
        {
             ApiResponse<ProjectsEndpointType> localVarResponse = await NewModelUnderProjectAsyncWithHttpInfo(projectUid, newmodel, envelope, embed, i4lProcessUid);
             return localVarResponse.Data;

        }

        /// <summary>
        /// Create a new model Create a new model.  To add a new Model , the content of Models  must be stored in advanced via the ContentItem endpoint
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="projectUid">Project UID</param>
        /// <param name="newmodel">New model data</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <param name="i4lProcessUid">Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional)</param>
        /// <returns>Task of ApiResponse (ProjectsEndpointType)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<ProjectsEndpointType>> NewModelUnderProjectAsyncWithHttpInfo (string projectUid, ModelsPostRequest newmodel, string envelope = null, List<string> embed = null, string i4lProcessUid = null)
        {
            // verify the required parameter 'projectUid' is set
            if (projectUid == null)
                throw new ApiException(400, "Missing required parameter 'projectUid' when calling ProjectsApi->NewModelUnderProject");
            // verify the required parameter 'newmodel' is set
            if (newmodel == null)
                throw new ApiException(400, "Missing required parameter 'newmodel' when calling ProjectsApi->NewModelUnderProject");

            var localVarPath = "/projects/{project_uid}/Models";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/json"
            };
            String localVarHttpContentType = Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (projectUid != null) localVarPathParams.Add("project_uid", Configuration.ApiClient.ParameterToString(projectUid)); // path parameter
            if (envelope != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("", "envelope", envelope)); // query parameter
            if (embed != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("csv", "embed", embed)); // query parameter
            if (i4lProcessUid != null) localVarHeaderParams.Add("i4l-process-uid", Configuration.ApiClient.ParameterToString(i4lProcessUid)); // header parameter
            if (newmodel != null && newmodel.GetType() != typeof(byte[]))
            {
                localVarPostBody = Configuration.ApiClient.Serialize(newmodel); // http body (model) parameter
            }
            else
            {
                localVarPostBody = newmodel; // byte array
            }


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.POST, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("NewModelUnderProject", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<ProjectsEndpointType>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (ProjectsEndpointType) Configuration.ApiClient.Deserialize(localVarResponse, typeof(ProjectsEndpointType)));
        }

        /// <summary>
        /// Create a new project Create a new project. The new project is modeled as a feature in a GeoJSON structure. Currently only one project feature is allowed.
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="newproject">New project data</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <param name="i4lProcessUid">Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional)</param>
        /// <returns>ProjectsEndpointType</returns>
        public ProjectsEndpointType NewProject (ProjectsPostRequest newproject, string envelope = null, List<string> embed = null, string i4lProcessUid = null)
        {
             ApiResponse<ProjectsEndpointType> localVarResponse = NewProjectWithHttpInfo(newproject, envelope, embed, i4lProcessUid);
             return localVarResponse.Data;
        }

        /// <summary>
        /// Create a new project Create a new project. The new project is modeled as a feature in a GeoJSON structure. Currently only one project feature is allowed.
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="newproject">New project data</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <param name="i4lProcessUid">Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional)</param>
        /// <returns>ApiResponse of ProjectsEndpointType</returns>
        public ApiResponse< ProjectsEndpointType > NewProjectWithHttpInfo (ProjectsPostRequest newproject, string envelope = null, List<string> embed = null, string i4lProcessUid = null)
        {
            // verify the required parameter 'newproject' is set
            if (newproject == null)
                throw new ApiException(400, "Missing required parameter 'newproject' when calling ProjectsApi->NewProject");

            var localVarPath = "/projects";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/json"
            };
            String localVarHttpContentType = Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (envelope != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("", "envelope", envelope)); // query parameter
            if (embed != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("csv", "embed", embed)); // query parameter
            if (i4lProcessUid != null) localVarHeaderParams.Add("i4l-process-uid", Configuration.ApiClient.ParameterToString(i4lProcessUid)); // header parameter
            if (newproject != null && newproject.GetType() != typeof(byte[]))
            {
                localVarPostBody = Configuration.ApiClient.Serialize(newproject); // http body (model) parameter
            }
            else
            {
                localVarPostBody = newproject; // byte array
            }


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) Configuration.ApiClient.CallApi(localVarPath,
                Method.POST, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("NewProject", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<ProjectsEndpointType>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (ProjectsEndpointType) Configuration.ApiClient.Deserialize(localVarResponse, typeof(ProjectsEndpointType)));
        }

        /// <summary>
        /// Create a new project Create a new project. The new project is modeled as a feature in a GeoJSON structure. Currently only one project feature is allowed.
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="newproject">New project data</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <param name="i4lProcessUid">Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional)</param>
        /// <returns>Task of ProjectsEndpointType</returns>
        public async System.Threading.Tasks.Task<ProjectsEndpointType> NewProjectAsync (ProjectsPostRequest newproject, string envelope = null, List<string> embed = null, string i4lProcessUid = null)
        {
             ApiResponse<ProjectsEndpointType> localVarResponse = await NewProjectAsyncWithHttpInfo(newproject, envelope, embed, i4lProcessUid);
             return localVarResponse.Data;

        }

        /// <summary>
        /// Create a new project Create a new project. The new project is modeled as a feature in a GeoJSON structure. Currently only one project feature is allowed.
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="newproject">New project data</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <param name="i4lProcessUid">Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional)</param>
        /// <returns>Task of ApiResponse (ProjectsEndpointType)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<ProjectsEndpointType>> NewProjectAsyncWithHttpInfo (ProjectsPostRequest newproject, string envelope = null, List<string> embed = null, string i4lProcessUid = null)
        {
            // verify the required parameter 'newproject' is set
            if (newproject == null)
                throw new ApiException(400, "Missing required parameter 'newproject' when calling ProjectsApi->NewProject");

            var localVarPath = "/projects";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/json"
            };
            String localVarHttpContentType = Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (envelope != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("", "envelope", envelope)); // query parameter
            if (embed != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("csv", "embed", embed)); // query parameter
            if (i4lProcessUid != null) localVarHeaderParams.Add("i4l-process-uid", Configuration.ApiClient.ParameterToString(i4lProcessUid)); // header parameter
            if (newproject != null && newproject.GetType() != typeof(byte[]))
            {
                localVarPostBody = Configuration.ApiClient.Serialize(newproject); // http body (model) parameter
            }
            else
            {
                localVarPostBody = newproject; // byte array
            }


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.POST, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("NewProject", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<ProjectsEndpointType>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (ProjectsEndpointType) Configuration.ApiClient.Deserialize(localVarResponse, typeof(ProjectsEndpointType)));
        }

        /// <summary>
        /// Create a new SpatialSource Create a new SpatialSource. To add a new SpatialSource , the content of SpatialSource  must be stored in advanced via the ContentItem endpoint
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="projectUid">Project UID</param>
        /// <param name="newspatialsource">New SpatialSource data</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <param name="i4lProcessUid">Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional)</param>
        /// <returns>ProjectsEndpointType</returns>
        public ProjectsEndpointType NewSpatialSourceUnderProject (string projectUid, SpatialSourcesPostRequest newspatialsource, string envelope = null, List<string> embed = null, string i4lProcessUid = null)
        {
             ApiResponse<ProjectsEndpointType> localVarResponse = NewSpatialSourceUnderProjectWithHttpInfo(projectUid, newspatialsource, envelope, embed, i4lProcessUid);
             return localVarResponse.Data;
        }

        /// <summary>
        /// Create a new SpatialSource Create a new SpatialSource. To add a new SpatialSource , the content of SpatialSource  must be stored in advanced via the ContentItem endpoint
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="projectUid">Project UID</param>
        /// <param name="newspatialsource">New SpatialSource data</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <param name="i4lProcessUid">Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional)</param>
        /// <returns>ApiResponse of ProjectsEndpointType</returns>
        public ApiResponse< ProjectsEndpointType > NewSpatialSourceUnderProjectWithHttpInfo (string projectUid, SpatialSourcesPostRequest newspatialsource, string envelope = null, List<string> embed = null, string i4lProcessUid = null)
        {
            // verify the required parameter 'projectUid' is set
            if (projectUid == null)
                throw new ApiException(400, "Missing required parameter 'projectUid' when calling ProjectsApi->NewSpatialSourceUnderProject");
            // verify the required parameter 'newspatialsource' is set
            if (newspatialsource == null)
                throw new ApiException(400, "Missing required parameter 'newspatialsource' when calling ProjectsApi->NewSpatialSourceUnderProject");

            var localVarPath = "/projects/{project_uid}/SpatialSources";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/json"
            };
            String localVarHttpContentType = Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (projectUid != null) localVarPathParams.Add("project_uid", Configuration.ApiClient.ParameterToString(projectUid)); // path parameter
            if (envelope != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("", "envelope", envelope)); // query parameter
            if (embed != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("csv", "embed", embed)); // query parameter
            if (i4lProcessUid != null) localVarHeaderParams.Add("i4l-process-uid", Configuration.ApiClient.ParameterToString(i4lProcessUid)); // header parameter
            if (newspatialsource != null && newspatialsource.GetType() != typeof(byte[]))
            {
                localVarPostBody = Configuration.ApiClient.Serialize(newspatialsource); // http body (model) parameter
            }
            else
            {
                localVarPostBody = newspatialsource; // byte array
            }


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) Configuration.ApiClient.CallApi(localVarPath,
                Method.POST, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("NewSpatialSourceUnderProject", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<ProjectsEndpointType>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (ProjectsEndpointType) Configuration.ApiClient.Deserialize(localVarResponse, typeof(ProjectsEndpointType)));
        }

        /// <summary>
        /// Create a new SpatialSource Create a new SpatialSource. To add a new SpatialSource , the content of SpatialSource  must be stored in advanced via the ContentItem endpoint
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="projectUid">Project UID</param>
        /// <param name="newspatialsource">New SpatialSource data</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <param name="i4lProcessUid">Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional)</param>
        /// <returns>Task of ProjectsEndpointType</returns>
        public async System.Threading.Tasks.Task<ProjectsEndpointType> NewSpatialSourceUnderProjectAsync (string projectUid, SpatialSourcesPostRequest newspatialsource, string envelope = null, List<string> embed = null, string i4lProcessUid = null)
        {
             ApiResponse<ProjectsEndpointType> localVarResponse = await NewSpatialSourceUnderProjectAsyncWithHttpInfo(projectUid, newspatialsource, envelope, embed, i4lProcessUid);
             return localVarResponse.Data;

        }

        /// <summary>
        /// Create a new SpatialSource Create a new SpatialSource. To add a new SpatialSource , the content of SpatialSource  must be stored in advanced via the ContentItem endpoint
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="projectUid">Project UID</param>
        /// <param name="newspatialsource">New SpatialSource data</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <param name="i4lProcessUid">Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional)</param>
        /// <returns>Task of ApiResponse (ProjectsEndpointType)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<ProjectsEndpointType>> NewSpatialSourceUnderProjectAsyncWithHttpInfo (string projectUid, SpatialSourcesPostRequest newspatialsource, string envelope = null, List<string> embed = null, string i4lProcessUid = null)
        {
            // verify the required parameter 'projectUid' is set
            if (projectUid == null)
                throw new ApiException(400, "Missing required parameter 'projectUid' when calling ProjectsApi->NewSpatialSourceUnderProject");
            // verify the required parameter 'newspatialsource' is set
            if (newspatialsource == null)
                throw new ApiException(400, "Missing required parameter 'newspatialsource' when calling ProjectsApi->NewSpatialSourceUnderProject");

            var localVarPath = "/projects/{project_uid}/SpatialSources";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/json"
            };
            String localVarHttpContentType = Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (projectUid != null) localVarPathParams.Add("project_uid", Configuration.ApiClient.ParameterToString(projectUid)); // path parameter
            if (envelope != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("", "envelope", envelope)); // query parameter
            if (embed != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("csv", "embed", embed)); // query parameter
            if (i4lProcessUid != null) localVarHeaderParams.Add("i4l-process-uid", Configuration.ApiClient.ParameterToString(i4lProcessUid)); // header parameter
            if (newspatialsource != null && newspatialsource.GetType() != typeof(byte[]))
            {
                localVarPostBody = Configuration.ApiClient.Serialize(newspatialsource); // http body (model) parameter
            }
            else
            {
                localVarPostBody = newspatialsource; // byte array
            }


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.POST, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("NewSpatialSourceUnderProject", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<ProjectsEndpointType>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (ProjectsEndpointType) Configuration.ApiClient.Deserialize(localVarResponse, typeof(ProjectsEndpointType)));
        }

        /// <summary>
        /// Update a project Updates some attributes of a project.
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="projectUid">Project UID to be patched</param>
        /// <param name="patchproject">Update data</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <param name="i4lProcessUid">Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional)</param>
        /// <returns>ProjectsEndpointType</returns>
        public ProjectsEndpointType UpdateProjects (string projectUid, RFC6902PatchRequest patchproject, string envelope = null, List<string> embed = null, string i4lProcessUid = null)
        {
             ApiResponse<ProjectsEndpointType> localVarResponse = UpdateProjectsWithHttpInfo(projectUid, patchproject, envelope, embed, i4lProcessUid);
             return localVarResponse.Data;
        }

        /// <summary>
        /// Update a project Updates some attributes of a project.
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="projectUid">Project UID to be patched</param>
        /// <param name="patchproject">Update data</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <param name="i4lProcessUid">Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional)</param>
        /// <returns>ApiResponse of ProjectsEndpointType</returns>
        public ApiResponse< ProjectsEndpointType > UpdateProjectsWithHttpInfo (string projectUid, RFC6902PatchRequest patchproject, string envelope = null, List<string> embed = null, string i4lProcessUid = null)
        {
            // verify the required parameter 'projectUid' is set
            if (projectUid == null)
                throw new ApiException(400, "Missing required parameter 'projectUid' when calling ProjectsApi->UpdateProjects");
            // verify the required parameter 'patchproject' is set
            if (patchproject == null)
                throw new ApiException(400, "Missing required parameter 'patchproject' when calling ProjectsApi->UpdateProjects");

            var localVarPath = "/projects/{project_uid}";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/json"
            };
            String localVarHttpContentType = Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (projectUid != null) localVarPathParams.Add("project_uid", Configuration.ApiClient.ParameterToString(projectUid)); // path parameter
            if (envelope != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("", "envelope", envelope)); // query parameter
            if (embed != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("csv", "embed", embed)); // query parameter
            if (i4lProcessUid != null) localVarHeaderParams.Add("i4l-process-uid", Configuration.ApiClient.ParameterToString(i4lProcessUid)); // header parameter
            if (patchproject != null && patchproject.GetType() != typeof(byte[]))
            {
                localVarPostBody = Configuration.ApiClient.Serialize(patchproject); // http body (model) parameter
            }
            else
            {
                localVarPostBody = patchproject; // byte array
            }


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) Configuration.ApiClient.CallApi(localVarPath,
                Method.PATCH, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("UpdateProjects", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<ProjectsEndpointType>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (ProjectsEndpointType) Configuration.ApiClient.Deserialize(localVarResponse, typeof(ProjectsEndpointType)));
        }

        /// <summary>
        /// Update a project Updates some attributes of a project.
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="projectUid">Project UID to be patched</param>
        /// <param name="patchproject">Update data</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <param name="i4lProcessUid">Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional)</param>
        /// <returns>Task of ProjectsEndpointType</returns>
        public async System.Threading.Tasks.Task<ProjectsEndpointType> UpdateProjectsAsync (string projectUid, RFC6902PatchRequest patchproject, string envelope = null, List<string> embed = null, string i4lProcessUid = null)
        {
             ApiResponse<ProjectsEndpointType> localVarResponse = await UpdateProjectsAsyncWithHttpInfo(projectUid, patchproject, envelope, embed, i4lProcessUid);
             return localVarResponse.Data;

        }

        /// <summary>
        /// Update a project Updates some attributes of a project.
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="projectUid">Project UID to be patched</param>
        /// <param name="patchproject">Update data</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <param name="i4lProcessUid">Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional)</param>
        /// <returns>Task of ApiResponse (ProjectsEndpointType)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<ProjectsEndpointType>> UpdateProjectsAsyncWithHttpInfo (string projectUid, RFC6902PatchRequest patchproject, string envelope = null, List<string> embed = null, string i4lProcessUid = null)
        {
            // verify the required parameter 'projectUid' is set
            if (projectUid == null)
                throw new ApiException(400, "Missing required parameter 'projectUid' when calling ProjectsApi->UpdateProjects");
            // verify the required parameter 'patchproject' is set
            if (patchproject == null)
                throw new ApiException(400, "Missing required parameter 'patchproject' when calling ProjectsApi->UpdateProjects");

            var localVarPath = "/projects/{project_uid}";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/json"
            };
            String localVarHttpContentType = Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (projectUid != null) localVarPathParams.Add("project_uid", Configuration.ApiClient.ParameterToString(projectUid)); // path parameter
            if (envelope != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("", "envelope", envelope)); // query parameter
            if (embed != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("csv", "embed", embed)); // query parameter
            if (i4lProcessUid != null) localVarHeaderParams.Add("i4l-process-uid", Configuration.ApiClient.ParameterToString(i4lProcessUid)); // header parameter
            if (patchproject != null && patchproject.GetType() != typeof(byte[]))
            {
                localVarPostBody = Configuration.ApiClient.Serialize(patchproject); // http body (model) parameter
            }
            else
            {
                localVarPostBody = patchproject; // byte array
            }


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.PATCH, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("UpdateProjects", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<ProjectsEndpointType>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (ProjectsEndpointType) Configuration.ApiClient.Deserialize(localVarResponse, typeof(ProjectsEndpointType)));
        }

    }
}
