/* 
 * its4land Public API
 *
 * The its4land Public API provides access to the services of the its4land Publish and Share platform.
 *
 * OpenAPI spec version: 0.0.2
 * Contact: contact@its4land.com
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */

using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using RestSharp;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace IO.Swagger.Api
{
    /// <summary>
    /// Represents a collection of functions to interact with the API endpoints
    /// </summary>
    public interface ISpatialUnitsApi : IApiAccessor
    {
        #region Synchronous Operations
        /// <summary>
        /// Creates a spatial unit
        /// </summary>
        /// <remarks>
        /// Create a 2D polygon base spatial unit from a boundary face string  as GeoJSON
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="spatialunitdata">Update data</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="i4lProcessUid">Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <returns>SpatialUnitsFeatureEndpointType</returns>
        SpatialUnitsFeatureEndpointType Create2PpolygonSPUfromBFS (SpatialUnitBaseFeaturePostRequest spatialunitdata, string envelope = null, string i4lProcessUid = null, List<string> embed = null);

        /// <summary>
        /// Creates a spatial unit
        /// </summary>
        /// <remarks>
        /// Create a 2D polygon base spatial unit from a boundary face string  as GeoJSON
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="spatialunitdata">Update data</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="i4lProcessUid">Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <returns>ApiResponse of SpatialUnitsFeatureEndpointType</returns>
        ApiResponse<SpatialUnitsFeatureEndpointType> Create2PpolygonSPUfromBFSWithHttpInfo (SpatialUnitBaseFeaturePostRequest spatialunitdata, string envelope = null, string i4lProcessUid = null, List<string> embed = null);
        /// <summary>
        /// Returns a single spatial unit
        /// </summary>
        /// <remarks>
        /// Returns a single spatial unit with qualitative base qualitative base spatial profile
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="spatialunitUid">Spatial unit UID</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <returns>SpatialUnitsFeatureEndpointType</returns>
        SpatialUnitsFeatureEndpointType GetSpatialUnitByUID (string spatialunitUid, string envelope = null, List<string> embed = null);

        /// <summary>
        /// Returns a single spatial unit
        /// </summary>
        /// <remarks>
        /// Returns a single spatial unit with qualitative base qualitative base spatial profile
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="spatialunitUid">Spatial unit UID</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <returns>ApiResponse of SpatialUnitsFeatureEndpointType</returns>
        ApiResponse<SpatialUnitsFeatureEndpointType> GetSpatialUnitByUIDWithHttpInfo (string spatialunitUid, string envelope = null, List<string> embed = null);
        /// <summary>
        /// Returns a single spatial unit concept
        /// </summary>
        /// <remarks>
        /// Returns a single spatial unit concept
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="conceptUid">Spatial unit concept UID</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <returns>SpatialUnitConceptEndpointType</returns>
        SpatialUnitConceptEndpointType GetSpatialUnitConceptByUID (string conceptUid, string envelope = null, List<string> embed = null);

        /// <summary>
        /// Returns a single spatial unit concept
        /// </summary>
        /// <remarks>
        /// Returns a single spatial unit concept
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="conceptUid">Spatial unit concept UID</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <returns>ApiResponse of SpatialUnitConceptEndpointType</returns>
        ApiResponse<SpatialUnitConceptEndpointType> GetSpatialUnitConceptByUIDWithHttpInfo (string conceptUid, string envelope = null, List<string> embed = null);
        /// <summary>
        /// Returns a list of SpatialUnits in a GeoJSON structure.
        /// </summary>
        /// <remarks>
        /// Returns a list of SpatialUnits as GeoJSON feature with 2D polygon base spatial profile
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="querywindow">Polygon. The polygon is encoded a comma separated list of coordinates. X1, Y1, X2, Y2, ..., Xn, Yn, X1, Y1</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="uid">Comma separated list of AdminSources UID (optional)</param>
        /// <param name="name">Comma separated list of AdminSources names (optional)</param>
        /// <param name="concept">Comma separated list of Spatial Unit concepts (optional)</param>
        /// <param name="level">Comma separated list of LADM Levels (optional)</param>
        /// <param name="projects">Comma separated list of project UID (optional)</param>
        /// <param name="adminsource">Comma separated list of SpatialSource UID (optional)</param>
        /// <param name="tags">Comma separated list of tags (optional)</param>
        /// <param name="page">Requests for collections can return between 0 and N results, controlled using the per_page and page query parameters. All endpoints are limited to 10 results by default. (optional)</param>
        /// <param name="sort">The sorting is initiated by the sort query parameter and a list of comma separated list of fields to sort by. (optional)</param>
        /// <param name="fields">Comma separated list of tags (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <returns>List&lt;SpatialUnitsFeatureEndpointType&gt;</returns>
        List<SpatialUnitsFeatureEndpointType> GetSpatialUnits (string querywindow, string envelope = null, List<string> uid = null, List<string> name = null, List<string> concept = null, List<string> level = null, List<string> projects = null, List<string> adminsource = null, List<string> tags = null, int? page = null, string sort = null, List<string> fields = null, List<string> embed = null);

        /// <summary>
        /// Returns a list of SpatialUnits in a GeoJSON structure.
        /// </summary>
        /// <remarks>
        /// Returns a list of SpatialUnits as GeoJSON feature with 2D polygon base spatial profile
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="querywindow">Polygon. The polygon is encoded a comma separated list of coordinates. X1, Y1, X2, Y2, ..., Xn, Yn, X1, Y1</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="uid">Comma separated list of AdminSources UID (optional)</param>
        /// <param name="name">Comma separated list of AdminSources names (optional)</param>
        /// <param name="concept">Comma separated list of Spatial Unit concepts (optional)</param>
        /// <param name="level">Comma separated list of LADM Levels (optional)</param>
        /// <param name="projects">Comma separated list of project UID (optional)</param>
        /// <param name="adminsource">Comma separated list of SpatialSource UID (optional)</param>
        /// <param name="tags">Comma separated list of tags (optional)</param>
        /// <param name="page">Requests for collections can return between 0 and N results, controlled using the per_page and page query parameters. All endpoints are limited to 10 results by default. (optional)</param>
        /// <param name="sort">The sorting is initiated by the sort query parameter and a list of comma separated list of fields to sort by. (optional)</param>
        /// <param name="fields">Comma separated list of tags (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <returns>ApiResponse of List&lt;SpatialUnitsFeatureEndpointType&gt;</returns>
        ApiResponse<List<SpatialUnitsFeatureEndpointType>> GetSpatialUnitsWithHttpInfo (string querywindow, string envelope = null, List<string> uid = null, List<string> name = null, List<string> concept = null, List<string> level = null, List<string> projects = null, List<string> adminsource = null, List<string> tags = null, int? page = null, string sort = null, List<string> fields = null, List<string> embed = null);
        /// <summary>
        /// Returns a list of SpatialUnits
        /// </summary>
        /// <remarks>
        /// Returns a list of SpatialUnits as feature with 2d polygon base spatial profile
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="spatialunitUid">Spatial unit UID</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <returns>List&lt;SpatialUnitsFeatureEndpointType&gt;</returns>
        List<SpatialUnitsFeatureEndpointType> GetSpatialUnitsByUUID (string spatialunitUid, string envelope = null, List<string> embed = null);

        /// <summary>
        /// Returns a list of SpatialUnits
        /// </summary>
        /// <remarks>
        /// Returns a list of SpatialUnits as feature with 2d polygon base spatial profile
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="spatialunitUid">Spatial unit UID</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <returns>ApiResponse of List&lt;SpatialUnitsFeatureEndpointType&gt;</returns>
        ApiResponse<List<SpatialUnitsFeatureEndpointType>> GetSpatialUnitsByUUIDWithHttpInfo (string spatialunitUid, string envelope = null, List<string> embed = null);
        /// <summary>
        /// Returns a list of spatial units concepts
        /// </summary>
        /// <remarks>
        /// Returns a list of spatial units concepts
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="uid">Comma separated list of Spatial unit UID (optional)</param>
        /// <param name="name">Comma separated list of AdminSources names (optional)</param>
        /// <param name="projects">Comma separated list of project UID (optional)</param>
        /// <param name="spatialunit">Comma separated list of SpatialSource UID (optional)</param>
        /// <param name="tags">Comma separated list of tags (optional)</param>
        /// <param name="page">Requests for collections can return between 0 and N results, controlled using the per_page and page query parameters. All endpoints are limited to 10 results by default. (optional)</param>
        /// <param name="sort">The sorting is initiated by the sort query parameter and a list of comma separated list of fields to sort by. (optional)</param>
        /// <param name="fields">Comma separated list of tags (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <returns>List&lt;SpatialUnitsFeatureEndpointType&gt;</returns>
        List<SpatialUnitsFeatureEndpointType> GetSpatialUnitsConcepts (string envelope = null, List<string> uid = null, List<string> name = null, List<string> projects = null, List<string> spatialunit = null, List<string> tags = null, int? page = null, string sort = null, List<string> fields = null, List<string> embed = null);

        /// <summary>
        /// Returns a list of spatial units concepts
        /// </summary>
        /// <remarks>
        /// Returns a list of spatial units concepts
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="uid">Comma separated list of Spatial unit UID (optional)</param>
        /// <param name="name">Comma separated list of AdminSources names (optional)</param>
        /// <param name="projects">Comma separated list of project UID (optional)</param>
        /// <param name="spatialunit">Comma separated list of SpatialSource UID (optional)</param>
        /// <param name="tags">Comma separated list of tags (optional)</param>
        /// <param name="page">Requests for collections can return between 0 and N results, controlled using the per_page and page query parameters. All endpoints are limited to 10 results by default. (optional)</param>
        /// <param name="sort">The sorting is initiated by the sort query parameter and a list of comma separated list of fields to sort by. (optional)</param>
        /// <param name="fields">Comma separated list of tags (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <returns>ApiResponse of List&lt;SpatialUnitsFeatureEndpointType&gt;</returns>
        ApiResponse<List<SpatialUnitsFeatureEndpointType>> GetSpatialUnitsConceptsWithHttpInfo (string envelope = null, List<string> uid = null, List<string> name = null, List<string> projects = null, List<string> spatialunit = null, List<string> tags = null, int? page = null, string sort = null, List<string> fields = null, List<string> embed = null);
        /// <summary>
        /// Returns a list of SpatialUnits
        /// </summary>
        /// <remarks>
        /// Returns a list of SpatialUnits as feature with geometry
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="querywindow">Polygon. The polygon is encoded a comma separated list of coordinates. X1, Y1, X2, Y2, ..., Xn, Yn, X1, Y1</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="uid">Comma separated list of Spatial unit UID (optional)</param>
        /// <param name="name">Comma separated list of AdminSources names (optional)</param>
        /// <param name="concept">Comma separated list of Spatial Unit concepts (optional)</param>
        /// <param name="level">Comma separated list of LADM Levels (optional)</param>
        /// <param name="projects">Comma separated list of project UID (optional)</param>
        /// <param name="adminsource">Comma separated list of SpatialSource UID (optional)</param>
        /// <param name="tags">Comma separated list of tags (optional)</param>
        /// <param name="page">Requests for collections can return between 0 and N results, controlled using the per_page and page query parameters. All endpoints are limited to 10 results by default. (optional)</param>
        /// <param name="sort">The sorting is initiated by the sort query parameter and a list of comma separated list of fields to sort by. (optional)</param>
        /// <param name="fields">Comma separated list of tags (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <returns>List&lt;SpatialUnitsFeatureEndpointType&gt;</returns>
        List<SpatialUnitsFeatureEndpointType> GetSpatialUnitsQualitative (string querywindow, string envelope = null, List<string> uid = null, List<string> name = null, List<string> concept = null, List<string> level = null, List<string> projects = null, List<string> adminsource = null, List<string> tags = null, int? page = null, string sort = null, List<string> fields = null, List<string> embed = null);

        /// <summary>
        /// Returns a list of SpatialUnits
        /// </summary>
        /// <remarks>
        /// Returns a list of SpatialUnits as feature with geometry
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="querywindow">Polygon. The polygon is encoded a comma separated list of coordinates. X1, Y1, X2, Y2, ..., Xn, Yn, X1, Y1</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="uid">Comma separated list of Spatial unit UID (optional)</param>
        /// <param name="name">Comma separated list of AdminSources names (optional)</param>
        /// <param name="concept">Comma separated list of Spatial Unit concepts (optional)</param>
        /// <param name="level">Comma separated list of LADM Levels (optional)</param>
        /// <param name="projects">Comma separated list of project UID (optional)</param>
        /// <param name="adminsource">Comma separated list of SpatialSource UID (optional)</param>
        /// <param name="tags">Comma separated list of tags (optional)</param>
        /// <param name="page">Requests for collections can return between 0 and N results, controlled using the per_page and page query parameters. All endpoints are limited to 10 results by default. (optional)</param>
        /// <param name="sort">The sorting is initiated by the sort query parameter and a list of comma separated list of fields to sort by. (optional)</param>
        /// <param name="fields">Comma separated list of tags (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <returns>ApiResponse of List&lt;SpatialUnitsFeatureEndpointType&gt;</returns>
        ApiResponse<List<SpatialUnitsFeatureEndpointType>> GetSpatialUnitsQualitativeWithHttpInfo (string querywindow, string envelope = null, List<string> uid = null, List<string> name = null, List<string> concept = null, List<string> level = null, List<string> projects = null, List<string> adminsource = null, List<string> tags = null, int? page = null, string sort = null, List<string> fields = null, List<string> embed = null);
        /// <summary>
        /// Create a new SpatialUnit
        /// </summary>
        /// <remarks>
        /// Create a new SpatialUnit with 2d polygon base spatial profile. The spatial unit is modeled as a GeoJSON feature. The endpoint currently allows only one spatial unit per request.
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="newspatialunit">New Spatial Unit data</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <param name="i4lProcessUid">Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional)</param>
        /// <returns>SpatialUnitsFeatureEndpointType</returns>
        SpatialUnitsFeatureEndpointType NewSpatialUnit (SpatialUnitsFeaturePostRequest newspatialunit, string envelope = null, List<string> embed = null, string i4lProcessUid = null);

        /// <summary>
        /// Create a new SpatialUnit
        /// </summary>
        /// <remarks>
        /// Create a new SpatialUnit with 2d polygon base spatial profile. The spatial unit is modeled as a GeoJSON feature. The endpoint currently allows only one spatial unit per request.
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="newspatialunit">New Spatial Unit data</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <param name="i4lProcessUid">Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional)</param>
        /// <returns>ApiResponse of SpatialUnitsFeatureEndpointType</returns>
        ApiResponse<SpatialUnitsFeatureEndpointType> NewSpatialUnitWithHttpInfo (SpatialUnitsFeaturePostRequest newspatialunit, string envelope = null, List<string> embed = null, string i4lProcessUid = null);
        /// <summary>
        /// Create a new concept for a spatial unit
        /// </summary>
        /// <remarks>
        /// Create a new concept for a spatial unit.
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="newspatialunitconcept">New Spatial Unit concept data</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <param name="i4lProcessUid">Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional)</param>
        /// <returns>SpatialUnitConceptEndpointType</returns>
        SpatialUnitConceptEndpointType NewSpatialUnitConcept (SpatialUnitConceptPostRequest newspatialunitconcept, string envelope = null, List<string> embed = null, string i4lProcessUid = null);

        /// <summary>
        /// Create a new concept for a spatial unit
        /// </summary>
        /// <remarks>
        /// Create a new concept for a spatial unit.
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="newspatialunitconcept">New Spatial Unit concept data</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <param name="i4lProcessUid">Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional)</param>
        /// <returns>ApiResponse of SpatialUnitConceptEndpointType</returns>
        ApiResponse<SpatialUnitConceptEndpointType> NewSpatialUnitConceptWithHttpInfo (SpatialUnitConceptPostRequest newspatialunitconcept, string envelope = null, List<string> embed = null, string i4lProcessUid = null);
        /// <summary>
        /// Create a new SpatialUnit
        /// </summary>
        /// <remarks>
        /// Create a new SpatialUnit with qualitative base spatial profile
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="newspatialunit">New Spatial Unit data</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <param name="i4lProcessUid">Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional)</param>
        /// <returns>SpatialUnitsFeatureEndpointType</returns>
        SpatialUnitsFeatureEndpointType NewSpatialUnitQualitative (SpatialUnitsFeaturePostRequest newspatialunit, string envelope = null, List<string> embed = null, string i4lProcessUid = null);

        /// <summary>
        /// Create a new SpatialUnit
        /// </summary>
        /// <remarks>
        /// Create a new SpatialUnit with qualitative base spatial profile
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="newspatialunit">New Spatial Unit data</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <param name="i4lProcessUid">Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional)</param>
        /// <returns>ApiResponse of SpatialUnitsFeatureEndpointType</returns>
        ApiResponse<SpatialUnitsFeatureEndpointType> NewSpatialUnitQualitativeWithHttpInfo (SpatialUnitsFeaturePostRequest newspatialunit, string envelope = null, List<string> embed = null, string i4lProcessUid = null);
        /// <summary>
        /// Update an spatial unit
        /// </summary>
        /// <remarks>
        /// Update an spatial unit with 2d polygon base spatial profile
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="spatialunitUid">Spatial unit UID</param>
        /// <param name="patchspatialunit">Update data</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="i4lProcessUid">Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional)</param>
        /// <returns>SpatialUnitsFeatureEndpointType</returns>
        SpatialUnitsFeatureEndpointType UpdateSpatialUnit (string spatialunitUid, RFC6902PatchRequest patchspatialunit, string envelope = null, string i4lProcessUid = null);

        /// <summary>
        /// Update an spatial unit
        /// </summary>
        /// <remarks>
        /// Update an spatial unit with 2d polygon base spatial profile
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="spatialunitUid">Spatial unit UID</param>
        /// <param name="patchspatialunit">Update data</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="i4lProcessUid">Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional)</param>
        /// <returns>ApiResponse of SpatialUnitsFeatureEndpointType</returns>
        ApiResponse<SpatialUnitsFeatureEndpointType> UpdateSpatialUnitWithHttpInfo (string spatialunitUid, RFC6902PatchRequest patchspatialunit, string envelope = null, string i4lProcessUid = null);
        /// <summary>
        /// Updates a new spatial unit concept
        /// </summary>
        /// <remarks>
        /// Updates a spatial unit concept
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="conceptUid">Spatial unit concept UID</param>
        /// <param name="patchspatialunitconcept">Update data</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="i4lProcessUid">Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional)</param>
        /// <returns>SpatialUnitConceptEndpointType</returns>
        SpatialUnitConceptEndpointType UpdateSpatialUnitConcept (string conceptUid, RFC6902PatchRequest patchspatialunitconcept, string envelope = null, string i4lProcessUid = null);

        /// <summary>
        /// Updates a new spatial unit concept
        /// </summary>
        /// <remarks>
        /// Updates a spatial unit concept
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="conceptUid">Spatial unit concept UID</param>
        /// <param name="patchspatialunitconcept">Update data</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="i4lProcessUid">Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional)</param>
        /// <returns>ApiResponse of SpatialUnitConceptEndpointType</returns>
        ApiResponse<SpatialUnitConceptEndpointType> UpdateSpatialUnitConceptWithHttpInfo (string conceptUid, RFC6902PatchRequest patchspatialunitconcept, string envelope = null, string i4lProcessUid = null);
        /// <summary>
        /// Updates a new SpatialUnit
        /// </summary>
        /// <remarks>
        /// Updates SpatialUnit with qualitative base spatial profile
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="spatialunitUid">Spatial unit UID</param>
        /// <param name="patchspatialunit">Update data</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="i4lProcessUid">Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional)</param>
        /// <returns>SpatialUnitsFeatureEndpointType</returns>
        SpatialUnitsFeatureEndpointType UpdateSpatialUnitQualitative (string spatialunitUid, RFC6902PatchRequest patchspatialunit, string envelope = null, string i4lProcessUid = null);

        /// <summary>
        /// Updates a new SpatialUnit
        /// </summary>
        /// <remarks>
        /// Updates SpatialUnit with qualitative base spatial profile
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="spatialunitUid">Spatial unit UID</param>
        /// <param name="patchspatialunit">Update data</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="i4lProcessUid">Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional)</param>
        /// <returns>ApiResponse of SpatialUnitsFeatureEndpointType</returns>
        ApiResponse<SpatialUnitsFeatureEndpointType> UpdateSpatialUnitQualitativeWithHttpInfo (string spatialunitUid, RFC6902PatchRequest patchspatialunit, string envelope = null, string i4lProcessUid = null);
        #endregion Synchronous Operations
        #region Asynchronous Operations
        /// <summary>
        /// Creates a spatial unit
        /// </summary>
        /// <remarks>
        /// Create a 2D polygon base spatial unit from a boundary face string  as GeoJSON
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="spatialunitdata">Update data</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="i4lProcessUid">Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <returns>Task of SpatialUnitsFeatureEndpointType</returns>
        System.Threading.Tasks.Task<SpatialUnitsFeatureEndpointType> Create2PpolygonSPUfromBFSAsync (SpatialUnitBaseFeaturePostRequest spatialunitdata, string envelope = null, string i4lProcessUid = null, List<string> embed = null);

        /// <summary>
        /// Creates a spatial unit
        /// </summary>
        /// <remarks>
        /// Create a 2D polygon base spatial unit from a boundary face string  as GeoJSON
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="spatialunitdata">Update data</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="i4lProcessUid">Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <returns>Task of ApiResponse (SpatialUnitsFeatureEndpointType)</returns>
        System.Threading.Tasks.Task<ApiResponse<SpatialUnitsFeatureEndpointType>> Create2PpolygonSPUfromBFSAsyncWithHttpInfo (SpatialUnitBaseFeaturePostRequest spatialunitdata, string envelope = null, string i4lProcessUid = null, List<string> embed = null);
        /// <summary>
        /// Returns a single spatial unit
        /// </summary>
        /// <remarks>
        /// Returns a single spatial unit with qualitative base qualitative base spatial profile
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="spatialunitUid">Spatial unit UID</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <returns>Task of SpatialUnitsFeatureEndpointType</returns>
        System.Threading.Tasks.Task<SpatialUnitsFeatureEndpointType> GetSpatialUnitByUIDAsync (string spatialunitUid, string envelope = null, List<string> embed = null);

        /// <summary>
        /// Returns a single spatial unit
        /// </summary>
        /// <remarks>
        /// Returns a single spatial unit with qualitative base qualitative base spatial profile
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="spatialunitUid">Spatial unit UID</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <returns>Task of ApiResponse (SpatialUnitsFeatureEndpointType)</returns>
        System.Threading.Tasks.Task<ApiResponse<SpatialUnitsFeatureEndpointType>> GetSpatialUnitByUIDAsyncWithHttpInfo (string spatialunitUid, string envelope = null, List<string> embed = null);
        /// <summary>
        /// Returns a single spatial unit concept
        /// </summary>
        /// <remarks>
        /// Returns a single spatial unit concept
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="conceptUid">Spatial unit concept UID</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <returns>Task of SpatialUnitConceptEndpointType</returns>
        System.Threading.Tasks.Task<SpatialUnitConceptEndpointType> GetSpatialUnitConceptByUIDAsync (string conceptUid, string envelope = null, List<string> embed = null);

        /// <summary>
        /// Returns a single spatial unit concept
        /// </summary>
        /// <remarks>
        /// Returns a single spatial unit concept
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="conceptUid">Spatial unit concept UID</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <returns>Task of ApiResponse (SpatialUnitConceptEndpointType)</returns>
        System.Threading.Tasks.Task<ApiResponse<SpatialUnitConceptEndpointType>> GetSpatialUnitConceptByUIDAsyncWithHttpInfo (string conceptUid, string envelope = null, List<string> embed = null);
        /// <summary>
        /// Returns a list of SpatialUnits in a GeoJSON structure.
        /// </summary>
        /// <remarks>
        /// Returns a list of SpatialUnits as GeoJSON feature with 2D polygon base spatial profile
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="querywindow">Polygon. The polygon is encoded a comma separated list of coordinates. X1, Y1, X2, Y2, ..., Xn, Yn, X1, Y1</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="uid">Comma separated list of AdminSources UID (optional)</param>
        /// <param name="name">Comma separated list of AdminSources names (optional)</param>
        /// <param name="concept">Comma separated list of Spatial Unit concepts (optional)</param>
        /// <param name="level">Comma separated list of LADM Levels (optional)</param>
        /// <param name="projects">Comma separated list of project UID (optional)</param>
        /// <param name="adminsource">Comma separated list of SpatialSource UID (optional)</param>
        /// <param name="tags">Comma separated list of tags (optional)</param>
        /// <param name="page">Requests for collections can return between 0 and N results, controlled using the per_page and page query parameters. All endpoints are limited to 10 results by default. (optional)</param>
        /// <param name="sort">The sorting is initiated by the sort query parameter and a list of comma separated list of fields to sort by. (optional)</param>
        /// <param name="fields">Comma separated list of tags (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <returns>Task of List&lt;SpatialUnitsFeatureEndpointType&gt;</returns>
        System.Threading.Tasks.Task<List<SpatialUnitsFeatureEndpointType>> GetSpatialUnitsAsync (string querywindow, string envelope = null, List<string> uid = null, List<string> name = null, List<string> concept = null, List<string> level = null, List<string> projects = null, List<string> adminsource = null, List<string> tags = null, int? page = null, string sort = null, List<string> fields = null, List<string> embed = null);

        /// <summary>
        /// Returns a list of SpatialUnits in a GeoJSON structure.
        /// </summary>
        /// <remarks>
        /// Returns a list of SpatialUnits as GeoJSON feature with 2D polygon base spatial profile
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="querywindow">Polygon. The polygon is encoded a comma separated list of coordinates. X1, Y1, X2, Y2, ..., Xn, Yn, X1, Y1</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="uid">Comma separated list of AdminSources UID (optional)</param>
        /// <param name="name">Comma separated list of AdminSources names (optional)</param>
        /// <param name="concept">Comma separated list of Spatial Unit concepts (optional)</param>
        /// <param name="level">Comma separated list of LADM Levels (optional)</param>
        /// <param name="projects">Comma separated list of project UID (optional)</param>
        /// <param name="adminsource">Comma separated list of SpatialSource UID (optional)</param>
        /// <param name="tags">Comma separated list of tags (optional)</param>
        /// <param name="page">Requests for collections can return between 0 and N results, controlled using the per_page and page query parameters. All endpoints are limited to 10 results by default. (optional)</param>
        /// <param name="sort">The sorting is initiated by the sort query parameter and a list of comma separated list of fields to sort by. (optional)</param>
        /// <param name="fields">Comma separated list of tags (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <returns>Task of ApiResponse (List&lt;SpatialUnitsFeatureEndpointType&gt;)</returns>
        System.Threading.Tasks.Task<ApiResponse<List<SpatialUnitsFeatureEndpointType>>> GetSpatialUnitsAsyncWithHttpInfo (string querywindow, string envelope = null, List<string> uid = null, List<string> name = null, List<string> concept = null, List<string> level = null, List<string> projects = null, List<string> adminsource = null, List<string> tags = null, int? page = null, string sort = null, List<string> fields = null, List<string> embed = null);
        /// <summary>
        /// Returns a list of SpatialUnits
        /// </summary>
        /// <remarks>
        /// Returns a list of SpatialUnits as feature with 2d polygon base spatial profile
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="spatialunitUid">Spatial unit UID</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <returns>Task of List&lt;SpatialUnitsFeatureEndpointType&gt;</returns>
        System.Threading.Tasks.Task<List<SpatialUnitsFeatureEndpointType>> GetSpatialUnitsByUUIDAsync (string spatialunitUid, string envelope = null, List<string> embed = null);

        /// <summary>
        /// Returns a list of SpatialUnits
        /// </summary>
        /// <remarks>
        /// Returns a list of SpatialUnits as feature with 2d polygon base spatial profile
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="spatialunitUid">Spatial unit UID</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <returns>Task of ApiResponse (List&lt;SpatialUnitsFeatureEndpointType&gt;)</returns>
        System.Threading.Tasks.Task<ApiResponse<List<SpatialUnitsFeatureEndpointType>>> GetSpatialUnitsByUUIDAsyncWithHttpInfo (string spatialunitUid, string envelope = null, List<string> embed = null);
        /// <summary>
        /// Returns a list of spatial units concepts
        /// </summary>
        /// <remarks>
        /// Returns a list of spatial units concepts
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="uid">Comma separated list of Spatial unit UID (optional)</param>
        /// <param name="name">Comma separated list of AdminSources names (optional)</param>
        /// <param name="projects">Comma separated list of project UID (optional)</param>
        /// <param name="spatialunit">Comma separated list of SpatialSource UID (optional)</param>
        /// <param name="tags">Comma separated list of tags (optional)</param>
        /// <param name="page">Requests for collections can return between 0 and N results, controlled using the per_page and page query parameters. All endpoints are limited to 10 results by default. (optional)</param>
        /// <param name="sort">The sorting is initiated by the sort query parameter and a list of comma separated list of fields to sort by. (optional)</param>
        /// <param name="fields">Comma separated list of tags (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <returns>Task of List&lt;SpatialUnitsFeatureEndpointType&gt;</returns>
        System.Threading.Tasks.Task<List<SpatialUnitsFeatureEndpointType>> GetSpatialUnitsConceptsAsync (string envelope = null, List<string> uid = null, List<string> name = null, List<string> projects = null, List<string> spatialunit = null, List<string> tags = null, int? page = null, string sort = null, List<string> fields = null, List<string> embed = null);

        /// <summary>
        /// Returns a list of spatial units concepts
        /// </summary>
        /// <remarks>
        /// Returns a list of spatial units concepts
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="uid">Comma separated list of Spatial unit UID (optional)</param>
        /// <param name="name">Comma separated list of AdminSources names (optional)</param>
        /// <param name="projects">Comma separated list of project UID (optional)</param>
        /// <param name="spatialunit">Comma separated list of SpatialSource UID (optional)</param>
        /// <param name="tags">Comma separated list of tags (optional)</param>
        /// <param name="page">Requests for collections can return between 0 and N results, controlled using the per_page and page query parameters. All endpoints are limited to 10 results by default. (optional)</param>
        /// <param name="sort">The sorting is initiated by the sort query parameter and a list of comma separated list of fields to sort by. (optional)</param>
        /// <param name="fields">Comma separated list of tags (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <returns>Task of ApiResponse (List&lt;SpatialUnitsFeatureEndpointType&gt;)</returns>
        System.Threading.Tasks.Task<ApiResponse<List<SpatialUnitsFeatureEndpointType>>> GetSpatialUnitsConceptsAsyncWithHttpInfo (string envelope = null, List<string> uid = null, List<string> name = null, List<string> projects = null, List<string> spatialunit = null, List<string> tags = null, int? page = null, string sort = null, List<string> fields = null, List<string> embed = null);
        /// <summary>
        /// Returns a list of SpatialUnits
        /// </summary>
        /// <remarks>
        /// Returns a list of SpatialUnits as feature with geometry
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="querywindow">Polygon. The polygon is encoded a comma separated list of coordinates. X1, Y1, X2, Y2, ..., Xn, Yn, X1, Y1</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="uid">Comma separated list of Spatial unit UID (optional)</param>
        /// <param name="name">Comma separated list of AdminSources names (optional)</param>
        /// <param name="concept">Comma separated list of Spatial Unit concepts (optional)</param>
        /// <param name="level">Comma separated list of LADM Levels (optional)</param>
        /// <param name="projects">Comma separated list of project UID (optional)</param>
        /// <param name="adminsource">Comma separated list of SpatialSource UID (optional)</param>
        /// <param name="tags">Comma separated list of tags (optional)</param>
        /// <param name="page">Requests for collections can return between 0 and N results, controlled using the per_page and page query parameters. All endpoints are limited to 10 results by default. (optional)</param>
        /// <param name="sort">The sorting is initiated by the sort query parameter and a list of comma separated list of fields to sort by. (optional)</param>
        /// <param name="fields">Comma separated list of tags (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <returns>Task of List&lt;SpatialUnitsFeatureEndpointType&gt;</returns>
        System.Threading.Tasks.Task<List<SpatialUnitsFeatureEndpointType>> GetSpatialUnitsQualitativeAsync (string querywindow, string envelope = null, List<string> uid = null, List<string> name = null, List<string> concept = null, List<string> level = null, List<string> projects = null, List<string> adminsource = null, List<string> tags = null, int? page = null, string sort = null, List<string> fields = null, List<string> embed = null);

        /// <summary>
        /// Returns a list of SpatialUnits
        /// </summary>
        /// <remarks>
        /// Returns a list of SpatialUnits as feature with geometry
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="querywindow">Polygon. The polygon is encoded a comma separated list of coordinates. X1, Y1, X2, Y2, ..., Xn, Yn, X1, Y1</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="uid">Comma separated list of Spatial unit UID (optional)</param>
        /// <param name="name">Comma separated list of AdminSources names (optional)</param>
        /// <param name="concept">Comma separated list of Spatial Unit concepts (optional)</param>
        /// <param name="level">Comma separated list of LADM Levels (optional)</param>
        /// <param name="projects">Comma separated list of project UID (optional)</param>
        /// <param name="adminsource">Comma separated list of SpatialSource UID (optional)</param>
        /// <param name="tags">Comma separated list of tags (optional)</param>
        /// <param name="page">Requests for collections can return between 0 and N results, controlled using the per_page and page query parameters. All endpoints are limited to 10 results by default. (optional)</param>
        /// <param name="sort">The sorting is initiated by the sort query parameter and a list of comma separated list of fields to sort by. (optional)</param>
        /// <param name="fields">Comma separated list of tags (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <returns>Task of ApiResponse (List&lt;SpatialUnitsFeatureEndpointType&gt;)</returns>
        System.Threading.Tasks.Task<ApiResponse<List<SpatialUnitsFeatureEndpointType>>> GetSpatialUnitsQualitativeAsyncWithHttpInfo (string querywindow, string envelope = null, List<string> uid = null, List<string> name = null, List<string> concept = null, List<string> level = null, List<string> projects = null, List<string> adminsource = null, List<string> tags = null, int? page = null, string sort = null, List<string> fields = null, List<string> embed = null);
        /// <summary>
        /// Create a new SpatialUnit
        /// </summary>
        /// <remarks>
        /// Create a new SpatialUnit with 2d polygon base spatial profile. The spatial unit is modeled as a GeoJSON feature. The endpoint currently allows only one spatial unit per request.
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="newspatialunit">New Spatial Unit data</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <param name="i4lProcessUid">Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional)</param>
        /// <returns>Task of SpatialUnitsFeatureEndpointType</returns>
        System.Threading.Tasks.Task<SpatialUnitsFeatureEndpointType> NewSpatialUnitAsync (SpatialUnitsFeaturePostRequest newspatialunit, string envelope = null, List<string> embed = null, string i4lProcessUid = null);

        /// <summary>
        /// Create a new SpatialUnit
        /// </summary>
        /// <remarks>
        /// Create a new SpatialUnit with 2d polygon base spatial profile. The spatial unit is modeled as a GeoJSON feature. The endpoint currently allows only one spatial unit per request.
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="newspatialunit">New Spatial Unit data</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <param name="i4lProcessUid">Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional)</param>
        /// <returns>Task of ApiResponse (SpatialUnitsFeatureEndpointType)</returns>
        System.Threading.Tasks.Task<ApiResponse<SpatialUnitsFeatureEndpointType>> NewSpatialUnitAsyncWithHttpInfo (SpatialUnitsFeaturePostRequest newspatialunit, string envelope = null, List<string> embed = null, string i4lProcessUid = null);
        /// <summary>
        /// Create a new concept for a spatial unit
        /// </summary>
        /// <remarks>
        /// Create a new concept for a spatial unit.
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="newspatialunitconcept">New Spatial Unit concept data</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <param name="i4lProcessUid">Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional)</param>
        /// <returns>Task of SpatialUnitConceptEndpointType</returns>
        System.Threading.Tasks.Task<SpatialUnitConceptEndpointType> NewSpatialUnitConceptAsync (SpatialUnitConceptPostRequest newspatialunitconcept, string envelope = null, List<string> embed = null, string i4lProcessUid = null);

        /// <summary>
        /// Create a new concept for a spatial unit
        /// </summary>
        /// <remarks>
        /// Create a new concept for a spatial unit.
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="newspatialunitconcept">New Spatial Unit concept data</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <param name="i4lProcessUid">Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional)</param>
        /// <returns>Task of ApiResponse (SpatialUnitConceptEndpointType)</returns>
        System.Threading.Tasks.Task<ApiResponse<SpatialUnitConceptEndpointType>> NewSpatialUnitConceptAsyncWithHttpInfo (SpatialUnitConceptPostRequest newspatialunitconcept, string envelope = null, List<string> embed = null, string i4lProcessUid = null);
        /// <summary>
        /// Create a new SpatialUnit
        /// </summary>
        /// <remarks>
        /// Create a new SpatialUnit with qualitative base spatial profile
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="newspatialunit">New Spatial Unit data</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <param name="i4lProcessUid">Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional)</param>
        /// <returns>Task of SpatialUnitsFeatureEndpointType</returns>
        System.Threading.Tasks.Task<SpatialUnitsFeatureEndpointType> NewSpatialUnitQualitativeAsync (SpatialUnitsFeaturePostRequest newspatialunit, string envelope = null, List<string> embed = null, string i4lProcessUid = null);

        /// <summary>
        /// Create a new SpatialUnit
        /// </summary>
        /// <remarks>
        /// Create a new SpatialUnit with qualitative base spatial profile
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="newspatialunit">New Spatial Unit data</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <param name="i4lProcessUid">Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional)</param>
        /// <returns>Task of ApiResponse (SpatialUnitsFeatureEndpointType)</returns>
        System.Threading.Tasks.Task<ApiResponse<SpatialUnitsFeatureEndpointType>> NewSpatialUnitQualitativeAsyncWithHttpInfo (SpatialUnitsFeaturePostRequest newspatialunit, string envelope = null, List<string> embed = null, string i4lProcessUid = null);
        /// <summary>
        /// Update an spatial unit
        /// </summary>
        /// <remarks>
        /// Update an spatial unit with 2d polygon base spatial profile
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="spatialunitUid">Spatial unit UID</param>
        /// <param name="patchspatialunit">Update data</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="i4lProcessUid">Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional)</param>
        /// <returns>Task of SpatialUnitsFeatureEndpointType</returns>
        System.Threading.Tasks.Task<SpatialUnitsFeatureEndpointType> UpdateSpatialUnitAsync (string spatialunitUid, RFC6902PatchRequest patchspatialunit, string envelope = null, string i4lProcessUid = null);

        /// <summary>
        /// Update an spatial unit
        /// </summary>
        /// <remarks>
        /// Update an spatial unit with 2d polygon base spatial profile
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="spatialunitUid">Spatial unit UID</param>
        /// <param name="patchspatialunit">Update data</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="i4lProcessUid">Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional)</param>
        /// <returns>Task of ApiResponse (SpatialUnitsFeatureEndpointType)</returns>
        System.Threading.Tasks.Task<ApiResponse<SpatialUnitsFeatureEndpointType>> UpdateSpatialUnitAsyncWithHttpInfo (string spatialunitUid, RFC6902PatchRequest patchspatialunit, string envelope = null, string i4lProcessUid = null);
        /// <summary>
        /// Updates a new spatial unit concept
        /// </summary>
        /// <remarks>
        /// Updates a spatial unit concept
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="conceptUid">Spatial unit concept UID</param>
        /// <param name="patchspatialunitconcept">Update data</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="i4lProcessUid">Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional)</param>
        /// <returns>Task of SpatialUnitConceptEndpointType</returns>
        System.Threading.Tasks.Task<SpatialUnitConceptEndpointType> UpdateSpatialUnitConceptAsync (string conceptUid, RFC6902PatchRequest patchspatialunitconcept, string envelope = null, string i4lProcessUid = null);

        /// <summary>
        /// Updates a new spatial unit concept
        /// </summary>
        /// <remarks>
        /// Updates a spatial unit concept
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="conceptUid">Spatial unit concept UID</param>
        /// <param name="patchspatialunitconcept">Update data</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="i4lProcessUid">Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional)</param>
        /// <returns>Task of ApiResponse (SpatialUnitConceptEndpointType)</returns>
        System.Threading.Tasks.Task<ApiResponse<SpatialUnitConceptEndpointType>> UpdateSpatialUnitConceptAsyncWithHttpInfo (string conceptUid, RFC6902PatchRequest patchspatialunitconcept, string envelope = null, string i4lProcessUid = null);
        /// <summary>
        /// Updates a new SpatialUnit
        /// </summary>
        /// <remarks>
        /// Updates SpatialUnit with qualitative base spatial profile
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="spatialunitUid">Spatial unit UID</param>
        /// <param name="patchspatialunit">Update data</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="i4lProcessUid">Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional)</param>
        /// <returns>Task of SpatialUnitsFeatureEndpointType</returns>
        System.Threading.Tasks.Task<SpatialUnitsFeatureEndpointType> UpdateSpatialUnitQualitativeAsync (string spatialunitUid, RFC6902PatchRequest patchspatialunit, string envelope = null, string i4lProcessUid = null);

        /// <summary>
        /// Updates a new SpatialUnit
        /// </summary>
        /// <remarks>
        /// Updates SpatialUnit with qualitative base spatial profile
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="spatialunitUid">Spatial unit UID</param>
        /// <param name="patchspatialunit">Update data</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="i4lProcessUid">Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional)</param>
        /// <returns>Task of ApiResponse (SpatialUnitsFeatureEndpointType)</returns>
        System.Threading.Tasks.Task<ApiResponse<SpatialUnitsFeatureEndpointType>> UpdateSpatialUnitQualitativeAsyncWithHttpInfo (string spatialunitUid, RFC6902PatchRequest patchspatialunit, string envelope = null, string i4lProcessUid = null);
        #endregion Asynchronous Operations
    }

    /// <summary>
    /// Represents a collection of functions to interact with the API endpoints
    /// </summary>
    public partial class SpatialUnitsApi : ISpatialUnitsApi
    {
        private IO.Swagger.Client.ExceptionFactory _exceptionFactory = (name, response) => null;

        /// <summary>
        /// Initializes a new instance of the <see cref="SpatialUnitsApi"/> class.
        /// </summary>
        /// <returns></returns>
        public SpatialUnitsApi(String basePath)
        {
            this.Configuration = new Configuration { BasePath = basePath };

            ExceptionFactory = IO.Swagger.Client.Configuration.DefaultExceptionFactory;
        }

        /// <summary>
        /// Initializes a new instance of the <see cref="SpatialUnitsApi"/> class
        /// using Configuration object
        /// </summary>
        /// <param name="configuration">An instance of Configuration</param>
        /// <returns></returns>
        public SpatialUnitsApi(Configuration configuration = null)
        {
            if (configuration == null) // use the default one in Configuration
                this.Configuration = Configuration.Default;
            else
                this.Configuration = configuration;

            ExceptionFactory = IO.Swagger.Client.Configuration.DefaultExceptionFactory;
        }

        /// <summary>
        /// Gets the base path of the API client.
        /// </summary>
        /// <value>The base path</value>
        public String GetBasePath()
        {
            return this.Configuration.ApiClient.RestClient.BaseUrl.ToString();
        }

        /// <summary>
        /// Sets the base path of the API client.
        /// </summary>
        /// <value>The base path</value>
        [Obsolete("SetBasePath is deprecated, please do 'Configuration.ApiClient = new ApiClient(\"http://new-path\")' instead.")]
        public void SetBasePath(String basePath)
        {
            // do nothing
        }

        /// <summary>
        /// Gets or sets the configuration object
        /// </summary>
        /// <value>An instance of the Configuration</value>
        public Configuration Configuration {get; set;}

        /// <summary>
        /// Provides a factory method hook for the creation of exceptions.
        /// </summary>
        public IO.Swagger.Client.ExceptionFactory ExceptionFactory
        {
            get
            {
                if (_exceptionFactory != null && _exceptionFactory.GetInvocationList().Length > 1)
                {
                    throw new InvalidOperationException("Multicast delegate for ExceptionFactory is unsupported.");
                }
                return _exceptionFactory;
            }
            set { _exceptionFactory = value; }
        }

        /// <summary>
        /// Gets the default header.
        /// </summary>
        /// <returns>Dictionary of HTTP header</returns>
        [Obsolete("DefaultHeader is deprecated, please use Configuration.DefaultHeader instead.")]
        public IDictionary<String, String> DefaultHeader()
        {
            return new ReadOnlyDictionary<string, string>(this.Configuration.DefaultHeader);
        }

        /// <summary>
        /// Add default header.
        /// </summary>
        /// <param name="key">Header field name.</param>
        /// <param name="value">Header field value.</param>
        /// <returns></returns>
        [Obsolete("AddDefaultHeader is deprecated, please use Configuration.AddDefaultHeader instead.")]
        public void AddDefaultHeader(string key, string value)
        {
            this.Configuration.AddDefaultHeader(key, value);
        }

        /// <summary>
        /// Creates a spatial unit Create a 2D polygon base spatial unit from a boundary face string  as GeoJSON
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="spatialunitdata">Update data</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="i4lProcessUid">Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <returns>SpatialUnitsFeatureEndpointType</returns>
        public SpatialUnitsFeatureEndpointType Create2PpolygonSPUfromBFS (SpatialUnitBaseFeaturePostRequest spatialunitdata, string envelope = null, string i4lProcessUid = null, List<string> embed = null)
        {
             ApiResponse<SpatialUnitsFeatureEndpointType> localVarResponse = Create2PpolygonSPUfromBFSWithHttpInfo(spatialunitdata, envelope, i4lProcessUid, embed);
             return localVarResponse.Data;
        }

        /// <summary>
        /// Creates a spatial unit Create a 2D polygon base spatial unit from a boundary face string  as GeoJSON
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="spatialunitdata">Update data</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="i4lProcessUid">Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <returns>ApiResponse of SpatialUnitsFeatureEndpointType</returns>
        public ApiResponse< SpatialUnitsFeatureEndpointType > Create2PpolygonSPUfromBFSWithHttpInfo (SpatialUnitBaseFeaturePostRequest spatialunitdata, string envelope = null, string i4lProcessUid = null, List<string> embed = null)
        {
            // verify the required parameter 'spatialunitdata' is set
            if (spatialunitdata == null)
                throw new ApiException(400, "Missing required parameter 'spatialunitdata' when calling SpatialUnitsApi->Create2PpolygonSPUfromBFS");

            var localVarPath = "/spatialunits/create2Dpolygonspatialunit";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/json"
            };
            String localVarHttpContentType = Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (envelope != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("", "envelope", envelope)); // query parameter
            if (embed != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("csv", "embed", embed)); // query parameter
            if (i4lProcessUid != null) localVarHeaderParams.Add("i4l-process-uid", Configuration.ApiClient.ParameterToString(i4lProcessUid)); // header parameter
            if (spatialunitdata != null && spatialunitdata.GetType() != typeof(byte[]))
            {
                localVarPostBody = Configuration.ApiClient.Serialize(spatialunitdata); // http body (model) parameter
            }
            else
            {
                localVarPostBody = spatialunitdata; // byte array
            }


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) Configuration.ApiClient.CallApi(localVarPath,
                Method.POST, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("Create2PpolygonSPUfromBFS", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<SpatialUnitsFeatureEndpointType>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (SpatialUnitsFeatureEndpointType) Configuration.ApiClient.Deserialize(localVarResponse, typeof(SpatialUnitsFeatureEndpointType)));
        }

        /// <summary>
        /// Creates a spatial unit Create a 2D polygon base spatial unit from a boundary face string  as GeoJSON
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="spatialunitdata">Update data</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="i4lProcessUid">Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <returns>Task of SpatialUnitsFeatureEndpointType</returns>
        public async System.Threading.Tasks.Task<SpatialUnitsFeatureEndpointType> Create2PpolygonSPUfromBFSAsync (SpatialUnitBaseFeaturePostRequest spatialunitdata, string envelope = null, string i4lProcessUid = null, List<string> embed = null)
        {
             ApiResponse<SpatialUnitsFeatureEndpointType> localVarResponse = await Create2PpolygonSPUfromBFSAsyncWithHttpInfo(spatialunitdata, envelope, i4lProcessUid, embed);
             return localVarResponse.Data;

        }

        /// <summary>
        /// Creates a spatial unit Create a 2D polygon base spatial unit from a boundary face string  as GeoJSON
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="spatialunitdata">Update data</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="i4lProcessUid">Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <returns>Task of ApiResponse (SpatialUnitsFeatureEndpointType)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<SpatialUnitsFeatureEndpointType>> Create2PpolygonSPUfromBFSAsyncWithHttpInfo (SpatialUnitBaseFeaturePostRequest spatialunitdata, string envelope = null, string i4lProcessUid = null, List<string> embed = null)
        {
            // verify the required parameter 'spatialunitdata' is set
            if (spatialunitdata == null)
                throw new ApiException(400, "Missing required parameter 'spatialunitdata' when calling SpatialUnitsApi->Create2PpolygonSPUfromBFS");

            var localVarPath = "/spatialunits/create2Dpolygonspatialunit";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/json"
            };
            String localVarHttpContentType = Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (envelope != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("", "envelope", envelope)); // query parameter
            if (embed != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("csv", "embed", embed)); // query parameter
            if (i4lProcessUid != null) localVarHeaderParams.Add("i4l-process-uid", Configuration.ApiClient.ParameterToString(i4lProcessUid)); // header parameter
            if (spatialunitdata != null && spatialunitdata.GetType() != typeof(byte[]))
            {
                localVarPostBody = Configuration.ApiClient.Serialize(spatialunitdata); // http body (model) parameter
            }
            else
            {
                localVarPostBody = spatialunitdata; // byte array
            }


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.POST, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("Create2PpolygonSPUfromBFS", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<SpatialUnitsFeatureEndpointType>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (SpatialUnitsFeatureEndpointType) Configuration.ApiClient.Deserialize(localVarResponse, typeof(SpatialUnitsFeatureEndpointType)));
        }

        /// <summary>
        /// Returns a single spatial unit Returns a single spatial unit with qualitative base qualitative base spatial profile
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="spatialunitUid">Spatial unit UID</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <returns>SpatialUnitsFeatureEndpointType</returns>
        public SpatialUnitsFeatureEndpointType GetSpatialUnitByUID (string spatialunitUid, string envelope = null, List<string> embed = null)
        {
             ApiResponse<SpatialUnitsFeatureEndpointType> localVarResponse = GetSpatialUnitByUIDWithHttpInfo(spatialunitUid, envelope, embed);
             return localVarResponse.Data;
        }

        /// <summary>
        /// Returns a single spatial unit Returns a single spatial unit with qualitative base qualitative base spatial profile
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="spatialunitUid">Spatial unit UID</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <returns>ApiResponse of SpatialUnitsFeatureEndpointType</returns>
        public ApiResponse< SpatialUnitsFeatureEndpointType > GetSpatialUnitByUIDWithHttpInfo (string spatialunitUid, string envelope = null, List<string> embed = null)
        {
            // verify the required parameter 'spatialunitUid' is set
            if (spatialunitUid == null)
                throw new ApiException(400, "Missing required parameter 'spatialunitUid' when calling SpatialUnitsApi->GetSpatialUnitByUID");

            var localVarPath = "/spatialunits/qualitative/{spatialunit_uid}";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (spatialunitUid != null) localVarPathParams.Add("spatialunit_uid", Configuration.ApiClient.ParameterToString(spatialunitUid)); // path parameter
            if (envelope != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("", "envelope", envelope)); // query parameter
            if (embed != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("csv", "embed", embed)); // query parameter


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) Configuration.ApiClient.CallApi(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("GetSpatialUnitByUID", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<SpatialUnitsFeatureEndpointType>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (SpatialUnitsFeatureEndpointType) Configuration.ApiClient.Deserialize(localVarResponse, typeof(SpatialUnitsFeatureEndpointType)));
        }

        /// <summary>
        /// Returns a single spatial unit Returns a single spatial unit with qualitative base qualitative base spatial profile
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="spatialunitUid">Spatial unit UID</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <returns>Task of SpatialUnitsFeatureEndpointType</returns>
        public async System.Threading.Tasks.Task<SpatialUnitsFeatureEndpointType> GetSpatialUnitByUIDAsync (string spatialunitUid, string envelope = null, List<string> embed = null)
        {
             ApiResponse<SpatialUnitsFeatureEndpointType> localVarResponse = await GetSpatialUnitByUIDAsyncWithHttpInfo(spatialunitUid, envelope, embed);
             return localVarResponse.Data;

        }

        /// <summary>
        /// Returns a single spatial unit Returns a single spatial unit with qualitative base qualitative base spatial profile
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="spatialunitUid">Spatial unit UID</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <returns>Task of ApiResponse (SpatialUnitsFeatureEndpointType)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<SpatialUnitsFeatureEndpointType>> GetSpatialUnitByUIDAsyncWithHttpInfo (string spatialunitUid, string envelope = null, List<string> embed = null)
        {
            // verify the required parameter 'spatialunitUid' is set
            if (spatialunitUid == null)
                throw new ApiException(400, "Missing required parameter 'spatialunitUid' when calling SpatialUnitsApi->GetSpatialUnitByUID");

            var localVarPath = "/spatialunits/qualitative/{spatialunit_uid}";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (spatialunitUid != null) localVarPathParams.Add("spatialunit_uid", Configuration.ApiClient.ParameterToString(spatialunitUid)); // path parameter
            if (envelope != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("", "envelope", envelope)); // query parameter
            if (embed != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("csv", "embed", embed)); // query parameter


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("GetSpatialUnitByUID", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<SpatialUnitsFeatureEndpointType>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (SpatialUnitsFeatureEndpointType) Configuration.ApiClient.Deserialize(localVarResponse, typeof(SpatialUnitsFeatureEndpointType)));
        }

        /// <summary>
        /// Returns a single spatial unit concept Returns a single spatial unit concept
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="conceptUid">Spatial unit concept UID</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <returns>SpatialUnitConceptEndpointType</returns>
        public SpatialUnitConceptEndpointType GetSpatialUnitConceptByUID (string conceptUid, string envelope = null, List<string> embed = null)
        {
             ApiResponse<SpatialUnitConceptEndpointType> localVarResponse = GetSpatialUnitConceptByUIDWithHttpInfo(conceptUid, envelope, embed);
             return localVarResponse.Data;
        }

        /// <summary>
        /// Returns a single spatial unit concept Returns a single spatial unit concept
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="conceptUid">Spatial unit concept UID</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <returns>ApiResponse of SpatialUnitConceptEndpointType</returns>
        public ApiResponse< SpatialUnitConceptEndpointType > GetSpatialUnitConceptByUIDWithHttpInfo (string conceptUid, string envelope = null, List<string> embed = null)
        {
            // verify the required parameter 'conceptUid' is set
            if (conceptUid == null)
                throw new ApiException(400, "Missing required parameter 'conceptUid' when calling SpatialUnitsApi->GetSpatialUnitConceptByUID");

            var localVarPath = "/spatialunits/concepts/{concept_uid}";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (conceptUid != null) localVarPathParams.Add("concept_uid", Configuration.ApiClient.ParameterToString(conceptUid)); // path parameter
            if (envelope != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("", "envelope", envelope)); // query parameter
            if (embed != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("csv", "embed", embed)); // query parameter


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) Configuration.ApiClient.CallApi(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("GetSpatialUnitConceptByUID", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<SpatialUnitConceptEndpointType>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (SpatialUnitConceptEndpointType) Configuration.ApiClient.Deserialize(localVarResponse, typeof(SpatialUnitConceptEndpointType)));
        }

        /// <summary>
        /// Returns a single spatial unit concept Returns a single spatial unit concept
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="conceptUid">Spatial unit concept UID</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <returns>Task of SpatialUnitConceptEndpointType</returns>
        public async System.Threading.Tasks.Task<SpatialUnitConceptEndpointType> GetSpatialUnitConceptByUIDAsync (string conceptUid, string envelope = null, List<string> embed = null)
        {
             ApiResponse<SpatialUnitConceptEndpointType> localVarResponse = await GetSpatialUnitConceptByUIDAsyncWithHttpInfo(conceptUid, envelope, embed);
             return localVarResponse.Data;

        }

        /// <summary>
        /// Returns a single spatial unit concept Returns a single spatial unit concept
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="conceptUid">Spatial unit concept UID</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <returns>Task of ApiResponse (SpatialUnitConceptEndpointType)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<SpatialUnitConceptEndpointType>> GetSpatialUnitConceptByUIDAsyncWithHttpInfo (string conceptUid, string envelope = null, List<string> embed = null)
        {
            // verify the required parameter 'conceptUid' is set
            if (conceptUid == null)
                throw new ApiException(400, "Missing required parameter 'conceptUid' when calling SpatialUnitsApi->GetSpatialUnitConceptByUID");

            var localVarPath = "/spatialunits/concepts/{concept_uid}";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (conceptUid != null) localVarPathParams.Add("concept_uid", Configuration.ApiClient.ParameterToString(conceptUid)); // path parameter
            if (envelope != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("", "envelope", envelope)); // query parameter
            if (embed != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("csv", "embed", embed)); // query parameter


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("GetSpatialUnitConceptByUID", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<SpatialUnitConceptEndpointType>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (SpatialUnitConceptEndpointType) Configuration.ApiClient.Deserialize(localVarResponse, typeof(SpatialUnitConceptEndpointType)));
        }

        /// <summary>
        /// Returns a list of SpatialUnits in a GeoJSON structure. Returns a list of SpatialUnits as GeoJSON feature with 2D polygon base spatial profile
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="querywindow">Polygon. The polygon is encoded a comma separated list of coordinates. X1, Y1, X2, Y2, ..., Xn, Yn, X1, Y1</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="uid">Comma separated list of AdminSources UID (optional)</param>
        /// <param name="name">Comma separated list of AdminSources names (optional)</param>
        /// <param name="concept">Comma separated list of Spatial Unit concepts (optional)</param>
        /// <param name="level">Comma separated list of LADM Levels (optional)</param>
        /// <param name="projects">Comma separated list of project UID (optional)</param>
        /// <param name="adminsource">Comma separated list of SpatialSource UID (optional)</param>
        /// <param name="tags">Comma separated list of tags (optional)</param>
        /// <param name="page">Requests for collections can return between 0 and N results, controlled using the per_page and page query parameters. All endpoints are limited to 10 results by default. (optional)</param>
        /// <param name="sort">The sorting is initiated by the sort query parameter and a list of comma separated list of fields to sort by. (optional)</param>
        /// <param name="fields">Comma separated list of tags (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <returns>List&lt;SpatialUnitsFeatureEndpointType&gt;</returns>
        public List<SpatialUnitsFeatureEndpointType> GetSpatialUnits (string querywindow, string envelope = null, List<string> uid = null, List<string> name = null, List<string> concept = null, List<string> level = null, List<string> projects = null, List<string> adminsource = null, List<string> tags = null, int? page = null, string sort = null, List<string> fields = null, List<string> embed = null)
        {
             ApiResponse<List<SpatialUnitsFeatureEndpointType>> localVarResponse = GetSpatialUnitsWithHttpInfo(querywindow, envelope, uid, name, concept, level, projects, adminsource, tags, page, sort, fields, embed);
             return localVarResponse.Data;
        }

        /// <summary>
        /// Returns a list of SpatialUnits in a GeoJSON structure. Returns a list of SpatialUnits as GeoJSON feature with 2D polygon base spatial profile
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="querywindow">Polygon. The polygon is encoded a comma separated list of coordinates. X1, Y1, X2, Y2, ..., Xn, Yn, X1, Y1</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="uid">Comma separated list of AdminSources UID (optional)</param>
        /// <param name="name">Comma separated list of AdminSources names (optional)</param>
        /// <param name="concept">Comma separated list of Spatial Unit concepts (optional)</param>
        /// <param name="level">Comma separated list of LADM Levels (optional)</param>
        /// <param name="projects">Comma separated list of project UID (optional)</param>
        /// <param name="adminsource">Comma separated list of SpatialSource UID (optional)</param>
        /// <param name="tags">Comma separated list of tags (optional)</param>
        /// <param name="page">Requests for collections can return between 0 and N results, controlled using the per_page and page query parameters. All endpoints are limited to 10 results by default. (optional)</param>
        /// <param name="sort">The sorting is initiated by the sort query parameter and a list of comma separated list of fields to sort by. (optional)</param>
        /// <param name="fields">Comma separated list of tags (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <returns>ApiResponse of List&lt;SpatialUnitsFeatureEndpointType&gt;</returns>
        public ApiResponse< List<SpatialUnitsFeatureEndpointType> > GetSpatialUnitsWithHttpInfo (string querywindow, string envelope = null, List<string> uid = null, List<string> name = null, List<string> concept = null, List<string> level = null, List<string> projects = null, List<string> adminsource = null, List<string> tags = null, int? page = null, string sort = null, List<string> fields = null, List<string> embed = null)
        {
            // verify the required parameter 'querywindow' is set
            if (querywindow == null)
                throw new ApiException(400, "Missing required parameter 'querywindow' when calling SpatialUnitsApi->GetSpatialUnits");

            var localVarPath = "/spatialunits";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (envelope != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("", "envelope", envelope)); // query parameter
            if (uid != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("csv", "uid", uid)); // query parameter
            if (name != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("csv", "name", name)); // query parameter
            if (concept != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("csv", "concept", concept)); // query parameter
            if (level != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("csv", "level", level)); // query parameter
            if (projects != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("csv", "projects", projects)); // query parameter
            if (adminsource != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("csv", "adminsource", adminsource)); // query parameter
            if (querywindow != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("", "querywindow", querywindow)); // query parameter
            if (tags != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("csv", "tags", tags)); // query parameter
            if (page != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("", "page", page)); // query parameter
            if (sort != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("", "sort", sort)); // query parameter
            if (fields != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("csv", "fields", fields)); // query parameter
            if (embed != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("csv", "embed", embed)); // query parameter


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) Configuration.ApiClient.CallApi(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("GetSpatialUnits", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<List<SpatialUnitsFeatureEndpointType>>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (List<SpatialUnitsFeatureEndpointType>) Configuration.ApiClient.Deserialize(localVarResponse, typeof(List<SpatialUnitsFeatureEndpointType>)));
        }

        /// <summary>
        /// Returns a list of SpatialUnits in a GeoJSON structure. Returns a list of SpatialUnits as GeoJSON feature with 2D polygon base spatial profile
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="querywindow">Polygon. The polygon is encoded a comma separated list of coordinates. X1, Y1, X2, Y2, ..., Xn, Yn, X1, Y1</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="uid">Comma separated list of AdminSources UID (optional)</param>
        /// <param name="name">Comma separated list of AdminSources names (optional)</param>
        /// <param name="concept">Comma separated list of Spatial Unit concepts (optional)</param>
        /// <param name="level">Comma separated list of LADM Levels (optional)</param>
        /// <param name="projects">Comma separated list of project UID (optional)</param>
        /// <param name="adminsource">Comma separated list of SpatialSource UID (optional)</param>
        /// <param name="tags">Comma separated list of tags (optional)</param>
        /// <param name="page">Requests for collections can return between 0 and N results, controlled using the per_page and page query parameters. All endpoints are limited to 10 results by default. (optional)</param>
        /// <param name="sort">The sorting is initiated by the sort query parameter and a list of comma separated list of fields to sort by. (optional)</param>
        /// <param name="fields">Comma separated list of tags (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <returns>Task of List&lt;SpatialUnitsFeatureEndpointType&gt;</returns>
        public async System.Threading.Tasks.Task<List<SpatialUnitsFeatureEndpointType>> GetSpatialUnitsAsync (string querywindow, string envelope = null, List<string> uid = null, List<string> name = null, List<string> concept = null, List<string> level = null, List<string> projects = null, List<string> adminsource = null, List<string> tags = null, int? page = null, string sort = null, List<string> fields = null, List<string> embed = null)
        {
             ApiResponse<List<SpatialUnitsFeatureEndpointType>> localVarResponse = await GetSpatialUnitsAsyncWithHttpInfo(querywindow, envelope, uid, name, concept, level, projects, adminsource, tags, page, sort, fields, embed);
             return localVarResponse.Data;

        }

        /// <summary>
        /// Returns a list of SpatialUnits in a GeoJSON structure. Returns a list of SpatialUnits as GeoJSON feature with 2D polygon base spatial profile
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="querywindow">Polygon. The polygon is encoded a comma separated list of coordinates. X1, Y1, X2, Y2, ..., Xn, Yn, X1, Y1</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="uid">Comma separated list of AdminSources UID (optional)</param>
        /// <param name="name">Comma separated list of AdminSources names (optional)</param>
        /// <param name="concept">Comma separated list of Spatial Unit concepts (optional)</param>
        /// <param name="level">Comma separated list of LADM Levels (optional)</param>
        /// <param name="projects">Comma separated list of project UID (optional)</param>
        /// <param name="adminsource">Comma separated list of SpatialSource UID (optional)</param>
        /// <param name="tags">Comma separated list of tags (optional)</param>
        /// <param name="page">Requests for collections can return between 0 and N results, controlled using the per_page and page query parameters. All endpoints are limited to 10 results by default. (optional)</param>
        /// <param name="sort">The sorting is initiated by the sort query parameter and a list of comma separated list of fields to sort by. (optional)</param>
        /// <param name="fields">Comma separated list of tags (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <returns>Task of ApiResponse (List&lt;SpatialUnitsFeatureEndpointType&gt;)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<List<SpatialUnitsFeatureEndpointType>>> GetSpatialUnitsAsyncWithHttpInfo (string querywindow, string envelope = null, List<string> uid = null, List<string> name = null, List<string> concept = null, List<string> level = null, List<string> projects = null, List<string> adminsource = null, List<string> tags = null, int? page = null, string sort = null, List<string> fields = null, List<string> embed = null)
        {
            // verify the required parameter 'querywindow' is set
            if (querywindow == null)
                throw new ApiException(400, "Missing required parameter 'querywindow' when calling SpatialUnitsApi->GetSpatialUnits");

            var localVarPath = "/spatialunits";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (envelope != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("", "envelope", envelope)); // query parameter
            if (uid != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("csv", "uid", uid)); // query parameter
            if (name != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("csv", "name", name)); // query parameter
            if (concept != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("csv", "concept", concept)); // query parameter
            if (level != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("csv", "level", level)); // query parameter
            if (projects != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("csv", "projects", projects)); // query parameter
            if (adminsource != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("csv", "adminsource", adminsource)); // query parameter
            if (querywindow != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("", "querywindow", querywindow)); // query parameter
            if (tags != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("csv", "tags", tags)); // query parameter
            if (page != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("", "page", page)); // query parameter
            if (sort != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("", "sort", sort)); // query parameter
            if (fields != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("csv", "fields", fields)); // query parameter
            if (embed != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("csv", "embed", embed)); // query parameter


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("GetSpatialUnits", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<List<SpatialUnitsFeatureEndpointType>>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (List<SpatialUnitsFeatureEndpointType>) Configuration.ApiClient.Deserialize(localVarResponse, typeof(List<SpatialUnitsFeatureEndpointType>)));
        }

        /// <summary>
        /// Returns a list of SpatialUnits Returns a list of SpatialUnits as feature with 2d polygon base spatial profile
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="spatialunitUid">Spatial unit UID</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <returns>List&lt;SpatialUnitsFeatureEndpointType&gt;</returns>
        public List<SpatialUnitsFeatureEndpointType> GetSpatialUnitsByUUID (string spatialunitUid, string envelope = null, List<string> embed = null)
        {
             ApiResponse<List<SpatialUnitsFeatureEndpointType>> localVarResponse = GetSpatialUnitsByUUIDWithHttpInfo(spatialunitUid, envelope, embed);
             return localVarResponse.Data;
        }

        /// <summary>
        /// Returns a list of SpatialUnits Returns a list of SpatialUnits as feature with 2d polygon base spatial profile
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="spatialunitUid">Spatial unit UID</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <returns>ApiResponse of List&lt;SpatialUnitsFeatureEndpointType&gt;</returns>
        public ApiResponse< List<SpatialUnitsFeatureEndpointType> > GetSpatialUnitsByUUIDWithHttpInfo (string spatialunitUid, string envelope = null, List<string> embed = null)
        {
            // verify the required parameter 'spatialunitUid' is set
            if (spatialunitUid == null)
                throw new ApiException(400, "Missing required parameter 'spatialunitUid' when calling SpatialUnitsApi->GetSpatialUnitsByUUID");

            var localVarPath = "/spatialunits/{spatialunit_uid}";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (spatialunitUid != null) localVarPathParams.Add("spatialunit_uid", Configuration.ApiClient.ParameterToString(spatialunitUid)); // path parameter
            if (envelope != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("", "envelope", envelope)); // query parameter
            if (embed != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("csv", "embed", embed)); // query parameter


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) Configuration.ApiClient.CallApi(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("GetSpatialUnitsByUUID", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<List<SpatialUnitsFeatureEndpointType>>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (List<SpatialUnitsFeatureEndpointType>) Configuration.ApiClient.Deserialize(localVarResponse, typeof(List<SpatialUnitsFeatureEndpointType>)));
        }

        /// <summary>
        /// Returns a list of SpatialUnits Returns a list of SpatialUnits as feature with 2d polygon base spatial profile
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="spatialunitUid">Spatial unit UID</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <returns>Task of List&lt;SpatialUnitsFeatureEndpointType&gt;</returns>
        public async System.Threading.Tasks.Task<List<SpatialUnitsFeatureEndpointType>> GetSpatialUnitsByUUIDAsync (string spatialunitUid, string envelope = null, List<string> embed = null)
        {
             ApiResponse<List<SpatialUnitsFeatureEndpointType>> localVarResponse = await GetSpatialUnitsByUUIDAsyncWithHttpInfo(spatialunitUid, envelope, embed);
             return localVarResponse.Data;

        }

        /// <summary>
        /// Returns a list of SpatialUnits Returns a list of SpatialUnits as feature with 2d polygon base spatial profile
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="spatialunitUid">Spatial unit UID</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <returns>Task of ApiResponse (List&lt;SpatialUnitsFeatureEndpointType&gt;)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<List<SpatialUnitsFeatureEndpointType>>> GetSpatialUnitsByUUIDAsyncWithHttpInfo (string spatialunitUid, string envelope = null, List<string> embed = null)
        {
            // verify the required parameter 'spatialunitUid' is set
            if (spatialunitUid == null)
                throw new ApiException(400, "Missing required parameter 'spatialunitUid' when calling SpatialUnitsApi->GetSpatialUnitsByUUID");

            var localVarPath = "/spatialunits/{spatialunit_uid}";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (spatialunitUid != null) localVarPathParams.Add("spatialunit_uid", Configuration.ApiClient.ParameterToString(spatialunitUid)); // path parameter
            if (envelope != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("", "envelope", envelope)); // query parameter
            if (embed != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("csv", "embed", embed)); // query parameter


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("GetSpatialUnitsByUUID", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<List<SpatialUnitsFeatureEndpointType>>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (List<SpatialUnitsFeatureEndpointType>) Configuration.ApiClient.Deserialize(localVarResponse, typeof(List<SpatialUnitsFeatureEndpointType>)));
        }

        /// <summary>
        /// Returns a list of spatial units concepts Returns a list of spatial units concepts
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="uid">Comma separated list of Spatial unit UID (optional)</param>
        /// <param name="name">Comma separated list of AdminSources names (optional)</param>
        /// <param name="projects">Comma separated list of project UID (optional)</param>
        /// <param name="spatialunit">Comma separated list of SpatialSource UID (optional)</param>
        /// <param name="tags">Comma separated list of tags (optional)</param>
        /// <param name="page">Requests for collections can return between 0 and N results, controlled using the per_page and page query parameters. All endpoints are limited to 10 results by default. (optional)</param>
        /// <param name="sort">The sorting is initiated by the sort query parameter and a list of comma separated list of fields to sort by. (optional)</param>
        /// <param name="fields">Comma separated list of tags (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <returns>List&lt;SpatialUnitsFeatureEndpointType&gt;</returns>
        public List<SpatialUnitsFeatureEndpointType> GetSpatialUnitsConcepts (string envelope = null, List<string> uid = null, List<string> name = null, List<string> projects = null, List<string> spatialunit = null, List<string> tags = null, int? page = null, string sort = null, List<string> fields = null, List<string> embed = null)
        {
             ApiResponse<List<SpatialUnitsFeatureEndpointType>> localVarResponse = GetSpatialUnitsConceptsWithHttpInfo(envelope, uid, name, projects, spatialunit, tags, page, sort, fields, embed);
             return localVarResponse.Data;
        }

        /// <summary>
        /// Returns a list of spatial units concepts Returns a list of spatial units concepts
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="uid">Comma separated list of Spatial unit UID (optional)</param>
        /// <param name="name">Comma separated list of AdminSources names (optional)</param>
        /// <param name="projects">Comma separated list of project UID (optional)</param>
        /// <param name="spatialunit">Comma separated list of SpatialSource UID (optional)</param>
        /// <param name="tags">Comma separated list of tags (optional)</param>
        /// <param name="page">Requests for collections can return between 0 and N results, controlled using the per_page and page query parameters. All endpoints are limited to 10 results by default. (optional)</param>
        /// <param name="sort">The sorting is initiated by the sort query parameter and a list of comma separated list of fields to sort by. (optional)</param>
        /// <param name="fields">Comma separated list of tags (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <returns>ApiResponse of List&lt;SpatialUnitsFeatureEndpointType&gt;</returns>
        public ApiResponse< List<SpatialUnitsFeatureEndpointType> > GetSpatialUnitsConceptsWithHttpInfo (string envelope = null, List<string> uid = null, List<string> name = null, List<string> projects = null, List<string> spatialunit = null, List<string> tags = null, int? page = null, string sort = null, List<string> fields = null, List<string> embed = null)
        {

            var localVarPath = "/spatialunits/concepts";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (envelope != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("", "envelope", envelope)); // query parameter
            if (uid != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("csv", "uid", uid)); // query parameter
            if (name != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("csv", "name", name)); // query parameter
            if (projects != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("csv", "projects", projects)); // query parameter
            if (spatialunit != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("csv", "spatialunit", spatialunit)); // query parameter
            if (tags != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("csv", "tags", tags)); // query parameter
            if (page != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("", "page", page)); // query parameter
            if (sort != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("", "sort", sort)); // query parameter
            if (fields != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("csv", "fields", fields)); // query parameter
            if (embed != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("csv", "embed", embed)); // query parameter


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) Configuration.ApiClient.CallApi(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("GetSpatialUnitsConcepts", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<List<SpatialUnitsFeatureEndpointType>>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (List<SpatialUnitsFeatureEndpointType>) Configuration.ApiClient.Deserialize(localVarResponse, typeof(List<SpatialUnitsFeatureEndpointType>)));
        }

        /// <summary>
        /// Returns a list of spatial units concepts Returns a list of spatial units concepts
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="uid">Comma separated list of Spatial unit UID (optional)</param>
        /// <param name="name">Comma separated list of AdminSources names (optional)</param>
        /// <param name="projects">Comma separated list of project UID (optional)</param>
        /// <param name="spatialunit">Comma separated list of SpatialSource UID (optional)</param>
        /// <param name="tags">Comma separated list of tags (optional)</param>
        /// <param name="page">Requests for collections can return between 0 and N results, controlled using the per_page and page query parameters. All endpoints are limited to 10 results by default. (optional)</param>
        /// <param name="sort">The sorting is initiated by the sort query parameter and a list of comma separated list of fields to sort by. (optional)</param>
        /// <param name="fields">Comma separated list of tags (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <returns>Task of List&lt;SpatialUnitsFeatureEndpointType&gt;</returns>
        public async System.Threading.Tasks.Task<List<SpatialUnitsFeatureEndpointType>> GetSpatialUnitsConceptsAsync (string envelope = null, List<string> uid = null, List<string> name = null, List<string> projects = null, List<string> spatialunit = null, List<string> tags = null, int? page = null, string sort = null, List<string> fields = null, List<string> embed = null)
        {
             ApiResponse<List<SpatialUnitsFeatureEndpointType>> localVarResponse = await GetSpatialUnitsConceptsAsyncWithHttpInfo(envelope, uid, name, projects, spatialunit, tags, page, sort, fields, embed);
             return localVarResponse.Data;

        }

        /// <summary>
        /// Returns a list of spatial units concepts Returns a list of spatial units concepts
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="uid">Comma separated list of Spatial unit UID (optional)</param>
        /// <param name="name">Comma separated list of AdminSources names (optional)</param>
        /// <param name="projects">Comma separated list of project UID (optional)</param>
        /// <param name="spatialunit">Comma separated list of SpatialSource UID (optional)</param>
        /// <param name="tags">Comma separated list of tags (optional)</param>
        /// <param name="page">Requests for collections can return between 0 and N results, controlled using the per_page and page query parameters. All endpoints are limited to 10 results by default. (optional)</param>
        /// <param name="sort">The sorting is initiated by the sort query parameter and a list of comma separated list of fields to sort by. (optional)</param>
        /// <param name="fields">Comma separated list of tags (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <returns>Task of ApiResponse (List&lt;SpatialUnitsFeatureEndpointType&gt;)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<List<SpatialUnitsFeatureEndpointType>>> GetSpatialUnitsConceptsAsyncWithHttpInfo (string envelope = null, List<string> uid = null, List<string> name = null, List<string> projects = null, List<string> spatialunit = null, List<string> tags = null, int? page = null, string sort = null, List<string> fields = null, List<string> embed = null)
        {

            var localVarPath = "/spatialunits/concepts";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (envelope != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("", "envelope", envelope)); // query parameter
            if (uid != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("csv", "uid", uid)); // query parameter
            if (name != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("csv", "name", name)); // query parameter
            if (projects != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("csv", "projects", projects)); // query parameter
            if (spatialunit != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("csv", "spatialunit", spatialunit)); // query parameter
            if (tags != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("csv", "tags", tags)); // query parameter
            if (page != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("", "page", page)); // query parameter
            if (sort != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("", "sort", sort)); // query parameter
            if (fields != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("csv", "fields", fields)); // query parameter
            if (embed != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("csv", "embed", embed)); // query parameter


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("GetSpatialUnitsConcepts", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<List<SpatialUnitsFeatureEndpointType>>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (List<SpatialUnitsFeatureEndpointType>) Configuration.ApiClient.Deserialize(localVarResponse, typeof(List<SpatialUnitsFeatureEndpointType>)));
        }

        /// <summary>
        /// Returns a list of SpatialUnits Returns a list of SpatialUnits as feature with geometry
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="querywindow">Polygon. The polygon is encoded a comma separated list of coordinates. X1, Y1, X2, Y2, ..., Xn, Yn, X1, Y1</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="uid">Comma separated list of Spatial unit UID (optional)</param>
        /// <param name="name">Comma separated list of AdminSources names (optional)</param>
        /// <param name="concept">Comma separated list of Spatial Unit concepts (optional)</param>
        /// <param name="level">Comma separated list of LADM Levels (optional)</param>
        /// <param name="projects">Comma separated list of project UID (optional)</param>
        /// <param name="adminsource">Comma separated list of SpatialSource UID (optional)</param>
        /// <param name="tags">Comma separated list of tags (optional)</param>
        /// <param name="page">Requests for collections can return between 0 and N results, controlled using the per_page and page query parameters. All endpoints are limited to 10 results by default. (optional)</param>
        /// <param name="sort">The sorting is initiated by the sort query parameter and a list of comma separated list of fields to sort by. (optional)</param>
        /// <param name="fields">Comma separated list of tags (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <returns>List&lt;SpatialUnitsFeatureEndpointType&gt;</returns>
        public List<SpatialUnitsFeatureEndpointType> GetSpatialUnitsQualitative (string querywindow, string envelope = null, List<string> uid = null, List<string> name = null, List<string> concept = null, List<string> level = null, List<string> projects = null, List<string> adminsource = null, List<string> tags = null, int? page = null, string sort = null, List<string> fields = null, List<string> embed = null)
        {
             ApiResponse<List<SpatialUnitsFeatureEndpointType>> localVarResponse = GetSpatialUnitsQualitativeWithHttpInfo(querywindow, envelope, uid, name, concept, level, projects, adminsource, tags, page, sort, fields, embed);
             return localVarResponse.Data;
        }

        /// <summary>
        /// Returns a list of SpatialUnits Returns a list of SpatialUnits as feature with geometry
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="querywindow">Polygon. The polygon is encoded a comma separated list of coordinates. X1, Y1, X2, Y2, ..., Xn, Yn, X1, Y1</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="uid">Comma separated list of Spatial unit UID (optional)</param>
        /// <param name="name">Comma separated list of AdminSources names (optional)</param>
        /// <param name="concept">Comma separated list of Spatial Unit concepts (optional)</param>
        /// <param name="level">Comma separated list of LADM Levels (optional)</param>
        /// <param name="projects">Comma separated list of project UID (optional)</param>
        /// <param name="adminsource">Comma separated list of SpatialSource UID (optional)</param>
        /// <param name="tags">Comma separated list of tags (optional)</param>
        /// <param name="page">Requests for collections can return between 0 and N results, controlled using the per_page and page query parameters. All endpoints are limited to 10 results by default. (optional)</param>
        /// <param name="sort">The sorting is initiated by the sort query parameter and a list of comma separated list of fields to sort by. (optional)</param>
        /// <param name="fields">Comma separated list of tags (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <returns>ApiResponse of List&lt;SpatialUnitsFeatureEndpointType&gt;</returns>
        public ApiResponse< List<SpatialUnitsFeatureEndpointType> > GetSpatialUnitsQualitativeWithHttpInfo (string querywindow, string envelope = null, List<string> uid = null, List<string> name = null, List<string> concept = null, List<string> level = null, List<string> projects = null, List<string> adminsource = null, List<string> tags = null, int? page = null, string sort = null, List<string> fields = null, List<string> embed = null)
        {
            // verify the required parameter 'querywindow' is set
            if (querywindow == null)
                throw new ApiException(400, "Missing required parameter 'querywindow' when calling SpatialUnitsApi->GetSpatialUnitsQualitative");

            var localVarPath = "/spatialunits/qualitative";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (envelope != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("", "envelope", envelope)); // query parameter
            if (uid != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("csv", "uid", uid)); // query parameter
            if (name != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("csv", "name", name)); // query parameter
            if (concept != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("csv", "concept", concept)); // query parameter
            if (level != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("csv", "level", level)); // query parameter
            if (projects != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("csv", "projects", projects)); // query parameter
            if (adminsource != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("csv", "adminsource", adminsource)); // query parameter
            if (querywindow != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("", "querywindow", querywindow)); // query parameter
            if (tags != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("csv", "tags", tags)); // query parameter
            if (page != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("", "page", page)); // query parameter
            if (sort != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("", "sort", sort)); // query parameter
            if (fields != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("csv", "fields", fields)); // query parameter
            if (embed != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("csv", "embed", embed)); // query parameter


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) Configuration.ApiClient.CallApi(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("GetSpatialUnitsQualitative", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<List<SpatialUnitsFeatureEndpointType>>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (List<SpatialUnitsFeatureEndpointType>) Configuration.ApiClient.Deserialize(localVarResponse, typeof(List<SpatialUnitsFeatureEndpointType>)));
        }

        /// <summary>
        /// Returns a list of SpatialUnits Returns a list of SpatialUnits as feature with geometry
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="querywindow">Polygon. The polygon is encoded a comma separated list of coordinates. X1, Y1, X2, Y2, ..., Xn, Yn, X1, Y1</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="uid">Comma separated list of Spatial unit UID (optional)</param>
        /// <param name="name">Comma separated list of AdminSources names (optional)</param>
        /// <param name="concept">Comma separated list of Spatial Unit concepts (optional)</param>
        /// <param name="level">Comma separated list of LADM Levels (optional)</param>
        /// <param name="projects">Comma separated list of project UID (optional)</param>
        /// <param name="adminsource">Comma separated list of SpatialSource UID (optional)</param>
        /// <param name="tags">Comma separated list of tags (optional)</param>
        /// <param name="page">Requests for collections can return between 0 and N results, controlled using the per_page and page query parameters. All endpoints are limited to 10 results by default. (optional)</param>
        /// <param name="sort">The sorting is initiated by the sort query parameter and a list of comma separated list of fields to sort by. (optional)</param>
        /// <param name="fields">Comma separated list of tags (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <returns>Task of List&lt;SpatialUnitsFeatureEndpointType&gt;</returns>
        public async System.Threading.Tasks.Task<List<SpatialUnitsFeatureEndpointType>> GetSpatialUnitsQualitativeAsync (string querywindow, string envelope = null, List<string> uid = null, List<string> name = null, List<string> concept = null, List<string> level = null, List<string> projects = null, List<string> adminsource = null, List<string> tags = null, int? page = null, string sort = null, List<string> fields = null, List<string> embed = null)
        {
             ApiResponse<List<SpatialUnitsFeatureEndpointType>> localVarResponse = await GetSpatialUnitsQualitativeAsyncWithHttpInfo(querywindow, envelope, uid, name, concept, level, projects, adminsource, tags, page, sort, fields, embed);
             return localVarResponse.Data;

        }

        /// <summary>
        /// Returns a list of SpatialUnits Returns a list of SpatialUnits as feature with geometry
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="querywindow">Polygon. The polygon is encoded a comma separated list of coordinates. X1, Y1, X2, Y2, ..., Xn, Yn, X1, Y1</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="uid">Comma separated list of Spatial unit UID (optional)</param>
        /// <param name="name">Comma separated list of AdminSources names (optional)</param>
        /// <param name="concept">Comma separated list of Spatial Unit concepts (optional)</param>
        /// <param name="level">Comma separated list of LADM Levels (optional)</param>
        /// <param name="projects">Comma separated list of project UID (optional)</param>
        /// <param name="adminsource">Comma separated list of SpatialSource UID (optional)</param>
        /// <param name="tags">Comma separated list of tags (optional)</param>
        /// <param name="page">Requests for collections can return between 0 and N results, controlled using the per_page and page query parameters. All endpoints are limited to 10 results by default. (optional)</param>
        /// <param name="sort">The sorting is initiated by the sort query parameter and a list of comma separated list of fields to sort by. (optional)</param>
        /// <param name="fields">Comma separated list of tags (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <returns>Task of ApiResponse (List&lt;SpatialUnitsFeatureEndpointType&gt;)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<List<SpatialUnitsFeatureEndpointType>>> GetSpatialUnitsQualitativeAsyncWithHttpInfo (string querywindow, string envelope = null, List<string> uid = null, List<string> name = null, List<string> concept = null, List<string> level = null, List<string> projects = null, List<string> adminsource = null, List<string> tags = null, int? page = null, string sort = null, List<string> fields = null, List<string> embed = null)
        {
            // verify the required parameter 'querywindow' is set
            if (querywindow == null)
                throw new ApiException(400, "Missing required parameter 'querywindow' when calling SpatialUnitsApi->GetSpatialUnitsQualitative");

            var localVarPath = "/spatialunits/qualitative";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
            };
            String localVarHttpContentType = Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (envelope != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("", "envelope", envelope)); // query parameter
            if (uid != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("csv", "uid", uid)); // query parameter
            if (name != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("csv", "name", name)); // query parameter
            if (concept != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("csv", "concept", concept)); // query parameter
            if (level != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("csv", "level", level)); // query parameter
            if (projects != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("csv", "projects", projects)); // query parameter
            if (adminsource != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("csv", "adminsource", adminsource)); // query parameter
            if (querywindow != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("", "querywindow", querywindow)); // query parameter
            if (tags != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("csv", "tags", tags)); // query parameter
            if (page != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("", "page", page)); // query parameter
            if (sort != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("", "sort", sort)); // query parameter
            if (fields != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("csv", "fields", fields)); // query parameter
            if (embed != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("csv", "embed", embed)); // query parameter


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.GET, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("GetSpatialUnitsQualitative", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<List<SpatialUnitsFeatureEndpointType>>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (List<SpatialUnitsFeatureEndpointType>) Configuration.ApiClient.Deserialize(localVarResponse, typeof(List<SpatialUnitsFeatureEndpointType>)));
        }

        /// <summary>
        /// Create a new SpatialUnit Create a new SpatialUnit with 2d polygon base spatial profile. The spatial unit is modeled as a GeoJSON feature. The endpoint currently allows only one spatial unit per request.
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="newspatialunit">New Spatial Unit data</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <param name="i4lProcessUid">Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional)</param>
        /// <returns>SpatialUnitsFeatureEndpointType</returns>
        public SpatialUnitsFeatureEndpointType NewSpatialUnit (SpatialUnitsFeaturePostRequest newspatialunit, string envelope = null, List<string> embed = null, string i4lProcessUid = null)
        {
             ApiResponse<SpatialUnitsFeatureEndpointType> localVarResponse = NewSpatialUnitWithHttpInfo(newspatialunit, envelope, embed, i4lProcessUid);
             return localVarResponse.Data;
        }

        /// <summary>
        /// Create a new SpatialUnit Create a new SpatialUnit with 2d polygon base spatial profile. The spatial unit is modeled as a GeoJSON feature. The endpoint currently allows only one spatial unit per request.
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="newspatialunit">New Spatial Unit data</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <param name="i4lProcessUid">Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional)</param>
        /// <returns>ApiResponse of SpatialUnitsFeatureEndpointType</returns>
        public ApiResponse< SpatialUnitsFeatureEndpointType > NewSpatialUnitWithHttpInfo (SpatialUnitsFeaturePostRequest newspatialunit, string envelope = null, List<string> embed = null, string i4lProcessUid = null)
        {
            // verify the required parameter 'newspatialunit' is set
            if (newspatialunit == null)
                throw new ApiException(400, "Missing required parameter 'newspatialunit' when calling SpatialUnitsApi->NewSpatialUnit");

            var localVarPath = "/spatialunits";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/json"
            };
            String localVarHttpContentType = Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (envelope != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("", "envelope", envelope)); // query parameter
            if (embed != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("csv", "embed", embed)); // query parameter
            if (i4lProcessUid != null) localVarHeaderParams.Add("i4l-process-uid", Configuration.ApiClient.ParameterToString(i4lProcessUid)); // header parameter
            if (newspatialunit != null && newspatialunit.GetType() != typeof(byte[]))
            {
                localVarPostBody = Configuration.ApiClient.Serialize(newspatialunit); // http body (model) parameter
            }
            else
            {
                localVarPostBody = newspatialunit; // byte array
            }


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) Configuration.ApiClient.CallApi(localVarPath,
                Method.POST, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("NewSpatialUnit", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<SpatialUnitsFeatureEndpointType>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (SpatialUnitsFeatureEndpointType) Configuration.ApiClient.Deserialize(localVarResponse, typeof(SpatialUnitsFeatureEndpointType)));
        }

        /// <summary>
        /// Create a new SpatialUnit Create a new SpatialUnit with 2d polygon base spatial profile. The spatial unit is modeled as a GeoJSON feature. The endpoint currently allows only one spatial unit per request.
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="newspatialunit">New Spatial Unit data</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <param name="i4lProcessUid">Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional)</param>
        /// <returns>Task of SpatialUnitsFeatureEndpointType</returns>
        public async System.Threading.Tasks.Task<SpatialUnitsFeatureEndpointType> NewSpatialUnitAsync (SpatialUnitsFeaturePostRequest newspatialunit, string envelope = null, List<string> embed = null, string i4lProcessUid = null)
        {
             ApiResponse<SpatialUnitsFeatureEndpointType> localVarResponse = await NewSpatialUnitAsyncWithHttpInfo(newspatialunit, envelope, embed, i4lProcessUid);
             return localVarResponse.Data;

        }

        /// <summary>
        /// Create a new SpatialUnit Create a new SpatialUnit with 2d polygon base spatial profile. The spatial unit is modeled as a GeoJSON feature. The endpoint currently allows only one spatial unit per request.
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="newspatialunit">New Spatial Unit data</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <param name="i4lProcessUid">Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional)</param>
        /// <returns>Task of ApiResponse (SpatialUnitsFeatureEndpointType)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<SpatialUnitsFeatureEndpointType>> NewSpatialUnitAsyncWithHttpInfo (SpatialUnitsFeaturePostRequest newspatialunit, string envelope = null, List<string> embed = null, string i4lProcessUid = null)
        {
            // verify the required parameter 'newspatialunit' is set
            if (newspatialunit == null)
                throw new ApiException(400, "Missing required parameter 'newspatialunit' when calling SpatialUnitsApi->NewSpatialUnit");

            var localVarPath = "/spatialunits";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/json"
            };
            String localVarHttpContentType = Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (envelope != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("", "envelope", envelope)); // query parameter
            if (embed != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("csv", "embed", embed)); // query parameter
            if (i4lProcessUid != null) localVarHeaderParams.Add("i4l-process-uid", Configuration.ApiClient.ParameterToString(i4lProcessUid)); // header parameter
            if (newspatialunit != null && newspatialunit.GetType() != typeof(byte[]))
            {
                localVarPostBody = Configuration.ApiClient.Serialize(newspatialunit); // http body (model) parameter
            }
            else
            {
                localVarPostBody = newspatialunit; // byte array
            }


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.POST, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("NewSpatialUnit", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<SpatialUnitsFeatureEndpointType>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (SpatialUnitsFeatureEndpointType) Configuration.ApiClient.Deserialize(localVarResponse, typeof(SpatialUnitsFeatureEndpointType)));
        }

        /// <summary>
        /// Create a new concept for a spatial unit Create a new concept for a spatial unit.
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="newspatialunitconcept">New Spatial Unit concept data</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <param name="i4lProcessUid">Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional)</param>
        /// <returns>SpatialUnitConceptEndpointType</returns>
        public SpatialUnitConceptEndpointType NewSpatialUnitConcept (SpatialUnitConceptPostRequest newspatialunitconcept, string envelope = null, List<string> embed = null, string i4lProcessUid = null)
        {
             ApiResponse<SpatialUnitConceptEndpointType> localVarResponse = NewSpatialUnitConceptWithHttpInfo(newspatialunitconcept, envelope, embed, i4lProcessUid);
             return localVarResponse.Data;
        }

        /// <summary>
        /// Create a new concept for a spatial unit Create a new concept for a spatial unit.
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="newspatialunitconcept">New Spatial Unit concept data</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <param name="i4lProcessUid">Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional)</param>
        /// <returns>ApiResponse of SpatialUnitConceptEndpointType</returns>
        public ApiResponse< SpatialUnitConceptEndpointType > NewSpatialUnitConceptWithHttpInfo (SpatialUnitConceptPostRequest newspatialunitconcept, string envelope = null, List<string> embed = null, string i4lProcessUid = null)
        {
            // verify the required parameter 'newspatialunitconcept' is set
            if (newspatialunitconcept == null)
                throw new ApiException(400, "Missing required parameter 'newspatialunitconcept' when calling SpatialUnitsApi->NewSpatialUnitConcept");

            var localVarPath = "/spatialunits/concepts";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/json"
            };
            String localVarHttpContentType = Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (envelope != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("", "envelope", envelope)); // query parameter
            if (embed != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("csv", "embed", embed)); // query parameter
            if (i4lProcessUid != null) localVarHeaderParams.Add("i4l-process-uid", Configuration.ApiClient.ParameterToString(i4lProcessUid)); // header parameter
            if (newspatialunitconcept != null && newspatialunitconcept.GetType() != typeof(byte[]))
            {
                localVarPostBody = Configuration.ApiClient.Serialize(newspatialunitconcept); // http body (model) parameter
            }
            else
            {
                localVarPostBody = newspatialunitconcept; // byte array
            }


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) Configuration.ApiClient.CallApi(localVarPath,
                Method.POST, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("NewSpatialUnitConcept", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<SpatialUnitConceptEndpointType>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (SpatialUnitConceptEndpointType) Configuration.ApiClient.Deserialize(localVarResponse, typeof(SpatialUnitConceptEndpointType)));
        }

        /// <summary>
        /// Create a new concept for a spatial unit Create a new concept for a spatial unit.
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="newspatialunitconcept">New Spatial Unit concept data</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <param name="i4lProcessUid">Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional)</param>
        /// <returns>Task of SpatialUnitConceptEndpointType</returns>
        public async System.Threading.Tasks.Task<SpatialUnitConceptEndpointType> NewSpatialUnitConceptAsync (SpatialUnitConceptPostRequest newspatialunitconcept, string envelope = null, List<string> embed = null, string i4lProcessUid = null)
        {
             ApiResponse<SpatialUnitConceptEndpointType> localVarResponse = await NewSpatialUnitConceptAsyncWithHttpInfo(newspatialunitconcept, envelope, embed, i4lProcessUid);
             return localVarResponse.Data;

        }

        /// <summary>
        /// Create a new concept for a spatial unit Create a new concept for a spatial unit.
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="newspatialunitconcept">New Spatial Unit concept data</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <param name="i4lProcessUid">Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional)</param>
        /// <returns>Task of ApiResponse (SpatialUnitConceptEndpointType)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<SpatialUnitConceptEndpointType>> NewSpatialUnitConceptAsyncWithHttpInfo (SpatialUnitConceptPostRequest newspatialunitconcept, string envelope = null, List<string> embed = null, string i4lProcessUid = null)
        {
            // verify the required parameter 'newspatialunitconcept' is set
            if (newspatialunitconcept == null)
                throw new ApiException(400, "Missing required parameter 'newspatialunitconcept' when calling SpatialUnitsApi->NewSpatialUnitConcept");

            var localVarPath = "/spatialunits/concepts";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/json"
            };
            String localVarHttpContentType = Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (envelope != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("", "envelope", envelope)); // query parameter
            if (embed != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("csv", "embed", embed)); // query parameter
            if (i4lProcessUid != null) localVarHeaderParams.Add("i4l-process-uid", Configuration.ApiClient.ParameterToString(i4lProcessUid)); // header parameter
            if (newspatialunitconcept != null && newspatialunitconcept.GetType() != typeof(byte[]))
            {
                localVarPostBody = Configuration.ApiClient.Serialize(newspatialunitconcept); // http body (model) parameter
            }
            else
            {
                localVarPostBody = newspatialunitconcept; // byte array
            }


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.POST, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("NewSpatialUnitConcept", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<SpatialUnitConceptEndpointType>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (SpatialUnitConceptEndpointType) Configuration.ApiClient.Deserialize(localVarResponse, typeof(SpatialUnitConceptEndpointType)));
        }

        /// <summary>
        /// Create a new SpatialUnit Create a new SpatialUnit with qualitative base spatial profile
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="newspatialunit">New Spatial Unit data</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <param name="i4lProcessUid">Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional)</param>
        /// <returns>SpatialUnitsFeatureEndpointType</returns>
        public SpatialUnitsFeatureEndpointType NewSpatialUnitQualitative (SpatialUnitsFeaturePostRequest newspatialunit, string envelope = null, List<string> embed = null, string i4lProcessUid = null)
        {
             ApiResponse<SpatialUnitsFeatureEndpointType> localVarResponse = NewSpatialUnitQualitativeWithHttpInfo(newspatialunit, envelope, embed, i4lProcessUid);
             return localVarResponse.Data;
        }

        /// <summary>
        /// Create a new SpatialUnit Create a new SpatialUnit with qualitative base spatial profile
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="newspatialunit">New Spatial Unit data</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <param name="i4lProcessUid">Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional)</param>
        /// <returns>ApiResponse of SpatialUnitsFeatureEndpointType</returns>
        public ApiResponse< SpatialUnitsFeatureEndpointType > NewSpatialUnitQualitativeWithHttpInfo (SpatialUnitsFeaturePostRequest newspatialunit, string envelope = null, List<string> embed = null, string i4lProcessUid = null)
        {
            // verify the required parameter 'newspatialunit' is set
            if (newspatialunit == null)
                throw new ApiException(400, "Missing required parameter 'newspatialunit' when calling SpatialUnitsApi->NewSpatialUnitQualitative");

            var localVarPath = "/spatialunits/qualitative";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/json"
            };
            String localVarHttpContentType = Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (envelope != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("", "envelope", envelope)); // query parameter
            if (embed != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("csv", "embed", embed)); // query parameter
            if (i4lProcessUid != null) localVarHeaderParams.Add("i4l-process-uid", Configuration.ApiClient.ParameterToString(i4lProcessUid)); // header parameter
            if (newspatialunit != null && newspatialunit.GetType() != typeof(byte[]))
            {
                localVarPostBody = Configuration.ApiClient.Serialize(newspatialunit); // http body (model) parameter
            }
            else
            {
                localVarPostBody = newspatialunit; // byte array
            }


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) Configuration.ApiClient.CallApi(localVarPath,
                Method.POST, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("NewSpatialUnitQualitative", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<SpatialUnitsFeatureEndpointType>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (SpatialUnitsFeatureEndpointType) Configuration.ApiClient.Deserialize(localVarResponse, typeof(SpatialUnitsFeatureEndpointType)));
        }

        /// <summary>
        /// Create a new SpatialUnit Create a new SpatialUnit with qualitative base spatial profile
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="newspatialunit">New Spatial Unit data</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <param name="i4lProcessUid">Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional)</param>
        /// <returns>Task of SpatialUnitsFeatureEndpointType</returns>
        public async System.Threading.Tasks.Task<SpatialUnitsFeatureEndpointType> NewSpatialUnitQualitativeAsync (SpatialUnitsFeaturePostRequest newspatialunit, string envelope = null, List<string> embed = null, string i4lProcessUid = null)
        {
             ApiResponse<SpatialUnitsFeatureEndpointType> localVarResponse = await NewSpatialUnitQualitativeAsyncWithHttpInfo(newspatialunit, envelope, embed, i4lProcessUid);
             return localVarResponse.Data;

        }

        /// <summary>
        /// Create a new SpatialUnit Create a new SpatialUnit with qualitative base spatial profile
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="newspatialunit">New Spatial Unit data</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="embed">Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)</param>
        /// <param name="i4lProcessUid">Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional)</param>
        /// <returns>Task of ApiResponse (SpatialUnitsFeatureEndpointType)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<SpatialUnitsFeatureEndpointType>> NewSpatialUnitQualitativeAsyncWithHttpInfo (SpatialUnitsFeaturePostRequest newspatialunit, string envelope = null, List<string> embed = null, string i4lProcessUid = null)
        {
            // verify the required parameter 'newspatialunit' is set
            if (newspatialunit == null)
                throw new ApiException(400, "Missing required parameter 'newspatialunit' when calling SpatialUnitsApi->NewSpatialUnitQualitative");

            var localVarPath = "/spatialunits/qualitative";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/json"
            };
            String localVarHttpContentType = Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (envelope != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("", "envelope", envelope)); // query parameter
            if (embed != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("csv", "embed", embed)); // query parameter
            if (i4lProcessUid != null) localVarHeaderParams.Add("i4l-process-uid", Configuration.ApiClient.ParameterToString(i4lProcessUid)); // header parameter
            if (newspatialunit != null && newspatialunit.GetType() != typeof(byte[]))
            {
                localVarPostBody = Configuration.ApiClient.Serialize(newspatialunit); // http body (model) parameter
            }
            else
            {
                localVarPostBody = newspatialunit; // byte array
            }


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.POST, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("NewSpatialUnitQualitative", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<SpatialUnitsFeatureEndpointType>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (SpatialUnitsFeatureEndpointType) Configuration.ApiClient.Deserialize(localVarResponse, typeof(SpatialUnitsFeatureEndpointType)));
        }

        /// <summary>
        /// Update an spatial unit Update an spatial unit with 2d polygon base spatial profile
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="spatialunitUid">Spatial unit UID</param>
        /// <param name="patchspatialunit">Update data</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="i4lProcessUid">Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional)</param>
        /// <returns>SpatialUnitsFeatureEndpointType</returns>
        public SpatialUnitsFeatureEndpointType UpdateSpatialUnit (string spatialunitUid, RFC6902PatchRequest patchspatialunit, string envelope = null, string i4lProcessUid = null)
        {
             ApiResponse<SpatialUnitsFeatureEndpointType> localVarResponse = UpdateSpatialUnitWithHttpInfo(spatialunitUid, patchspatialunit, envelope, i4lProcessUid);
             return localVarResponse.Data;
        }

        /// <summary>
        /// Update an spatial unit Update an spatial unit with 2d polygon base spatial profile
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="spatialunitUid">Spatial unit UID</param>
        /// <param name="patchspatialunit">Update data</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="i4lProcessUid">Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional)</param>
        /// <returns>ApiResponse of SpatialUnitsFeatureEndpointType</returns>
        public ApiResponse< SpatialUnitsFeatureEndpointType > UpdateSpatialUnitWithHttpInfo (string spatialunitUid, RFC6902PatchRequest patchspatialunit, string envelope = null, string i4lProcessUid = null)
        {
            // verify the required parameter 'spatialunitUid' is set
            if (spatialunitUid == null)
                throw new ApiException(400, "Missing required parameter 'spatialunitUid' when calling SpatialUnitsApi->UpdateSpatialUnit");
            // verify the required parameter 'patchspatialunit' is set
            if (patchspatialunit == null)
                throw new ApiException(400, "Missing required parameter 'patchspatialunit' when calling SpatialUnitsApi->UpdateSpatialUnit");

            var localVarPath = "/spatialunits/{spatialunit_uid}";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/json"
            };
            String localVarHttpContentType = Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (spatialunitUid != null) localVarPathParams.Add("spatialunit_uid", Configuration.ApiClient.ParameterToString(spatialunitUid)); // path parameter
            if (envelope != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("", "envelope", envelope)); // query parameter
            if (i4lProcessUid != null) localVarHeaderParams.Add("i4l-process-uid", Configuration.ApiClient.ParameterToString(i4lProcessUid)); // header parameter
            if (patchspatialunit != null && patchspatialunit.GetType() != typeof(byte[]))
            {
                localVarPostBody = Configuration.ApiClient.Serialize(patchspatialunit); // http body (model) parameter
            }
            else
            {
                localVarPostBody = patchspatialunit; // byte array
            }


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) Configuration.ApiClient.CallApi(localVarPath,
                Method.PATCH, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("UpdateSpatialUnit", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<SpatialUnitsFeatureEndpointType>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (SpatialUnitsFeatureEndpointType) Configuration.ApiClient.Deserialize(localVarResponse, typeof(SpatialUnitsFeatureEndpointType)));
        }

        /// <summary>
        /// Update an spatial unit Update an spatial unit with 2d polygon base spatial profile
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="spatialunitUid">Spatial unit UID</param>
        /// <param name="patchspatialunit">Update data</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="i4lProcessUid">Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional)</param>
        /// <returns>Task of SpatialUnitsFeatureEndpointType</returns>
        public async System.Threading.Tasks.Task<SpatialUnitsFeatureEndpointType> UpdateSpatialUnitAsync (string spatialunitUid, RFC6902PatchRequest patchspatialunit, string envelope = null, string i4lProcessUid = null)
        {
             ApiResponse<SpatialUnitsFeatureEndpointType> localVarResponse = await UpdateSpatialUnitAsyncWithHttpInfo(spatialunitUid, patchspatialunit, envelope, i4lProcessUid);
             return localVarResponse.Data;

        }

        /// <summary>
        /// Update an spatial unit Update an spatial unit with 2d polygon base spatial profile
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="spatialunitUid">Spatial unit UID</param>
        /// <param name="patchspatialunit">Update data</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="i4lProcessUid">Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional)</param>
        /// <returns>Task of ApiResponse (SpatialUnitsFeatureEndpointType)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<SpatialUnitsFeatureEndpointType>> UpdateSpatialUnitAsyncWithHttpInfo (string spatialunitUid, RFC6902PatchRequest patchspatialunit, string envelope = null, string i4lProcessUid = null)
        {
            // verify the required parameter 'spatialunitUid' is set
            if (spatialunitUid == null)
                throw new ApiException(400, "Missing required parameter 'spatialunitUid' when calling SpatialUnitsApi->UpdateSpatialUnit");
            // verify the required parameter 'patchspatialunit' is set
            if (patchspatialunit == null)
                throw new ApiException(400, "Missing required parameter 'patchspatialunit' when calling SpatialUnitsApi->UpdateSpatialUnit");

            var localVarPath = "/spatialunits/{spatialunit_uid}";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/json"
            };
            String localVarHttpContentType = Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (spatialunitUid != null) localVarPathParams.Add("spatialunit_uid", Configuration.ApiClient.ParameterToString(spatialunitUid)); // path parameter
            if (envelope != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("", "envelope", envelope)); // query parameter
            if (i4lProcessUid != null) localVarHeaderParams.Add("i4l-process-uid", Configuration.ApiClient.ParameterToString(i4lProcessUid)); // header parameter
            if (patchspatialunit != null && patchspatialunit.GetType() != typeof(byte[]))
            {
                localVarPostBody = Configuration.ApiClient.Serialize(patchspatialunit); // http body (model) parameter
            }
            else
            {
                localVarPostBody = patchspatialunit; // byte array
            }


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.PATCH, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("UpdateSpatialUnit", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<SpatialUnitsFeatureEndpointType>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (SpatialUnitsFeatureEndpointType) Configuration.ApiClient.Deserialize(localVarResponse, typeof(SpatialUnitsFeatureEndpointType)));
        }

        /// <summary>
        /// Updates a new spatial unit concept Updates a spatial unit concept
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="conceptUid">Spatial unit concept UID</param>
        /// <param name="patchspatialunitconcept">Update data</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="i4lProcessUid">Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional)</param>
        /// <returns>SpatialUnitConceptEndpointType</returns>
        public SpatialUnitConceptEndpointType UpdateSpatialUnitConcept (string conceptUid, RFC6902PatchRequest patchspatialunitconcept, string envelope = null, string i4lProcessUid = null)
        {
             ApiResponse<SpatialUnitConceptEndpointType> localVarResponse = UpdateSpatialUnitConceptWithHttpInfo(conceptUid, patchspatialunitconcept, envelope, i4lProcessUid);
             return localVarResponse.Data;
        }

        /// <summary>
        /// Updates a new spatial unit concept Updates a spatial unit concept
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="conceptUid">Spatial unit concept UID</param>
        /// <param name="patchspatialunitconcept">Update data</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="i4lProcessUid">Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional)</param>
        /// <returns>ApiResponse of SpatialUnitConceptEndpointType</returns>
        public ApiResponse< SpatialUnitConceptEndpointType > UpdateSpatialUnitConceptWithHttpInfo (string conceptUid, RFC6902PatchRequest patchspatialunitconcept, string envelope = null, string i4lProcessUid = null)
        {
            // verify the required parameter 'conceptUid' is set
            if (conceptUid == null)
                throw new ApiException(400, "Missing required parameter 'conceptUid' when calling SpatialUnitsApi->UpdateSpatialUnitConcept");
            // verify the required parameter 'patchspatialunitconcept' is set
            if (patchspatialunitconcept == null)
                throw new ApiException(400, "Missing required parameter 'patchspatialunitconcept' when calling SpatialUnitsApi->UpdateSpatialUnitConcept");

            var localVarPath = "/spatialunits/concepts/{concept_uid}";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/json"
            };
            String localVarHttpContentType = Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (conceptUid != null) localVarPathParams.Add("concept_uid", Configuration.ApiClient.ParameterToString(conceptUid)); // path parameter
            if (envelope != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("", "envelope", envelope)); // query parameter
            if (i4lProcessUid != null) localVarHeaderParams.Add("i4l-process-uid", Configuration.ApiClient.ParameterToString(i4lProcessUid)); // header parameter
            if (patchspatialunitconcept != null && patchspatialunitconcept.GetType() != typeof(byte[]))
            {
                localVarPostBody = Configuration.ApiClient.Serialize(patchspatialunitconcept); // http body (model) parameter
            }
            else
            {
                localVarPostBody = patchspatialunitconcept; // byte array
            }


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) Configuration.ApiClient.CallApi(localVarPath,
                Method.PATCH, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("UpdateSpatialUnitConcept", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<SpatialUnitConceptEndpointType>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (SpatialUnitConceptEndpointType) Configuration.ApiClient.Deserialize(localVarResponse, typeof(SpatialUnitConceptEndpointType)));
        }

        /// <summary>
        /// Updates a new spatial unit concept Updates a spatial unit concept
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="conceptUid">Spatial unit concept UID</param>
        /// <param name="patchspatialunitconcept">Update data</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="i4lProcessUid">Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional)</param>
        /// <returns>Task of SpatialUnitConceptEndpointType</returns>
        public async System.Threading.Tasks.Task<SpatialUnitConceptEndpointType> UpdateSpatialUnitConceptAsync (string conceptUid, RFC6902PatchRequest patchspatialunitconcept, string envelope = null, string i4lProcessUid = null)
        {
             ApiResponse<SpatialUnitConceptEndpointType> localVarResponse = await UpdateSpatialUnitConceptAsyncWithHttpInfo(conceptUid, patchspatialunitconcept, envelope, i4lProcessUid);
             return localVarResponse.Data;

        }

        /// <summary>
        /// Updates a new spatial unit concept Updates a spatial unit concept
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="conceptUid">Spatial unit concept UID</param>
        /// <param name="patchspatialunitconcept">Update data</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="i4lProcessUid">Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional)</param>
        /// <returns>Task of ApiResponse (SpatialUnitConceptEndpointType)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<SpatialUnitConceptEndpointType>> UpdateSpatialUnitConceptAsyncWithHttpInfo (string conceptUid, RFC6902PatchRequest patchspatialunitconcept, string envelope = null, string i4lProcessUid = null)
        {
            // verify the required parameter 'conceptUid' is set
            if (conceptUid == null)
                throw new ApiException(400, "Missing required parameter 'conceptUid' when calling SpatialUnitsApi->UpdateSpatialUnitConcept");
            // verify the required parameter 'patchspatialunitconcept' is set
            if (patchspatialunitconcept == null)
                throw new ApiException(400, "Missing required parameter 'patchspatialunitconcept' when calling SpatialUnitsApi->UpdateSpatialUnitConcept");

            var localVarPath = "/spatialunits/concepts/{concept_uid}";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/json"
            };
            String localVarHttpContentType = Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (conceptUid != null) localVarPathParams.Add("concept_uid", Configuration.ApiClient.ParameterToString(conceptUid)); // path parameter
            if (envelope != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("", "envelope", envelope)); // query parameter
            if (i4lProcessUid != null) localVarHeaderParams.Add("i4l-process-uid", Configuration.ApiClient.ParameterToString(i4lProcessUid)); // header parameter
            if (patchspatialunitconcept != null && patchspatialunitconcept.GetType() != typeof(byte[]))
            {
                localVarPostBody = Configuration.ApiClient.Serialize(patchspatialunitconcept); // http body (model) parameter
            }
            else
            {
                localVarPostBody = patchspatialunitconcept; // byte array
            }


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.PATCH, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("UpdateSpatialUnitConcept", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<SpatialUnitConceptEndpointType>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (SpatialUnitConceptEndpointType) Configuration.ApiClient.Deserialize(localVarResponse, typeof(SpatialUnitConceptEndpointType)));
        }

        /// <summary>
        /// Updates a new SpatialUnit Updates SpatialUnit with qualitative base spatial profile
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="spatialunitUid">Spatial unit UID</param>
        /// <param name="patchspatialunit">Update data</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="i4lProcessUid">Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional)</param>
        /// <returns>SpatialUnitsFeatureEndpointType</returns>
        public SpatialUnitsFeatureEndpointType UpdateSpatialUnitQualitative (string spatialunitUid, RFC6902PatchRequest patchspatialunit, string envelope = null, string i4lProcessUid = null)
        {
             ApiResponse<SpatialUnitsFeatureEndpointType> localVarResponse = UpdateSpatialUnitQualitativeWithHttpInfo(spatialunitUid, patchspatialunit, envelope, i4lProcessUid);
             return localVarResponse.Data;
        }

        /// <summary>
        /// Updates a new SpatialUnit Updates SpatialUnit with qualitative base spatial profile
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="spatialunitUid">Spatial unit UID</param>
        /// <param name="patchspatialunit">Update data</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="i4lProcessUid">Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional)</param>
        /// <returns>ApiResponse of SpatialUnitsFeatureEndpointType</returns>
        public ApiResponse< SpatialUnitsFeatureEndpointType > UpdateSpatialUnitQualitativeWithHttpInfo (string spatialunitUid, RFC6902PatchRequest patchspatialunit, string envelope = null, string i4lProcessUid = null)
        {
            // verify the required parameter 'spatialunitUid' is set
            if (spatialunitUid == null)
                throw new ApiException(400, "Missing required parameter 'spatialunitUid' when calling SpatialUnitsApi->UpdateSpatialUnitQualitative");
            // verify the required parameter 'patchspatialunit' is set
            if (patchspatialunit == null)
                throw new ApiException(400, "Missing required parameter 'patchspatialunit' when calling SpatialUnitsApi->UpdateSpatialUnitQualitative");

            var localVarPath = "/spatialunits/qualitative/{spatialunit_uid}";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/json"
            };
            String localVarHttpContentType = Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (spatialunitUid != null) localVarPathParams.Add("spatialunit_uid", Configuration.ApiClient.ParameterToString(spatialunitUid)); // path parameter
            if (envelope != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("", "envelope", envelope)); // query parameter
            if (i4lProcessUid != null) localVarHeaderParams.Add("i4l-process-uid", Configuration.ApiClient.ParameterToString(i4lProcessUid)); // header parameter
            if (patchspatialunit != null && patchspatialunit.GetType() != typeof(byte[]))
            {
                localVarPostBody = Configuration.ApiClient.Serialize(patchspatialunit); // http body (model) parameter
            }
            else
            {
                localVarPostBody = patchspatialunit; // byte array
            }


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) Configuration.ApiClient.CallApi(localVarPath,
                Method.PATCH, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("UpdateSpatialUnitQualitative", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<SpatialUnitsFeatureEndpointType>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (SpatialUnitsFeatureEndpointType) Configuration.ApiClient.Deserialize(localVarResponse, typeof(SpatialUnitsFeatureEndpointType)));
        }

        /// <summary>
        /// Updates a new SpatialUnit Updates SpatialUnit with qualitative base spatial profile
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="spatialunitUid">Spatial unit UID</param>
        /// <param name="patchspatialunit">Update data</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="i4lProcessUid">Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional)</param>
        /// <returns>Task of SpatialUnitsFeatureEndpointType</returns>
        public async System.Threading.Tasks.Task<SpatialUnitsFeatureEndpointType> UpdateSpatialUnitQualitativeAsync (string spatialunitUid, RFC6902PatchRequest patchspatialunit, string envelope = null, string i4lProcessUid = null)
        {
             ApiResponse<SpatialUnitsFeatureEndpointType> localVarResponse = await UpdateSpatialUnitQualitativeAsyncWithHttpInfo(spatialunitUid, patchspatialunit, envelope, i4lProcessUid);
             return localVarResponse.Data;

        }

        /// <summary>
        /// Updates a new SpatialUnit Updates SpatialUnit with qualitative base spatial profile
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="spatialunitUid">Spatial unit UID</param>
        /// <param name="patchspatialunit">Update data</param>
        /// <param name="envelope">The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)</param>
        /// <param name="i4lProcessUid">Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional)</param>
        /// <returns>Task of ApiResponse (SpatialUnitsFeatureEndpointType)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<SpatialUnitsFeatureEndpointType>> UpdateSpatialUnitQualitativeAsyncWithHttpInfo (string spatialunitUid, RFC6902PatchRequest patchspatialunit, string envelope = null, string i4lProcessUid = null)
        {
            // verify the required parameter 'spatialunitUid' is set
            if (spatialunitUid == null)
                throw new ApiException(400, "Missing required parameter 'spatialunitUid' when calling SpatialUnitsApi->UpdateSpatialUnitQualitative");
            // verify the required parameter 'patchspatialunit' is set
            if (patchspatialunit == null)
                throw new ApiException(400, "Missing required parameter 'patchspatialunit' when calling SpatialUnitsApi->UpdateSpatialUnitQualitative");

            var localVarPath = "/spatialunits/qualitative/{spatialunit_uid}";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/json"
            };
            String localVarHttpContentType = Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json"
            };
            String localVarHttpHeaderAccept = Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (spatialunitUid != null) localVarPathParams.Add("spatialunit_uid", Configuration.ApiClient.ParameterToString(spatialunitUid)); // path parameter
            if (envelope != null) localVarQueryParams.AddRange(Configuration.ApiClient.ParameterToKeyValuePairs("", "envelope", envelope)); // query parameter
            if (i4lProcessUid != null) localVarHeaderParams.Add("i4l-process-uid", Configuration.ApiClient.ParameterToString(i4lProcessUid)); // header parameter
            if (patchspatialunit != null && patchspatialunit.GetType() != typeof(byte[]))
            {
                localVarPostBody = Configuration.ApiClient.Serialize(patchspatialunit); // http body (model) parameter
            }
            else
            {
                localVarPostBody = patchspatialunit; // byte array
            }


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.PATCH, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("UpdateSpatialUnitQualitative", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<SpatialUnitsFeatureEndpointType>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (SpatialUnitsFeatureEndpointType) Configuration.ApiClient.Deserialize(localVarResponse, typeof(SpatialUnitsFeatureEndpointType)));
        }

    }
}
